C
C File: CLalir.for
C Description: CLI Alias Support Routines
C Author: A.Shirahashi, Univ. of Tokyo
C
C History: 29-Sep-1992, add CLalip
C          15-Feb-1993, check duplicate registration
C
C     Subroutine CLalir( input,output,length )
C     Subroutine CLalil( input,output,length )
C     Subroutine CLalii( key,value )
C     Subroutine CLalip
C
C ********
C  CLALIR  Alias Replace
C ********
      Subroutine CLaliR( INPUT,OUTPUT,LENGTH )
C
      Implicit None 
C ARG
      Character * (*)  INPUT, OUTPUT
      Integer * 4      LENGTH
C
C VAR
      Integer * 4  NARGS, MARGS, LARGS(10)
      Character * 3  Pstr
      Character * 16  CARGS(10)
      Character * 80  Buffer
      Integer * 4  i, j, iargs
C
C FUNCION
      Integer  Lenrd
C
C BEGIN
      length = Lenrd(input)
      Call CLALIL( INPUT,OUTPUT,LENGTH )
      If( LENGTH.lt.0 ) Return
C
      NARGS = 0
      MARGS = 0
      Do 100 I = 1, LENGTH
C       If( OUTPUT(I:I).eq.'%' .or. OUTPUT(I:I).eq.'#' ) Then
        If( OUTPUT(I:I).eq.'%' ) Then
          NARGS = NARGS + 1
          Read( OUTPUT(I+1:I+1),'(I1)' ) IARGS
          MARGS = MAX( MARGS,IARGS )
        End If
100   Continue
      If( NARGS.eq.0 ) Return
C
      Do 200 I = 1, MARGS
        Write(Pstr,'(1H?,I1,1H?)') I
        Call TXTRD( Pstr,CARGS(I) )
        LARGS(I) = LENRD( CARGS(I) )
200   Continue
C
      I = 1
      J = 1
300   Continue
        If( OUTPUT(I:I).eq.'%' .or. OUTPUT(I:I).eq.'#' ) Then
          Read( OUTPUT(I+1:I+1),'(I1)' ) IARGS
          Buffer(J:J+LARGS(IARGS)-1) = CARGS(IARGS)(:LARGS(IARGS))
          I = I + 2
          J = J + LARGS(IARGS)
        Else
          Buffer(J:J) = OUTPUT(I:I)
          I = I + 1
          J = J + 1
        End If
      If( I.le.Length ) Goto 300
C
      Length = J - 1
      OUTPUT = ' '
      OUTPUT(:Length) = Buffer(:Length)
C     PRINT *, 'Length=',Length
C     PRINT *, 'Buffer=',Buffer(:Length)
C
      Return
      End
C
C ********
C  CLALIL  Alias Lookup
C ********
      Subroutine CLaliL( INPUT,OUTPUT,Length )
C
      Implicit None 
C ARG
      Character * (*)  INPUT, OUTPUT
      Integer * 4      Length
C local
      Integer * 4  i
C
C Common
      Common / CLALI1 / NMAC,LKMAC(100),LMMAC(100)
      Common / CLALI2 / MACKEY(100),MACBUF(100)
      Integer   *  4  NMAC, LKMAC, LMMAC
      Character * 16  MACKEY
      Character * 80  MACBUF
C function
      Integer * 4  Lenrd
C BEGIN
      Length = Lenrd(input)
      Do 100 I = NMAC, 1, -1
C       PRINT *, Length,LKMAC(I)
C       PRINT *, '/',INPUT(:Length),'/',MACKEY(I)(:Length),'/'
        If( Length.ne.LKMAC(I) ) Goto 100
        Call STRUPC( Length,INPUT )
        If( INPUT(:Length).eq.MACKEY(I)(:Length) ) Then
          OUTPUT = MACBUF(I)(:LMMAC(I))
          Length = LMMAC(I)
          Return
        End If
100   Continue
C
      Length = -1
      Return
      End
C
C ********
C  CLALII  Alias Install
C ********
      Subroutine CLaliI( key, value )
C
      Implicit None 
C const
      Integer  MAXALI
      Parameter( MAXALI = 100 )
C ARG
      Character * (*) key, value
C
C Common
      Common / CLALI1 / NMAC,LKMAC(MAXALI),LMMAC(MAXALI)
      Common / CLALI2 / MACKEY(MAXALI),MACBUF(MAXALI)
      Integer   *  4  NMAC, LKMAC, LMMAC
      Character * 16  MACKEY
      Character * 80  MACBUF
C local
      Integer  Lkey, Imac
      Character * 80  ckey
C function
      Integer * 4  Lenrd
C BEGIN
C     ... check if already registered alias 
      Lkey = Lenrd(key)
      ckey(:Lkey) = key
      Call Strupc(Lkey,ckey)
C
      Do Imac = Nmac, 1, -1
        If( Lkey.eq.Lkmac(Imac) ) Then
          If( ckey(:Lkey).eq.Mackey(Imac)(:Lkey) ) Goto 100
        End If
      End Do
C
      If( Nmac.ge.MAXALI ) Then
        Call CLIerr(2,'too many aliases')
        Return
      End If
C
      Nmac = Nmac + 1
      Imac = Nmac
C
 100  Continue
C
      mackey(Imac) = ckey(:Lkey)
      lkmac(Imac) = Lkey
C
      macbuf(Imac) = value
      lmmac(Imac) = Lenrd(value)
C
C     PRINT *, STRING
C     PRINT *, NMAC
C     PRINT *, LKMAC(NMAC),':',MACKEY(NMAC)(:LKMAC(NMAC))
C     PRINT *, LMMAC(NMAC),':',MACBUF(NMAC)(:LMMAC(NMAC))
      Return
      End
C
C
      Subroutine CLaliP
C
      Implicit None
C common
      Common / CLALI1 / NMAC,LKMAC(100),LMMAC(100)
      Common / CLALI2 / MACKEY(100),MACBUF(100)
      Integer   *  4  NMAC, LKMAC, LMMAC
      Character * 16  MACKEY
      Character * 80  MACBUF
C local
      Integer  I, LKmax
C begin
      LKmax = 0
      Do I = 1, NMAC
        LKmax = Max( LKmax, LKmac(I) )
      End Do
C
      Do I = 1, NMAC
        Write(6,*) MacKey(I)(:LKmax), ' ', MacBuf(I)(:LMmac(I))
      End Do
C
      Return
      End




