C
C File: CLGETL.FOR
C Description: Various support routines for Argrd etc.
C Author: A.Shirahashi, Univ. of Tokyo
C
C History: 27-Jul-1992, continuation mark '-' -> '\'
C          10-Aug-1992, #define sym exp -> @sym=exp
C          21-Oct-1992, ! at first column is not treated as comment
C          22-Oct-1992, do not call CLhins if ! at first column
C          27-Oct-1992, pseude CR code '\\'
C           5-Dec-1992, export CLilvl, CLilun to flgrd.f
C          26-Apr-1993, support for GNU readline (QUICK HACK!)
C          27-Apr-1993, CLgets -> CLgets, CLargr, CLinco
C          24-Feb-1994, @! bug fixed, remove CLtget
C          12-Mar-1994, line1: 80 -> 256, buffer: 80 -> *
C          29-Sep-1994, PROMPT -> CLprom
C          30-Sep-1994, \!, !!
C          11-Jan-1995, symbol replacement in @$
C
C      Subroutine CLGETL( QUES,LINE,LAST )
C      Subroutine CLIEOF()
C      Subroutine CLMKPR( QUEST,ANSWER,QUECOM,QUES,LQ )
C      Subroutine CLICMD( LINE1,LAST1 )
C      Subroutine CLWLOG( LINE )
C      Integer Function CLILOG( SWITCH )
C      Subroutine CLSTAR( IICOM )
C      Integer Function CLGETS( LUN,BUFFER,LENGTH )
C      Subroutine CLIERR( LEVEL,MESAGE )
C      Subroutine CLSTOP
C      Logical Function IFATN()
C      Subroutine RSTATN()
C
C ----------
C   CLGETL   ... Read one Logical line
C ----------
      Subroutine CLGETL( LINE,LAST )
C
      Implicit None
C ARG
C     (Ouput)
      Character * (*)  LINE
      Integer   *  4   LAST
C
C Common
      Include 'clidef.inc'
      Include 'unitrd.inc'
      Include 'flagrd.inc'
      Include 'tvdisp.inc'
      Include 'clitxt.inc'
C
C VAR
      Logical * 4  LASK, LMODE, LECHO, LTSSIN, LTTY
      Character * 256  line1
      Character * 80  ans
      Integer * 4  Last1, LQ, Lans, Ists
C
C FUNC
      Integer * 4  CLgets, Lenrd
      Logical * 4  IFTSS, CLITTY
C
C BEGIN
10    Continue
      LUNIN = LUNLST(LUNPTR)
      If( ICOM .eq. 1 ) LUNIN = 5
      LTTY = CLITTY()
      LTSSIN = IFTSS() .and. (LUNIN.eq.5 .and. (LTTY .or. ICOM.eq.1))
      LASK = IFLQ.ne.0 .and. LTSSIN
      LMODE = LTVLOC .and. LTSSIN
      LECHO = .not.LTVLOC .and. .not.LTSSIN
C
      LAST = 0
100   Continue
C
      Call CLMKPR( QUEST,ANSWE,QUECOM,QUES,LQ )
C
      If( LTSSIN .and. LASK ) Then
        Call CLrdln( Ques(1:LQ),Line1,Last1 )
C       Write(*,*) '1:',Last1,'[',Line1(:Last1),']'
        If( Last1.lt.0 ) Then
          Last = -1 
          Return
        End If
      Else
        If( LASK ) Call CLprom( QUES(1:LQ) )
        Ists = CLGETS( LUNIN,Line1,Last1 )
        If( Ists.lt.0 ) Then
          Last = -1
          Return
        End If
      End If
      If ( Line1(1:1) .EQ. '!' .OR. Line1(1:2) .EQ. '@!' ) Goto 100
C
C     ... remove inline comment
      Call CLinco( Line1,Last1 )
C     Write(*,*) '2:',Last1,'[',Line1(:Last1),']'
C
C     ... replace arguments
      Call CLargr( Line1,Last1 )
C     Write(*,*) '3:',Last1,'[',Line1(:Last1),']'
C
      If( LUNPTR.ne.0 .and. ISNGL.eq.1 ) Then
        Call CLprom( QUES(1:LQ)//' '//LINE1(:LAST1)//' =>' )
        ISTS = CLGETS( 5,ans,LANS )
        Call STRUPC( 1,ans )
        If( LANS.eq.0 .or. ans(1:1).eq.'G' ) Then
        Else If( ans(1:1).eq.'S' ) Then
          Goto 100
        Else If( ans(1:1).eq.'R' ) Then
          Call CLprom( QUES(1:LQ) )
          ISTS = CLGETS( 5,LINE1,LAST1 )
        Else If( ans(1:1).eq.'A' ) Then
          Call CLSTOP()
          Goto 10
        End If
      End If
C
      If( LECHO .and. .not.(LUNPTR.ne.0 .and. ISNGL.eq.1) .and.
     &    .not.(LAST1.ge.2 .and. LINE1(1:2).eq.'@*') ) Then
        LQ = LENRD( QUES )
C       Write( 6,'(1H ,A,A,A)' ) QUES(1:LQ),' ',LINE1(1:LAST1)
        Call CLputL( 6,QUES(:LQ)//' '//LINE1(:LAST1) )
      End If
C
      If( INHLOG.eq.0 .and. LINE1(1:1).ne.'@' ) Then
        Call CLWLOG( LINE1(1:LAST1) )
      End If
C
      If( LINE1(LAST1:LAST1) .eq. CONTMARK ) Then
        ICON = 1
        LAST1 = LAST1 - 1
      Else
        ICON = 0
      End If
      If( LAST+LAST1 .gt. LEN(LINE) ) Then
        PRINT *, '%CLI-E, Too long line, truncated.'
        Return
      End If
      If( LAST1 .ge. 1 ) Then
        LINE(LAST+1:LAST+LAST1) = LINE1(1:LAST1)
        LAST = LAST + LAST1
      End If
      If( ICON .eq. 1 ) Goto 100
C
      If( line(1:1).ne.'!' ) Then
        Call CLhins( LINE,LAST )
      Else                         ! RI
        Goto 100                   ! RI
      End If
C
      Return
      End
C
C ----------
C   CLIEOF   ... End of file detected
C ----------
       Subroutine CLIEOF()
C
       include 'unitrd.inc'
       include 'flagrd.inc'
       include 'tvdisp.inc'
       include 'clitxt.inc'
C
       Logical  CLItty
C
C BEGIN
       If( LUNPTR .eq. 0 ) Then
         If( .not.CLItty() ) Then
           Call CLIerr( 2,'End of file on console input, aborted.' )
           Call CLstop()
           Call Exit
         Else
           Call CLIerr( 1,'End of file on console input, why ?' )
         End If
       Else
         If( .not.LOPNRD ) Then
           Call CFARGP
         End If
         LOPNRD = .FALSE.
         Call CLclos( LUNLST(LUNPTR),IERR )
         If( IERR .ne. 0 ) Then
           Call CLIERR( 1,'Can''t close command file' )
         Else If( .not. LTVLOC ) Then
           Call CLMKPR( QUEST,ANSWE,QUECOM,QUES,LQ )
           If( QUES(LQ:LQ).eq.' ' ) LQ = LQ - 1
C          Write( 6,'(1H ,A,A,A)') QUES(1:LQ),' ','(End OF FILE)'
           Call CLputL(6,QUES(:LQ)//' (End of File)')
         End If
         LUNPTR = LUNPTR - 1
       End If
C
       Return
       End
C
C ----------
C   CLMKPR   ... build prompt string
C ----------
       Subroutine CLMKPR( QUEST,ANSWER,QUECOM,QUES,LQ )
C
C ARG
       Character * (*)  QUEST, ANSWER, QUECOM
       Character * (*)  QUES
       Integer   *  4   LQ
C
C Common
       include 'flagrd.inc'
C
C VAR
       Character * 80  QTEMP
C
C BEGIN
       LQ = LENRD( QUEST )
       If( QUEST(1:1).eq.'?' ) Then
         If( INDEX(QUEST,'>')+INDEX(QUEST(2:),'?').eq.0 ) Then
           QUES = QUEST(2:LQ)//' ? '
         Else
           QUES = QUEST(2:LQ)
         End If
         ANSWER = ' '
       Else
         LL = LKBRD( ANSWER,LEN(ANSWER) )
         If( INDEX( QUEST,'>' )+INDEX( QUEST,':' ) .eq. 0 ) Then
           QUES = QUEST(1:LQ)//': '//ANSWER(1:LL)//' ? '
         Else
           QUES = QUEST(1:LQ)//' '//ANSWER(1:LL)//' ? '
         End If
       End If
C
       LQ = LENRD( QUES )
       LQ = LQ + 1
       QUES(LQ:LQ) = ' '
       If( ICOM .eq. 1 ) Then
         QTEMP(1:LQ+1) = '*'//QUES(1:LQ)
         QUES(1:LQ+1) = QTEMP(1:LQ+1)
         LQ = LQ + 1
         LC = LENRD( QUECOM )
         If( LC .gt. 0 ) Then
           QUES(LQ+1:LQ+LC) = QUECOM(1:LC)
           LQ = LQ + LC
           If( QUES(LQ:LQ) .ne. ' ' ) Then
             LQ = LQ + 1
             QUES(LQ:LQ) = ' '
           End If
         End If
       End If
       If( ICON .eq. 1 ) Then
         QTEMP(1:LQ+1) = '_'//QUES(1:LQ)
         QUES(1:LQ+1) = QTEMP(1:LQ+1)
         LQ = LQ + 1
       End If
C
       Return
       End
C
C ----------
C   CLICMD   ... Execute CLI Local Command
C ----------
      Subroutine CLICMD( LINE1,LAST1 )
C
      Implicit None
C constant
      include 'clidef.inc'     
C input
      Character * (*)  LINE1
      Integer   *  4   LAST1
C common
       include 'flagrd.inc'
       include 'unitrd.inc'
       include 'clitxt.inc'
C local
       Logical   *  4  LOGON
       Character * 80  DSNAME, LINEU
       Character * 132 path, result
       Integer  Ldsn, Lpath, Ierr, iret1, iret2, status
       Integer  pos1, pos2, reslen
C function
       Logical * 4  CLITTY
C begin
       LINEU = LINE1
       Call STRUPC( 80,LINEU )
       LOGON = .FALSE.
C
C%%    If( ICOM .eq. 1 ) Then
C%%      Call CLIERR( 2,'Unexpected CLI command' )
C%%    Else If( LINE1(2:2) .eq. '(' ) Then
       If( LINE1(2:2) .eq. '(' ) Then
C          ... Open Log File
         If( ILOG .eq. 0 ) Then
           Call CLopen( LINE1(3:LAST1),KLUN,'W',IERR,'.com' )
           If( IERR .eq. 0 ) ILOG = 1
         Else
           Call CLIERR( 2,'Log file already opened' )
         End If
       Else If( LINE1(2:2) .eq. ')' ) Then
C          ... Close Log File
         Call CLclos( KLUN,IERR )
         If( IERR .ne. 0 ) Then
           Call CLIERR( 2,'Can''t close log file' )
         End If
         ILOG = 0
       Else If( LINE1(2:2) .eq. '*' ) Then
C          ... Inquire String from Console in Command File
         If( LUNPTR.eq.0 .and. CLITTY() ) Then
           Call CLIERR( 1,'Inquire in direct mode, why ?' )
         Else
           If( LAST1 .ge. 3 ) Then
             QUECOM = LINE1(3:LAST1)
           Else
             QUECOM = ' '
           End If
           ICOM = 1
         End If
       Else If( LINE1(2:2).eq.'<' ) Then
C          ... suspend/resume the execuation of the command procedure
           If( LPTRSV.eq.0 ) Then
             LPTRSV = LUNPTR
             LUNPTR = 0
           Else
             LUNPTR = LPTRSV
             LPTRSV = 0
           End If
       Else If( LINE1(2:2).eq.'$' ) Then
C        ... Execute TSS Command
         Call CLeval( line1(3:last1),result,reslen )
         Call IPFCMD( IRET1,IRET2,result,reslen )
         LOGON = .TRUE.
       Else If( LINE1(2:2).eq.'!' ) Then
C          ... Comment
C          ... Do Nothing
         LOGON = .TRUE.
       Else If( LINE1(2:2) .eq. '>' ) Then
C          ... Redirect standard output to file
         LOGON = .TRUE.
C        Close( 6 )
         If( LAST1.eq.2 ) Then
           Call CLsyso(6,'SYS$OUTPUT','UNKNOWN',status)
         Else If( LINE1(3:LAST1).eq.'*' .or.
     &            LINEU(3:LAST1).eq.'TERMINAL' ) Then
           Call CLsyso(6,'SYS$OUTPUT','UNKNOWN',status)
         Else If( LINEU(3:LAST1).eq.'NULLFILE' ) Then
           Call CLsyso(6,'NLA0:','UNKNOWN',status)
         Else
           Call CLopen( LINE1(3:LAST1),6,'W',IERR,'.lis' )
           If( IERR .ne. 0 ) Then
             Call CLsyso(6,'SYS$OUTPUT','UNKNOWN',status)
             Call CLIERR( 2,'Can''t redirect standard output' )
             LOGON = .FALSE.
           End If
         End If
       Else If( LINE1(2:2) .eq. '?' ) Then
C          ... Debug On/Off
         IDEBUG = .not. IDEBUG
         LOGON = .TRUE.
       Else If( LINE1(2:2) .eq. '#' ) Then
         Call CLsyso(6,'SYS$OUTPUT','NEW',status)
         Call CLputL(6,'%output on')
       Else If( LINE1(2:2) .eq. '%' ) Then
         Call CLputL(6,'%output off')
         Call CLsyso(6,'NLA0:','NEW',status)
       Else
         pos1 = Index(line1,'=')
         pos2 = Index(line1,' ')
         If( pos1.gt.0 .and. (pos2.eq.0 .or. pos2.gt.pos1) ) Then
C          ... symbol assign
           Call CLeval( line1(pos1+1:last1),result,reslen )
           Call CLsetv( line1(2:pos1-1),result(:reslen) )
         Else
C          ... Redirect command input to indirect file
           If( LINE1(2:2).eq.'@' ) Then
C            ... Single step execution
             DSNAME = LINE1(3:LAST1)
             LAST1 = LAST1 - 1
             LINE1(2:LAST1) = DSNAME
             ISNGL = 1
           Else
             ISNGL = 0
           End If
           If( LUNPTR .ge. MAXNST ) Then
             Call CLIERR( 2,'Command files nests too deep' )
           Else
             LOGON = .TRUE.
             LUNPTR = LUNPTR + 1
             FILIST(LUNPTR) = DSNAME
             FILINE = 0
             Call CFargs( LINE1(2:LAST1),DSNAME,LDSN )
             Call CLopen( DSNAME(1:LDSN),LUNLST(LUNPTR),
     &                    'r',Ierr,'.com' )
             If( Ierr .ne. 0 ) Then
               Call CLmkpn( dsname(:Ldsn),path,Lpath )
               If( Lpath.gt.Ldsn ) Then
                 Call CLopen( path(:Lpath),LunLst(LunPtr),
     &                        'r',Ierr,'.com' )
               End If
             End If
             If( Ierr .ne. 0 ) Then
               Call CLIerr( 2,'can''t open '''//dsname(:Ldsn)//'''' )
               If( LUNPTR .gt. 0 ) Then
                 LUNPTR = LUNPTR - 1
               End If
               LOGON = .FALSE.
             End If
           End If
         End If
       End If
C        ... Write log If necessary
       If( LOGON .and. INHLOG.eq.0 ) Then
         Call CLWLOG( LINE1(1:LAST1) )
       End If
C
       Return
       End
C
C ----------
C   CLWLOG   ... Write on log file
C ----------
       Subroutine CLWLOG( LINE )
C
C ARG
       Character * (*)  LINE
C
C Common
       include 'unitrd.inc'
       include 'flagrd.inc'
       include 'clibuf.inc'
C
C BEGIN
C      ... Write on file
       If( ILOG.eq.1 .and. LUNIN.eq.5 .and. ICOM.eq.0 ) Then
         Write( KLUN,'(A)' ) LINE
       End If
C
C      ... Write on memory
       If( NMEM.gt.0 .and. IMEM.lt.NMEM ) Then
         IMEM = IMEM + 1
         If( LINE(1:1).eq.'@' ) Then
           Write( CLINES(IMEM),'(A,A)' ) '@|', LINE
         Else
           Write( CLINES(IMEM),'(A)' ) LINE
         End If
       End If
C
       Return
       End
C
C ----------
C   CLILOG
C ----------
       Integer Function CLILOG( SWITCH )
C
C ARG
C      (Input)
       Integer * 4  SWITCH
C
C Common
       include 'unitrd.inc'
       include 'flagrd.inc'
C
C BEGIN
       If( SWITCH .eq. 0 ) Then
         INHLOG = 1
       Else
         INHLOG = 0
       End If
       If( ( ILOG.eq.1 ) .and. ( LUNPTR.eq.0 .or. ICOM.eq.1 ) ) Then
         CLILOG = 1
       Else
         CLILOG = 0
       End If
       Return
       End
C
C ----------
C   CLIMEM
C ----------
      Integer Function CLIMEM( NLINES )
C
C NLINES > 0 : Specify the max number of lines stored in the Common
C              /CLIBUF/ and start recording.
C NLINES = 0 : Return the current number of lines.
C
C ARG
      Integer * 4  NLINES
C
C Common
      include 'flagrd.inc'
      include 'clibuf.inc'
C
C BEGIN
      If( NLINES.eq.0 ) Then
        CLIMEM = IMEM
      Else If( NLINES.gt.0 ) Then
        NMEM = NLINES
        IMEM = 0
        CLIMEM = 0
      Else
        CLIMEM = -1
      End If
C
      Return
      End
C
C ----------
C   CLSTAR
C ----------
       Subroutine CLSTAR( IICOM )
C
C ARG
       Integer * 4  IICOM
C
C Common
       include 'flagrd.inc'
       include 'clitxt.inc'
C
C BEGIN
       ICOM = IICOM
       QUECOM = ' '
       Return
       End
C
C ----------
C   CLGETS   .... Read a line from input stream
C ----------
      Integer Function CLGETS( LUN,BUFFER,LENGTH )
C
      Implicit None
C common
      Include 'cliio.inc'
      Include 'unitrd.inc'
C ARG
      Integer * 4  LUN
      Character * ( * )  buffer
      Integer * 4  LENGTH
C local
      Integer * 4  L
C begin
C      ... Read one line
      If( ITRML.gt.0 ) Then
         L = MIN( ITRML, LEN(buffer) )
      Else
         L = LEN(buffer)
      End If
10    Continue
      Read( LUN,'(A)',End=800 ) filbuf(:L)
      FILINE = FILINE + 1
      buffer(:L) = filbuf(:L)
      buffer(L+1:) = ' '
C     ... deprive trailing blnaks
      Do 110 Length = L,1,-1
        If( buffer(Length:Length) .ne. ' ' ) Goto 120
110   Continue
      Length = 0
120   Continue
      buffer(Length+1:) = ' '
C
      CLgets = 0
      Return
C
 800  Continue
      CLgets = -1
      Return
      End
C
C --------
C  CLargr   ... replace arguments
C --------
      Subroutine CLargr( buffer,length)
C
      Implicit None
C common
      Include 'unitrd.inc'
C input/output
      Character * (*)  buffer
      Integer  length
C local
      Character * 80  Args
      Integer  I, Iarg, Largs
C begin
      If( LunPtr.eq.0 ) Goto 210
      I = 0
200   Continue
        I = I + 1
        If( I .ge. Length ) Goto 210
        If( Buffer(I:I) .ne. '%' ) Goto 200
        Iarg = INDEX( '123456789',Buffer(I+1:I+1) )
        If( Iarg .eq. 0 ) Then
          buffer(I:length-1) = buffer(I+1:length)
          buffer(length:) = ' '
          length = length - 1
          Goto 200
        End If
        Call CFARGI( Iarg,Args,Largs )
        Args(Largs+1:) = buffer(I+2:length)
        buffer(I:) = Args(:Largs+length-I-1)
        length = length + Largs - 2
        I = I + Largs - 1
      Goto 200
210   Continue
C
      Return
      End
C
C --------
C  CLinco  ... deprive inline comment
C --------
      Subroutine CLinco( buffer,length )
C
      Implicit None
C common
      Include 'clidef.inc'
      Include 'unitrd.inc'
C input/output
      Character * (*)  buffer
      Integer  length
C local
      Integer  i
C function
      Integer  Lenrd
C begin
      If( length.eq.0 ) Return
C
      i = Index( buffer(:length),'@!' )
      If( i.gt.0 ) Then
        buffer(i:) = ' '
        length = i - 1
      End If
C
      i = 0
 100  Continue
        i = i + 1
        If( i.gt.length ) Goto 200
        If( buffer(i:i).ne.'!' ) Goto 100
        If( i.gt.1 ) Then
          If( buffer(i-1:i-1).eq.BSLA ) Then
            buffer(i-1:length-1) = buffer(i:length)
            buffer(length:length) = ' '
            length = length - 1
            Goto 100
          End If
        End If
        If( i.lt.length ) Then
           If( buffer(i+1:i+1).eq.'!' ) Then
              buffer(i:length-1) = buffer(i+1:length)
              buffer(length:length) = ' '
              length = length - 1
              Goto 100
           End If
        End If
        If( i.gt.1 .or. lunptr.gt.0 ) Then
          buffer(i:) = ' '
          length = i - 1
        End If
 200  Continue
C
      length = Lenrd( buffer )
      Return
      End
C
C
       Subroutine CLTRML( LENGTH )
C
C ARG
       Integer * 4  LENGTH
C
C Common
       include 'cliio.inc'
C
C BEGIN
       ITRML = LENGTH
       Return
       End
C
C ----------
C   CLIERR   ... print error message
C ----------
       Subroutine CLIERR( LEVEL,MESAGE )
C
C ARG
C      (Input)
       Integer * 4  LEVEL
       Character * ( * )  MESAGE
C
C Common
       include 'unitrd.inc'
C
C VAR
       Character * 8  PREFIX
       Logical   * 4  YES
       Character * 80 string
C
C FUNC
       Logical * 4  IFTSS
C
C BEGIN
      If( LEVEL .eq. 0 ) Then
        PREFIX = '%CLI-I, '
      Else If( LEVEL .eq. 1 ) Then
        PREFIX = '%CLI-W, '
      Else If( LEVEL .eq. 2 ) Then
        PREFIX = '%CLI-E, '
      End If
C
      LMSG = LENRD( MESAGE )
      string = Mesage
      Call CLputL(6,Prefix//String(:Lmsg))
C
      If( LEVEL.le.0 ) Return
      If( .not.IFTSS() .or. LUNIN.eq.5 .or. LUNPTR.eq.0 ) Return
C
      YES = .TRUE.
      Call AFFIRM( 'Continue to execute command procedure ?', YES )
      If( .not.YES ) Call CLSTOP()
C
      Return
      End
C
C ----------
C   CLSTOP   ... abort command procedure
C ----------
       Subroutine CLstop
C
       Implicit None
C common
       include 'unitrd.inc'
       include 'flagrd.inc'
C local
      Integer  j, status
C begin
C     ... close all command files
      Do 100 J = 1, LUNPTR
        Call CLclos( LUNLST(J),status )
100   Continue
C
C     ... restore input stream
      LUNPTR = 0
      Call CLsyso(5,'SYS$INPUT','UNKNOWN',status)
C     ... discard remaining command line
C%    Call LINRD( 1,1 )
      IPNT = 0
      IFLQ = 1
      IFCR = 1
C
      Return
      End
C
C ----------
C   CLCURL   ... Return current filename, line number and its contents
C ----------
      Subroutine CLCURL( LUNP, LINUMB, linbuf )
C
C ARG
      Integer * 4  LUNP, LINUMB
      Character * (*)  linbuf
C
C Common
      include 'unitrd.inc'
C
C BEGIN
      LUNP = LUNPTR
      If( LUNP.gt.0 ) Then
        LINUMB = FILINE
        linbuf = filbuf(:LEN(linbuf))
      End If
C
      Return
      End
