C
C File: CLhcmd.f
C Description: Collection of routines to support HISTORY facility
C Author: A.Shirahashi
C
C Routines: CLhcmd, CLhins, CLhrec, Clhget, CLhall
C
C History: 21-Oct-1992, renamed from CLhins.f
C
      Subroutine CLhcmd( buffer,length )
C
      Implicit None
C input/output
      Character * (*)  buffer
      Integer  length
C local
      Integer  no
C begin
C     Write(*,*) '* CLhcmd: ', buffer, length
      buffer(length+1:) = ' '
      If( buffer(2:2).eq.'!' ) Then
        Call CLhget( -1,buffer,length )
      Else If( buffer(2:2).eq.'-') Then
        Read(buffer(2:length),*) no
        Call Clhget( no,buffer,length )
      Else If( Index('0123456789',buffer(2:2) ).gt.0 ) Then
        length = -1
      Else
        Call CLhget( 0,buffer,length )
      End If
      Return
      End
C
C ----------
C   CLHINS   .... history/install
C ----------
       Subroutine CLHINS( LINE,LENGTH )
C
C ARG
       Character * (*)  LINE
       Integer * 4  LENGTH
C
C CONST
       Integer MAXHIS
       Parameter( MAXHIS = 20 )
C
C Common
       Common / CLHIS1 / HISBUF( 0:MAXHIS-1 )
       Character * 80  HISBUF
       Common / CLHIS2 / IHEAD, ITAIL, NENT
       Integer * 4  IHEAD, ITAIL, NENT
C
C BEGIN
       If( IHEAD.eq.ITAIL .and. NENT.ge.MAXHIS ) Then
         ITAIL = MOD( ITAIL+1,MAXHIS )
       Else
         NENT = NENT + 1
       End If
       HISBUF( IHEAD ) = LINE(:LENGTH)
       IHEAD = MOD( IHEAD+1,MAXHIS )
C
       Return
       End
C
C
       Subroutine CLhget( no,buffer,length )
C
       Implicit None
C const
       Integer MAXHIS
       Parameter( MAXHIS = 20 )
C common
       Common / CLHIS1 / HISBUF( 0:MAXHIS-1 )
       Character * 80  HISBUF
       Common / CLHIS2 / IHEAD, ITAIL, NENT
       Integer * 4  IHEAD, ITAIL, NENT
C input
       Integer  no
C output
       Character * (*) buffer
       Integer  length
C local
       Integer irecal, N, L
C function
       Integer Lenrd
C begin
       length = -1
       If( no.lt.0 ) Then
         If( Nent+no.lt.0 ) Return
         irecal = Ihead + no
         If( irecal.lt.0 ) irecal = irecal + MAXHIS
         buffer = Hisbuf( irecal )
         length = Lenrd( buffer )
       Else If( no.eq.0 ) Then
         irecal = Ihead
         N = Nent
         L = Lenrd( buffer ) 
 100     Continue
           N = N - 1
           If( N.lt.0 ) Goto 110
           irecal = irecal - 1
           If( irecal.lt.0 ) irecal = irecal + MAXHIS
           If( buffer(2:L).eq.Hisbuf(irecal)(1:L-1) ) Then
C             write(*,*) L,'<',buffer(2:L),'><',
C     &                  Hisbuf(irecal)(1:L-1),'>'
             buffer = Hisbuf(irecal)
             length = Lenrd( buffer )
             Goto 110
           End If
           Goto 100
 110     Continue
       End If
C
       Return
       End
C 
C ----------
C   CLHREC   .... history/recall
C ----------
       Subroutine CLHREC( IDIR,LINE,LENGTH )
C
C ARG
       Integer   *  4  IDIR, LENGTH
       Character * (*) LINE
C
C CONST
       Parameter( MAXHIS = 20 )
C
C Common
       Common / CLHIS1 / HISBUF( 0:MAXHIS-1 )
       Character * 80  HISBUF
       Common / CLHIS2 / IHEAD, ITAIL, NENT
       Integer * 4  IHEAD, ITAIL, NENT
C
C BEGIN
       If( IDIR.eq.0 ) Then
         IRECAL = IHEAD
         NRECAL = 0
         Return
       End If
C
       If( NENT.eq.0 ) Then
         LENGTH = 0
         Return
       End If
C
       If( IDIR.lt.0 ) Then
         If( NRECAL.lt.NENT ) Then
           NRECAL = NRECAL + 1
           IRECAL = IRECAL - 1
           If( IRECAL.lt.0 ) IRECAL = MAXHIS-1
         End If
         LINE = HISBUF( IRECAL )
         LENGTH = LENRD( LINE )
       Else If( IDIR.gt.0 ) Then
         If( NRECAL.eq.0 ) Then
           LENGTH = 0
           Return
         Else If( NRECAL.gt.1 ) Then
           NRECAL = NRECAL - 1
           IRECAL = MOD( IRECAL+1,MAXHIS )
         End If
         LINE = HISBUF( IRECAL )
         LENGTH = LENRD( LINE )
       End If
C
       Return
       End
C
C ----------
C   CLHALL   .... recall/all
C ----------
       Subroutine CLHALL()
C
C CONST
       Parameter( MAXHIS = 20 )
C
C Common
       Common / CLHIS1 / HISBUF( 0:MAXHIS-1 )
       Character * 80  HISBUF
       Common / CLHIS2 / IHEAD, ITAIL, NENT
       Integer * 4  IHEAD, ITAIL, NENT
C
C BEGIN
       If( NENT.eq.0 ) Return
       Call TVCLR
       PRINT *
C
       J = ITAIL
       Do 100 I = 1, NENT
         L = LENRD( HISBUF( J ) )
         PRINT '(1X,I3,1X,A)', I, HISBUF( J )(:L)
         J = MOD( J+1,MAXHIS )
100    Continue
C
       Return
       End
C
