C
C File: CLITEST.FOR
C Description: Test program for CLI
C
      Character * 80  string
      Character * 16  text
      Character * 16  words(8), word, key
      Character * 2  table(5)
      Data table / 'aa','ab','c','d','e' /
C
      Integer * 4  status
      Logical * 4  lstat
C
      Integer * 4  ival / 123 /
      Real * 4  rval / 1.23E0 /
      Real * 8  dval / 1.23D0 /
      Integer * 4  hval / 255 /
      Logical * 4  lval / .TRUE. /
C
C function
      Integer * 4  Iopen
      Logical * 4  Qopen
C
C     ...test for basic input routines
      Call Intrd('Input INTEGER',ival)
      Print *, 'ival =', ival
      Call IntrdL('Input INTEGER (IntrdL)',ival,1,10)
      Print *, 'ival =', ival
      Call IntrdX('Input INTEGER (IntrdX)',ival,text)
      Print *, 'ival =', ival, ' text =',text
C
      Call Fltrd('Input REAL*4',rval)
      Print *, 'rval =', rval
      Call FltrdL('Input REAL*4 (FltrdL)',rval,1.0,10.0)
      Print *, 'rval =', rval
      Call FltrdX('Input REAL*4 (FltrdX)',rval,text)
      Print *, 'rval =', rval, ' text =',text
C
      Call Fdprd('Input REAL*8',dval)
      Print *, 'dval =', dval
      Call FdprdL('Input REAL*8',dval,1.0D0,10.0D0)
      Print *, 'dval =', dval
C
      Call Hexrd('Input HEX',hval)
      Print *, 'hval =', hval
      Call HexrdL('Input HEX',hval,1,10)
      Print *, 'hval =', hval
C
      Call Logrd('Input LOGICAL',lval)
      Print *, 'lval =', lval
C
C     ...test for conversion routines
      Call Txtrd('?Input Real',text)
      Call CLatof(text,rval)
      Print *, 'text,rval=',text,rval
      Call Txtrd('?Input Integer',text)
      Call CLatoi(text,ival)
      Print *, 'text,ival=',text,ival
      Call Fltrd('?Input Real',rval)
      Call CLftoa(rval,text)
      Print *, 'rval,text=',rval,text
      Call Fdprd('?Input Double',dval)
      Call CLdtoa(dval,text)
      Print *, 'dval,text=',dval,text
C
C     ...test for string maipulation routines
      Call CLword('word1, word2, word3',' ,',nw,words)
      Do i = 1, nw
        Print *, 'word(',i,')=',words(i)
      End Do
      Call CLpart('word1 word2 word3',2,word)
      Print *, '2nd part is:',word
C
C     ...test for OPNRD
      Call Opnrd('clitest.com')
      Call Txtrd('OPNRD>',string)
      Call Txtrd('OPNRD>',string)
      Call Txtrd('OPNRD>',string)
      Call Txtrd('OPNRD>',string)
C
C     ...test for LUNRD
      Open(Unit=1,File='clitest.com',Status='OLD',Form='FORMATTED')
      Call Lunrd(1,6)
      Call Txtrd('LUNRD>',string)
      Call Txtrd('LUNRD>',string)
      Call Txtrd('LUNRD>',string)
      Call Txtrd('LUNRD>',string)
      close(1)
C
C     ... test for PRINTF
      a = 1.0
      b = 1.99
      c = 0.12345
      Call Printf(6,'a = %f, b = %6f, c = %6.3f, d = %d, e = (%5d)$',
     &            a,b,c,100,12)
C
C     ... test for IOPEN
      status = Iopen(1,'clitest','.dat',' ')
      write(*,*) 'Iopen (w) status = ', status
      write(1,*) 'THIS IS A TEST (1)'
      close(1)
      status = Iopen(1,'clitest','.dat','R')
      write(*,*) 'Iopen (R) status = ', status
      read(1,'(A)') string
      write(6,*) string
      close(1)
C
C     ... test for QOPEN
      string = '*.inc'
      lstat = Qopen('filename>',1,string,'READ','FORMATTED','OLD')
      write(*,*) string
      close(1)
      string = 'clitest.dat'
      lstat = Qopen('filename>',1,string,'WRITE','FORMATTED','NEW')
      write(1,*) 'THIS IS A TEST (2)'
      close(1)
C
C     ... test for KEYRD
      Call Keyrd(-3,'?KEY>',key,table,5,it)
      Print *, it,',',key
C
      Stop
      End
C
