C
C File: CLmacr.f
C Description: CLI Macro Support Routines
C Author: A.Shirahashi, Univ. of Tokyo
C
C History: 10-Aug-1992, CLmaci, 2 arguments (sym,str)
C                       CLmacr, $(sym)
C          26-Oct-1992, CLmaci -> CLsetv
C          27-Oct-1992, add CLmacS
C          18-Nov-1992, add CLgetv
C          11-Jan-1995, recycle symbol area by Y.Ishisaki
C
C Public: CLmacR, CLmacS, CLmacL, CLsetv
C
C Note: CLmacR may be obsolete.
C
      Subroutine CLmacR( string,length )
C ... replace macros
      Implicit None
C ARG
      Character * (*)  string
      Integer * 4  length
C
C COMMON
      Common / CLMAC1 / NMAC,LKMAC(100),LMMAC(100)
      Integer * 4  NMAC,LKMAC,LMMAC
C
C ARGS
      Character * 132  subst, output
C local
      Integer  N, J, L, L1, M, M1
C
C BEGIN
C     Write(*,*) 'CLmacr: ', length, '<',string(:length),'>'
      If( NMAC.le.0 ) Return
      string(length+1:) = ' '
      N = 0
      J = 0
100   Continue
      N = N + 1
      If( N.gt.LENGTH ) Goto 200
      If( string(N:N).eq.' ' ) Then
        J = J + 1
        output(J:J) = ' '
        Goto 100
      End If
      M = Min( Index( string(N:),' ' )+N-2,length )
      M1 = M
      L = M - N + 1
      If( string(N:N).eq.'$' ) Then
        If( string(N+1:N+1).eq.'(' ) Then
          N = N+2
          M = Min( Index( string(N:),')' )+N-2,length )
          M1 = M+1
        Else
          N = N+1
        End If
        L1 = M-N+1
        Call CLmacl( string(N:M),subst,L1 )
        If( L1.gt.0 ) Then
          output(J+1:J+L1) = subst(:L1)
          J = J+L1
        End If
      Else
        output(J+1:J+L) = string(N:M)
        J = J+L
      End If  
      N = M1
      Goto 100
200   Continue
      LENGTH = J
      STRING = OUTPUT(:LENGTH)
C     PRINT *, '/',OUTPUT(:LENGTH),'/'
      Return
      End
C
C 
      Subroutine CLmacS( input,length )
C     ... replace one macro
      Implicit None
C ARG
      Character * (*)  input
      Integer * 4  length
C
C COMMON
      Common / CLMAC1 / NMAC,LKMAC(100),LMMAC(100)
      Integer * 4  NMAC,LKMAC,LMMAC
C
C ARGS
      Character * 132  subst, output
C local
      Integer  N, L1, M, M1, N1
C
C BEGIN
CC      Write(*,*) 'CLmacr: ', length, '<',input(:length),'>'
      If( NMAC.le.0 ) Return
      input(length+1:) = ' '
C
      N = Index(input,'$')
      If( N.eq.0 ) Return
      N1 = N - 1
C
      M = Min( Index( input(N:),' ' )+N-2,length )
      M1 = M + 1
C
      If( input(N+1:N+1).eq.'(' ) Then
        N = N + 2
        M = Min( Index( input(N:),')' )+N-2,length )
        M1 = M + 2
      Else
        N = N + 1
      End If
      L1 = M - N + 1
      Call CLmacL( input(N:M),subst,L1 )
      If( L1.gt.0 ) Then
        output = input(:N1)//subst(:L1)//input(M1:length)
        length = N1 + L1 + (length-M1+1)
        input = output(:length)
      End If  
CC      Write(*,*) '/',input(:length),'/'
      Return
      End
C
C ********
C  CLMACL  Macro Lookup
C ********
      Subroutine CLmacL( INPUT,OUTPUT,LENGTH )
C
      Implicit None
C ARG
      Character * (*)  INPUT, OUTPUT
      Integer * 4      LENGTH
C
C COMMON
      Common / CLMAC1 / NMAC,LKMAC(100),LMMAC(100)
      Common / CLMAC2 / MACKEY(100),MACBUF(100)
      Integer   *  4  NMAC, LKMAC, LMMAC
      Character * 16  MACKEY
      Character * 80  MACBUF
C local
      Integer  I
C BEGIN
      Do 100 I = NMAC, 1, -1
        If( LENGTH.ne.LKMAC(I) ) Goto 100
        If( INPUT(:LENGTH).eq.MACKEY(I)(:LENGTH) ) Then
          OUTPUT = MACBUF(I)(:LMMAC(I))
          LENGTH = LMMAC(I)
          Return
        End If
100   Continue
C
      LENGTH = -1
      Return
      End
C
C ********
C  CLMACI  Macro Install
C ********
      Subroutine CLsetv( symbol,string )
C
      Implicit None
C ARG
      Character * (*) symbol, string
C
C COMMON
      Common / CLMAC1 / NMAC,LKMAC(100),LMMAC(100)
      Common / CLMAC2 / MACKEY(100),MACBUF(100)
      Integer   *  4  NMAC, LKMAC, LMMAC
      Character * 16  MACKEY
      Character * 80  MACBUF
C local
      Integer  I, Lsym
C function
      Integer  Lkbrd
C BEGIN
      Lsym = Lkbrd(symbol,0)
C
      If ( 0.eq.Lsym ) then
        Do I = NMAC, 1, -1
          Write(*,*) MACKEY(I)(:lkmac(I))//'='//MACBUF(I)(:lmmac(I))
       End do
       Return
      End if
      
      Do I = NMAC, 1, -1
        If ( Lsym.eq.LKMAC(I) ) then
          If ( symbol(:Lsym).eq.MACKEY(I)(:Lsym) ) Goto 200
        End if
      End do
      NMAC = NMAC + 1
      I = NMAC
 200  Continue
C
      mackey(I) = symbol(:Lsym)
      lkmac(I) = Lsym
      macbuf(I) = string
      lmmac(I) = Len(string)
C
      Return
      End
C
C
      Subroutine CLgetv( input,output,length )
C
      Implicit None
C input
      Character * (*)  input
C output
      Character * (*)  output
      Integer  length
C function
      Integer  Lenrd
C begin
      length = Lenrd( input )
      Call CLmacL( input,output,length )
C
      Return
      End
