/*
 CLrdln: Interface to GNU readline package
 Author: A.Shirahashi
 Date: 26-Apr-93

 History: 29-Sep-1994: READLINE_INCLUDE
                       fix ^D handling
*/

#include <stdio.h>
#include <string.h>
#include <readline/readline.h>

void clrdin_(void)
{
  /* dummy */
}

void clrdln_(char *pro,char *buf,int *len,int lpro,int lbuf)
{
  char *p, *line;
  int i;

  p = (char *)malloc(lpro+1);
  strncpy(p,pro,lpro);
  *(p+lpro) = '\0';

  line = readline(p);
  free(p);

  if( !line ) {
    memset(buf,' ',lbuf);
    *len = -1;/* return negative value on EOF */
    free(line);
    return;    
  } else {
    add_history(line);
    *len = strlen(line);
  }

  for( i = 0, p = buf; i<lbuf; i++,p++ ) {
    *p = ' ';
  }

  if( *len <= lbuf ) {
    strcpy(buf,line);
    *(buf+(*len)) = ' ';
  } else {
    strncpy(buf,line,lbuf);
    *(buf+lbuf) = ' ';
  }

  free(line);
}
