C
C File: CLword.for
C Description: Collection of string manipulation routines
C Author: A.Shirahashi, Univ. of Tokyo
C
C History: 7-Oct-1992, CLword, CLpart: quotation
C
C Public: CLword, CLpart, CLsubp
C
C Subroutine: CLword
C Description: divede the string 'S' into the words delimiter by any one
C              character in the string 'D' into the array of strings 'W'.
C
      Subroutine CLword( S,D,N,W )
C
      Implicit None 
C
      Character * 1  SQ, DQ
      Parameter( SQ = '\'', DQ = '\"' )
C input
      Character * (*)  S, D
C output
      Character * (*)  W(*)
      Integer  N
C local
      Integer  L, I, J
      Character * 1  quote
C begin
      L = Len( S )
      I = 0
      N = 0
 100  Continue
      I = I + 1
      If( I.gt.L ) Return
      If( Index( D,S(I:I) ).ne.0 ) Goto 100
      J = I
      If( S(J:J).eq.SQ .or. S(J:J).eq.DQ ) Then
        quote = S(J:J)
        J = J + 1
      Else
        quote = ' '
      End If
 300  Continue
      I = I + 1
      If( I.gt.L ) Goto 310
      If( quote.eq.' ' ) Then
        If( Index( D,S(I:I) ).eq.0 ) Goto 300
      Else
        If( S(I:I).ne.quote ) Goto 300
      End If
 310  N = N + 1
      If( I-1.ge.J ) Then
        W(N) = S(J:I-1)
      Else
        W(N) = ' '
      End If
      Goto 100
C
      End
C
C Subroutine: CLpart
C Description: return the 'N'-th word in the string 'S' into 'W'.
C
      Subroutine CLpart( S,N,W )
C
      Implicit None 
C const
      Character * 1  D, SQ, DQ
      Parameter( D = ' ', SQ = '\'', DQ = '\"' )
C input
      Character * (*)  S
C output
      Character * (*)  W
      Integer  N
C local
      Integer L, I, J, N1
      Character * 1  quote
C begin
      W = ' '
      L = Len( S )
      I = 0
      N1 = 0
 100  Continue
      I = I + 1
      If( I.gt.L ) Return
      If( Index( D,S(I:I) ).ne.0 ) Goto 100
      J = I
      If( S(J:J).eq.SQ .or. S(J:J).eq.DQ ) Then
        quote = S(J:J)
        J = J + 1
      Else
        quote = ' '
      End If
 300  Continue
      I = I + 1
      If( I.gt.L ) Goto 310
      If( quote.eq.' ' ) Then
        If( Index( D,S(I:I) ).eq.0 ) Goto 300
      Else
        If( S(I:I).ne.quote ) Goto 300
      End If
 310  N1 = N1 + 1
      If( N1.eq.N ) Then
        If( I-1.ge.J ) Then
          W = S(J:I-1)
        Else
          W = ' '
        End If
        Return
      End If
      Goto 100
C
      End
C
C Subroutine: CLsubp
C Description: return the offset of the first character of 'N'-th word
C              in the string 'S' into 'I'.
C
      Subroutine CLsubp( S,N,I )
C
      Implicit None
C cont
      Character * 1  D
      Parameter( D = ' ' )
C input
      Character * (*)  S
      Integer  N
C output
      Integer  I
C local
      Integer  L, J, I1, N1
C begin
      I = 0
      L = Len( S )
      I1 = 0
      N1 = 0
 100  Continue
      I1 = I1 + 1
      If( I1.gt.L ) Return
      If( Index( D,S(I1:I1) ).ne.0 ) Goto 100
      J = I1
 300  Continue
      I1 = I1 + 1
      If( I1.gt.L ) Goto 310
      If( INDEX( D,S(I1:I1) ).eq.0 ) Goto 300
 310  N1 = N1 + 1
      If( N1.eq.N ) Then
        I = J
        Return
      End If
      Goto 100
C     
      End
