C
C File: FLGRD.FOR
C Description: set/get flags for control of command line
C Original: extracted from CHARD.FOR
C
C Entries: Linrd, Flard, Flgrd, CLerok
C
C History: 10-Jun-1992, add Clerok
C           5-Feb-1992, import CLilvl, CLilun from clgetl.f
C           4-Apr-1994, add CLIopt
C
C ---------
C   CLEROK  ...discard the remaining input
C ---------
      Subroutine CLEROK()
C
      Implicit None 
C begin
      Call Linrd(1,1)
      Return
      End
C
C ----------
C   CLILVL
C ----------
       Integer Function CLILVL*4( IDUMMY )
C
       include 'unitrd.inc'
       include 'flagrd.inc'
C
       CLILVL = LUNPTR
       Return
       End
C
C ----------
C   CLILUN
C ----------
       Subroutine CLilun( Lun )
C
       Implicit None
C
       Include 'unitrd.inc'
C output
       Integer  Lun
C begin
       Lun = LunLst(LunPtr)
       Return
       End
C
C ---------
C   LINRD   ...define flags
C ---------
      Subroutine LINRD(IFLQQ,IFCRR)
C
      Implicit None 
C common
      include 'flagrd.inc'
C input
      Integer  IFLQQ, IFCRR
C begin
      IPNT = 0
      IFLQ = IFLQQ
      IFCR = IFCRR
      Return
      End
C
C ---------
C   FLGRD     ... set flags
C ---------
      Subroutine FLGRD(IFLQQ,IFCRR)
C
      Implicit None 
C common
      include 'flagrd.inc'
C input
      Integer  IFLQQ, IFCRR
C begin
      IFLQ = IFLQQ
      IFCR = IFCRR
      Return
      End
C
C ---------
C   FLARD     ... get flags
C ---------
      Subroutine FLARD(IFLQQ,IFCRR)
C
      Implicit None 
C common
      include 'flagrd.inc'
C output
      Integer  IFLQQ, IFCRR
C begin
      IFLQQ = IFLQ
      IFCRR = IFCR
      Return
      End
C
C
      Subroutine CLIopt( Copt,Ival )
C input
      Character * (*)  Copt
      Integer  Ival
C common
      Include 'flagrd.inc'
C begin
      If( Copt.eq.'AT' ) Then
        Opt_AT = Ival
      Else If( Copt.eq.'ECHO' ) Then
        Opt_ECHO = Ival
      Else If( Copt.eq.'EOF' ) Then
        Opt_EOF = Ival
      Else
        Write(*,*) 'CLIopt: unknown option: ', Copt
      End If
C
      Return
      End
