C 
C File: INTRD.FOR
C Description: Collection of "Data input and conversion" routines
C 
C Entries: Intrd,  Fltrd,  Fdprd,  Hexrd
C          IntrdL, FltrdL, FdprdL, HexrdL
C
C Target: VAX/VMS
C
C Note: This module is machince dependent becase it uses NARGET.
C       All users are strongly recommended to use ***RDL for the
C       compatibility with UN*X version.
C
C Subroutine: Intrd
C Description: Read integer from input token stream
C
      Subroutine Intrd( Quest,Value,Minim,Maxim )
C
      Implicit None 
C constant
      include 'clidef.inc'
C input
      Character * (*) QUEST
      Integer * 4  minim, maxim
C output
      Integer * 4  VALUE
C local
      Character * 1  K
      Character * 16  ANSWER
      Real * 8  F
      Integer  I3
C function
      Integer  Narget
C begin
      I3 = NARGET()
      Goto 1
C
      Entry IntrdL( Quest,Value,Minim,Maxim )
C
      I3 = 4
      Goto 1
C
    1 Continue
      If( QUEST(1:1).eq.'?' ) VALUE = 0
      If( I3.ge.3 ) VALUE = MAX( MINIM,VALUE )
      If( I3.ge.4 ) VALUE = MIN( MAXIM,VALUE )
      Write ( ANSWER,* ) VALUE
    3 Call ARGRD(QUEST,ANSWER)
      F = VALUE
      Call NUMRD(F,10,K)
      If (K.eq.BSLA) Goto 3
      VALUE = MIN(MAX(-2147483648.D0,F),2147483647.D0)
      If (I3.ge.3) VALUE = MAX(MINIM,VALUE)
      If (I3.ge.4) VALUE = MIN(MAXIM,VALUE)
      Return
      End
C
C Subroutine: Fltrd
C Description: Read float (REAL * 4) from input token stream
C
      Subroutine Fltrd( QUEST,VALUE,MINIM,MAXIM )
C
      Implicit None 
C constant
      include 'clidef.inc'
C input
      Character * (*) QUEST
      Real * 4  minim, maxim
C output
      Real * 4  VALUE
C local
      Character * 1  K
      Character * 16  ANSWER
      Real * 8  F
      Integer  I3
C function
      Integer  Narget
C begin
      I3 = NARGET()
      Goto 1
C
      Entry FltrdL( QUEST,VALUE,MINIM,MAXIM )
C
      I3 = 4
      Goto 1
C
    1 Continue
      If (QUEST(1:1).eq.'?') VALUE = 0
      If (I3.ge.3) VALUE = MAX(MINIM,VALUE)
      If (I3.ge.4) VALUE = MIN(MAXIM,VALUE)
      Call CLftoa( value, answer )
      If (ANSWER(12:16).eq.'0E+00') ANSWER(12:16) = ' '
    3 Call ARGRD(QUEST,ANSWER)
      F = VALUE
      Call NUMRD(F,10,K)
      If (K.eq.BSLA) Goto 3
      VALUE = F
      If (I3.ge.3) VALUE = MAX(MINIM,VALUE)
      If (I3.ge.4) VALUE = MIN(MAXIM,VALUE)
      Return
      End
C
C Subroutine: Fdprd
C Description: Read double (REAL * 8) from input token stream
C
      Subroutine FDPRD( QUEST,VALUE,MINI,MAXI )
C
      Implicit None 
C constant
      include 'clidef.inc'
C input
      Character * (*) QUEST
      Real * 8  mini, maxi
C output
      Real * 8  VALUE
C local
      Character * 1  K
      Character * 16  ANSWER
      Real * 8  F
      Integer  I3
C function
      Integer  Narget
C begin
      I3 = NARGET()
      Goto 1
C
      Entry FDPRDL( QUEST,VALUE,MINI,MAXI )
C
      I3 = 4
      Goto 1

    1 Continue
      If (QUEST(1:1).eq.'?') VALUE = 0.0D0
      If (I3.ge.3) VALUE = MAX(MINI,VALUE)
      If (I3.ge.4) VALUE = MIN(MAXI,VALUE)
C     Write (ANSWER,101) VALUE
C 101 Format (1PG16.6)
C     If (ANSWER(12:16).eq.'0E+00') ANSWER(12:16) = ' '
      Call CLdtoa(value,answer)
    3 Call ARGRD(QUEST,ANSWER)
      F = VALUE
      Call NUMRD(F,10,K)
      If (K.eq.BSLA) Goto 3
      VALUE = F
      If (I3.ge.3) VALUE = MAX(MINI,VALUE)
      If (I3.ge.4) VALUE = MIN(MAXI,VALUE)
      Return
      End
C
C Subroutine: Hexrd
C Description: Read hexadecimal from input token stream
C
      Subroutine HEXRD( QUEST,VALUE,MINIM,MAXIM )
C
      Implicit None 
C constant
      include 'clidef.inc'
C input
      Character * (*) QUEST
      Integer * 4  minim, maxim
C output
      Integer * 4  VALUE
C local
      Character * 1  K
      Character * 16  ANSWER
      Real * 8  F
      Integer  I3
C function
      Integer  Narget
C begin
      I3 = NARGET()
      Goto 1
C
      Entry HEXRDL( QUEST,VALUE,MINIM,MAXIM )
C
      I3 = 4
      Goto 1
C
    1 Continue
      If( QUEST(1:1).eq.'?' ) VALUE = 0
      If( I3.ge.3 ) VALUE = MAX( MINIM,VALUE )
      If( I3.ge.4 ) VALUE = MIN( MAXIM,VALUE )
      Write ( ANSWER,101 ) VALUE
  101 Format (I16)
    3 Call ARGRD(QUEST,ANSWER)
      F = VALUE
      Call NUMRD(F,16,K)
      If (K.eq.BSLA) Goto 3
      VALUE = MIN(MAX(-2147483648.D0,F),2147483647.D0)
      If (I3.ge.3) VALUE = MAX(MINIM,VALUE)
      If (I3.ge.4) VALUE = MIN(MAXIM,VALUE)
      Return
      End
