C
C File: miscunix.f
C Description: Miscellaneous I/O routines for UNIX
C
C History: 1-Apr-1994, add CLsigI, CLsigC, CLsigR, CLsigX, CLsigF
C                      remove dummy routines
C
      Logical  Function  IFTSS()
C
      IFTSS = .TRUE.
C
      Return
      End
C
C
      Logical Function CLitty()
C
      Logical fisatty
C begin
      CLitty = fisatty(0)
      Return
      End
C
C
      Subroutine CLowrt( filename )
C
C     ... delete a file to be overwritten (for UNIX)
C const
      Include 'clidef.inc'
C input
      Character * (*)  filename
C local
      Logical  fexist, yes
      Character * 80   String
C begin
      L = Lenrd(filename)
      String = filename
      Inquire( File=filename(:L),Exist=fexist,Err=900 )
CDEBUGWrite(*,*) 'CLowrt:',filename(:L),':',fexist
      If( fexist ) Then
        yes = .False.
        Call Affirm( 
     &    QUOTE//string(:L)//QUOTE//' already exists, delete',yes)
        If( yes ) Then
          Call fdelete( filename(:L) ) 
        End If
      End If
 900  Continue
      Return
      End
C
C
      Integer Function CLgetc( buffer,length )
C
C output
      Character * (*)  buffer
      Integer  length
C begin
      Write(*,*) 'miscunix: CLgetc: not yet implemented.'
      CLgetc = 0
      Return
      End
C
C
      Subroutine Clsyso( Lun, File, Stat, status )
C ... open stdin/stdout for redirection, or open a formatted file
      Implicit None
C input
      Integer  Lun
      Character * (*)  File, Stat
C output
      Integer status
C local
      Integer  fh, fhin, fhout, Lfile
      Character * 80  refile
      Save  fhin, fhout, refile
      Data refile / ' ' /
C function
      Integer  Fredirect, Lenrd
C begin
      If( Lun.eq.5 .and. 
     &    (File.eq.'SYS$INPUT' .or. File.eq.'/dev/stdin') ) Then
         Call Frestore(0,fhin)
      Else If( Lun.eq.6 .and.
     &         (File.eq.'SYS$OUTPUT' .or. File.eq.'/dev/stdout') ) Then
        If( fhout.gt.0 ) Then
          Call Fflush(1)
          Call Frestore(1,fhout)
          fhout = 0
        End If
        If( Stat(1:1).ne.' ' ) Then
          Refile = ' '
        End If
      Else If( Lun.eq.6 .and. 
     &         (File.eq.'NLA0:' .or. File.eq.'/dev/null') ) Then
        fhout = Fredirect(1,'/dev/null','w')
      Else If( Lun.eq.6 ) Then
        If( File(1:1).ne.' ' ) Then
          Call Fflush(1)
          refile = File
          Lfile = Lenrd(refile)
          If( Stat(1:1).eq.'A' .or. Stat(1:1).eq.'a' ) Then
            fh = Fredirect(1,refile(:Lfile),'a')
          Else
            fh = Fredirect(1,refile(:Lfile),'w')
          End If
          If( fh.gt.0 ) fhout = fh
        Else If( Refile(1:1).ne.' ' ) Then
          Call Fflush(1)
          Lfile = Lenrd(refile)
          fh = Fredirect(1,refile(:Lfile),'a')
          If( fh.gt.0 ) fhout = fh
        End If
      Else If( Lun.ne.6 ) Then
        If( stat(1:1).eq.'A' .or. stat.eq.'a' ) Then
          Open( Unit=Lun,File=File,Status='OLD',
     &          Access='APPEND',Err=900 )
        Else If( stat(1:1).eq.'W' .or. stat(1:1).eq.'w' ) Then
          Open( Unit=Lun,File=File,Status='NEW',
     &          Form='FORMATTED',Err=900 )
        Else
          Write(*,*) 'CLsyso: unknown mode: ', stat
          Goto 900
        End If     
      Else
        Write(*,*) 'CLsyso: unknown device: ', File, ' for LUN ', Lun
        Goto 900
      End If
C
      status = 0
      Return
C
 900  Continue
      status = -1
      Return
      End
C
C
      Subroutine IPFCMD( IRET1, IRET2, COMAND, LCMD )
C
C ARG
      Integer  IRET1, IRET2, LCMD
      Character * (*)  COMAND
C
C BEGIN
      Call fsystem( Comand(:Lcmd) )
      IRET2 = IRET1
      Return
      End
C
C
      Subroutine CLexec( comand,input,output )
C
      Implicit None
C input
      Character * (*)  comand, input, output
C local
      Integer  Lcom, Lin, Lout
      Character * 128  cmdline
C function
      Integer  Lenrd
C begin
      Lcom = Lenrd(comand)
      Lin = Lenrd(input)
      Lout = Lenrd(output)
C
      cmdline(:Lcom) = comand(:Lcom)
C      
      If( Lin.gt.0 ) Then
        cmdline(Lcom+1:Lcom+Lin+2) = ' <'//input(:Lin)
        Lcom = Lcom + Lin + 2
      End If
C
      If( Lout.gt.0 ) Then
        cmdline(Lcom+1:Lcom+Lout+2) = ' >'//output(:Lout)
        Lcom = Lcom + Lout + 2
      End If
C
CDEBUGWrite(*,*) Lin,Lout,Lcom,'[',cmdline(:Lcom),']'
C
      Call fsystem( cmdline(:Lcom) )
      Return
      End
C
C
      Subroutine CLfdel( file )
C
C input
      Character * (*)  file
C begin
CDEBUGWrite(*,*) 'CLfdel:file=[',file,']'
      Call fdelete( file )
      Return
      End
C
C
      Subroutine STRUPC( LEN, STRING )
C
C ARG
      Integer  LEN
      Character * (*)  STRING
C LOCAL
      Integer  I
C
C BEGIN
CVMS      CALL STR$UPCASE( STRING,STRING(:LEN) )
      Do I = 1, LEN
	If( STRING(I:I).ge.'a' .and. STRING(I:I).le.'z' ) Then
	  STRING(I:I) = Char( Ichar(STRING(I:I))
     &                        - Ichar('a') + Ichar('A') )
	End If
      End Do
      Return
      End
C
C
      Subroutine TPUT( BUFFER,LENGTH,MODE,IRET )
C
C ARG
      Character * (*)  BUFFER, MODE
      Integer  LENGTH, IRET
C
C BEGIN
      Write(*,*) '*TPUT'
      Return
      End
C
C
      Subroutine TGET( BUFFER, LBUF, MODE, IRET, LRET )
C
C ARG
      Character * (*)  BUFFER, MODE
      Integer  LBUF, IRET, LRET
C
C BEGIN
      Write(*,*) '*TGET'
      Return
      End
C
C
      Logical  Function  IFATN()
C
      IFATN = .FALSE.
      Return
      End
C
C
      Subroutine  RSTATN()
C
      Return
      End
C
C
      Subroutine CLmkpn( name, path, Lpath )
C
      Implicit None
C common
      Common /CLENV1/ prefix
      Character * 80  prefix
      Common /CLENV2/ Lpref
      Integer  Lpref
C input
      Character * (*) name
C output
      Character * (*) path
      Integer  Lpath
C local
      Integer  Lname
C function
      Integer  Lenrd
C data
      Data prefix / ' ' /
      Data Lpref / 0 /
C begin
      If( Lpref.eq.0 ) Goto 100
      Call GetEnv( prefix(:Lpref),path )
      Lpath = Lenrd( path )
      If( Lpath.eq.0 ) Goto 100
      If( path(Lpath:Lpath).ne.'/' ) Then
        Lpath = Lpath + 1
        path(Lpath:Lpath) = '/'
      End If
      Lname = Lenrd( name )
      path(Lpath+1:Lpath+Lname) = name(:Lname)
      Lpath = Lpath + Lname
      Return
C
 100  Lpath = Lenrd( name )
      path(:Lpath) = name(:Lpath)
      path(Lpath+1:) = ' '
      Return
      End
C
C
      Subroutine CLpath( prenv )
C 
      Implicit None
C input
      Character * (*)  prenv
C common
      Common /CLENV1/ prefix
      Character * 80  prefix
      Common /CLENV2/ Lpref
      Integer  Lpref
C function
      Integer  Lenrd
C begin
      Lpref = Lenrd( prenv )
      prefix(:Lpref) = prenv(:Lpref)
      Return
      End
C
C
      Subroutine  LISTC( INPUT,OUTPUT,NO )
C
C ARG
      Integer * 4      NO
      Character * (*)  INPUT, OUTPUT(*)
C
C VAR
      Integer * 4  ICONT
      Integer * 4  Dirp, Status
      Character * 80  Buffer
C function
      Integer  OPENDIR, READDIR
C begin
      ICONT = 0
      NMAX = NO
      NO = 0
      Dirp = OPENDIR(INPUT)
C     Write(*,*) 'DIRP=',Dirp
      If( Dirp.eq.0 ) Return
100   Continue
      If( NO.ge.NMAX ) Goto 900
      Status = READDIR( Dirp,Buffer )
C     Write(*,*) 'Status, Buffer =',Status, ', ', Buffer
      IF( Status.eq.0 ) Goto 900
      NO = NO + 1
      Output(NO) = Buffer
      Goto 100
900   Continue
      Call CLOSEDIR(Dirp)
      Return
      End
C
C
      Subroutine FILTYPE(FILE,EXT)
C
C ARG
      Character * (*)  FILE, EXT
C function
      Integer  CLrchr, Lenrd
C BEGIN
      I = CLrchr( File,'/' )
      J = Index( File(I+1:),'.' )
      IF( J .EQ. 0 ) THEN
        L = Lenrd( File )
        IF( EXT(1:1).EQ.'.' ) THEN
          File(L+1:) = EXT
        ELSE
          File(L+1:) = '.'//EXT
        END IF
      END IF
C
      Return
      End
C
C
      Subroutine CLsigI( signum )
C     ... establish signal hander
C input
      Integer signum
C common
      Common /CLsign/ sigsts, sigold
      Logical sigsts
      Integer sigold
C function
      Integer  Fsignal
      External CLsigH
C begin
      sigsts = .FALSE.
      sigold = Fsignal( signum,CLsigH,-1 )
      Return
      End
C
C
      Logical Function CLsigC( signum )
C     ... check if signal occured
C input
      Integer  signum
C common
      Common /CLsign/ sigsts,sigold
      Logical sigsts
      Integer sigold
C begin
      CLsigC = sigsts
      Return
      End
C
C
      Subroutine CLsigR( signum )
C     ... reset signal flag
C input
      Integer  signum
C common
      Common /CLsign/ sigsts,sigold
      Logical sigsts
      Integer sigold
C begin
      sigsts = .FALSE.
      Return
      End
C
C
      Subroutine CLsigX( signum )
C     ... restore original signal handler
C input
      Integer  signum
C local
      Integer  junk
C function
      Integer  Fsignal
C begin
      junk = Fsignal( signum, 0, sigold )
      Return
      End
C
C
      Subroutine CLsigH( signum )
C     ... signal handler
      Integer  signum
C common
      Common /CLsign/ sigsts,sigold
      Logical sigsts
      Integer sigold
C begin
      sigsts = .TRUE.
      Return
      End
C
C
      Subroutine CLsigF( signum,sigsub )
C     ... establish signal hander
C input
      Integer signum
      External sigsub
C common
      Common /CLsign/ sigsts, sigold
      Logical sigsts
      Integer sigold
C function
      Integer  Fsignal
C begin
      sigold = Fsignal( signum,sigsub,-1 )
      Return
      End
