C
C File: miscvms.for
C Description: Miscellaneous Routines for VAX/VMS version
C
C History: 15-Jun-1992, rename ISATTY -> CLITTY
C          27-Aug-1992, CLsyso Append mode
C          25-Sep-1992, CLputL
C          14-Jan-1993, CLsyso: CarriageControl='LIST'
C           4-Feb-1993, add CLexec, CLfdel
C           1-Apr-1994, add CLsigI, CLsigC, CLsigR, CLsigX, CLsigF
C
      Logical  Function  IFTSS()
C
      Include '($JPIDEF)'
C
      Integer * 4  IRET
C      
C BEGIN
      Call LIB$GETJPI( JPI$_MODE,,,IRET )
C
      If( IRET .eq. JPI$K_INTERACTIVE ) Then
        IFTSS = .TRUE.
      Else
        IFTSS = .FALSE.
      End If
C
      Return
      End
C
C
      Logical Function CLITTY()
C
      Include '($DVIDEF)'
C
C VAR
      Character * 64  DEVNAM
C
C BEGIN
      Call LIB$SYS_TRNLOG( 'SYS$INPUT',L,DEVNAM )
      Call LIB$GETDVI( DVI$_FOD,,DEVNAM(:L),IRET )
      If( IRET.eq.0 ) Then
        CLITTY = .TRUE.
      Else
        CLITTY = .FALSE.
      End If
C
      Return
      End
C
C
      Integer Function LUNTTY()
C
C VAR
      Integer  LUN
C
C BEGIN
      Call LIB$GET_LUN( LUN )
      OPEN( UNIT=LUN,FILE='SYS$COMMAND',STATUS='OLD' )
      LUNTTY = LUN
C
      Return
      End
C
C
      Subroutine CLputL( Lun, String )
C
      Implicit None
C input
      Integer  Lun
      Character * (*)  String
C begin
      Write(Lun,'(1H ,A)') String
      Return
      End
C
C
      Subroutine CLsyso( Lun, File, Stat, status )
C ... open stdin/stdout for redirection, or open a formatted file
C input
      Integer  Lun
      Character * (*)  File, Stat
C output
      Integer  status
C begin
      If( Stat(1:1).eq.'A' .or. Stat.eq.'a' ) Then
        Open( Unit=Lun,File=File,Status='OLD',Access='APPEND',
     &        Err=900 )
      Else
        If( File.eq.'SYS$OUTPUT' ) Then
          Open( Unit=Lun,File=File,Status=Stat,Err=900 )
        Else If( stat(1:1).eq.'W' .or. stat(1:1).eq.'w' ) Then
          Open( Unit=Lun,File=File,Status='NEW',
     &          Form='FORMATTED',CarriageControl='LIST',Err=900 )
        Else
          Open( Unit=Lun,File=File,Status=Stat,
     &          Form='FORMATTED',CarriageControl='LIST',Err=900 )
        End If     
      End If
C
      status = 0
      Return
C
900   Continue 
      status = -1
      Return
      End
C
C
      Subroutine CLowrt( File )
C
C     ... delete a file to be overwritten (just DUMMY for VMS)
C input
      Character * (*)  File
C begin
      Return
      End
C
C
      Integer Function CLGETC( LINE,LAST )
C
C ARG
      Character * (*)  LINE
      Integer * 4  LAST
C
C BEGIN
      Call LIB$GET_COMMAND( LINE,, LAST )
      CLGETC = 0
      Return
      End
C
      Subroutine IPFCMD( IRET1, IRET2, COMAND, LCMD )
C
C ARG
      Integer  IRET1, IRET2, LCMD
      Character * (*)  COMAND
C
C BEGIN
      Call LIB$SPAWN( COMAND(:LCMD),,,,,IRET1 )
      IRET2 = IRET1
      Return
      End
C
C
      Subroutine CLexec( comand,input,output )
C
      Implicit None
C input
      Character * (*)  comand, input, output
C local
      Integer  Lin, Lout
      Character * 64  infile, outfile
C function
      Integer  Lenrd
C begin
      Lin = Lenrd(input)
      Lout = Lenrd(output)
C
      If( Lin.gt.0 ) Then
        infile(:Lin) = input(:Lin)
      Else If( Lout.eq.0 ) Then
        infile = 'SYS$INPUT'
        Lin = Lenrd(infile)
      Else
        infile = 'NL:'
        Lin = Lenrd(infile)
      End If
C
      If( Lout.gt.0 ) Then
        outfile(:Lout) = output(:Lout)
      Else
        outfile = 'SYS$OUTPUT'
        Lout = Lenrd(outfile)
      End If
C
CDEBUGWrite(*,*) 'exec: comand=[',comand,']'
CDEBUGWrite(*,*) 'exec: input=[',infile(:Lin),']'
CDEBUGWrite(*,*) 'exec: output=[',outfile(:Lout),']'
C
      Call LIB$SPAWN( comand, infile(:Lin), outfile(:Lout) )
      Return
      End
C
C
      Subroutine CLfdel( file )
C
      Implicit None
C input
      Character * (*)  file
C local
      Integer  L
C function
      Integer  Lenrd
C begin
      L = Lenrd(file)
      If( Index(file(:L),';') .eq. 0 ) Then
        Call LIB$DELETE_FILE( file(:L)//';*' )
      Else
        Call LIB$DELETE_FILE( file )
      End If
C
      Return
      End
C
C
      Subroutine PROMPT( STRING )
C
C ARG
      Character * (*)  STRING
C
C BEGIN
      Write( *,'(1H$A)' ) STRING
C
      Return
      End
C
C
      Subroutine STRUPC( LEN, STRING )
C
C ARG
      Integer  LEN
      Character * (*)  STRING
C
C BEGIN
C     Call STR$UPCASE( STRING,STRING(:LEN) )
C
      Do I = 1, LEN
	If( STRING(I:I).ge.'a' .and. STRING(I:I).le.'z' ) Then
	  STRING(I:I) = Char( Ichar(STRING(I:I))
     &                        - Ichar('a') + Ichar('A') )
	End If
      End Do
C
      Return
      End
C
C
      Subroutine TPUT( BUFFER,LENGTH,MODE,IRET )
C
C ARG
      Character * (*)  BUFFER, MODE
      Integer  LENGTH, IRET
C
C BEGIN
      Write(*,*) '*TPUT'
      Return
      End
C
C
      Subroutine TGET( BUFFER, LBUF, MODE, IRET, LRET )
C
C ARG
      Character * (*)  BUFFER, MODE
      Integer  LBUF, IRET, LRET
C
C BEGIN
      Write(*,*) '*TGET'
      Return
      End
C
C
      Logical  Function  IFATN()
C
      IFATN = .FALSE.
      Return
      End
C
C
      Subroutine  RSTATN()
C
      Return
      End
C
C
      Subroutine CLmkpn( name, path, Lpath )
C
      Implicit None
C common
      Common /CLENV1/ prefix
      Character * 80  prefix
      Common /CLENV2/ Lpref
      Integer  Lpref
C input
      Character * (*) name
C output
      Character * (*) path
      Integer  Lpath
C local
      Integer  Lname
C function
      Integer  Lenrd
C data
      Data prefix / ' ' /
      Data Lpref / 0 /
C begin
      Lpath = Lpref
      path(:Lpath) = prefix(:Lpref)
      Lpath = Lpath + 1
      path(Lpath:Lpath) = ':'
      Lname = Lenrd( name )
      path(Lpath+1:Lpath+Lname) = name(:Lname)
      Lpath = Lpath + Lname
      Return
C
      End
C
C
      Subroutine CLpath( prenv )
C 
      Implicit None
C input
      Character * (*)  prenv
C common
      Common /CLENV1/ prefix
      Character * 80  prefix
      Common /CLENV2/ Lpref
      Integer  Lpref
C function
      Integer  Lenrd
C begin
      Lpref = Lenrd( prenv )
      prefix(:Lpref) = prenv(:Lpref)
      Return
      End
C
C
      Subroutine  LISTC( INPUT,OUTPUT,NO )
C
C ARG
      Integer * 4      NO
      Character * (*)  INPUT, OUTPUT(1)
C
C VAR
      Integer * 4  ICONT
C
C BEGIN
      ICONT = 0
      NMAX = NO
      NO = 0
100   Continue
      If( NO.ge.NMAX ) Goto 900
      ISTAT = LIB$FIND_FILE( INPUT,OUTPUT(NO+1),ICONT )
      If( .not. BJTEST( ISTAT,0 ) ) Goto 900
      NO = NO + 1
      Goto 100
900   Continue
      Call LIB$FIND_FILE_END( ICONT )
      Return
      End
C
C
C Misc. library
C
      Subroutine FILTYPE( FILE,EXT )
C
C ARG
      Character * (*)  FILE, EXT
C
C BEGIN
      I = INDEX( FILE,']' )
      J = INDEX( FILE(I+1:),'.' )
      If( J .eq. 0 ) Then
        L = LENRD( FILE )
        If( EXT(1:1).eq.'.' ) Then
          FILE(L+1:) = EXT
        Else
          FILE(L+1:) = '.'//EXT
        End If
      End If
C
      Return
      End
C
C
      Subroutine CLsigI( signum )
C     ... establish signal hander
C input
      Integer signum
C common
      Common /CLsign/ sigsts, sigold
      Logical sigsts
      Integer sigold
C function
      External CLsigH
C begin
      sigsts = .FALSE.
      Call CLsigF( signum,CLsigH )
      Return
      End
C
C
      Logical Function CLsigC( signum )
C     ... check if signal occured
C input
      Integer  signum
C common
      Common /CLsign/ sigsts,sigold
      Logical sigsts
      Integer sigold
C begin
      CLsigC = sigsts
      Return
      End
C
C
      Subroutine CLsigR( signum )
C     ... reset signal flag
C input
      Integer  signum
C common
      Common /CLsign/ sigsts,sigold
      Logical sigsts
      Integer sigold
C begin
      sigsts = .FALSE.
      Return
      End
C
C
      Subroutine CLsigX( signum )
C     ... restore original signal handler
C input
      Integer  signum
C local
      Integer  junk
C begin
      Return
      End
C
C
      Subroutine CLsigH( signum )
C     ... signal handler
      Integer  signum
C common
      Common /CLsign/ sigsts,sigold
      Logical sigsts
      Integer sigold
C begin
      sigsts = .TRUE.
      Return
      End
C
C
      Subroutine CLsigF( signum,sigsub )
C     ... establish signal hander
C input
      Integer signum
      External sigsub
C common
      Common /CLsign/ sigsts, sigold, sigadr
      Logical sigsts
      Integer sigold, sigadr
C local
      Integer * 4  ttchan
      Integer * 2  iosb(4)
C function
      External CLsigvms_handler
C begin
      Call CLsigvms_extsub(sigadr,%LOC(sigsub))
      Call CLsigvms_establish
C
      Return
      End
C
C
      Subroutine CLsigvms_handler
C
      Implicit None
C common
      Common /CLsign/ sigsts, sigold, sigadr
      Logical sigsts
      Integer sigold, sigadr
C local
      Integer * 4  ttchan
      Integer * 2  iosb(4)
C begin
      sigsts = .TRUE.
      If( sigadr.ne.0 ) Then
        Call CLsigvms_callsub(%VAL(sigadr))
      End If
C
      Call CLsigvms_establish
C
      Return
      End
C
C
      Subroutine CLsigvms_establish
C header
      Include '($IODEF)'
C local
      Integer * 4  ttchan
      Integer * 2  iosb(2)
C function
      External  CLsigvms_handler
C begin
      Call SYS$ASSIGN( 'TT',ttchan,, )
      Call SYS$QIO( , %VAL(ttchan),
     &                %VAL( IO$_SETMODE+IO$M_CTRLCAST ),
     &                iosb,,,
     &                CLsigvms_handler,,,,, )
C
      Return
      End
C
C
      Subroutine CLsigvms_extsub(address,routine)
C
      Integer * 4  address, routine
C begin
      address = routine
      Return
      End
C
C
      Subroutine CLsigvms_callsub(address)
C
      Implicit None
C
      External  address
C
      Call Address( 2 )
      Return
      End
