
C   04/12/86 810282314  MEMBER NAME  QOPEN    (FORT)     M  FORTRAN
C
C THIS MODULE IS HEAVILY MACHINE DEPENDENT.
C
CC*********************************************************************
C*
C*  LOGICAL FUNCTION QOPEN( PROMPT,LUN,DSNAME,MODE,FRM,STS,
C*                          /ICONT/,/SELECT/ )
C*
C*
C*  (Purpose) Inquire filename on console and open it
C*
C*  (Input)  CHARACTER * (*)  PROMPT   prompt string, CLI convention
C*           INTEGER   *   4  LUN      logical unit number
C*                                     if LUN < 0, QOPEN will NOT open
C*                                     specified dataset actually.
C*           CHARACTER * (*)  MODE     'READ', 'WRITE', 'BOTH', 'DIRECT'
C*           CHARACTER * (*)  FRM      'UNFORMATTED', 'FORMATTED'
C*           CHARACTER * (*)  STS      'OLD', 'NEW', 'SHR', 'UNKNOWN'
C*
C*  (Input/Output)
C*           CHARACTER * (*)  DSNAME   (In)  default dataset name
C*                                     (Out) name of opened dataset
C*           INTEGER   *  4   ICONT    Context switch
C*                                     must be 0 for first call
C*
C*  (Output)
C*           CHARACTER * (*)  SELECT   Command string used to select
C*                                     this dataset.
C*
C*  (Function Value) .True. for successful completion
C*                   .False. for can't open
C*
C*  (Screen mode)  If first character of PROMPT or DSNAME is '$',
C*
C*  (Relation)  Calls XOPEN, YOPEN
C*
C*  (Author)  A.Shirahahsi, Univ. of Tokyo
C*  (Date)    4-Dec-1986
C*            5-Sep-1987, full screen version
C*           13-Mar-1988, FB format
C*           20-Sep-1988, return SELECT
C*           29-Sep-1988, VBS format
C*
C*           16-Jun-1992, DIRECT access file
C*            2-Jul-1992, fix a bug for negative LUN, DIRECT=recl
C*
CC**********************************************************************
C
C     Logical Function QOPEN( PROMPT,LUN,DSNAME,MODE,FRM,STS,
C    &                        ICONT )
C
      Logical Function Qopen( Prompt,Lun,Dsname,Mode,Frm,Sts )
C
C ARG
C     (Input)
      Character * (*)  PROMPT
      Integer   *   4  LUN
      Character * (*)  MODE, FRM, STS
C     (Input/Output)
      Character * (*)  DSNAME
      Integer   *   4  ICONT
C
C VAR
      Integer * 4  ILOG, IMODE, LDS
      Character *  6  SSEL
      SAVE  IMODE
C
C FUNC
      Integer * 4  CLILOG
      Logical * 4  XOPEN
C
C BEGIN
C     NARGC = NARGET()
      NARGC = 6
      If( NARGC .ge. 7 ) Then
        IICONT = ICONT
      Else
        IICONT = 0
      End If
C
C     ... have CLI to stop logging
      ILOG = CLILOG( 0 )
C
      SSEL = ' '
C
      Call TXTRD( PROMPT,DSNAME )
      ILOG = CLILOG( 0 )
      IMODE = 0
      QOPEN = XOPEN( LUN,DSNAME,MODE,FRM,STS )
C
      If( ILOG.eq.1 ) Then
        LDS = LENRD( DSNAME )
        Call CLWLOG( DSNAME(:LDS) )
      End If
C
C     ... restore CLI logging mode
      ILOG = CLILOG( 1 )
C
      If( NARGC .ge. 7 ) Then
        If( IMODE .eq. 0 ) Then
          ICONT = 1
        Else
          ICONT = 2
        End If
      End If
C
C
      Return
      End
C
CC**********************************************************************
C
C  LOGICAL FUNCTION XOPEN(LUN,DSNAME,MODE,FRM,STS )
C
C  (Purpose) Open dataset
c            when '*' is included in the filename, datasets are searched
C            that match the given name and inquire on the console which
C            dataset to be selected.
C
C (Input)    LUN     logical unit number
C                    if LUN < 0, XOPEN will NOT open the dataset
C            MODE    'READ' / 'WRITE' / 'DIRECT'
C            FRM     'UNFORMATTED' / 'FORMATTED'
C            STS     'OLD' / 'NEW' / 'SHR' / 'UNKNOWN'
C (In/Out)   DSNAME  (In)  dataset name to be opened
C                    (Out) dataset name to have been opened
C (Output)   Function return value  .True.  = Succesful Completion
C                                   .False. = Can't Open
C
C (Author)   A.Shirahasi, Univ. of Tokyo
C (Date)     18-Nov-1986
C (Update)   3-Dec-1986, bug fixed
C            4-Dec-1986, change for QOPEN
C
C           16-Jun-1992, DIRECT access file
C            2-Jul-1992, fix a bug for negative LUN, DIRECT=recl
C
CC**********************************************************************
C
        Logical Function XOPEN( LUN,DSNAME,MODE,FRM,STS )
C
C ARG
        Integer   * 4    LUN
        Character * (*)  DSNAME, MODE, FRM, STS
C
C CONST
        Character * 1  SQ
        Parameter( SQ = '''' )
C
C VAR
        Character * 80  FULNAM
C
C FUNC
        Logical * 4  OPENIT
C
C BEGIN
C        If( LUN.lt.0 ) Then
C          XOPEN = .TRUE.
C          Return
C        End If
C
C
        LDS = LENRD( DSNAME )
        If( LDS .eq. 0 ) Goto 9000
C       Call STRUPC( LDS,DSNAME )
C
        Fulnam = Dsname
C
C       FULNAM = ' '
C       If( DSNAME(1:1) .eq. '.' ) Then
C         Call GETUID( FULNAM(1:4) )
C         FULNAM(5:) = DSNAME
C       Else
C         FULNAM = DSNAME
C       End If
C
        JS = INDEX( FULNAM,'*' )
        If( JS .gt. 0 ) Then
          Call CLISTC( FULNAM,LENRD(FULNAM),IERR )
          If( IERR .ne. 0 ) Goto 9000
        End If
C
        If( OPENIT( LUN,FULNAM,MODE,FRM,STS ) ) Then
          DSNAME = FULNAM
          XOPEN = .TRUE.
          Goto 9900
        End If
C
9000    XOPEN = .FALSE.
        Goto 9900
C
9900    Continue
        Return
        End
C
C
      Subroutine CLISTC( NAME,N,IERR )
C
C ARG
      Character * (*)  NAME
      Integer          N, IERR
C
C CONST
      Integer * 4  MAXDSN
      Parameter( MAXDSN = 100 )
C
C VAR
      Character * 80  DSNAME( MAXDSN )
      Integer  J, L
C
C BEGIN
      Call FINDIT( NAME,N,DSNAME,MAXDSN,NO )
      If( NO.le.0 ) Goto 9000
C
      Write( 6,'(1H )' )
      Do 10 J = 1, NO
        L = Lenrd(DSNAME(J))
        Write( 6,'(1H ,I3,1H ,A)' ) J,DSNAME(J)(:L)
10    Continue
      Write( 6,'(1H )' )
C     ... always inquire on console
      Call CLSTAR( 1 )
      Call INTRD( '?Select number',K )
      If( K .le. 0 .or. K .gt. NO ) Goto 9000
      NAME = ' '
      L = Lenrd(DSNAME(K))
      NAME = DSNAME(K)(:L)
      IERR = 0
      Return
9000  IERR = -1
      Return
      End
C
C
      Subroutine FINDIT( NAME,N,DSNAME,MAXDSN,NDSN )
C
C ARG
C     (Input)
      Character * (*)  NAME
      Integer   * 4    N, MAXDSN
C     (Output)
      Character * (*)  DSNAME( MAXDSN )
      Integer   * 4    NDSN
C
C VAR
      Character * 80   PREFIX
C
C BEGIN
C     If( N .gt. 0 ) Then
C       Call STRUPC( N,NAME )
C     End If
C
      L = N
      PREFIX(:L) = NAME(:L)
      NO = MAXDSN
      PREFIX(L+1:) = ' '
      Call LISTC( PREFIX,DSNAME,NO )
      If( NO .gt. MAXDSN ) Then
        PRINT *, '%QOPEN-W, Too many datasets'
        NO = MAXDSN
      End If
      If( NO .eq. 0 ) Goto 9000
C
C%%         PRINT *, 'L+1,L+N-M,DSNAME=',L+1,L+N-M,DSNAME(J)(L+1:L+N-M)
C%%         PRINT *, 'M+1,N,NAME=',M+1,N,NAME(M+1:N)
C
      NDSN = NO
      Return
C
9000  NDSN = 0
      Return
C
      End
C
C
      Logical Function OPENIT( LUN,DSN,MODE,FRM,STS )
C
C (Update)
C     10-Feb-88, Ask member name for PO file without member name.
C                Note: DSN may be overwritten in this routine.
C     28-Sep-88, Can create a new member in an old PO dataset.
C 
C     16-Jun-92, DIRECT access file
C      2-Jul-92, DIRECT=recl
C      3-Jul-92, LIST
C      9-Oct-92, ask overwrite in case of LUN<0
C
C ARG
C     (Input)
      Integer * 4  LUN
      Character * (*)  DSN, MODE, FRM, STS
C
C CONST
      Character * 1  SQ
      Parameter( SQ = '''' )
C
C VAR
      Character * 80  DSNAME
      Character *  6  KMODE
      Character * 11  KFRM
      Character *  7  KSTS
      Character *  4  CC
      Logical         LEXIST
      Integer   *  4  LE, Reclen
C
      Data NSPACE / 2 /
C
C BEGIN
C     LDSN = LENRD( DSN )
C     Write(*,*) 'OPENIT: LUN=',LUN,' DSN=',DSN(:LDSN)
C     Write(*,*) 'MODE,FRM,STS=',MODE,',',FRM,',',STS
C      If( LUN .lt. 0 ) Then
C        OPENIT = .TRUE.
C        Return
C      End If
C
      DSNAME = DSN
      LDSN = LENRD( DSNAME )
C
      If( MODE(1:1).eq.'R' .or. MODE(1:1).eq.'r' ) Then
        KMODE = 'READ'
      Else If( MODE(1:1).eq.'W' .or. MODE(1:1).eq.'w' ) Then
        KMODE = 'WRITE'
      Else If( MODE(1:1).eq.'B' .or. MODE(1:1).eq.'b' ) Then
        KMODE = 'BOTH'
      Else If( MODE(1:1).eq.'D' .or. MODE(1:1).eq.'d' ) Then
        KMODE = 'DIRECT'
        LE = Index(MODE,'=')
        IF( LE.gt.0 ) Then
          Read(Mode(LE+1:),*) RecLen
        Else
          RecLen = 1024
        End If
      Else
        Goto 9000
      End If
C
      LFRM = LENRD( FRM )
      If( FRM(1:1).eq.'U' .or. FRM(1:1).eq.'u' ) Then
        KFRM = 'UNFORMATTED'
      Else If( FRM(1:1).eq.'F' .or. FRM(1:1).eq.'f' ) Then
        KFRM = 'FORMATTED'
        CC = 'NONE'
      Else If( FRM(1:1).eq.'L' .or. FRM(1:1).eq.'l' ) Then
        KFRM = 'FORMATTED'
        CC = 'LIST'
      Else
        Goto 9000
      End If
C
      If( STS(1:1).eq.'N' .or. STS(1:1).eq.'n' ) Then
        KSTS = 'NEW'
      Else If( STS(1:1).eq.'O' .or. STS(1:1).eq.'o' ) Then
        KSTS = 'OLD'
      Else If( STS(1:1).eq.'S' .or. STS(1:1).eq.'s' ) Then
        KSTS = 'SHR'
      Else If( STS(1:1).eq.'U' .or. STS(1:1).eq.'u' ) Then
        KSTS = 'UNKNOWN'
      Else
        Goto 9000
      End If
C
C     If( (IDSN.eq.1 .or. IDSN.eq.3) .and. KSTS(1:3).eq.'NEW' ) Then
C       KSTS = 'OLD'
C     End If
C
C     Write(*,*) 'KMODE=',KMODE,',KFRM=',KFRM,',KSTS=',KSTS
      If( KMODE(1:1).eq.'R' ) Then
        INQUIRE( FILE=DSNAME(:LDSN),EXIST=LEXIST,ERR=9000 )
        If( .not.LEXIST ) Goto 9000
        If( Lun.gt.0 ) Then
#ifndef linux
          OPEN( UNIT=LUN,FILE=DSNAME(:LDSN),
     &          READONLY,FORM=KFRM,STATUS=KSTS,ERR=9000 )
#else
          OPEN( UNIT=LUN,FILE=DSNAME(:LDSN),
     &          FORM=KFRM,STATUS=KSTS,ERR=9000 )
#endif
        End If
      Else If( KMODE(1:1).eq.'W' .or. 
     &         KMODE(1:1).eq.'B' .or.
     &         KMODE(1:1).eq.'D' ) Then
          If( KSTS(1:3).eq.'NEW' ) Then
C           ... delete a file to be overwritten. (for UNIX)
            Call CLowrt( Dsname(:LDSN) )
          End If
	  If( KMODE(1:1).eq.'W' ) Then
            If( KFRM(1:1).eq.'U' ) Then
              If( Lun.gt.0 ) Then
                OPEN( UNIT=LUN,FILE=DSNAME(:LDSN),
     &                FORM=KFRM,STATUS=KSTS,ERR=9000 )
              End If
            Else If( KFRM(1:1).eq.'F' ) Then
              If( Lun.gt.0 ) Then
#ifndef linux
                OPEN( UNIT=LUN,FILE=DSNAME(:LDSN),Form=KFRM,
     &                STATUS=KSTS,Carriagecontrol=CC,ERR=9000 )
#else
                OPEN( UNIT=LUN,FILE=DSNAME(:LDSN),Form=KFRM,
     &                STATUS=KSTS,ERR=9000 )
#endif
              End If
            End If
          Else If( KMODE(1:1).eq.'D' ) Then
C           Write(*,*) '...trying to open direct access file.'
            If( Lun.gt.0 ) Then
              OPEN( UNIT=LUN,FILE=DSNAME(:LDSN),ACCESS='DIRECT',
     &              Recl=RecLen,FORM=KFRM,STATUS=KSTS,ERR=9000 )
            End If
          Else
            If( Lun.gt.0 ) Then
              OPEN( UNIT=LUN,FILE=DSNAME(:LDSN),
     &              FORM=KFRM,STATUS=KSTS,ERR=9000 )
            End If
          End If
      End If
C
      OPENIT = .TRUE.
      Return
C
9000  OPENIT = .FALSE.
C     Write(*,*) 'but failed.'
C     PRINT *, DSNAME
      Return
      End
