C
C File: Txtrd.for
C Descriotion: Collection of character input routines
C Date: 15-Jun-1992
C
C History: 4-Sep-1992, Titrd "title"/'title'
C         18-Jan-1993, add Optrd
C          2-Feb-1993, IntrdX: call CLitoa
C          4-Feb-1993, Txtrd rewritten: allow " for quotation
C         15-Feb-1993, Txtrd: skip preceding spaces before next text
C
C Public: Txtrd, Titrd, IntrdX, FltrdX, Optrd
C
C Subroutine: Txtrd
C Description: Read one word from input token stream
C
      Subroutine Txtrd( quest,answer )
C
      Implicit None 
C constant
      include 'clidef.inc'
C input
      Character * (*)  quest
C input/output
      Character * (*)  answer
C common
      include 'flagrd.inc'
C local
      Character K, K2, Q
      Integer   Nch, Ich
C begin
      If( quest(1:1) .eq. '?' ) answer = ' '
      Nch = Len( answer )
      Ich = 0
      Call ARGRD( quest,answer )
C
 10   Continue
      Call Chard( K,K2 )
      IF( K.eq.' ' .or. K.eq.TAB ) Goto 10
C
      IF( K.eq.CRET ) Return
C
      If( K.eq.QUOTE .or. K.eq.'"' ) Then
        Q = K
      Else
        Q = ' '
        Ich = Ich + 1
        answer(Ich:Ich) = K
      End If
C
 20   Continue
      Call Chard( K,K2 )
      If( Q.eq.' ' .and.
     &    (K.eq.CRET .or. K.eq.SPACE .or. K.eq.TAB .or.
     &     K.eq.',' .or. K.eq.'=')
     &  ) Then
        Goto 30
      End If
      If( Q.ne.' ' .and. (K.eq.Q .or. K.eq.CRET ) ) Then
        Goto 30
      End If
      Ich = Ich + 1
      If( Ich.le.Nch ) answer(Ich:Ich) = K
      Goto 20
C
 30   Continue
      If( Ich.lt.Nch ) answer(Ich+1:) = ' '
 40   Continue
        If( K2.ne.' ' .and. K2.ne.TAB ) Goto 50
        Call Chard( K,K2 )
      Goto 40
 50   Continue
      Return
      End
C
C
C Subroutine: Titrd
C Description: Read a whole line from input stream
C
      Subroutine TITRD(QUEST,ANSWER)
C
      Implicit None 
C constant
      include 'clidef.inc'
C input
      Character * (*)  quest
C input/output
      Character * (*)  answer
C local
      Character K, K2, Q
      Integer lenq, lena, ich
C function
      Integer Lenrd
C begin
      If (QUEST(1:1).eq.'?') ANSWER = ' '
      LENQ = LENRD(QUEST)
      LENA = LENRD(ANSWER)
      Call ARGRD(QUEST,ANSWER)
      ICH = 0
      Q = ' '
      Call Chard( K,K2 )
      If( K.eq.'"' .or. K.eq.QUOTE ) Then
        Q = K
      Else If( K.eq.CRET ) Then
        Return
      Else
        Ich = Ich + 1
        Answer(Ich:Ich) = K
      End If
10    Continue
        Call CHARD( K,K2 )
        If( K.eq.CRET ) Goto 20
        If( Q.ne.' ' .and. K.eq.Q ) Goto 20
        Ich = Ich + 1
        ANSWER(Ich:Ich) = K
      Goto 10
20    Continue
      If( ICH.gt.0 ) ANSWER(ICH+1:) = ' '
      Return
      End
C
C
      Subroutine IntrdX( quest,value,text )
C
      Implicit None
C input
      Character * (*)  quest
C input/output
      Integer  value
C output
      Character * (*)  text
C begin
      IF( quest(1:1).eq.'?' ) Then
        value = 0
      ELse
        text = ' ' ! why this code, I don't know
        Call CLitoa(value,text)
      End If
      Call Txtrd( quest,text )
      If( Index('0123456789+-',text(1:1)).gt.0 ) Then
        Call CLatoi( text,value )
      Else If( Index('0123456789+-',text(2:2)).gt.0 ) Then
        Call CLatoi( text(2:),value )
      End If
      Return
      End
C
C
      Subroutine FltrdX( quest,value,text )
C
      Implicit None
C input
      Character * (*)  quest
C input/output
      Real  value
C output
      Character * (*)  text
C begin
      IF( quest(1:1).eq.'?' ) Then
        value = 0.0
      ELse
        text = ' ' ! why this code, I don't know
        Call CLftoa( value,text )
      End If
      Call Txtrd( quest,text )
      If( Index('0123456789+-.',text(1:1)).gt.0 ) Then
        Call CLatof( text,value )
      Else If( Index('0123456789+-.',text(2:2)).gt.0 ) Then
        Call CLatof( text(2:),value )
      End If
      Return
      End
C
C
      Subroutine Optrd( quest,text )
C
      Implicit None
C input
      Character * (*)  quest
C input/output
      Character * (*)  text
C local
      Integer  L
C function
      Integer  Lenrd
C begin
      Call Txtrd( quest,text )
      L = Lenrd( text )
C
      If( Index('#0123456789+-.',text(1:1)).gt.0 ) Then
        Call Ugetrd( text,L )
        text = ' '
      Else
        Call Strupc( L,text )
      End If
C
      Return
      End

      
