C+
C File : HLMEDX
C Description : Calculate Median/Mode of each slice along x axis
C
C Author : Ryosuke Itoh, TOPAZ, KEK
C Date : 31 - MAY - 1990
C-
      SUBROUTINE HLMEDX
C
C
C COMMON
C
C%MACRO  'T#TP.DIS.FORT(#HPLOU)'
C	Include 'display$library:display(hplou)'
      Parameter	( NBIN2 = 50000 )
      COMMON /POUBEL/ C(NBIN2), CL(1000), CZ(1000), CE(1000), CY(1000),
     #                CG(1000), CGE (1000)
      REAL * 4      C, CL, CZ, CE, CY, CG, CGE
C
C CONST
C
      REAL * 4         DEF(3)
      DATA      DEF    /.5,.16,.84/
C
C VAR
C
      INTEGER * 4      ITIT(22)
      REAL * 4         VAL ( 3 )
      REAL * 4         X ( 11 ), Y ( 11 ), YERR ( 11 )
      REAL * 4         PARAM ( 3 ), ERR ( 3 ), CHISQ
      Character * 80   Title
C
C Func
c
      Integer * 4      DIS45_needhist,  DIS45_makehist
C
C MAIN
C
C 0. Check source hist.
C
C      IF (ICOU.EQ.0) THEN
C        IFLERR = 2
C        RETURN
C      END IF
C      IF (IDIM(ICOU).NE.2) THEN
C        IFLERR = 6
C        RETURN
C      END IF
C      CALL ERRSET ( 209, 256, 10, 1, 0, 209 )
      If ( DIS45_needhist(2,error) .le. 0 ) Return
      Call DIS45_thishist ( here, ide, dim )
C
C 1. Set up new histograms and unpack current one
C
C      IDE=IV(ICOU)
      CALL HNOENT(IDE,NOENT)
C      CALL HARGU2(IDE,ITIT,NX,DX,FX,NY,DY,FY)
      Call DIS45_hinfo2 ( Ide, Title, Nx, Dx, Fx, Ny, Dy, Fy )
      CALL HUNPAK(IDE,C,'HIST',1)
C
C      CALL HLFNID(IDT,IV(ICOU))
C      CALL HLINSR(IDT,1)
C      CALL HLMOTI('MEDX',ITIT)
      If ( DIS45_makehist ( ide, 1, idt, error ) .le. 0 ) return
      CALL HBOOK1(IDT,'MEDX '//Title,NX,DX,FX,0.0)
C
C      CALL HARGU2(IDE,ITIT,NX,DX,FX,NY,DY,FY)
C      CALL HLFNID(IDS,IV(ICOU))
C      CALL HLINSR(IDS,1)
C      CALL HLMOTI('MODX',ITIT)
      If ( DIS45_makehist ( ide, 1, ids, error ) .le. 0 ) return
      CALL HBOOK1(IDS,'MODX '//Title,NX,DX,FX,0.0)
C
C      CALL HLFNID(IDG,IV(ICOU))
C      CALL HLINSR(IDG,1)
C      CALL HLMOTI('GFIT',ITIT)
      If ( DIS45_makehist ( ide, 1, idg, error ) .le. 0 ) return
      CALL HBOOK1(IDG,'GFIT '//Title,NX,DX,FX,0.0)
C
      CALL HLFNID(IDU,Ide)
CCC   CALL HLINSR(IDU,1)
CCC      If ( DIS45_makehist ( ide, 1, idu, error ) .le. 0 ) return
      CALL HBOOK1(IDU,Title,NY,DY,FY,0.0)
C
      YBIN = ( FY - DY ) / FLOAT(NY)
C
C 2. Scan Histogram
C
      DO 10 I = 1, NX
        VALMAX = 0.0
        VALBIN = 0.0
        DO 20 J = 1, NY
          CL ( J ) = C ( I + NX*(J-1) )
          IF ( CL(J) .GT. VALMAX ) THEN
            VALMAX = CL(J)
            VALBIN = DY + YBIN*(FLOAT(J)-0.5)
            MAXBIN = J
          END IF
20      CONTINUE
        CALL HPAK ( IDU, CL )
        CALL QEVAL ( IDU, 3, VAL, DEF, ITIT, AN)
        CZ ( I ) = VAL ( 2 )
        CE ( I ) = ( VAL(3) - VAL(2) ) * 0.5 / MAX(0.001,SQRT(AN))
        CY ( I ) = VALBIN
        DO 30 J = 1, 3
          X(J) = DY + YBIN*(FLOAT(MAXBIN+J-2) - 0.5 )
          Y(J) = CL(MAXBIN+J-2)
          IF ( Y(J) .LT. 1.0E-8 ) THEN
            CG ( I ) = 0.0
            CGE ( I ) = 0.0
            GO TO 10
          END IF
          YERR(J) = SQRT(C(MAXBIN+J-3))
30      CONTINUE
        CALL PARABR ( 3, X, Y, CENTER, AMP )
        CG ( I ) = CENTER
C       PARAM ( 1 ) = VALMAX
C       PARAM ( 2 ) = 1.0
C       PARAM ( 3 ) = 0.1
C       PRINT *, 'X = ', X
C       PRINT *, 'Y = ', Y
C       PRINT *, 'PARAM = ', PARAM
CC      CALL GFIT ( 5, X, Y, YERR, PARAM, ERR, CHISQ )
C       CG ( I ) = PARAM ( 2 )
C       CGE ( I ) = ERR ( 2 )
10    CONTINUE
C
C 3. Make Median Histogram
C
      CALL HDELET ( IDU )
      CALL HPAK ( IDT, CZ )
      CALL HPAKE ( IDT, CE )
      CALL HMAXIM ( IDT ,FY )
      CALL HMINIM ( IDT, DY )
C
      CALL HPAK ( IDS, CY )
      CALL HPAKE ( IDS, CE )
      CALL HMAXIM ( IDS ,FY )
      CALL HMINIM ( IDS, DY )
C
      CALL HPAK ( IDG, CG )
C     CALL HPAKE ( IDG, CE GE )
      CALL HMAXIM ( IDG ,FY )
      CALL HMINIM ( IDG, DY )
C
      RETURN
      END
C
C
        SUBROUTINE QEVAL(ID,NVAL,VAL,DEF,ITIT,AN)
C
C ID IS THE HISTOGRAM IDENT
C THIS PROGRAM READS AN HBOOK HISTOGRAM AND FINDS THE POINTS WHERE
C DEF(I) OF THE ENTRIES ARE AT THE LEFT.
C DEF (I) ARE THE FRACTIONS OF THE ENTRIES TO BE LEFT AT THE LEFT
C FOR EXAMPLE .5 TO CALCULATE THE MEDIANE,.16 AND.84 TO CALCULATE
C 2*SIGMA.
C THE NUMBER OF VALUES TO CALCULATE IS NVAL,THE RESULT IN VAL
C
C%MACRO #HPLOU
	Parameter ( NBIN1 = 50000 )
	Parameter ( MXJUNK = 100000 )
c
	Character * 80	Title
C
        COMMON /POUBEL/ C(NBIN1),SSJUNK(MXJUNK-NBIN1)
C
        DIMENSION VAL(NVAL),DEF(NVAL),DM(10)
        DIMENSION ITIT(1)
C        CALL HARGU1(ID,ITIT,NC,DV,FV)
	Call DIS45_Hinfo1 ( Id, Title, Nc, Dv, Fv )
        CALL HUNPAK(ID,C,'HIST',0)
        AN=0.
        DO 2 I=1,NC
 2      AN=AN+C(I)
        IF(AN.LE.0)RETURN
        DO 1 I=1,NVAL
 1      DM(I)=AN*DEF(I)
        T=0.
        DO 10 I=1,NC
        TC=T+C(I)
        IF(C(I).EQ.0.) GOTO 10
        DO 11 J=1,NVAL
        IF(DM(J).GT.TC) GO TO 11
        IF(DM(J).LT.T) GO TO 11
        VAL(J)=I-1+(DM(J)-T)/C(I)
        VAL(J)=DV+VAL(J)*(FV-DV+.000001)/NC
 11     CONTINUE
        T=TC
 10     CONTINUE
        RETURN
        END
C+
C File : PARABR
C Description : Fit Parabola to 3 buckets
C
C Author : Ryosuke Itoh, Univ. of Tokyo
C Date : 14 - JUN - 1986
C-
C
C---------
C PARABR
C---------
C
      SUBROUTINE PARABR ( NDATA, X, Y, CENTER, AMPL )
C
C ARGUMENTS
C
      INTEGER * 4   NDATA
      REAL * 4      X ( 3 )
      REAL * 4      Y ( 3 )
      REAL * 4      CENTER
      REAL * 4      AMPL
C
C VARIABLES
C
      REAL * 4      UNDER1, UNDER2, UNDER3
      REAL * 4      A, B, C
C
C MAIN
C
      UNDER1 = ( X(3) - X(1) ) * ( X(1) - X(2) )
      UNDER2 = ( X(1) - X(2) ) * ( X(2) - X(3) )
      UNDER3 = ( X(2) - X(3) ) * ( X(3) - X(1) )
C
      IF ( ABS(UNDER1) .LE. 1.0E-8 ) UNDER1 = 1.0E-8
      IF ( ABS(UNDER2) .LE. 1.0E-8 ) UNDER2 = 1.0E-8
      IF ( ABS(UNDER3) .LE. 1.0E-8 ) UNDER3 = 1.0E-8
C
      A = - ( Y(1) / UNDER1 + Y(2) / UNDER2 + Y(3) / UNDER3)
      B = Y(1) * ( X(2) + X(3) ) / UNDER1 +
     #    Y(2) * ( X(3) + X(1) ) / UNDER2 +
     #    Y(3) * ( X(1) + X(2) ) / UNDER3
      C = - ( Y(1) * X(2) * X(3) / UNDER1 +
     #        Y(2) * X(3) * X(1) / UNDER2 +
     #        Y(3) * X(1) * X(2) / UNDER3 )
C
      IF ( ABS(A) .LE. 1.0E-8 ) A = 1.0E-8
      CENTER = - B / ( 2 * A )
      AMPL = C - B**2 / ( 4 * A )
C
      RETURN
      END

