

!Macro Definitions

MAINPROGRAM = DISPLAY45

INITEND_PROGRAM = DISPLAY45_INITEND

INITEND_PROGRAM_X = DISPLAY45_INITEND_X

! SYSTEM_DEPEND = DISPLAY45VMS

! Library Path

CERNLIB_PATH = LIB:[LIB.CERN.PRO.LIB]
NAG_PATH     = LIB:[LIB.NAG]
SRC_PATH     = SYS$DISK:[.SRC]
CLI_PATH     = SYS$DISK:[.CLI]
COM_PATH     = SYS$DISK:[.COM]
MIN_PATH     = SYS$DISK:[.MIN45]
SOURCE_PATH = SYS$DISK:[]

! Libraries

TOOL_LIBRARIES = $(SRC_PATH)DISPLAY45TOOL.OLB/LIB

! Minuit

MIN_TOOLS_LIB = $(MIN_PATH)MIN_TOOLS.OLB/LIB

! CERN LIB

CERN_LIBRARIES = -
            $(CERNLIB_PATH)graflib/lib,-
            $(CERNLIB_PATH)grafgks/lib,gks_olb/lib,-
            $(CERNLIB_PATH)packlib/lib,$(CERNLIB_PATH)kernlib/lib

! for DEC GKS
!CERN_LIBRARIES = -
!            $(CERNLIB_PATH)graflib/lib,-
!            $(CERNLIB_PATH)grafdgks/lib,$(CERNLIB_PATH)grafdgks/opt,-
!            $(CERNLIB_PATH)packlib/lib,$(CERNLIB_PATH)kernlib/lib

CERN_LIBRARIES_X11 = -
            $(CERNLIB_PATH)graflib/lib,-
            $(CERNLIB_PATH)grafx11/lib, $(CERNLIB_PATH)grafx11/opt,-
            $(CERNLIB_PATH)gethostname.obj,-
            $(CERNLIB_PATH)packlib/lib,$(CERNLIB_PATH)kernlib/lib

NEW_CLI_LIB = $(CLI_PATH)CLI.OLB/LIB
NEW_COM_LIB = $(COM_PATH)COM.OLB/LIB

NEW_PEP4_LIBS = $(NEW_COM_LIB),$(NEW_CLI_LIB)

NAG_LIBRARIES = $(NAG_PATH)nage$library/lib

! Full Libraries

!LIBRARIES = $(DISPLAY45_TOOL_LIBRARY),MIN45,CLI,COM
LIBRARIES = $(DISPLAY45_TOOL_LIBRARY)

LINK_LIBRARIES = $(TOOL_LIBRARIES),$(MIN_TOOLS_LIB),-
                 $(CERN_LIBRARIES),$(NEW_PEP4_LIBS),-
                 $(NAG_LIBRARIES)

LINK_LIBRARIES_X11 = $(TOOL_LIBRARIES),$(MIN_TOOLS_LIB),-
                     $(CERN_LIBRARIES_X11),-
                     $(NEW_PEP4_LIBS),$(NAG_LIBRARIES)

LINK_OPT = DISPLAY45.OPT/OPT

! Objects

USER_OBJ = sys$disk:[]UFUNC.OBJ

OBJECTS = $(MAINPROGRAM).OBJ,$(INITEND_PROGRAM).OBJ,DIS45COMAND.OBJ

OBJECTS_X11 = $(MAINPROGRAM).OBJ,$(INITEND_PROGRAM_X).OBJ,DIS45COMAND.OBJ


! Dependencies

ALL : SRC, CLI, COM, MIN45, DISPLAY45X, DISPLAY45

EXE : DISPLAY45X, DISPLAY45
	@ write sys$output "everything is now up to date"

DISPLAY45 : $(OBJECTS),$(USER_OBJ)
	LINK/EXEC=DISPLAY45 $(OBJECTS),$(LINK_LIBRARIES),$(USER_OBJ),$(LINK_OPT)

DISPLAY45X : $(OBJECTS_X11),$(USER_OBJ)
	LINK/EXEC=DISPLAY45X $(OBJECTS_X11),$(LINK_LIBRARIES_X11),$(USER_OBJ),$(LINK_OPT)

SRC :
	set def [.src]
	mms
	set def [-]

CLI : 
	set def [.cli]
	mms
	set def [-]

COM :
	set def [.com]
	mms
	set def [-]

MIN45 :
	set def [.min45]
	mms
	set def [-]

DISPLAY.HLB : COMMANDS.HLP
	LIB/REP DISPLAY.HLB COMMANDS.HLP

INSTALL :
	copy display45.exe [-.exe]ndisplay45.exe
	copy display45x.exe [-.exe]ndisplay45x.exe
	pur [-.exe]

HISTORY :
	copy aaahistory.doc [-.doc]
	copy aaahistory.doc [-.export.doc]
	pur [-.doc]
	pur [-.export.doc]

HELP :
	lib/rep display.hlb commands.hlp
	copy commands.hlp [-.doc]
	copy commands.hlp [-.export.doc]
	pur [-.doc]
	pur [-.export.doc]

UPDATE :
	copy/log/modify/since=today *.for [-.dist.src]
	purge [-.dist.src]

DIST :
	backup/list [...] [-.dist]display45.bck/save
	pur [-.dist]

