      PROGRAM DISPLAY45
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Display Program based on HBOOK4/HPLOT5
C-                         Graphic Kernel is GKS
C-
C-                         Commands are extracted from UTKDIS
C-
C-   Created   5-MAR-1992   T.Takahashi
C-              DISPLAY45_INIT,END,BODY,ERROR
C-   History:
C-      5-MAR-1992 Very Preliminary Version
C-     14-MAR-1992 A.Shirahashi: add "proy" command 
C-     23-MAR-1992 A.Shirahashi: enrich error codes
C-                               use txtrd in stead of keyrd
C-     13-Apr-1992 T.Takahashi : add "lego","opt","set"e
C-     16-Apr-1992 A.Shirahashi: add "chbn","blow" commands
C-     17-Apr-1992 T.Takahashi : add "include","minuit" commands
C-     21-Apr-1992 A.Shirahashi: add "er","noer","rer" commands
C-     23-Apr-1992 A.Shirahashi: add "del","gdel" commands
C-     24-Apr-1992 A.Shirahashi: add "surf","slix","sliy" command
C-     26-Apr-1992 T.Takahashi : add "val" command
C-     27-Apr-1992 A.Sirahashi : add "cntr" command
C-     28-Apr-1992 T.Takahashi : add "open", "close", "table" commands
C-     28-Apr-1992 T.Takahashi : add "fitga" command
C-      3-May-1992 A.Shirahashi: add "oper" command 
C-      6-May-1992 A.Shirahashi: add "renum" command
C-      7-May-1992 A.Shirahashi: add "add","sub","mul","div" commands
C-     11-May-1992 A.Shirahashi: add "ts","tc" command
C-     14-May-1992 A.Shirahahsi: add "scale","bscal","hscal","nscal"
C-     18-May-1992 T.Takahashi : add "minui"
C-     18-May-1992 N.Yamaoka   : add "dofft","fftw"
C-     19-May-1992 N.Yamaoka   : add "exp" 
C-     22-May-1992 A.Shirahashi: add "help"
C-     25-May-1992 A.Shirahashi: add "avx"
C-     27-May-1992 A.Shirahashi: add "stat"
C-      1-Jun-1992 A.Shirahashi: add "cwd"
C-      2-Jun-1992 A.Shirahashi: add "chtit", "fitus"
C-      4-Jun-1992 A.Shirahashi: add "smooth", "spline"
C-      5-Jun-1992 A.Shirahashi: add "nofn"
C-      6-Jun-1992 T.Takahashi : add "fipo"
C-      9-Jun-1992 A.Shirahashi: add "alias"
C-                             : add DISPLAY45_SETUP
C-     10-Jun-1992 A.Shirahashi: call clerok to discard error
C-     12-Jun-1992 A.Shirahashi: add "sort"
C-     16-Jun-1992 A.Shirahashi: char*5 -> char*6
C-     23-Jun-1992 A.Shirahashi: add "chwin", chbn -> chbin
C-     24-Jun-1992 A.Shirahashi: pson,psoff -> ps on/off
C-                               add "join","plot"
C-     25-Jun-1992 A.Shirahashi: change call format to HLpdef
C-     26-Jun-1992 A.Shirahashi: add "gpl","tsc"
C-     29-Jun-1992 A.Shirahashi: add "hpkc,x,a" and "wkty" (from UNIX)
C-                               Parameter()
C-                               split display45_setup.for
C-      7-Jul-1992 A.Shirahashi: display45_version
C-     13-Jul-1992 A.Shirahashi: add "higz"
C-     15-Jul-1992 A.Shirahashi: fix call to HLfitpo, add "FIEX"
C-                               add "g" (just for test)
C-                               add an arg to call to HLstore
C-     16-Jul-1992 A.Shirahashi: change call format to HLval
C-     20-Jul-1992 A.Shirahashi: HLreer -> HLrerro
C-                               HLopen, HLclose, HLtable, remove 'lunout'
C-     23-Jul-1992 A.Shirahashi: HLmove, HLnext, HLback
C-                               add "avy"
C-     27-Jul-1992 A.Shirahashi: add "residu"
C-     28-Jul-1992 A.Shirahashi: add "distri", "integr"
C-     30-Jul-1992 A.Shirahashi: add "kill"
C-      3-Aug-1992 A.Shirahashi: add "gtit", "plax"
C-      4-Aug-1992 A.Shirahashi: add "stdiff"
C-      5-Aug-1992 A.Shirahashi: plaxti -> axtit
C-      6-Aug-1992 A.Shirahashi: add "dupl"
C-     11-Aug-1992 A.Shirahashi: add "echo"
C-     17-Aug-1992 A.Shirahashi: call HLhelp('DISPLAY',error)
C-     19-Aug-1992 A.Shirahahsi: add "tuple"
C-     20-Aug-1992 A.Shirahashi: remove "tuple", add "splot", "proj1", "proj2"
C-     21-Aug-1992 A.Shirahashi: fit E|G|P|S|U
C-     25-Aug-1992 A.Shirahashi: remove "b|h|n scale"
C-     18-Sep-1992               Display45_Command
C-     29-Sep-1992               Display45_GetComand, Display45_DoComand
C-      5-Oct-1992               Display45_GetComand(Mode,...)
C-     14-Oct-1992               pakerr, exterr
C-      8-Dec-1992               add "fetx"
C-     11-Dec-1992 T.Takahashi : add EXTFUN
C-     22-Dec-1992 T.Takahashi : add RANDOM
C-     02-Jan-1993 T.Takahashi : changer length of commmand name from 6 to 8
C-     05-Jan-1993 T.Takahashi : add PACKFUN
C-      6-Jan-1993 A.S         : CNTR -> CONTOUR, PAKERR -> PACKERR
C-     18-JAN-1993 T.Takahashi : add BOOK (only 1 dim)
C-     18-JAN-1993 T.Takahashi : MUL -> MULT
C-     20-JAN-1993 A.S         : add TITLE
C-     21-JAN-1993 T.Takahashi : add RESET
C-     28-JAN-1993 A.S         : add AREA, remove KILL
C-      5-Mar-1993 A.S.        : add P
C-      8-Jun-1993 A.S.        : add BINOER (work by R.Itoh)
C-     25-Jun-1993 K.M.        : add CHEDGE (work by K.Matsuzaki)
C-     28-Jul-1993 A.S.        : Matsuzaki's mod to Minuit
C-                               Itoh's mod to Handypak
C-     11-Aug-1993 A.S.        : DIS45_User_Command
C-     28-Aug-1993 A.S.        : cd, ls
C-     10-Feb-1994 A.S.        : split DIS45_{Get,Do}Comand 
C-                                     to be generated by gencomand
C-     31-Mar-1994 A.S.        : add REPEAT command
C------------------------------------------------------------------------
      IMPLICIT NONE

      Call DISPLAY45_INIT     ! device dependent init
      Call DISPLAY45_SETUP    ! device independent init
      Call DISPLAY45_BODY     ! command loop
      Call DISPLAY45_END      ! device dependent end
C----------------------------------------------------------------------
      END
C
C DISPLAY45_VERSION
C
      Subroutine DISPLAY45_version
C
      Write(*,*) 
     &  'display45 version 1.36 (last update: 10-Feb-1995)'
      Return 
      End
C
C DISPLAY45_BODY
C
      Subroutine DISPLAY45_BODY
C
c local
      Character * 8 Cmd
      Character * 6 Prompt
      Integer error_flag, igo
C data
      Data Prompt / '?DIS> ' /
      Data error_flag / 0 /
C begin
 100  Continue
C
      Call Display45_GetComand(-3,prompt,cmd,igo)
C
      error_flag = 0
C
      If (Cmd.eq.'EXIT    ') Then
        Return
      Else If (Cmd.eq.'GLOBAL  ') Then
        Call HLglob(error_flag)
      Else If (Cmd.eq.'REPEAT  ') Then
        Call HLrepeat(error_flag)
      Else if (Cmd.eq.'MINUIT  ') Then
        Call HLminuit(error_flag)     
      Else
        Call Display45_DoComand( Cmd,error_flag )
      End If
C
C     ...show error message
      Call Display45_Error(error_flag)
C
C     ...discard the remaining input if error occured
      If( error_flag .ne. 0 ) Then
        Call CLerok
      End If
C
      Goto 100
C
      End
C
C DISPLAY45_ERROR
C
      Subroutine DISPLAY45_ERROR (error_flag)
      Implicit NONE
c input:
      Integer error_flag
c local:
      Integer MAXERR
      Parameter( MAXERR = 36 )
      Character ErrMsg( MAXERR ) * 48
C
      Data ErrMsg( 1) / 'You should fetch something'/
      Data ErrMsg( 2) / 'You should move to some id#' /
      Data ErrMsg( 3) / 'Nothing after' /
      Data ErrMsg( 4) / 'Nothing before' /
      Data ErrMsg( 5) / 'This histogram does not exist' /
      Data ErrMsg( 6) / 'Command not valid for a 1-dim histogram' /
      Data ErrMsg( 7) / 'Command not valid for a 2-dim histogram' /
      Data ErrMsg( 8) / 'Histogram empty' /
      Data ErrMsg( 9) / 'Can''t open file' /
      Data ErrMsg(10) / 'No such command' /
      Data ErrMsg(11) / 'Ambiguous command' /
      Data ErrMsg(12) / 'Dataset open error' /
      Data ErrMsg(13) / 'Too many histograms' /
      Data ErrMsg(14) / 'Insufficient buffer size' /
      Data ErrMsg(15) / 'Dimension mismatch' /
      Data ErrMsg(16) / 'Histogram already exists' /
      Data ErrMsg(17) / 'The operand hitogram does not exist' /
      Data ErrMsg(18) / 'Too many X bins: enlarge /PAWC/'/
      Data ErrMsg(19) / 'Too many Y bins: enlarge /PAWC/'/
      Data ErrMsg(20) / 'You have rejected everything' /
      Data ErrMsg(21) / 'Too many data points' /
      Data ErrMsg(22) / 'Invalid histogram ID' /
      Data ErrMsg(23) / 'Illegal option' /
      Data ErrMsg(24) / 'Too small data points' /
      Data ErrMsg(25) / 'Can not open File for output'/
      Data ErrMsg(26) / 'Nag library error'/
      Data ErrMsg(27) / 'Arithmetic error: new histogram may be wrong'/
      Data ErrMsg(28) / 'Can''t load dynamic link module' /        
      Data ErrMsg(29) / 'Command valid only for N-tuples' /
      Data ErrMsg(30) / 'Command not valid for N-tuples' /
      Data ErrMsg(31) / 'Locator out of range' /
      Data ErrMsg(32) / 'No associated function' /
      Data ErrMsg(33) / 'Different number of bins' /
      Data ErrMsg(34) / 'Parameter should be positive number'/
      Data ErrMsg(35) / 'Too many paramaters come in'/
      Data ErrMsg(36) / 'Book histogram first by BOOK command'/
C
      If (error_flag.eq.0) then
        Return
      else
	Write(*,'(1X,A,A)') '%DIS-E, ',ErrMsg(error_flag)
      Endif
      Return
      End

