.TH dis45 1 "14 Sep 1992"
.SH NAME
dis45 \- Interactive Histogram Browser
.SH SYNOPSIS
.B dis45
.RB [-options]
[
.I file
]
.SH DESCRIPTION
.LP
.B dis45
is a command-driven interactive histogram browsing program based on 
CERN libraries.
.SH OPTIONS
.TP 
.I file
a histogram file.
.IP "-1"
tell that the file has HBOOK4 (portable binary) format.
.IP "-2"
tell that the file has HBOOK4 (portable ASCII) format.
.IP "-3" 
tell that the file has HBOOK3 format.
This is default for a file with suffix \`.dsh\'.
.IP "-4"
tell that the file has HBOOK4 (native) format.
This is default for a file with suffix \`.hbk\'.
.IP "-q"
do not load a initialization file.
.IP "-v"
print version of
.B dis45
on your system.
.SH COMMANDS
.IP "ADD" 4
.br
ADD\|
.I operand-id

Add the contents of the operand histogram to the current histogram.
.IP "ALIAS" 4
.br
ALIAS\|
.I alias\|
.I command

Define an alias name for sequence of commands.
.IP "AVX" 4
.br
AVX\| 
.I method\|
.I lower-cut\|
.I upper-cut\|

Create 1-dim histograms of the mean value of Y and its RMS for each
bin in X of a 2-dim histogram.
.I lower-cut
/
.I upper-cut 
is the raito of entries at the
lower/upper side which will be excluded from the calculation.
.IP "AVY" 4
.br
AVY\| 
.I method\|
.I lower-cut\|
.I upper-cut\|

Create 1-dim histograms of the mean value of X and its RMS for each
bin in Y of a 2-dim histogram.  
.I lower-cut
/
.I upper-cut 
is the raito of entries at the
lower/upper side which will be excluded from the calculation.
.IP "AXTITL" 4
AXTITL\|
.I type\|
[
.I title\|
]

Define a title to be printed along X axis.
.IP "B" 4
.br
Move to the previous histogram in a list.
.IP "BANX" 4
.br
BANX\|
.I low-x\|
.I high-x

Make a projection onto Y, restricted to the X interval (low-x,high-x).
.IP "BANY" 4
.br
BANY\|
.I low-y\|
.I high-y

Make a projection onto X, restricted to the Y interval (low-y,high-y).
.IP "BLOW" 4
.br
BLOW\|
.I lower\| upper
.br
BLOW\|
.I lower-x\| upper-x\| lower-y\| upper-y

Create a new histogram into which the bins within the specified
range are cumulated. 
.br
The channel number instaed of coordinate value 
may be used to specify limits by prefixing \'#\' before the number.

.IP "CLOSE" 4
.br
Close the file opened by OPEN command and resume the output to
SYS$OUTPUT (stdout).
.IP "CHBIN" 4
.br
CHBIN\|
.I factor\|
.I start
.br
CHBIN\|
.I factor-x\|
.I start-x\|
.I factor-y\|
.I start-y

Change bin size, i.e. merge 2 or more bins into one bin.
.IP "CHTIT" 4
.br
CHTIT\|
.I title

Change the title of the current histogram.
.IP "CHWIN" 4
.br
CHWIN\|
.I number

Select another window. If the specifed window does not exist,
the new window will be created. This command is valid only for
X (DEC) window version.
.IP "CNTR" 4
.br
CNTR\|
.I number-of-contours

To draw a contour plot for 2 dim histogram.
.IP "COPY" 4
.br
COPY\|
.I title

Create a copy of the current histogram, with an altered title.

.IP "CWD" 4
.br
CWD\|
.I directory

Change current Working Directory
.IP "DELETE" 4
.br
Delete the current histogram.
.IP "DISTRI" 4
DISTRI\|
.I number-of-bins\| lower-edge\| upper-edge

Make a projection onto the ordinate axis with regarding the contents of
each bin as an abscissa value.
.IP "DIV" 4
.br
DIV\|
.I operand-id

Divide the contents of the current histogram by the operand histogram.
.IP "DOFFT" 4
Do Fast Fourier Transform for the current histogram.
.br
(need NAG library, currently available only for VAX/VMS)
.IP "DUPL" 4
DUPL\|
.I id

Duplicate the current histogram to the specified
.I id
\&.
.IP "ECHO" 4
.br
ECHO\|
.I text

Write 
.I text 
on Fortran UNIT 6. This command is usually used in conjunction
with OPEN/CLOSE commands. 

Escape sequences (\\t:tab, \\n:newline, \\r: return, \\f:formfeed, 
\\b:backspace,\\a:bell, \\e:escape, \\033:octal) can be included in 
.I text
, useful to send control sequences to the terminal.
.IP "ER" 4
.br
Enable the print of error bars.
.IP "EXIT" 4
.br
Terminate DISPLAY session.
.IP "FETC" 4
.br
FETC\|
.I file\|
.I format\|
.I id

This command reads one or more HBOOK4 histograms from a disk file 
using HRIN.  
.IP "FETC3" 4
.br
FETC3\|
.I file\|
.I id

Reads a file created by HBOOK3.
.IP "FFTW" 4
.br
FFTW\|
.I option

Multiply the window function for FFT
.br
Available funvtions are as follows:
.br
HANN (Hanning) ,HAMM (Hamming)  ,TRI (Triangle)

(need NAG library, currently available only for VAX/VMS)
.IP "FIT" 4
.br
Fits various functions to the contents of one dim histogram
or N-tuples.

FIT\|
.I function\| weight\| method\| [option]
.br
FIT\|
.I function\| weight\| method\| [option] variables
.IP "    FIT Exponent" 8
Fits an exponential (y = exp(AA+BB*x)) to the contents of 1 dim histogram.
.IP "    FIT Gauss" 8
.br
Fits a gaussian to the contents of 1 dim histogram.
.IP "    FIT Poly" 8
.br
Fits a polynomial function to the contents of 1 dim histogram.
.IP "    FIT Single" 8
Fits a single power (y = K*(x**Alpha)) to the contents of 1 dim histogram.
.IP "    FIT User" 8
.br
Fits a user-supplied function to the contents of 1 dim histogram.
.IP "GDEL" 4
.br
GDEL\|
.I first-id\|
.I last-id

Delete histograms within specified range.
.IP "GPL" 4
.br
Plot all histograms. If you want a carriage return to be requested 
between each new page, please set PTO option by OPT command.
.IP "GTITLE" 4
.br
GTITLE\|
.I title

Define a global title to be printed at the top of each histogram.
.IP "H" 4
.br
H\|
.I id

Move to a specified histogram 
.I id
\&.
.IP "HIGZ" 4
.br 
HIGZ\| ON\| [
.I file
]
.br
HIGZ\| OFF

Enable/disable output to HIGZ meta file. HIGZ meta file can be edited
by using PICTURE/MODIFY comamnd in PAW.
.IP "I" 4
.br
Print index of all histograms.
.IP "INCLUD" 4
.br
INCLUD\|
.I file\| format\| id\| title

Read ASCII file containing multicolumn table and make an one dim
histogram or a N-tuple.
.IP "INTEGR" 4
INTEGR\|
.I region-option

Create a histogram of which each bin at X is the total number of entries 
between the region (xmin,X) or (X,xmax).
.IP "JOIN" 4
.br
JOIN\| (0:new|1:super)\| (0:straight|1:curve)\|
.I line-style

Draw a straight line or smoothed curve across points at the center
of each bin.
.IP "KILL" 4
.br
KILL\|
.I lower\| upper
.br
KILL\|
.I lower-x\| upper-x\| lower-y\| upper-y

Set the contents of bins within the specified region to zero.
.br
The channel number instaed of coordinate value may be used
to specify limits by prefixing \'#\' before the number.
.IP "LEGO" 4
.br
LEGO\|
.I theta
.I phi

Plot a scatter plot as a 3 dim view (LEGO plot).
.IP "LINX" 4
.br
Set the scale for X axis linear.
.IP "LINY" 4
.br
Set the scale for Y axis linear.
.IP "LOGX" 4
.br
Set the scale for X axis logarithmic.
.IP "LOGY" 4
.br
Set the scale for Y axis logarithmic.
.IP "MAMI" 4
.br
MAMI\|
.I minimum\|
.I maximum

The lower and upper limits for the contents scale are set to the
specified values. If minimum >= maximum the the limits will be
computed automatically.
.IP "MINUIT" 4
.br
Call MINUIT, powerful interactive fitting package.
.IP "MUL" 4
.br
MUL\|
.I operand-id

Multiply the contents of the current histogram by the operand histogram.
.IP "N" 4
.br
Move to the next histogram in a list.  
  
The histograms in DISPLAY are chained together into a list.
All operations, e.g. display, fit etc., are performed on the
current histogram in this list.  
.IP "NOER" 4
.br
Disable the print of error bars.
.IP "NOFN" 4
.br
Surpress the superimposition of function on the current histogram.
.IP "N-TUPLES" 4
Refer to HBOOK4 User Guide Chapter 10 about the concept of N-tuples.
.IP "    PROJ1" 8
.br
PROJ1\|
.I varx\| first\| last\| select\| nx\| xmin\| xmax

Define an one dim histogram and fill it with one variable of the N-tuple.
.IP "    PROJ2" 8
.br
PROJ2\|
.I varx\| vary\| first\| last\| select\| 
.I nx\| xmin\| xmax\| ny\| ymin\| ymax

Define a two dim histogram and fill it with two variables of the N-tuple.
.IP "    SPLOT" 8
.br
SPLOT\|
.I varx\| vary\| first\| last\| select

Draw two variables of the N-tuple as a scatter plot.
.IP "OPEN" 4
.br
OPEN\|
.I file

The subsequent output on Fortran Logical Unit 6 will be written
on the specified file.
.IP "OPER" 4
.br
OPER\|+\|
.I num-of-hists \|id1 \|id2...
.br
OPER \|(-|*|/)\|
.I id1 \|id2 \|coef1 \|coef2

Do an arithmetic operation between two (or more) histograms and fill 
the result into a new histogram.

result = 
.I coef1
* hist1 
(
.I operation
) 
.I coef2 
* hist2
.IP "OPT" 4
.br
OPT\|
.I option

Call HPLOPT to change HPLOT options.

Available options are as follows:

.nf
 BAR,  BOX,  CHA,  STA, HARD, DVXR, DVYR,  PTO,  TIC,  ZFL, LOGZ
NBAR, NBOX, NCHA, NSTA, SOFT, DVXI, DVYI, NPTO, NTIC, NZFL, LINZ
.fi

Try OPT SHOW for more descriptions and current options.
.IP "PDEF" 4
.br
Print definiation of the current histogram.
.IP "PLOT" 4
.br
PLOT\| (0:new|1:super)\| marker-type\| marker-size
.br
PLOT\| (0:new|1:super)\| marker-type\| marker-size\| plot-type\| variables

Plot polymarker at the center of each bin for 1 dim histogram
or plot polymarker at (X,Y) data points with optional X/Y error
bars for N-tuples.
.IP "PRINT" 4
.br
Dump the current histogram to the console.
.IP "PROX" 4
.br
Make a projection of 2 dim histogram onto X axis.
.IP "PROY" 4
.br
Make a projection of 2 dim histogram onto Y axis.
.IP "PS" 4
.br 
PS\| ON\| [
.I file
]
.br
PS\| OFF
.br
PS\| CLOSE

Enable/disable output to PostScript file.
.IP "REBIN" 4
.br
REBIN\|
.I factor\| from-x\| to-x

Merge multiple bins into one bin within the specifed region of 1
dim histogram. The resultant histogram will have non equidistant
width bins.
.IP "RER" 4
.br
Create a new histogram from a 1-dim. histogram with statistical errors 
explicitly booked.
.IP "RENUM" 4
.br
RENUM\|
.I start-id\|
.I step-id
 
Renumber histogram id like BASIC RENUM command.
.IP "RESIDU" 4
.br
Create a histogram of the difference between the associated function
and the contents of the current histogram. The error bars are copied
from the original histogram.
.IP "SCALE" 4
.br
SCALE\| 
.I factor
.br
SCALE\|
.I option 
(B,H,N) ...

Note that the SCALE commands will replace the contents of the current
histogram.
.IP "    SCALE" 8
.br
SCALE\|
.I factor

The content of each bin is multiplied by
.I factor
\&.
.IP "    SCALE N" 8
.br
SCALE N\|
.I number-of-entry

The total entries of the current histogram is scaled to
.I number-of-entry
\&.
.IP "    SCALE H" 8
.br
SCALE H\|
.I id

The content of each bin is divided by the total entries of histogram
.I id
\&.
.IP "    SCALE B" 8
.br
SCALE B

Divide the content of each bin by its bin width.
.IP "SET" 4
.br
SET\|
.I parameter\|
.I value

Call HPLSET to change HPLOT parameters.

Available options are as follows:

.nf
HTYP, BTYP, PTYP, BARO, BARW, ASIZ, GSIZ, TSIZ, AFON, GFON, LFON
.fi

Try SET SHOW for more descriptions and current values.
.IP "SLIX" 4
.br
SLIX\|
.I number-of-slices

Make slices along Y of 2 dim histogram as
.I number-of-slices
1 dim histograms.
.IP "SLIY" 4
.br
SLIY\|
.I number-of-slices

Make slices along X of 2 dim histogram as
.I number-of-slices
1 dim histograms.
.IP "SORT" 4
.br
SORT\| (1:by ID|2:by title)

Sort histograms by ID or by title.
.IP "SUB" 4
.br
SUB\|
.I operand-id

Subtract the contents of the operand histogram from the current histogram.
.IP "SMOOTH" 4
.br
SMOOTH\| (0:replace|1:super)

Smooths 1 dim histogram according to algoritm 353QH, TWICE.
.IP "SPLINE" 4
.br
SPLINE\| (0:replace|1:super)\| number-of-knots\| degree
.br
SPLINE\|
.I knots-x\| degree-x\| knots-y\| degree-y

B-splines smoothing of the 1 or 2 dim histogram.
.IP "STAT" 4
.br
Calculate mean value, rms sigma for 1 or 2 dim histogram.
Resolution (= sigma/mean) is also calculated for 1 dim histogram.
.IP "STDIFF" 4
STDIFF\|
.I id1\| id2\| norm-opt\| flow-opt

Compare two histograms using Kolmogorov test and gives the probability 
that they could come from the same distribution.
.IP "STORE" 4
.br
STORE\|
.I file\| format\| number-of-hist\|
[
.I id1...
]

This command allows to store specified histograms 
into one file, for use in subsequent DISPLAY sessions.
.IP "SURF" 4
.br
SURF\|
.I theta\|
.I phi

Plot a scatter plot as 3 dim view (surface plot).
.IP "T" 4
.br
Plot the current histogram.
.IP "TABLE" 4
.br
TABLE\|
.I error\|
.I format

Output the contents of 1 dim. histogram as a multicolumn table.
The output may be written on the file using OEPN command.
.IP "TS" 4
.br
Plot the current histogram to be superimposed on the previous one.
.IP "TC" 4
.br
Plot the current histogram to be superimposed. The axes scales (
lin/log) are automatically set as same as the previous one.
.IP "TSC" 4
.br
Like TC, but the current histogram is normalized to the previous
one by its total number of entries.
.IP "VALUE" 4
.br
VALUE\| 
.I x 
.br
VALUE\|
.I x\|
.I y

Print the content of bin that contains the specified coordinate.
.IP "W" 4
.br
W\|
.I x-win\| 
.I y-win

Splits the picture into smaller parts, called windows.
.SH FILES
~/.dis45rc (UNIX)
.br
sys$login:display.ini (VMS)

.RS 4
initialization file. Each time
.B dis45
is invoked, this file is executed at first.
.RE
.SH AVAILABILITY
.B dis45
is currently available for the following computers:

DEC VAX/VMS 5.5
.br
DEC DECstation/Ultrix 4.2
.br
SUN Sparc Station/SUN-OS 4.1.2
.br
Data General AViiON/DG-UX 5.4
.SH BUGS
There is an E-MAIL address (display45@tkyux.phys.s.u-tokyo.ac.jp) for
reporting 
.B dis45
bugs and fixes.
.SH AUTHORS
.B display 
is originally developed by PEP4/LBL group and continuously improved
by TOPAZ/KEK group and Kamae group/UT. 

.B dis45
is almost completely rewritten by the following 3 people.

Akihiro Shirahashi (sirahasi@tkyux.phys.s.u-tokyo.ac.jp)
.br
Tadayuki Takahashi (tttp04@tkyvax.phys.s.u-tokyo.ac.jp)
.br
Ryosuke Itoh (itoh@kekvax.kek.ac.jp)

