C
C DIS45_MIN_COMMAND
C
C-   Created  17-MAY-1992   T.Takahashi
C-
C-   History: 3-Jun-1992, A.Shirahashi, for UNIX (Parameter,External)
C            18-Oct-1992, A.Shirahashi, lib$establish
C            21-Oct-1992, A.Shirahashi, contplot, scanplot
C             7-Nov-1992, "alias", "opt", "chwin", "pdef" in MINUIT mode
C             2-Mar-1993, -> dis45_min_body_vms.for/dis45_min_body_unix.f
C                            dis45_call_min_body.f
C             8-Mar-1993, again merged with dis45_call_min_body
C                         add "LOCATE", use QOPEN
C            18-Nov-1993, 'MINEXIT'
C
C    File: dis45_min_body_vms.for (VMS version)
C----------------------------------------------------------------------
      Subroutine DIS45_MIN_BODY(id, dim, error_flag)

      Implicit None
c input
      Integer id , dim
c output
      Integer error_flag
C local
      Character * 80  minfile
C function
      External DIS45_handler
C begin
      Call LIB$Establish(DIS45_Handler)
C
      Call DIS45_MIN_INIT(minfile,error_flag)
      If (error_flag.ne.0) then
        Return  
      Endif
c
      Do While( error_flag.eq.0 )
        Call DIS45_Call_Min_Body(id,dim,minfile,error_flag)
      End Do
C
      If( error_flag.lt.0 ) Then
        error_flag = 0
      End If
C
      Call DIS45_MIN_END
      Return
      End
C
C
      Subroutine DIS45_Call_Min_Body(id,dim,minfile,error_flag)
C
      Implicit None
C
C constant
      Integer  Ncomm
      Parameter (Ncomm = 42)
C input
      Integer  id, dim
      Character * (*)  minfile
C input/output
      Logical   error_flag
C local
      Character*8 Comm(Ncomm)
C
      Data Comm /
     &  'ALIAS   ',
     &  'CHISQ   ',
     &  'CHISCAN ',      ! Generate 2-dim Chisq Plot
     &  'CHWIN   ',
     &  'CONT    ',
     &  'CONTPLOT',     
     &  'D       ',
     &  'ERROR   ',
     &  'EXIT    ',
     &  'FIX     ',
     &  'HELP    ',
     &  'HESSE   ',
     &  'HIGZ    ',     
     &  'I       ',     
     &  'IMPROVE ',
     &  'LIN     ',
     &  'LINX    ',
     &  'LINY    ',               
     &  'LOCATE  ',
     &  'LOG     ',
     &  'LOGX    ',
     &  'LOGY    ',               
     &  'MAMI    ',     
     &  'MIGRAD  ',
     &  'MINIMIZE',
     &  'MINOS   ',
     &  'OPT     ',
     &  'PARA    ',
     &  'PDEF    ',
     &  'PUNCH   ',
     &  'PS      ',     
     &  'RELEASE ',
     &  'SAVE    ',
     &  'SCALE   ',     
     &  'SCAN    ',
     &  'SCANPLOT',
     &  'SEEK    ',
     &  'SET     ',
     &  'SHOW    ',
     &  'SIMPLEX ',
     &  'W       ',
     &  'RETURN  '
     &  /
C
C interface to MINUIT
      Real*8 Arglist(10)
      Integer IERRFLAG
C const
      Integer MAXCALL_MIGRAD
      Parameter (MAXCALL_MIGRAD=20)
C local
      Character Cmd*8, Prompt*6, PunchFile*80
      Integer Igo, Ncalls, PunchOut, error
      Character * 80  comand
      Integer  Lcom
C function
      External DIS45_MIN_FCN
      External DIS45_Handler
      Logical  Qopen
C data
      Data Prompt / '?MIN> ' /
      Data punchfile / 'DIS45_MINUIT.MIN' /
      Data PUNCHOUT / 7 / 
      Data Lcom / 0 /
C
C Set Error Handler
c
      Call LIB$establish(DIS45_handler)
c
c Main Body
c
100   Continue
C
C Keyrd Mode -3 : Alias, Return If Fail
C
      Call Keyrd(-3,Prompt,Cmd,Comm,Ncomm,Igo)
C
      If (Igo.gt.0) then
        error_flag = 0
        If (Cmd.eq.'RETURN  ') then
          error_flag = -1
          Goto 200
        Else If (Cmd.eq.'EXIT    ') then
          Call CLgetv( 'MINEXIT',comand,Lcom )
          If( Lcom.gt.0 ) Then
            Call DIS45_Open_Scratch(1,'display-min-tmp.rc',error)
            Write(1,'(A)') '@%'
            Write(1,'(A)') comand(1:Lcom)
            Write(1,'(A)') 'RETURN'
            Write(1,'(A)') '@#'
            Rewind( Unit=1 )            
            Call Lunrd( 1 )
            Goto 100
          Else
            error_flag = -1
            Goto 200
          End If
        else if (Cmd.eq.'ERROR  ') then
          Write(*,*) 'ERROR PRINT'
          Call DIS45_MIN_ERROR_PRINT(error_flag)
        else if (Cmd.eq.'CHISQ  ') then
          arglist(1)=97 ! iflag=97
          Call MNEXCM(DIS45_MIN_FCN, 'CALL FCN',arglist,1,IERRFLAG)
        else if (Cmd.eq.'CHISCAN') then
          arglist(1)=98 ! iflag=98
          Call MNEXCM(DIS45_MIN_FCN, 'CALL FCN',arglist,1,IERRFLAG)
        else if (Cmd.eq.'CONT') then
           Call DIS45_MIN_CONT(DIS45_MIN_FCN,error_flag)
        Else If (Cmd.eq.'CONTPLOT') Then
          Call DIS45_min_plotcont(dis45_min_fcn,error_flag)
        else if (Cmd.eq.'D      ') then
          arglist(1)=3 ! iflag=3
          Call MNEXCM(DIS45_MIN_FCN, 'CALL FCN',arglist,1,IERRFLAG)
        else if (Cmd.eq.'FIX ') then
          Call DIS45_MIN_FIX(DIS45_MIN_FCN,error_flag)
        else if (Cmd.eq.'HELP  ') then
          Call HLhelp ('MINUIT',error_flag)
        else if (Cmd.eq.'HESSE ') then
          Call MNEXCM(DIS45_MIN_FCN, 'HESSE',arglist,0,IERRFLAG)
        else if (Cmd.eq.'IMPROVE') then
          Call MNEXCM(DIS45_MIN_FCN, 'IMPROVE',arglist,0,IERRFLAG)
        Else if (Cmd.eq.'MIGRAD ') Then
          Call DIS45_Min_get_maxcalls(ncalls)
          arglist(1) = DBLE(ncalls)
          Call MNEXCM(DIS45_MIN_FCN, 'MIGRAD',arglist,1,IERRFLAG)
        Else if (Cmd.eq.'MINIMIZE') Then
          Call DIS45_min_get_maxcalls(ncalls)
          arglist(1) = DBLE(ncalls)
          Call MNEXCM(DIS45_MIN_FCN, 'MINIMIZE',arglist,1,IERRFLAG)
        else if (Cmd.eq.'MINOS  ') then
          Call MNEXCM(DIS45_MIN_FCN, 'MINOS',arglist,0,IERRFLAG)
        else if (Cmd.eq.'PARA   ') then
          Call MNEXCM(DIS45_MIN_FCN, 'SHOW PARAMETER',arglist,
     &      0,IERRFLAG)
        else if (Cmd.eq.'PUNCH  ') then
          Call DIS45_MIN_PUNCH(minfile,error_flag)
        else if (Cmd.eq.'RELEASE') then
          Call DIS45_MIN_REL(DIS45_MIN_FCN,error_flag)
        else if (Cmd.eq.'SAVE   ') then
          If( Qopen('output file name',PunchOut,PunchFile,
     &              'WRITE','LIST','NEW') 
     &    ) Then
            Call MNEXCM(DIS45_MIN_FCN, 'SAVE',arglist,0,IERRFLAG)
            Close(Unit=PunchOut)
          Else
            error_flag = 25
          End If
        Else if (Cmd.eq.'SCAN ') Then
          Call DIS45_min_scan(dis45_min_fcn,error_flag)
        Else If (Cmd.eq.'SCANPLOT') Then
          Call DIS45_min_scanplot(dis45_min_fcn,error_flag)
        Else if (Cmd.eq.'SEEK ') Then
          Call MNEXCM(DIS45_MIN_FCN, 'SEEK',arglist,0,IERRFLAG)
        Else if (Cmd.eq.'SET') Then
          Call DIS45_MIN_SET(DIS45_MIN_FCN,error_flag)
        Else if (Cmd.eq.'SHOW') Then
          Call DIS45_MIN_SHOW(DIS45_MIN_FCN,error_flag)
        Else if (Cmd.eq.'SIMPLEX') Then
          Call MNEXCM(DIS45_MIN_FCN, 'SIMPLEX',arglist,0,IERRFLAG)
        Else if (Cmd.eq.'TABLE  ') Then
          arglist(1)=99 ! iflag=99
          Call MNEXCM(DIS45_MIN_FCN, 'CALL FCN',arglist,1,IERRFLAG)
        Else
          Call Display45_DoComand( cmd,error_flag )
        Endif
        Call DIS45_Min_Error( error_flag )
      Else
C       Call Display45_DoComand( Cmd,error_flag )
        Call DIS45_Min_Error( 10 ) ! no such command
      Endif
      Goto 100
C
  200 Continue
c
      Return
      End
c
c DISPLAY45_ERROR
c
      Subroutine DIS45_MIN_ERROR (error_flag)
      Implicit NONE
c input:
      Integer error_flag
c local:
      Integer MAXERR
      Parameter( MAXERR = 25 )
      Character ErrMsg( MAXERR ) * 48
      Data ErrMsg( 1) / 'Algorithm to make contour failed'/
      Data ErrMsg( 2) / 'Step =0.0 not allowed'/
C
C
      If (error_flag.eq.0) then
        Return
      else if (error_flag.lt.0) then
        error_flag=abs(error_flag)
        Write(*,'(1X,A,A)') '%DIS-E, ',ErrMsg(error_flag)
      else
        Call DISPLAY45_ERROR (error_flag) 
      Endif
      Return
      End

