C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Plot 2-dim Chisq Distribution
C-
C-
C-   Created  14-SEP-1992   T.Takahashi
C-            22-JUN-1993   K.Matsuzaki support N-tuple
C-
C----------------------------------------------------------------------
      Subroutine Dis45_Min_Chiscan 
     &   (min_funct,id_hist,ndatax,nbiny,npar,par,iddata,error_flag)
C
      Implicit None
c input:
      External min_funct
      Integer id_hist
      Integer npar
      Real*8  par(*)                    ! parameter values
      Integer Ndatax,nbiny
      Integer iddata
c output:
      Integer error_flag                

      Integer idnew
      Integer  mx_id1, mx_id2
c
c common area for scratch
      Include 'pawc.inc'
      Integer idbuf
      Integer loc,locx,locy,locdx,locdy
c
c logical:
      Integer  DIS45_makehist, DIS45_malloc

c
c local:
      Character*80 title
      Real Xmin, Xmax, Ymin, Ymax
      Integer Ibin
      Real*8 xval,yval,yerr,xbin,ythe
      
      Real err
      Real*8 likelihood
      Real*8 Yval_double 
      Real*8 all,bck,sig
      Integer ichoice /1/  ! choose specified x bin  as valid or not
                           ! 1 valid 2. no use
      Integer i,j

c for chisq plot
c
      Integer idnew2
      Real*8 Chisq_min
      Integer param_id1, param_id2
      Real * 8  low_id1, up_id1, step_id1
      Real * 8  low_id2, up_id2, step_id2
      Real * 8  par_id1, par_id2
      Real * 8  par_save1,par_save2
      Real * 8  chisq

      If (DIS45_makehist(id_hist, 2, idnew, error_flag).le.0) then
        Write (*,*) 'ERROR'
        Call DIS45_MIN_ERROR(error_flag)
        Return
      Endif
! for 1 sigma chisq
      If (DIS45_makehist(idnew, 2, idnew2, error_flag).le.0) then
        Write (*,*) 'ERROR'
        Call DIS45_MIN_ERROR(error_flag)
        Return
      Endif
      Call DIS45_MIN_SELECT_PARAM(param_id1,low_id1,up_id1,step_id1)
      Call DIS45_MIN_SELECT_PARAM(param_id2,low_id2,up_id2,step_id2)
      mx_id1 = Int((up_id1-low_id1)/step_id1)
      mx_id2 = Int((up_id2-low_id2)/step_id2)
      
      If (DIS45_malloc(mx_id1*mx_id2,idbuf,loc,error_flag).le.0) then
        Call DIS45_MIN_ERROR(error_flag)
        Return
      Endif
      Call Hbook2(idnew,'CHISQ '//title,
     &    mx_id1,Real(low_id1),Real(up_id1),
     &    mx_id2,Real(low_id2),Real(up_id2),0.0)
      Call Hbook2(idnew2,'1S-CHI2 '//title,
     &    mx_id1,Real(low_id1),Real(up_id1),
     &    mx_id2,Real(low_id2),Real(up_id2),0.0)
      Call DIS45_locate(idbuf, loc) ! make sure the location in the buf
      Call DIS45_locate(iddata, locx)
      locy = locx + ndatax
      locdx = locy + ndatax
      locdy = locdx + ndatax
C
      par_save1 = par(param_id1)
      par_save2 = par(param_id2)
      Chisq_min=1.0E+32
      Do i = 1, mx_id1
        par_id1 = low_id1 + (i-1)*step_id1
        par(param_id1) = par_id1
        Do j = 1, mx_id2
          par_id2 = low_id2 + (j-1)*step_id2
          par(param_id2) = par_id2
          Chisq = 0.0D0
          Do Ibin = 1,Ndatax
ccc            Call DIS45_MIN_FCN_GETVAL(id_hist, ibin, xbin, 
ccc     &        xval, yval,yerr)
            Xval = Rmem(locx +Ibin-1)  
            Yval = Rmem(locy +Ibin-1) 
            Xbin = Rmem(locdx+Ibin-1) 
            Yerr = Rmem(locdy+Ibin-1) 
            all = yval
            Call MIN_funct(Xval,Xbin,par,
     &        ichoice, all,bck,sig)
            If (ichoice.ne.0) then ! accept this bin
              Ythe = all
              If ( Yerr .NE. 0.0 ) then
                Chisq = Chisq + 
     &            ((Yval-Ythe)/Yerr)**2
              else ! Yerr.eq.0 
                Chisq = Chisq + 
     &            ((Yval-Ythe))**2
              End If
            End If
          Enddo
          If (Chisq.lt.Chisq_min) Chisq_min = Chisq
ccc          Write(*,*) Chisq
          Rmem(loc-1+i+(j-1)*mx_id1) = Chisq
        End do
      End do
      Call Hpak(idnew,Rmem(loc))
c
c 1 sigma
c
      Do i = 1, mx_id1
        Do j = 1, mx_id2
          If (Rmem(loc-1+i+(j-1)*mx_id1).le.(Chisq_min+1.0)) then 
            Rmem(loc-1+i+(j-1)*mx_id1) = 1.0
          else
            Rmem(loc-1+i+(j-1)*mx_id1) = 0.0
          Endif
        End do
      End do
      Call Hpak(idnew2,Rmem(loc))
      Call DIS45_free( idbuf )
      par(param_id1) = par_save1 
      par(param_id2) = par_save2 

C----------------------------------------------------------------------
  999 RETURN
      END
