C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Calculate Total Chisq and Return 
C-   Confidense Level
C-
C-
C-   Created  14-SEP-1992   T.Takahashi
C-            22-JUN-1993   K.Matsuzaki support N-tuple
C-
C----------------------------------------------------------------------
      Subroutine Dis45_Min_Chisq 
     &  (min_funct,id_hist,ndatax,nbiny,npar,par,iddata,error_flag)
C
      Implicit None
c input:
      External min_funct
      Integer id_hist
      Integer Ndatax,Nbiny
      Integer npar
      Real*8  par(*)                    ! parameter values
      Integer iddata
c output:
      Integer error_flag                
c
c -------------------
c common area for scratch
      Include 'pawc.inc'
      Integer locx, locy, locdx, locdy
C----------------------------------------------------------------------
c function
      Real G01BCE
c local:
      Integer nfree
      Character*80 title
      Real Xmin, Xmax, Ymin, Ymax
      Integer Ibin
      Real*8 xval,yval,yerr,xbin,ythe
      Real   cl
      Integer ierr,ndf
      Real err
      Real*8 Yval_double 
      Real*8 all,bck,sig
      Integer ichoice /1/  ! choose specified x bin  as valid or not
                           ! 1 valid 2. no use
      Integer i,j
      Integer ifail
      Real * 8  chisq
C
      Call DIS45_locate(iddata, locx)
      locy = locx + ndatax
      locdx = locy + ndatax
      locdy = locdx + ndatax
C
      Chisq = 0.0D0
      Do Ibin = 1,Ndatax
        ichoice = 1
ccc        Call DIS45_MIN_FCN_GETVAL(id_hist, ibin, xbin, 
ccc     &      xval, yval,yerr)
        Xval = Rmem(locx +Ibin-1)  
        Yval = Rmem(locy +Ibin-1) 
        Xbin = Rmem(locdx+Ibin-1) 
        Yerr = Rmem(locdy+Ibin-1) 
        all = yval
        Call MIN_funct(Xval,Xbin,par,ichoice, all,bck,sig)
        If (ichoice.ne.0) then ! accept this bin
          Ythe = all
          If ( Yerr .NE. 0.0 ) then
            Chisq = Chisq + 
     &           ((Yval-Ythe)/Yerr)**2
          else ! Yerr.eq.0 
            Chisq = Chisq + 
     &           ((Yval-Ythe))**2
          End If
        End If
      Enddo

      Write (6,*) 'Total Chisq : ',Chisq
      Write (6,*) '# of Bins   : ',Ndatax 
      Write (6,*) '# of Params (includes Fix): ',npar
      Call DIS45_MIN_askfreeparam(nfree)
      Write (6,*) '# of Free Params:',nfree
      ndf = ndatax-nfree
      Write(6,*) 'Chisq/ndf    :', chisq/Real(ndf)
      ifail = 0
      cl = G01BCE(chisq,ndf,ifail)            
      If( ifail.ne.0 ) Then
        error_flag = 26 ! NAG library error
      else
        Write(6,*) 'Conf. Level     :', cl
      End If

C----------------------------------------------------------------------
  999 RETURN
      END
