      SUBROUTINE DIS45_MIN_CONT(DIS45_MIN_FCN,err)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : 
C-
C-   Inputs  : 
C-   Modified: 
C-   Outputs : 
C-
C-   Created  16-JUL-1992   T.Takahashi
C-
C----------------------------------------------------------------------
      IMPLICIT NONE
c input function
      External DIS45_MIN_FCN
c output
      Integer err
c
c const
      Integer MAXPNT
      Parameter (MAXPNT=100)
c
c buffer
      Real xpt(MAXPNT),ypt(MAXPNT)
c
c interface to MINUIT
      Real*8 Arglist(10)
      Integer IERRFLAG
c local
      Integer param1, param2
      Integer nfound
      Integer i

      Call DIS45_MIN_SELECT_PARAM_NAME(param1)
      Call DIS45_MIN_SELECT_PARAM_NAME(param2)
      
      arglist(1)=param1
      arglist(2)=param2
      Call MNEXCM(DIS45_MIN_FCN, 'CONTOUR',arglist,2,IERRFLAG)
C----------------------------------------------------------------------
  999 RETURN
      END
C
C Description: plot minuit contour plot on graphics
C Author: A.Shirahashi
C Date: 20-Oct-1992
C
      Subroutine DIS45_min_plotcont(DIS45_MIN_FCN,err)
C
      Implicit None
c input function
      External DIS45_MIN_FCN
c output
      Integer err
c const
      Integer MAXPNT, MAXPNT1
      Parameter (MAXPNT=100)
      Parameter (MAXPNT1=101)
c buffer
      Real*8 xpt8(MAXPNT),ypt8(MAXPNT)
      Real*4 xpt4(MAXPNT1),ypt4(MAXPNT1)
C local
      Integer param1, param2
      Integer nfound
      Integer i, id
      Real  xmin, xmax, ymin, ymax, dx, dy
      Real * 8  val, step, bnd1, bnd2
      Character * 16  name1, name2
      Integer ierflag, Lname1, Lname2
C function
      Integer  DIS45_makehist, Lenrd
C begin
      Call DIS45_min_select_param_name(param1)
      Call DIS45_min_select_param_name(param2)
C       
      Call MNcont(DIS45_MIN_FCN,param1,param2,MAXPNT,xpt8,ypt8,
     &            nfound,0)
C
C      Write(*,*) '*** nfound = ', nfound
C
C     ... MNcont sets nfound = 1 on return in case of success
      If (nfound.lt.0) Then
        err = -1
        Return
      End If
C
      If( nfound.eq.0 ) Then
        nfound = MAXPNT
      End If
C
      Do I = 1, nfound
        xpt4(I) = Real(xpt8(I))
        ypt4(I) = Real(ypt8(I))
      End Do
      xpt4(nfound+1) = Real(xpt8(1))
      ypt4(nfound+1) = Real(ypt8(1))
C
      xmin = xpt4(1)
      xmax = xpt4(1)
      ymin = ypt4(1)
      ymax = ypt4(1)
C
      Do I = 1, nfound
        xmin = Min(xmin,xpt4(I))
        xmax = Max(xmax,xpt4(I))
        ymin = Min(ymin,ypt4(I))
        ymax = Max(ymax,ypt4(I))
      End Do
C
      dx = (xmax - xmin) * 0.05
      dy = (ymax - ymin) * 0.05
C
      xmin = xmin - dx
      xmax = xmax + dx
C
      If( DIS45_makehist(9999,2,id,err).le.0 ) Return
C
      Call Hbinsz('YES')
C
      Call MNpout(param1,name1,val,step,bnd1,bnd2,ierflag)
      Call MNpout(param2,name2,val,step,bnd1,bnd2,ierflag)
      Lname1 = Lenrd(name1)
      Lname2 = Lenrd(name2)
C
      Call Hbook2(id,
     &  'Chi*2 Contour ('//name1(:Lname1)//' vs '//name2(:Lname2)//')',
     &  20,xmin-dx,xmax+dx,
     &  20,ymin-dy,ymax+dy,0.0)
C
      Call Hbinsz('NO')
C
      Call Hplot(id,' ',' ',1)
      Call DIS45_hdelete(id)
C
      Call Hplfun(xpt4,ypt4,nfound+1,' ')
      Call IUWK(0,0) ! Update Workstation 
C
      Return
      End




















