      SUBROUTINE DIS45_MIN_FCN(npar, grad, chisq, par, iflag)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : 
C-
C-   Created  18-MAY-1992   T.Takahashi
C-
C- History: 8-Jun-1992, A.Shirahashi
C-            Use DIS45_dynlink instead of lib$find_image_symbol
C-          25-Jun-1992, R. Itoh
C-            Use static linking of MIN_FUNCT for UNIX machines
C-          2-Jul-1992, A.Shirahashi
C-            Float -> Real
C-          6-Jul-1992, S.Shirahashi
C-            Now DIS45_dynlink returns static address, thus use it
C-            instead of %LOC.
C-            Some bug fixes: low_id1,...: Real -> Real * 8
C-                            Hmem(..) = Chisq -> Rmem(..) = Chisq
C-          7-Jul-1992 T.Takahashi
C-            Some bug fixed. Xbin, Improve CHISCAN
C-          26-Aug-1992 T.Takahashi
C-            Major Version up, Eliminate Array
C-          24-Dec-1992 A.Shirahashi
C             DIS45_min_fcn_init: Titrd -> Txtrd
C           2-Mar-1993 A.Shirahashi
C             DIS45_MIN_FCN_INIT: allow null filename specification
C             move 'call init_com_talk' to dis45_min_init.f
C           16-Mar-1993, A.Shirahashi
C             temporary fix: yval_double = 0.0
C           31-Mar-1993, 
C             all <- yval
C           22-Jun-1993 K.Matsuzaki
C             support N-tuple, residual plot
C           13-Mar-1994 Ishisaki's patch
C----------------------------------------------------------------------
      IMPLICIT NONE
c input:
      Integer npar
      Real*8  par(*)                    ! parameter values
      Integer iflag                      ! flag where to go
c output:
      Real*8  grad(*)                   ! derivative (optional)
      Real*8  chisq                     ! function to be minimized
c -------------------
c common area for scratch
      Include 'pawc.inc'
      Integer iddata,idresi
      Integer locx, locy, locdx, locdy, loctx, locty, locby
C----------------------------------------------------------------------
c function:
      Integer  DIS45_dynlink, DIS45_malloc, DIS45_makehist, Lenrd
      Logical  Qopen
      Real Hi, Hie
c local:
      Integer  fcn_flag, error_flag
      Character * 80  name, exec_name, title
      Integer  here, id_hist, idim
      Integer  Nbinx, Nbiny, Ibin
      Real  Xmin, Xmax, Ymin, Ymax, err
      Real * 8  likelihood, Yval_double, all, bck, sig
      Integer  ichoice  ! choose specified x bin  as valid or not
                        ! 1 valid 2. no use
      Integer  i, j, L, Nwt, Iloc
      Logical  status
      Integer  plotmode
C storage: 
      Integer  ndatax
      Real * 8  xval,yval,yerr,xbin,ythe
      Real * 4  low, high
C
      Integer error_flag_ini
      Integer address                   ! Address of function which calculates
                                        ! Theory
c
c for N-tuple
c
      Integer  ifmt
      Character*8  varx, vary, vardx, vardy
      Integer ivx, ivy, ivdx, ivdy
      Integer  nevent
      Integer  mtype /20/, msize /1.0/
C data
      Save  exec_name, fcn_flag, ichoice, address
      Data  exec_name / 'min_funct' /
      Data  fcn_flag / 1 /
      Data  ichoice / 1 /
      Data  address / 0 /
C
C begin
      Call DIS45_current_his(here, id_hist, idim)
C
      If( address.eq.0 ) Then
        Write(*,*) 'your function not yet specified.'
        Return
      End If
C
C From Minuit
      If (Iflag.eq.1) then
        Goto 400
      else if (Iflag.eq.2) then
        Goto 200
      else if (Iflag.eq.3) then
        Goto 300
C From DIS45_MIN_SET
      else if (Iflag.eq.81) then       ! Select Minimization Function
        Call INTRDL('FCN (1.CHISQ, 2.Likelihood):',FCN_FLAG,1,2) 
                 ! Change FCN To Minimize
        If ((FCN_FLAG.ne.1).and.(FCN_FLAG.ne.2)) then
          FCN_FLAG = 1
        Endif
        Return
C From DIS45_MINUIT
      else if (Iflag.eq.96) then
        Goto 96                         ! Residual plot
      else if (Iflag.eq.97) then
        Goto 97                         ! Chisq
      else if (Iflag.eq.98) then
        Goto 98                         ! Chisq Scan in 2 dim space
      else if (Iflag.eq.99) then
        Goto 99                         ! Dump Out Contents
      else ! actualy it must be 4
        Goto 400
      Endif
c
c Iflag = 1 : Read Input Data and... 
c
  100 Continue
c 
c Iflag = 2 : calculate derivative (optional) 
c
  200 Continue
c 
c Always Comes here : calculate likelihood/chisq 
c

  400 Continue
      If (FCN_FLAG.eq.1) then
        Chisq = 0.0D0
        Likelihood = 0.0D0
        Do Ibin = 1,Ndatax
          ichoice = 1
          Xval = Rmem(locx +Ibin-1)  
          Yval = Rmem(locy +Ibin-1) 
          Xbin = Rmem(locdx+Ibin-1) 
          Yerr = Rmem(locdy+Ibin-1) 
          all = yval
          Call DO_MIN_funct(%val(address),Xval,Xbin,par
     &      ,ichoice,all,bck,sig) 
          If (ichoice.ne.0) then ! accept this bin
            Ythe = all
            If ( Yerr .NE. 0.0 ) then
              Chisq = Chisq + 
     &           ((Yval-Ythe)/Yerr)**2
            else ! Yerr.eq.0 
              Chisq = Chisq + 
     &           ((Yval-Ythe))**2
            End If
          End If
        Enddo
      else ! Likelihood
        Likelihood = 0.0D0
	Yval_double = 0.0D0 ! temporary fix (16-Mar-1993)
        Do Ibin = 1,Ndatax
          ichoice = 1
          Xval = Rmem(locx +Ibin-1)  
          Yval = Rmem(locy +Ibin-1) 
          Xbin = Rmem(locdx+Ibin-1) 
          Yerr = Rmem(locdy+Ibin-1) 
          all = yval
          Call DO_MIN_funct(%val(address),Xval,Xbin,par,
     &      ichoice, all,bck,sig)
          If (ichoice.ne.0) then ! accept this bin
            Ythe = all
            If ((Yerr.ne.0.0).and.(Ythe.gt.0.0)) then
              If (Yval.eq.0.) then
                Likelihood = Likelihood-Ythe
              else
                Likelihood = Likelihood+Yval_double
     &                  *(Dlog(Ythe/Yval))
     &                  +Yval-Ythe
              Endif
            Endif
          End If
        Enddo
        Chisq = -2.*Likelihood
      Endif
      Return ! --------------------------------------- Return
c 
c Iflag = 3 ! 
c
  300 Continue 
      If      (idim.eq.1) Then
        Call hlplot(error_flag)
      Else If (idim.eq.3) Then
ccc        Call hlmark(error_flag)
        Call Intrd('marker type ?',mtype)
        Call IGSET('MTYP',Float(mtype))
        Call Fltrd('marker size ?',msize)
        Call IGSET('MSCF',msize)
        Call DIS45_set_hplopt(id_hist)
        Call HLplotNT(id_hist,' ',ivx,ivy,ivdx,ivdy,mtype,msize,
     &                error_flag )
      Endif

      If (error_flag.eq.0) then
        Do Ibin = 1, ndatax
          Xval = Rmem(locx +Ibin-1)  
          Yval = Rmem(locy +Ibin-1) 
          Xbin = Rmem(locdx+Ibin-1) 
          Yerr = Rmem(locdy+Ibin-1) 
          all = yval
          Call DO_MIN_funct(%val(address),Xval,Xbin,par,
     &      ichoice, all,bck,sig)
          Rmem(loctx+Ibin-1) = Real(xval)
          If ( abs(all) .gt. 1.0E37 ) then
            If ( all .lt. 0 ) then
              all = -1.0E37
            Else
              all = 1.0E37
            End If
          End If
          Rmem(locty+Ibin-1) = Real(all)
          Rmem(locby+Ibin-1) = Real(bck)
        End do
ccc        Print *, 'Xval = ', (Rmem(loctx+Ibin-1),Ibin=1,Ndatax)
ccc        Print *, 'Ythe = ', (Rmem(locty+Ibin-1),Ibin=1,Ndatax)
        Call hpline(Rmem(loctx),Rmem(locty),Ndatax,' ')
        Call hplset('DMOD',3.0) ! change line style to dash dot
        Call hpline(Rmem(loctx),Rmem(locby),Ndatax,' ')
        Call hplset('DMOD',0.0) ! change line style to default
        Call IUWK(0,0)   ! Update Workstation GKS func.
        Call DIS45_min_get_plotmode(plotmode)
        If( plotmode.eq.1 ) Then
          Call DIS45_MIN_RESIDUAL(%val(address),' ', ndatax, nbiny,
     &      npar, par, iddata, error_flag)
          If (error_flag.ne.0) then
            Call DIS45_MIN_ERROR(error_flag)
          Endif
        Endif
      else
        Call DIS45_MIN_ERROR(error_flag)
      Endif
      Return
c -------------------------------------------------------------      
c
c Iflag = 96 ! Residual
c
   96 Continue
      Call DIS45_MIN_RESIDUAL(%val(address),'M', ndatax, nbiny,
     &  npar, par, iddata,
     &  error_flag)
      If (error_flag.ne.0) then
        Call DIS45_MIN_ERROR(error_flag)
      Endif

      Return
c -------------------------------------------------------------      
c
c Iflag = 97 ! Calculate Total Chisq
c
   97 Continue
      Write(*,*) 'Calc. Total Chisq.'
      Call DIS45_MIN_CHISQ(%val(address),id_hist, ndatax, nbiny,
     &  npar, par, iddata,
     &  error_flag)
      If (error_flag.ne.0) then
        Call DIS45_MIN_ERROR(error_flag)
      Endif

      Return
c -------------------------------------------------------------      
c
c Iflag = 98 ! Calculate Total Chisq
c
   98 Continue
ccc   Call DIS45_MIN_CHISCAN(%val(address),id_hist, ndatax, nbiny,
      Call DIS45_MIN_residual(%val(address),id_hist, ndatax, nbiny,
     &  npar, par, iddata,
     &  error_flag)
      If (error_flag.ne.0) then
        Call DIS45_MIN_ERROR(error_flag)
      Endif

      Return
c -------------------------------------------------------------      
c
c Iflag = 99 ! Dump Contents of Histogram and theretical value
c
   99 Continue
      Write(6,*) ' ( Contents of Histogram and Theoretical Value )'
      Write(6,*) 
      Do Ibin = 1, Ndatax
        Xval = Rmem(locx +Ibin-1)  
        Yval = Rmem(locy +Ibin-1) 
        Xbin = Rmem(locdx+Ibin-1) 
        Yerr = Rmem(locdy+Ibin-1) 
        all = yval
        Call DO_MIN_funct(%val(address),Xval,Xbin,par,ichoice,
     &        all,bck,sig)
        Ythe = all
        Write (6,*) Real(xval),Real(Yval),Real(Yerr),Real(Ythe),Ichoice 
      End do
      Return
C
C --------------------------
C ENTRY DIS45_MIN_FCN_INIT 
C --------------------------
C      
      Entry DIS45_MIN_FCN_INIT(error_flag_ini)
C
      Call DIS45_current_his(here, id_hist, idim)

      ivx = 0
      ivy = 0
      ivdx = 0
      ivdy = 0
      If (idim.eq.3) Then
C       Call IntrdL('format (0:xy, 1:xydy, 2:xydxdy)',ifmt,0,2)
        Call IntrdL('format (0:xy, 1:xydy)',ifmt,0,1)
        Call HLtuple_asktag(id_hist,'x variable',1,varx,ivx)
        Call Hltuple_asktag(id_hist,'y variable',2,vary,ivy)
        If( ifmt.eq.1 ) Then
          Call HLtuple_asktag(id_hist,'dy variable',3,vardy,ivdy)
        Else If( ifmt.eq.2 ) Then
          Call HLtuple_asktag(id_hist,'dx variable',3,vardx,ivdx)
          Call HLtuple_asktag(id_hist,'dy variable',4,vardy,ivdy)
        Endif
      Endif
C
      If     (idim.eq.3) Then
        Call Hnoent(id_hist,nevent)
        ndatax = nevent
      Else if(idim.eq.1) Then
        Call DIS45_hinfo1(id_hist,title,nbinx,xmin,xmax)
        ndatax = nbinx
      Endif
C
      If( DIS45_malloc( ndatax*7,iddata,locx,error_flag_ini )
     & .le.0 )    Return
      locy = locx + ndatax
      locdx = locy + ndatax
      locdy = locdx + ndatax
      loctx = locdy + ndatax
      locty = loctx + ndatax
      locby = locty + ndatax
C
      If     (idim.eq.1) Then
        Do Ibin=1,Nbinx
          Call HIX(Id_hist,Ibin, low)
          Call HIX(Id_hist,Ibin+1,high)
          Xbin = high-low
          Xval = low + Xbin/2.0D0
          Yval = Hi(Id_hist,Ibin)
          Yerr = Hie(Id_hist,Ibin)
          If (Yerr.eq.0.0) then
            If (Yval.gt.0.) then
              Yerr = Sqrt(Abs(Yval))
            Endif
          Endif
          Rmem(locx +Ibin-1) = Xval
          Rmem(locy +Ibin-1) = Yval
          Rmem(locdx+Ibin-1) = Xbin
          Rmem(locdy+Ibin-1) = Yerr
        End do
      Else if(idim.eq.3) Then
        Call DIS45_tuple_getvec(id_hist,ivx,1,nevent,Rmem(locx),
     &    error_flag_ini)
        Call DIS45_tuple_getvec(id_hist,ivy,1,nevent,Rmem(locy),
     &    error_flag_ini)

        If( ivdx.ne.0 ) Then
          Call DIS45_tuple_getvec(id_hist,ivdx,1,nevent,Rmem(locdx),
     &      error_flag_ini)
        End If
        If( ivdy.ne.0 ) Then
          Call DIS45_tuple_getvec(id_hist,ivdy,1,nevent,Rmem(locdy),
     &      error_flag_ini)
        Else
          Do Ibin=1,Nevent
            Yval = Rmem(locy +Ibin-1)
            If (Yval.eq.0.) then
              Yerr = 0.
            else
              Yerr = Sqrt(Abs(Yval))
            Endif
            Rmem(locdy+Ibin-1) = Yerr
          End do
        Endif
      Endif
C
      L = Lenrd(exec_name)
      name = ' '
      name(:L) = exec_name(:L)
C
      status = Qopen('exec file for function',-1,name,
     &               'READ','UNFORMATTED','OLD')
C
      If( name(1:1).eq.' ' ) Then
C       ... if null specified, just return
        Return
      Else
C        >>> temporary fix for VMS
C        If( .not.status ) Then
C          error_flag_ini = 9
C          Return
C        End If
C        >>>
        L = Lenrd(name)
        exec_name = ' '
        exec_name(:L) = name(:L)
      End If
C
      address = DIS45_dynlink(exec_name,'MIN_FUNCT')
C
      If( address .eq. 0 ) Then
        error_flag_ini = 9
      End If
      Return
C
C --------------------------
C ENTRY DIS45_MIN_FCN_END 
C --------------------------
C      
      Entry DIS45_MIN_FCN_END(error_flag_ini)
C
      Call dis45_free(iddata)
      End

c
c Subroutine
c
      Subroutine DO_Min_funct(address,x,xwidth,par,ichoice,
     &    all,bak,sig)

      Implicit NONE
! input:
      External       address
      Real*8       x
      Real*8       xwidth             ! Bin width
      Real*8       par(*)             ! Par(2) =  # of Gaussian to fit
      Integer      ichoice
C
C output:
      Real*8       all
      Real*8       bak
      Real*8       sig
C
      Call address (x,xwidth,par, ichoice, all, bak, sig)
C
      Return
      End



cccccccccccccccccccccccccccccccccccc

      SUBROUTINE DIS45_MIN_residual (min_funct,opt,ndatax,nbiny,
     &  npar,par,iddata,error_flag)
C
C-   Purpose and Methods : Create a residual histogram
C
C-   Created  21-JUN-1993   K.Matuzaki
C
C----------------------------------------------------------------------
      IMPLICIT NONE
c input:
      External min_funct
      Character*1 opt
      Integer Ndatax,Nbiny
      Integer npar
      Real*8  par(*)                    ! parameter values
      Integer iddata
c output:
      Integer error_flag                
c
c -------------------
c common area for scratch
      Include 'pawc.inc'
      Integer locx, locy, locdx, locdy, loctx, locty, locby
C----------------------------------------------------------------------
C function:
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
      Real  Hi, Hie, Hif
c local:
      Integer id_hist
      Character*80 title
      Real Xmin, Xmax, Ymin, Ymax
      Real record(3)
      Character*8 regitags(3)
      Integer Ibin
      Real*8 xval,yval,yerr,xbin,ythe
      Real*8 all,bck,sig
      Integer ichoice /1/  ! choose specified x bin  as valid or not
                           ! 1 valid 2. no use
      Integer  here, dim, idnew, idim, idresi, logx
      Integer  nx, idbuf, loc
      Integer  nent
c 1-dim hist
      Integer Nbinx
c N-tule
      integer mtype,msize,nvar
        Integer  MAXTAG
        Parameter( MAXTAG = 1 )
        Character*8 tags(1)
C
      Call DIS45_current_his(here, id_hist, idim)

      Call DIS45_locate(iddata, locx)
      locy = locx + ndatax
      locdx = locy + ndatax
      locdy = locdx + ndatax
      loctx = locdy + ndatax
      locty = loctx + ndatax
      locby = locty + ndatax
C
      Do Ibin = 1, ndatax
        Xval = Rmem(locx +Ibin-1)  
        Yval = Rmem(locy +Ibin-1) 
        Xbin = Rmem(locdx+Ibin-1) 
        Yerr = Rmem(locdy+Ibin-1) 
        all = yval
        Call MIN_funct(Xval,Xbin,par,
     &        ichoice, all,bck,sig)
        If( Yerr.eq.0.0 ) Then
          Rmem(locby+Ibin-1) = 0
          Rmem(locty+Ibin-1) = 10.0
        Else
          Rmem(locby+Ibin-1) = (Yval - all)/Yerr 
          Rmem(locty+Ibin-1) = 1.0
        End If
      End Do
C
      If      (Idim.eq.1) Then
        If( DIS45_makehist(id_hist,1,idresi,error_flag).le.0 ) Return
        Call DIS45_hinfo1(id_hist,title,nbinx,xmin,xmax)
        Call Hcopy(id_hist,idresi,'SIGMA '//title)
C
        Call Hpak( idresi, Rmem(locby) )
        Call Hpake( idresi, Rmem(locty) )
C
        Call Hnoent(idresi,nent)
        Call DIS45_setentry(idresi,nent)
C
        Call DIS45_hsetopt(idresi,'NPFU')
      Else If (Idim.eq.3) Then
        If( DIS45_makehist(id_hist,1,idresi,error_flag).le.0 ) Return
        Call DIS45_hinfoN(id_hist,title,nvar,MAXTAG,tags)
        regitags(1) = 'x'
        regitags(2) = 'sigma'
        regitags(3) = 'error'
        Call HbookN(idresi,'SIGMA '//title, 3,' ',1000,regitags)
        Do Ibin = 1, ndatax
          record(1) = Rmem(locx +Ibin-1)
          record(2) = Rmem(locby+Ibin-1)
          record(3) = 1.0
          Call Hfn(idresi,record)
        End Do
      Endif
C
      If(opt.eq.' ') Then
        If (Idim.eq.1) Then
          Call Hminim(idresi,-5.0)
          Call Hmaxim(idresi, 5.0)
          Call DIS45_getopt(id_hist,'LOGX',logx)
          If( logx.ne.0 ) Call HPLopt('LOGX',1)
          Call Hplot(idresi,' ',' ',0)
        Else if (Idim.eq.3) Then
          Call DIS45_aux_putinfo(idresi,'YMIN',-5.0)
          Call DIS45_aux_putinfo(idresi,'YMAX', 5.0)
          Call Intrd('marker type ?',mtype)
          Call IGSET('MTYP',Float(mtype))
          Call Fltrd('marker size ?',msize)
          Call IGSET('MSCF',msize)
          Call DIS45_set_hplopt(idresi)
          Call HLplotNT(idresi,' ',1,2,0,3,mtype,msize,
     &                  error_flag )
        Endif
        Call IUWK(0,0)                 ! Update Workstation
        Call dis45_hdelete(idresi)
      Endif
C----------------------------------------------------------------------
  999 RETURN
      END



