      Subroutine DIS45_MIN_MIDATA(minfile,error_flag)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Read Initial values of parameters used in the fit
C-
C-   Created  18-MAY-1992   T.Takahashi
C
C    History  2-Mar-1993 A.Shirahashi
C             allow null filename specification
C             call mninit here instead of dis45_min_init
C             3-Mar-1993 A.Shirahashi
C             call MNcler instead of MNinit
C-
C----------------------------------------------------------------------
      IMPLICIT NONE
c
c input/output
      Character*(*)  minfile
c output
      Integer error_flag
C----------------------------------------------------------------------
      Integer  num, L
      Logical  status
      Character  chnam*10, file*80, title*120
      Real * 8  stval,step,bnd1,bnd2
      Integer  IErflag
      Integer  MAXLEN
      Parameter (MAXLEN=50)
C function
      Integer  Lenrd
      Logical  Qopen
C data
      Integer  number_of_parameters
      Save     number_of_parameters
      Data     number_of_parameters / 0 /
C begin
      L = Lenrd(minfile)
      file = ' '
      file(:L) = minfile(:L)
C
      status = Qopen('parameter file name',-1,file,
     &               'READ','FORMATTED','OLD')
C
      If( file(1:1).eq.' ' ) Then
C       ... if null specified, just return
        Return
      Else
        If( .not.status ) Then
          error_flag = 9
          Return
        End If
        L = Lenrd(file)
        minfile = ' '
        minfile(:L) = file(:L)
C       ... clear MINUIT
        Call MNcler
      End If
C
      Call OpnRD(minfile)
C
      Call Titrd('?title',title)
      Call DIS45_MIN_put_title(title)
      Call MNSETI(title(1:MAXLEN))
C
      WRITE (*,*) 'Enter Parameter',
     &  ' Number, Name, Value, Error, Lower and Upper Limits'
      number_of_parameters = 0

      Do While (.true.)
        CALL LINRD(1,0)
        CALL INTRD('?Param',num)
        CALL TXTRD('?Name ',chnam)
        CALL FDPRD('?Value',stval)
        Call FDPRD('?Error',step)
        Call FDPRD('?Low L',bnd1)
        Call FDPRD('?Upp L',bnd2)
     
        If (num.eq.0) Goto 1
        Call MNPARM(num,chnam,stval,step,bnd1,bnd2,ierflag)
        number_of_parameters = number_of_parameters + 1
        If (Ierflag.gt.0) then
          Write(*,*) 'Request failed in defining parameter',chnam
        Endif
      End do
    1 Continue
      Call DIS45_MIN_put_nparam(number_of_parameters)
C
      Return
      
      END
      
