C
C File: dis45_min_scan.f
C Description: SCAN and SCANPLOT
C Author: A.Shirahashi
C Date: 21-Oct-1992
C
      Subroutine DIS45_min_scan(dis45_min_fcn,error)
C
      Implicit None
C input
      Integer  error
C local
      Real * 8  arglist(10)
      Integer  param_id, ierflag
      Real * 8  low, up, step
C function
      External dis45_min_fcn
C begin
      Call DIS45_Min_Select_Param(param_id,low,up,step)
      arglist(1) = param_id
      If (step.eq.0.0D0) then
        error = -2 
        Return
      Endif  
      arglist(2) = (up-low)/step
      arglist(3) = low
      arglist(4) = up
      Call MNEXCM(DIS45_MIN_FCN, 'SCAN',arglist,4,ierflag)
      Return
      End
C
C
      Subroutine DIS45_min_scanplot(FCN,error)
C
      Implicit None
C const
      Integer  MAXDIV, MAXDIV1
      Parameter( MAXDIV = 100, MAXDIV1 = 101 )
C input
      Integer  error
C local
      Real * 8  arglist(10)
      Integer  param_id, ierflag
      Character * 16  name
      Integer  Lname, I
      Real * 8  val0, step0, low0, up0
      Real * 8  val, step, low, up
      Real * 8  fmin, fedm, errdef
      Integer  npari, nparx, istat
      Integer  print_level, junk
      Real  xpt(MAXDIV1), ypt(MAXDIV1), ymin, ymax, dy
      Integer  id
C function
      Integer  DIS45_makehist, Lenrd
      External FCN
C begin
      Call DIS45_min_select_param_name(param_id)
      Call MNpout(param_id,name,val0,step0,low0,up0,ierflag)
      Lname = Lenrd(name)
C
      low = val0 - 2.0D0 * step0
      up = val0 + 2.0D0 * step0
C
      Call Fdprd('lower limit',low)
      Call Fdprd('upper limit',up)
C
      step = (up - low)/Dble(MAXDIV)
C
C     ... disable output on TTY
      Call DIS45_min_set_printout(-1,print_level)
C
      Do I = 1, MAXDIV+1
        val = low + step * Dble(I-1)
        Call MNparm(param_id,name,val,step0,low0,up0,ierflag)
        arglist(1) = Dble(4)
        Call MNexcm(FCN,'CALL FCN',arglist,1,ierflag)
        Call MNstat(fmin,fedm,errdef,npari,nparx,istat)
        xpt(I) = Real(val)
        ypt(I) = Real(fmin)
      End Do
C
      Call MNparm(param_id,name,val0,step0,low0,up0,ierflag)
C
C     ... retore output on TTY
      Call DIS45_min_set_printout(print_level,junk)
C
      ymin = ypt(1)
      ymax = ypt(1)
      Do I = 1, MAXDIV1
        ymin = Min(ymin,ypt(I))
        ymax = Max(ymax,ypt(I))
      End Do
C
      dy = (ymax - ymin)*0.05
      ymin = ymin - dy
      ymax = ymax + dy
C
      If( DIS45_makehist(9999,1,id,error).lt.0 ) Return
C
      Call Hbook1(id,'Chi*2 Scan on '//name(:Lname),10,
     &            Real(low),Real(up),0.0)
C
      Call Hminim(id,ymin)
      Call Hmaxim(id,ymax)
C
      Call Hplot(id,' ',' ',1)
      Call DIS45_hdelete(id)
C
      Call Hplfun(xpt,ypt,MAXDIV1,' ')
      Call IUWK(0,0) ! Update Workstation
C
      Return
      End


