C----------------------------------------------------------------------
C-
C-   Created   3-JUN-1992   T.Takahashi
C-
C-   History   20-Oct-1992  A.Shirahashi  SET DEBUG
C-             21-Oct-1992  A.Shirahashi  SET PRINTOUT
C-                                        DIS45_min_set_printout
C-             26-Oct-1992  A.Shirahashi  SET MAXCALLS
C-
C----------------------------------------------------------------------
      Subroutine Dis45_Min_Set(dis45_min_fcn,error_flag)
C
      Implicit None
c functions:
      External DIS45_MIN_FCN
c output:
      Integer error_flag
c
      Integer igo
      Integer Ncomm
      Parameter (Ncomm = 12)
      Character*9 Comm(Ncomm)
      Data Comm /
     &  'ONE_PARAM',
     &  'PARAM    ',
     &  'ERROR    ',
     &  'LOWLIMIT ',
     &  'UPLIMIT  ',
     &  'FCN      ',
     &  'MAXCALLS ',
     &  'DEFERROR ',
     &  'DEBUG    ',
     &  'PRINTOUT ',
     &  'PLOTMODE ',
     &  'EXIT     '          
     &  /
c interface to MINUIT
      Real*8 Arglist(10)
      Integer IERRFLAG
C local
      Integer  debug_sw, print_level, old_level
      Character*9 Cmd
      Character*10 Prompt 
C data
      Data Prompt /'?MIN:SET> '/
c
c Main Body
c
100   Continue
      Call Keyrd(-1,Prompt,Cmd,Comm,Ncomm,Igo)
      error_flag = 0
      If (Cmd.eq.     'PARAM') then
        Call DIS45_MIN_Setparam
      else if (Cmd.eq.'ONE_PARAM') then
        Call DIS45_MIN_Setparam_one
      else if (Cmd.eq.'ERROR') then
        Call DIS45_MIN_Seterror
      else if (Cmd.eq.'LOWLIMIT') then
        Call DIS45_MIN_Setlowlimit
      else if (Cmd.eq.'UPLIMIT' ) then
        Call DIS45_MIN_Setuplimit
      Else If (Cmd.eq.'MAXCALLS ') Then
        Call DIS45_min_set_maxcalls
      Else if (Cmd.eq.'FCN    ') then
        arglist(1)=81 ! iflag=81
        Call MNEXCM(DIS45_MIN_FCN, 'CALL FCN',arglist,1,IERRFLAG)
      Else If (Cmd.eq.'DEFERROR ') Then
        Call Fdprd('?up',arglist(1))
        Call MNexcm(dis45_min_fcn,'SET ERRORDEF',arglist,1,ierrflag)
      Else If (Cmd.eq.'DEBUG    ') Then
        Call Intrd('?No.',debug_sw)
        arglist(1) = Dble(debug_sw)
        Call MNexcm(dis45_min_fcn,'SET DEBUG',arglist,1,ierrflag)
      Else If (Cmd.eq.'PRINTOUT ') Then
        Call Intrd('?level',print_level)
        Call DIS45_min_set_printout(print_level,old_level)
C        arglist(1) = Dble(print_level)
C        Call MNexcm(dis45_min_fcn,'SET PRINTOUT',arglist,1,ierrflag)
      Else If (Cmd.eq.'PLOTMODE ') Then
        Call DIS45_min_set_plotmode
      Else If (Cmd.eq.'EXIT ') Then
        Goto 999
      Endif
C----------------------------------------------------------------------
  999 RETURN
      END
C
C
      Subroutine DIS45_min_set_printout(newlevel,oldlevel)
C
C common
      Integer  MAXDBG
      Parameter( MAXDBG = 10 )
      Integer  ISW, IDBG, NBLOCK, ICOMND
      Common /MN7FLG/ ISW(7) ,IDBG(0:MAXDBG) ,NBLOCK ,ICOMND
C input
      Integer  newlevel
C output
      Integer  oldlevel
C begin
      oldlevel = ISW(5) 
      ISW(5) = newlevel
      Return
      End
C
C
      Subroutine DIS45_min_set_maxcalls
C
      Integer  ncalls
C
      Integer  maxcalls
      Save maxcalls
      Data maxcalls / 1000 /
C
      Call Intrd('maxcalls',maxcalls)
C
      Return
C
      Entry DIS45_min_get_maxcalls(ncalls)
C
      ncalls = maxcalls
      Return
      End
C
C
      Subroutine DIS45_min_set_plotmode
C
      Integer  outmode
C
      Integer  plotmode
      Save plotmode
      Data plotmode / 1 /
C
      Call IntrdL('0:without 1:with residual',plotmode,0,1)
C
      Return
C
      Entry DIS45_min_get_plotmode(outmode)
C
      outmode = plotmode
      Return
      End
