C
C Subroutine to calculate theory or model
C 
C
      Subroutine min_funct(x,xwidth,par,ichoice,all,bak,sig)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Function to be used in DISPLAY-MINUIT
C-
C-   Inputs  : 
C-   Outputs : 
C-   Controls: 
C-
C-   Created  24-JAN-1991   T.Takahashi
C-
C----------------------------------------------------------------------
      Implicit None
!
!
! input:
      Real*8       x
      Real*8       xwidth             ! Bin width
      Real*8       par(*)             ! Par(2) =  # of Gaussian to fit
      Integer      ichoice
C
C output:
      Real*8       all
      Real*8       bak
      Real*8       sig
C
C const:
      Integer maxgauss
      Parameter (maxgauss=10)
C local:
      Real*8       bin_width
      Integer*4    i
      Integer*4    ngauss
      Logical      area_flag
!
      Real*8       sigma(10)
      Real*8       peak(10)
      Real*8       area(10)
      Real*8       c1
      Real*8       c2
      Real*8       c3
      Real*8       c4
      Real*8       c5
      Real*8       c6
      Real*8       c7
      Real*8       c8
      Real*8       c9,c10,c11,c12,Xp
      Real*8 Xdenom
      Real*8 Thresh
      Integer Idenom
C
      Logical over_all_flag  /.false./

      Integer*4    flag_func
C
      all = 0.
      bak = 0.
      sig = 0.
C
      bin_width = par(1)
      If (par(2).lt.0) then
        over_all_flag = .true.
      else
        over_all_flag = .false.
      Endif

      ngauss      = abs( par(2) )

      If (ngauss.gt.maxgauss) Then
        ngauss=maxgauss
        Write(6,*) 'Ngauss exceeds ',maxgauss,' and is set to',maxgauss
      Endif
      c1           =  par(3)
      c2           =  par(4)
      c3           =  par(5)
      c4           =  par(6)
      c5           =  par(7)
      c6           =  par(8)
      c7           =  par(9)
      c8           =  par(10) 
      c9           =  par(11) 
      Do i=1,ngauss
        area(i) = par(12+3*(i-1))
        sigma(i) = par(13+3*(i-1))
        peak(i) = par(14+3*(i-1))
      End Do

      If (x.ge.0) then
        bak = c1 * (c2 + c3*x + c4*x**2 + c5*x**3 +                   
     &          c6*x**c7 + c8*x**c9 )
      else 
        bak = c1 * (c2 + c3*x + c4*x**2 + c5*x**3 )
      Endif
C
      Do i = 1, ngauss
        If ( sigma(i) .ne. 0.0 ) then
          sig = sig +
     &         0.39894*area(i)*exp(-0.5*((x-peak(i))/sigma(i))**2)
     &         /sigma(i)
        End If
Ccc                     !  1/Sqrt(2*PI)=0.39894
      End Do

      If (bin_width.gt.0.0) then
        sig=sig*bin_width
      else
        sig=sig*Xwidth
      Endif
      If (over_all_flag) then
        sig = c1 * sig
      else
        Continue
      Endif

      all = bak+sig
!
c

      Return
      End
