C
C Subroutine to calculate theory or model
C 
C
      Subroutine min_funct(x,xwidth,par,ichoice,all,bak,sig)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Function to be used in DISPLAY-MINUIT
C-
C-    Broken Power Law
C-
C-_           a*x**b (x <= break)
C-            c*x**d (x >  break)
C-
C-   Created  24-JAN-1991   T.Takahashi
C-
C----------------------------------------------------------------------
      Implicit None
!
!
! input:
      Real*8       x
      Real*8       xwidth             ! Bin width
      Real*8       par(*)            
      Integer      ichoice
C
C output:
      Real*8       all
      Real*8       bak
      Real*8       sig
C
c local:
      Real*8       a,b
      Real*8       c,d
      Real*8       break
c
      break = par(1)
      a = par(2)
      b = par(3)

      c = b- (log(c)-log(a))/log(break)
      d = par(4)

      bak=0
      If (x .le. break) then
        sig = a*x**b
      else 
        sig = c*x**d 
      all=sig
c
      Return
      End
