
!Rules

.FOR.OBJ
        fortran/separate/nolist $(MMS$SOURCE_LIST)

!Macro Definitions

MAINPROGRAM = DISPLAY45

INITEND_PROGRAM = DISPLAY45_INITEND

INITEND_PROGRAM_X = DISPLAY45_INITEND_X

SYSTEM_DEPEND = DISPLAY45VMS

! Library Path

CERNLIB_PATH = LIB:[LIB.CERN.PRO.LIB]
NAG_PATH     = LIB:[LIB.NAG]
CLI_PATH     = [.CLI]
COM_PATH     = [.COM]
MIN_PATH     = [.MIN45]
SOURCE_PATH = SYS$DISK:[]

! Libraries

TOOL_LIBRARIES = $(SOURCE_PATH)DISPLAY45TOOL.OLB/LIB

DISPLAY45_TOOL_MODULES = -
         display45vms,Display45_setup,-
         DIS45TOOL1,DIS45TOOL2,DIS45HUTIL,DIS45MISC,-
         HLalias, HLarea, HLaxtitl, HLavx, -
         HLbanx, HLbindiff, HLbinoper, HLBlow, HLbook, -
         Hlcdir, HLchbn, HLchedge, HLchtit, HLchwin, -
         HLcopy, HLcwd, HLdel, HLdist, -
         HLdofft, HLDEVI, HLecho, HLENT, HLexp, HLextfun,HLerro,-
         HLfetc, HLfetm_vms, HLfftw,-
         HLfit, HLfit_option, HLfitex, HLfitga, HLfitpo, HLfitsp, HLfitus, -
         HLglob, -
         HLhelp, HLhigz, HLinclude, HLindx, HLinteg, -
         HLjoin, HLlego, HLlocate, -
         HLmami, HLminuit,  HLmove, HLntplot, HLopen, HLoper, -
         HLopt, HLpdef, HLpake, HLpackfun, HLpfun, HLplot, HLprint, HLprox, -
         HLrebin, HLrepeat, HLreset, -
         HLrerro, HLrenum, HLresi, HLrandom, HLscale, HLset, HLslix, -
         HLsmooth, HLsort, HLsplot, HLsplot2, HLstat, HLstdiff, HLstore, -
         HLtable, HLtitle, HLtuple, HLval, HLwindow, HLwkty, HPKiovms

DISPLAY45_TOOL_LIBRARY = $(SOURCE_PATH)DISPLAY45TOOL.OLB($(DISPLAY45_TOOL_MODULES))

! Minuit

MIN_TOOLS_LIB = $(MIN_PATH)MIN_TOOLS.OLB/LIB

! CERN LIB

CERN_LIBRARIES = -
            $(CERNLIB_PATH)graflib/lib,-
            $(CERNLIB_PATH)grafgks/lib,gks_olb/lib,-
            $(CERNLIB_PATH)packlib/lib,$(CERNLIB_PATH)kernlib/lib

! for DEC GKS
!CERN_LIBRARIES = -
!            $(CERNLIB_PATH)graflib/lib,-
!            $(CERNLIB_PATH)grafdgks/lib,$(CERNLIB_PATH)grafdgks/opt,-
!            $(CERNLIB_PATH)packlib/lib,$(CERNLIB_PATH)kernlib/lib

CERN_LIBRARIES_X11 = -
            $(CERNLIB_PATH)graflib/lib,-
            $(CERNLIB_PATH)grafx11/lib, $(CERNLIB_PATH)grafx11/opt,-
            $(CERNLIB_PATH)gethostname.obj,-
            $(CERNLIB_PATH)packlib/lib,$(CERNLIB_PATH)kernlib/lib

NEW_CLI_LIB = $(CLI_PATH)CLI.OLB/LIB
NEW_COM_LIB = $(COM_PATH)COM.OLB/LIB

NEW_PEP4_LIBS = $(NEW_COM_LIB),$(NEW_CLI_LIB)

NAG_LIBRARIES = $(NAG_PATH)nage$library/lib

! Full Libraries

!LIBRARIES = $(DISPLAY45_TOOL_LIBRARY),MIN45,CLI,COM
LIBRARIES = $(DISPLAY45_TOOL_LIBRARY)

LINK_LIBRARIES = $(TOOL_LIBRARIES),$(MIN_TOOLS_LIB),-
                 $(CERN_LIBRARIES),$(NEW_PEP4_LIBS),-
                 $(NAG_LIBRARIES)

LINK_LIBRARIES_X11 = $(TOOL_LIBRARIES),$(MIN_TOOLS_LIB),-
                     $(CERN_LIBRARIES_X11),-
                     $(NEW_PEP4_LIBS),$(NAG_LIBRARIES)

LINK_OPT = DISPLAY45.OPT/OPT

! Objects

USER_OBJ = sys$disk:[]UFUNC.OBJ

OBJECTS = $(MAINPROGRAM).OBJ,$(INITEND_PROGRAM).OBJ,$(SYSTEM_DEPEND).OBJ

OBJECTS_X11 = $(MAINPROGRAM).OBJ,$(INITEND_PROGRAM_X).OBJ,$(SYSTEM_DEPEND).OBJ


! Dependencies

ALL : $(DISPLAY45_TOOL_LIBRARY)
	@ write sys$output "display45.olb is now up to date"

