C
C File: HLcdir.f
C Description: CD to other HBOOK directory
C Author: A.Shirahashi
C Date: 8-Oct-1993
C
      Subroutine HLcdir(error)
C
      Implicit None
C output
      Integer  error
C local
      Character * 80 subdir
      Integer  Ldir
C function
      Integer  Lenrd
C begin
      Call Txtrd('?directory',subdir)
C
      Ldir = Lenrd(subdir)
      Call Strupc(Ldir, subdir(:Ldir))
      If( Ldir.eq.0 ) Then
        Call HCDIR(subdir,'R')
        Ldir = Lenrd(subdir)
        Write(*,*) 'current directory: ', subdir(:Ldir)
        Return
      End If
C
      Call DIS45_cdir(subdir(:Ldir))
C
      Return
      End
C
C
      Subroutine HLldir(error)
C
      Implicit None
C const
      Integer  MAXDIR
      Parameter( MAXDIR = 32 )
C output
      Integer  error
C local
      Character * 16  dirs(MAXDIR)
      Integer  ndir, I, Ldir
C function
      Integer  Lenrd
C begin
      Call Hrdir(MAXDIR,dirs,ndir)
C
      Do I = 1, ndir
        Ldir = Lenrd(dirs(I))
        Write(*,'(1H ,I2,2X,A)') I,dirs(I)(:Ldir)
      End Do
C
      Return
      End
C
C
      Subroutine DIS45_alloc_cwd(idbuf, loc, create)
      Implicit NONE
C input
      Integer idbuf, loc
      Logical create
C common
      Include 'pawc.inc'
      Include 'display.inc'
C constant (HBOOK4)
      Integer  KCON1, IQ
      Parameter( KCON1 = 9, IQ = 18 )
C constant
      Integer cwd_id
      Parameter (cwd_id = 65536)
      Character*80 cwd_title
      Parameter (cwd_title = 'CWD')
C local
      Integer size, dim
      Character*80 title
C function
      Logical Hexist
C start
      idbuf = cwd_id
      If ( Hexist(idbuf) ) then
         Call DIS45_hinfo0(idbuf, title, dim)
         If ( cwd_title .ne. title ) then
            Write(*,*) "DIS45_store_cwd: HBOOK ID already used"
            idbuf = 0
            Return
         End if
      Else if ( create ) then
         size = 2 + 6 * Nplots
         Call Hbook1(idbuf, cwd_title, size, 0.0, 1.0, 0.0)
      Else
         idbuf = 0
         Return            
      End if
      
      Call Hlocat(idbuf, loc)
      
      If ( loc.le.0 ) then
         Write(*,*) "DIS45_store_cwd: Can't allocate buffer"
         idbuf = 0
         Return
      End if
      
      loc = Hmem(loc + 9) + IQ + KCON1 + 1
      
      Return
      End
C
C
      Subroutine DIS45_store_cwd
      Implicit NONE
C common
      Include 'display.inc'
      Include 'pawc.inc'
C local
      Integer i, idbuf, loc
C start
      Call DIS45_alloc_cwd(idbuf, loc, .true.)
      If ( 0.eq.idbuf ) then
         Return
      End if
      
      Hmem(loc) = Nh
      loc = loc + 1
      Hmem(loc) = Icou
      Do i = 1, Nh
         Hmem(loc+Nplots*0+i) = Iv(i)
         Hmem(loc+Nplots*1+i) = Idim(i)
         Hmem(loc+Nplots*2+i) = Iopt(i)
         Hmem(loc+Nplots*3+i) = Iaux(i)
         Rmem(loc+Nplots*4+i) = Smin(i)
         Rmem(loc+Nplots*5+i) = Smax(i)
      End do
      
      Return
      End
C
C
      Subroutine DIS45_restore_cwd
      Implicit NONE
C common
      Include 'display.inc'
      Include 'pawc.inc'
C local
      Integer i, idbuf, loc
C start
      Call DIS45_alloc_cwd(idbuf, loc, .false.)
      If ( 0.eq.idbuf ) then
         Call DIS45_inchist(' ')
         Return
      End if
      
      Nh = Hmem(loc)
      loc = loc + 1
      Icou = Hmem(loc)
      Do i = 1, Nh
          Iv(i)   = Hmem(loc+Nplots*0+i)
          Idim(i) = Hmem(loc+Nplots*1+i)
          Iopt(i) = Hmem(loc+Nplots*2+i)
          Iaux(i) = Hmem(loc+Nplots*3+i)
          Smin(i) = Rmem(loc+Nplots*4+i)
          Smax(i) = Rmem(loc+Nplots*5+i)
      End do
      Call Hdelet(idbuf)
      
      Return
      End
C
C
      Subroutine DIS45_cdir(subdir)
      Implicit NONE
C input
      Character*(*) subdir
C local
      Character*1 up
      Integer  Ldir
C function
      Integer  Lenrd
C start
      Call DIS45_store_cwd
      Ldir = Lenrd(subdir)
      If ( subdir(:Ldir).eq.'..' ) then
         up(1:1) = Char(92)
         Call HCDIR(up,' ')
      Else
         Call HCDIR(subdir(:Ldir),' ')
      End If
      Call DIS45_restore_cwd
C
      Return
      End
