C
C File: HLfetc.for
C Description: Fetch HBOOK4 files
C
C PEP4 Version mod by tt
C
C History: 15-Jun-1992, A.Shirahashi, use Iopen
C          16-Jun-1992, A.Shirahashi, use Qopen
C          25-Jun-1992, A.Shirahashi, use DIS45_getlun
C           2-Jun-1992, A.Shirahashi, support FZ format file
C           3-Jun-1992, A.Shirahashi, try to fix ERROR, but in vain
C          20-Oct-1992, A.Shirahashi, HLfetm
C           1-Nov-1992, use Hropen instead of Hrfile
C           8-Dec-1992, add HLfetx
C           9-Dec-1992, bug fix (freelun)
C          28-May-1993, hlfetm separated
C           2-Apr-1994, HLtahi -> DIS45_inchist
C
      Subroutine HLfetc(iod, error)
C
      Implicit None
C input
      Integer  iod
C output
      Integer  error
C begin
      Call HLfetch(' ',error)
      Return
      End
C
C
      Subroutine HLfetx(iod,error)
C
      Implicit None
C input
      Integer  iod
C output
      Integer  error
C begin
      Call HLfetch('X',error)
      Return
      End
C
C
      Subroutine HLfetch(mode,error)
C
      Implicit None
c intput
      Character * 1  mode
c output:
      Integer error
c
      Character*80 filename /'HISFILE'/

c function:
      Logical Qopen, Xopen
c local:
      Integer lun, fzlun, fmt
      Integer Istat
      Integer Nhists,Ihist
      Integer N
      Integer idoffset
C
      Integer MAXDIR
      Parameter( MAXDIR = 32 )
      Character * 16 dirs(MAXDIR)
      Integer ndir, I
C data
      Save idoffset
      Data idoffset / 0 /
C begin
      Call DIS45_getlun(lun)
C
      If( .not. Qopen('input file name',-1,filename,
     &                'Read','UNFORMATTED','OLD') ) Goto 999
C
      fmt = 0
      Call IntrdL(
     &  'Format (0:native, 1:portable binary, '//
     &  '2:portable ascii, 3:obsolete)',
     &  fmt,0,3)
C
      If( fmt.eq.0 ) Then
ccc        If( .not. Xopen(-lun,filename,
ccc     &                  'DIRECT=1024','UNFORMATTED','OLD' ) ) Goto 999
ccc        Call Hropen(lun,'ROOT',filename,' ',1024,istat)
ccc        If( istat.ne.0 ) Goto 999
        If( .not. Xopen(lun,filename,
     &                  'DIRECT=1024','UNFORMATTED','OLD' ) ) Goto 999
        Call Hrfile(lun,'ROOT',' ')
      Else If( fmt.eq.3 ) Then
        If( .not. Xopen(lun,filename,
     &                  'DIRECT=1024','UNFORMATTED','OLD' ) ) Goto 999
        Call Hrfile(lun,'ROOT',' ')
      Else If( fmt.eq.1 .or. fmt.eq.2 ) Then
        Call DIS45_getlun(fzlun)
        If( fmt.eq.1 ) Then
          If( .not. Xopen(fzlun,filename,
     &                    'Read','UNFORMATTED','OLD' ) ) Goto 999
          Call Fzfile(fzlun,0,'XI')
        Else If( fmt.eq.2 ) Then
          If( .not. Xopen(fzlun,filename,
     &                    'Read','FORMATTED','OLD' ) ) Goto 999
          Call Fzfile(fzlun,0,'AI')
        End If
        Open(Unit=lun,Form='UNFORMATTED',Access='DIRECT',
     &       Recl=1024,Status='SCRATCH')
        Call Hrfile(lun,'RZ','N')
        Call Rzfrfz(fzlun,' ')
        Call Fzendi(fzlun,'T')
        Call Hrend('RZ')
        Close(fzlun)
        Call DIS45_freelun(fzlun)
        Call Hrfile(lun,'ROOT',' ')
      End If
C
      If( mode.eq.' ' ) Then
        idoffset = 0
      Else If( mode.eq.'X' ) Then
        idoffset = idoffset + 1000
        Call Intrd('ID offset',idoffset)
      Else
        Print *, 'HLfetch: unknown mode: ', mode
      End If
C        
      Call Intrd('?how many histograms (0 for all)',Nhists)
      If (Nhists.eq.0) Then
        Call Hrin(0,999,idoffset)
C
C       ... support for subdirectory
        Call Hrdir(MAXDIR,dirs,ndir)
C       Write(*,*) 'ndir=',ndir
C       Call Hldir(' ',' ')
        Do I = 1, ndir
C         Write(*,*) 'dirs(i)=',dirs(I)
          Call Hcdir('//ROOT/'//dirs(I),' ')
          Call Hmdir('//PAWC/'//dirs(I),'S')
          Call Hrin(0,999,0)
        End Do
C
      Else
        Do N=1,Nhists
1         Call Intrd('?histogram id#',Ihist)
          If (Ihist.gt.0) Then
            Call Hrin(Ihist,9999,idoffset)
          Else                            
            Goto 1
          End If
        End Do
      End If
201   Continue
      Call Hrend('ROOT')
C
      Call DIS45_inchist( ' ' )
C
      Close (Lun)
      Call DIS45_freelun(lun)
      Return
C
  999 Continue
      error = 9                       ! file not found
      Return
      End
C
C
C File: HLfetc3.for
C Description: Read HBOOK3 file
C
C PEP4 Version mod by tt : Read Hbook3 histogram file
C
C History: 16-Jun-1992, A.Shirahashi, use QOPEN
C          25-Jun-1992, A.Shirahashi, use DIS45_getlun
C
      Subroutine Hlfetc3(Iod,error)
      Implicit None
c
c input:
      Integer Iod
c 
c output:
      Integer error
c
      Character*80 filename /'HISFILE'/
c
c local:
      Integer lun
      Integer Nhists,Ihist
      Integer N
C function
      Logical  Qopen
C begin
      Call DIS45_getlun(lun)
2     Continue 
C
C     Call Txtrd('Input file name',filename)
C     Open (unit=lun, file=filename,FORM='UNFORMATTED',
C    &  STATUS='OLD', ERR=999)

      If( .not. Qopen('input file name',lun,filename,
     &                'Read','UNFORMATTED','OLD' ) ) Goto 999
C
ccc      If(Iod.Eq.0) Go To 200

      Call Intrd('?How many histograms (0 for all)',Nhists)
      If (Nhists.eq.0) Then
        Call Hfetch(0,lun)
      Else
        Do N=1,Nhists
1         Call Intrd('?Histogram id#',Ihist)
          If (Ihist.gt.0) Then
            Call Hfetch(Ihist,lun)
          Else                            
            Goto 1
          End If
        End Do
      End If
201   Continue
      Call DIS45_inchist( ' ' )

      Close (Lun)
c
      Return
999   Continue
      error = 9
      Return
      End
C
C
