c
c File: HLstore.for
c Description: Store histograms into a file
c Author: R.Itoh
c
c History: 2-Jul-1992, A.Shirahashi, support FZ format
c          3-Jul-1992, A.Shirahashi, carriagecontrol=LIST
C         15-Jul-1992, A.Shirahashi, ask number of histograms 
C          8-Oct-1992, use getlun/freelun
C          1-Nov-1992, use Hropen instead of Hrfile
C         21-Jul-1994, store only valis histograms (by Ishisaki)
c                        
      Subroutine HLstore(error)
C
      Implicit None
C common
      Include 'pawc.inc'
C output
      Integer  error
C local
      Integer  fmt, istat
      Integer  nh, ih, id, idbuf, loc
      Character*80  file
      Integer  Lun1, Lun2
C function
      Logical  Xopen, Hexist
      Integer  DIS45_malloc
C data
      Data file /'histfile.hbk'/
C begin
      Call Txtrd('output histogram file name',file)
      fmt = 0
      Call IntrdL(
     &  'format (0:native, 1:portable binary, '//
     &  '2:portable ascii, 3:obsolete)',
     &  fmt,0,3)
C
      nh = 0
      Call Intrd('how many histograms (0:all)',nh)
      idbuf = 0
      If( nh.gt.0 ) Then
        If( DIS45_malloc( nh,idbuf,loc,error ).le.0 ) Return
        ih = 0
  100   Continue
        Call Intrd('?histogram ID (0:last)',id)
        If( id.eq.0 ) Then
          If( ih.eq.0 ) Goto 800
          nh = ih
          Goto 110
        End If
        If( .not. Hexist(id) ) Then
          Write(*,1000) id
 1000     Format(1X,'histogram ',I5,' not found.')
          Goto 100
        End If
        Hmem(loc+ih) = id
        ih = ih + 1
        If( ih.lt.nh ) Goto 100
  110   Continue
      End If
C
      Call DIS45_getlun( Lun1 )
      Call DIS45_getlun( Lun2 )
C
      If( fmt.eq.0 ) Then
        If( .not. Xopen(-Lun1,file,'DIRECT=1024','UNFORMATTED','NEW') )
     &    Goto 900
        Call Hropen(Lun1,'ROOT',file,'N',1024,istat)
        If( istat.ne.0 ) Goto 900
        Call HLstore_out(nh,Hmem(loc))
        Call Hrend('ROOT')
        Close(Lun1)
      Else If( fmt.eq.3 ) Then
        If( .not. Xopen(Lun1,file,'DIRECT=1024','UNFORMATTED','NEW') )
     &    Goto 900
        Call Hrfile(Lun1,'ROOT','N')
        Call HLstore_out(nh,Hmem(loc))
        Call Hrend('ROOT')
        Close(Lun1)
      Else If( fmt.eq.1 .or. fmt.eq.2 ) Then
        Open(Unit=Lun1,Form='UNFORMATTED',Access='DIRECT',Recl=1024,
     &       Status='SCRATCH')
        Call Hrfile(Lun1,'ROOT','N')
C       Call Hrout(0,icycle,' ')
        Call HLstore_out(nh,Hmem(loc))
        Call Hrend('ROOT')
        If( fmt.eq.1 ) Then
          If( .not. Xopen(Lun2,file,'WRITE','UNFORMATTED','NEW') )
     &      Goto 900
C          Open(Unit=2,File=file,Form='UNFORMATTED',Access='SEQUENTIAL',
C     &         Status='NEW')
          Call Fzfile(Lun2,0,'XO')
        Else If( fmt.eq.2 ) Then
          If( .not. Xopen(Lun2,file,'WRITE','LIST','NEW') )
     &      Goto 900
C          Open(Unit=2,File=file,Form='FORMATTED',Access='SEQUENTIAL',
C     &         Status='NEW')
          Call Fzfile(Lun2,0,'AO')
        End If
        Call Hrfile(Lun1,'FZ',' ')
        Call Rztofz(Lun2,' ')
        Call Fzendo(Lun2,'TE')
        Call Hrend('FZ')
        Close(Unit=Lun1)
        Close(Unit=Lun2)
      End If
C
  800 Continue
      Call DIS45_freelun(Lun1)
      Call DIS45_freelun(Lun2)
      If( idbuf.ne.0 ) Call DIS45_free( idbuf )
      Return
C
  900 Continue
      If( idbuf.ne.0 ) Call DIS45_free( idbuf )
      error = 9 ! can't open file
      Return
      End
C
C
      Subroutine HLstore_out(nh,idlist)
C
      Implicit None 

C input
      Integer  nh, idlist(*)
C local
      Integer  icycle, i, error
      Integer MAXDIR
      Parameter( MAXDIR = 32 )
      Character * 16 dirs(MAXDIR)
      Integer ndir, idir
C function
      Integer DIS45_numhist, DIS45_info_i
C begin
      If( nh.eq.0 ) Then
        nh = DIS45_numhist(error)
        Do i = 1, nh
           Call Hrout(DIS45_info_i(i),icycle,' ')
        End do
        Call DIS45_cdir('//PAWC')
        Call Hrdir(MAXDIR,dirs,ndir)
        If ( MAXDIR .lt. ndir ) then
           Write(*,*) 'Too many subdirectories (ndir=', ndir, ')'
           ndir = MAXDIR
        End if
        Do idir = 1, ndir
           Call DIS45_cdir('//PAWC/'//dirs(idir))
           Call Hmdir('//ROOT/'//dirs(idir),'S')
           nh = DIS45_numhist(error)
           Do i = 1, nh
              Call Hrout(DIS45_info_i(i),icycle,' ')
           End do
        End do
      Else If( nh.gt.0 ) Then
        Do i = 1, nh
          Call Hrout(idlist(i),icycle,' ')
        End Do
      End If
      Return
      End
