C
C File: DISPLAY45_HUTIL.FOR
C Description: Routines that depend on HBOOK/HPLOT internals
C Date: 2-May-1992
C Author: A.Shirahashi
C Original: DISPLAY45_TOOL
C
C Entries: DIS45_malloc, DIS45_locate, DIS45_free, DIS45_realloc
C          DIS45_hgetopt, DIS45_hsetopt, DIS45_hasbar,
C          DIS45_setentry, DIS45_fixentry, DIS45_hplinfo
C
C History:  7-May-1992 add DIS45_hasbar
C           8-May-1992 add DIS45_setentry, DIS45_fixentry
C          11-May-1992 add DIS45_hplinfo
C          21-May-1992 add dummy routine DISPLAY45_HUTIL for MMS
C           5-Jun-1992 add 'PFUN/NPFU' options to DIS45_hsetopt
C          30-Jul-1992 add DIS45_realloc
C          18-Aug-1992 add DIS45_hinfon (N-tuples)
C                          DIS45_tuple_minmax
C          24-Aug-1992 add DIS45_tuple_{getevt,getvec}
C           1-Sep-1992 DIS45_hgetopt (NEQB), add DIS45_getxbins
C          10-Sep-1992 DIS45_hsetopt (PFUN)
C          30-Oct-1992 DIS45_hinfoN, DIS45_tuple_minmax: use HgiveN
C          18-Mar-1993,DIS45_free, DIS45_locate -> Subroutine
C          30-Aug-1993,Include 'dis45def.inc'
C
      Subroutine DISPLAY45_HUTIL
C     dummy routine just for MMS
      End
C
      Integer Function DIS45_malloc( nwords,id,loc,error )
C
C Memory allocation routine using ZEBRA
C
      Implicit None
C common
      Include 'pawc.inc'
C
      Common /dis45_alloc/ nextid
      Integer  nextid
C
C constant (HBOOK4)
      Integer  KCON1, IQ
      Parameter( KCON1 = 9, IQ = 18 )
C input
      Integer nwords
C output
      Integer id, loc, error
C entries (unnecessary but required for Implit None)
C     Integer DIS45_free, DIS45_locate
C input for DIS45_free
C     Integer freeid
C input for DIS45_locate
C     Integer locid
C output for DIS45_locate
C     Integer locloc
C function
      Logical Hexist
C data
      Data nextid / 65537 /
C begin
      Do While( Hexist( nextid ) )
        nextid = nextid + 1
      End Do
      id = nextid
      Call Hbook1( id,'MALLOC',nwords,0.0,1.0,0.0 )
C     I would like to use Harray in stead of Hbook1, but it does not work.
C     Call Harray( id,nwords,loc )
      Call Hlocat( id,loc )
C     Print *, 'MALLOC: id,nwords,loc=',id,nwords,loc
      If( loc.le.0 ) Then
        error = 25 ! cannot allocate memory for buffer
        DIS45_malloc = -1
        Return
      End If
      loc = Hmem(loc + 9) + IQ + KCON1 + 1
C ifdef DEBUG
C     Print *, 'DIS45_malloc: id,loc,loc1 = ', id,loc,loc1
C     Do i = -10, Min(nwords,10)
C       print *, i, Hmem(Loc+i)
C     End do
C endif
      DIS45_malloc = loc
      Return
      End
C
      Subroutine DIS45_free( freeid )
C
      Implicit None
C input
      Integer  freeid
C common
      Common /dis45_alloc/ nextid
      Integer  nextid
C begin                     
C     Print *, 'FREE: id=',freeid
      Call Hdelet( freeid )
      nextid = freeid
      Return
      End
C
      Subroutine DIS45_locate( locid, locloc )
C
C Thie routine is necessary because 'loc' is subject to change due to
C ZEBRA garbage collection.
C
C constant
      Integer  KCON1, IQ
      Parameter( KCON1 = 9, IQ = 18 )
C input
      Integer  locid
C output
      Integer  locloc
C common
      Include 'pawc.inc'
C begin
      Call Hlocat( locid, locloc )
      locloc = Hmem(locloc + 9) + IQ + KCON1 + 1
      Return
      End
C
C
      Integer Function DIS45_realloc( nwords, id, loc, error )
C ... increase the size of buffer alreasy allocated
      Implicit None 
C common
      Include 'pawc.inc'      
C constant (HBOOK4)
      Integer  KCON1, IQ
      Parameter( KCON1 = 9, IQ = 18 )
C input
      Integer  nwords
C input/output
      Integer  id
C output
      Integer  loc, error
C local
      Integer  loc1, loc2, id2, nword1
      Integer  i
      Real  xmin, xmax
      Character * 80  title
C function
      Logical  Hexist
C local
      id2 = id + 1
      Do While( Hexist( id2 ) )
        id2 = id2 + 1
      End Do
C
      Call Hbook1( id2,'MALLOC',nwords,0.0,1.0,0.0 )
C
      Call DIS45_hinfo1( id,title,nword1,xmin,xmax )
C
      Call Hlocat( id,loc1 )
      If( loc1.le.0 ) Then
        Write(*,*) 'DIS45_realloc: id, loc1 = ', id, loc1
        DIS45_realloc = -1
        Return
      End If
      loc1 = Hmem(loc1 + 9) + IQ + KCON1 + 1
C
      Call Hlocat( id2,loc2 )
      If( loc2.le.0 ) Then
        error = 25 ! cannot allocate memory for buffer
        DIS45_realloc = -1
        Return
      End If
      loc2 = Hmem(loc2 + 9) + IQ + KCON1 + 1
C     Write(*,*) 'loc1,loc2=',loc1,loc2,nword1
C
      Do i = 0, nword1 - 1
        Rmem(loc2 + i) = Rmem(loc1 + i)
      End Do
C
      Call Hdelet( id )
      id = id2
      Call Hlocat( id,loc )
      loc = Hmem(loc + 9) + IQ + KCON1 + 1
      DIS45_realloc = loc
      Return
      End
C
C
      Integer Function DIS45_hgetopt( id,opt )
C
C inverse of HIDOPT
C this routine depends on HBOOK4
C
      Implicit None
C common
      Include 'pawc.inc'
C constant (HBOOK4)
      Integer  KBITS, IQ
      Parameter( KBITS = 1, IQ = 18 )
      Integer  MASK_ERRO, MASK_PERR, MASK_BARX, MASK_NEQB, MASK_PFUN
      Parameter( MASK_ERRO = '00000400'X ) ! error
      Parameter( MASK_PERR = '40000000'X ) ! print error
      Parameter( MASK_BARX = '00000100'X ) ! BARX
      Parameter( MASK_NEQB = '00000020'X ) ! non equivalent width bin
      Parameter( MASK_PFUN = '00000800'X ) ! plot function
C input
      Integer  id
      Character * (*)  opt
C output
      Integer  value
C local
      Integer  loc, flag
C begin
      Call Hlocat( id,loc )
      If( loc.le.0 ) Then
        DIS45_hgetopt = -1
        Return
      End If
      loc = loc + IQ + KBITS
      flag = Hmem(loc) 
      If ( opt.eq.'ERRO' ) Then
        DIS45_hgetopt = Iand( flag,MASK_ERRO )
      Else If ( opt.eq.'PERR' ) Then
        DIS45_hgetopt = Iand( flag,MASK_PERR )
      Else If ( opt.eq.'BARX' ) Then
        DIS45_hgetopt = Iand( flag,MASK_BARX )
      Else If ( opt.eq.'NEQB' ) Then
        DIS45_hgetopt = Iand( flag,MASK_NEQB )
      Else If ( opt.eq.'PFUN' ) Then
        DIS45_hgetopt = Iand( flag,MASK_PFUN )
      Else If ( opt.eq.'SHOW' ) Then
        Print '(1H ,Z8.8)', flag ! for test
        DIS45_hgetopt = flag
        Return
      Else
        Print *, 'DIS45_hgetopt, unknown option: ', opt
        DIS45_hgetopt = 0
      End If
      Return
      End
C
C
      Subroutine DIS45_hsetopt( id,opt )
C
C replacement of HIDOPT
C necessary because some options cannot be set by HIDOPT
C you cannot be too careful to use this routine
C
      Implicit None
C common
      Include 'pawc.inc'
C constant (HBOOK4)
      Integer  KBITS, IQ
      Parameter( KBITS = 1, IQ = 18 )
      Integer  MASK_ERRO, MASK_PERR, MASK_BARX, MASK_PFUN
      Parameter( MASK_ERRO = '00000400'X ) ! error
      Parameter( MASK_PERR = '40000000'X ) ! print error
      Parameter( MASK_BARX = '00000100'X ) ! BARX
      Parameter( MASK_PFUN = '00000800'X ) ! plot function
C input
      Integer  id
      Character * (*)  opt
C output
      Integer  value
C local
      Integer  loc, flag
C begin
      Call Hlocat( id,loc )
      If( loc.le.0 ) Return
      loc = loc + IQ + KBITS
      flag = Hmem(loc) 
      If ( opt.eq.'ERRO' ) Then
        flag = Ior( flag,MASK_ERRO )
      Else If ( opt.eq.'NERR' ) Then
        flag = Iand( flag,Not(MASK_ERRO) )
      Else If ( opt.eq.'PERR' ) Then
        flag = Ior( flag,MASK_PERR )
      Else If ( opt.eq.'NPER' ) Then
        flag = Iand( flag,Not(MASK_ERRO) )
      Else If ( opt.eq.'BARX' ) Then
        flag = Ior( flag,MASK_BARX )
      Else If ( opt.eq.'NBAX' ) Then
        flag = Iand( flag,Not(MASK_BARX) )
      Else If ( opt.eq.'PFUN' ) Then
        flag = Ior( flag,MASK_PFUN )
      Else If ( opt.eq.'NPFU' ) Then
        flag = Iand( flag,Not(MASK_PFUN) )
      Else If ( opt.eq.'SHOW' ) Then
        Print '(1H ,Z8.8)', flag ! for test
        Return
      Else
        Print *, 'DIS45_hsetopt, unknown option: ', opt
        Return
      End If
      Hmem(loc) = flag
      Return
      End
C
C
      Integer  Function  DIS45_hasbar(id)
C have error bar ?
      Implicit None
C input
      Integer id
C function
      Integer  DIS45_hgetopt
C begin
      DIS45_hasbar = DIS45_hgetopt(id,'ERRO')
     &             + DIS45_hgetopt(id,'BARX')
      Return
      End
C
C
      Subroutine DIS45_hist_minmax(id,minval,maxval)
C return min and max value set by Hminim, Hmaxim
      Implicit None
C common
      Include 'pawc.inc'
C constant (HBOOK4)
      Integer  KNOENT, IQ, KMIN, KMAX
      Parameter( KNOENT = 2, IQ = 18, KMIN = 7, KMAX = 8 )
C input
      Integer  id
C output
      Real  minval, maxval
C local
      Integer  loc
C begin
      Call Hlocat( id,loc )
      If( loc.le.0 ) Return
      minval = Rmem(loc+IQ+KMIN)
      maxval = Rmem(loc+IQ+KMAX)
      Return
      End
C
C
      Subroutine DIS45_setentry(id,entry)
C set number of entries 
      Implicit None
C common
      Include 'pawc.inc'
C constant (HBOOK4)
      Integer  KNOENT, IQ
      Parameter( KNOENT = 2, IQ = 18 )
C input
      Integer  id
      Integer  entry
C local
      Integer  loc
C begin
      Call Hlocat( id,loc )
      If( loc.le.0 ) Return                                             
      loc = Hmem(loc+9) + IQ + KNOENT
      Hmem(loc) = entry
      Return
      End
C
C
      Subroutine DIS45_fixentry(id)
C set number of entries = integrated counts
      Implicit None
C input
      Integer  id
C function
      Real  Hsum
C begin
      Call DIS45_setentry(id,Int(Hsum(id)))
      Return
      End
C
C
      Subroutine DIS45_hplinfo(name, value)
C return various internal infomation about HPLOT
C     Implicit None ! comment out for HPL.INC
C hplot common
      Include 'hpl.inc'
C input
      Character * (*)  name
C output
      Integer  value
C local
      Integer  Ival
      Logical  Lval
      Real  Rval
      Equivalence( Ival,Lval,Rval ) ! this is machine dependent
C begin
      If( name.eq.'YMINI' ) Then
        Rval = YMINI
      Else If( name.eq.'YMAXI' ) Then
        Rval = YMAXI
      Else If( name.eq.'FACTOR' ) Then
        Rval = FACTOR
      Else If( name.eq.'LOGY' ) Then
        Ival = LOGY
      Else
        Print *, 'DIS45_hplinfo: unknown item: ', name
        Return
      End If
      value = Ival
      Return
      End
C
C
      Subroutine DIS45_hinfoN(id,title,nvar,ntag,tags)
C
      Implicit None 
C const
C     Integer  MAXTAG
C     Parameter( MAXTAG = 64 )
      Include 'dis45def.inc'
C input
      Integer  id, ntag
C output
      Character * (*)  title, tags(ntag)
      Integer   nvar
C local
      Real  rlows(MAXTAG), rhighs(MAXTAG)
C begin
      nvar = Min( ntag,MAXTAG )
      Call HgiveN(id,title,nvar,tags,rlows,rhighs)
C
      Return
      End
C
C
      Subroutine DIS45_tuple_minmax(id,ivar,low,high)
C
      Implicit None 
C const
C     Integer  MAXTAG
C     Parameter( MAXTAG = 64 )
      Include 'dis45def.inc'
C input
      Integer  id, ivar
C output
      Real  low, high
C local
      Integer  nvar
      Character * 80  title
      Character * 8  tags(MAXTAG)
      Real  rlows(MAXTAG), rhighs(MAXTAG)
C begin
      nvar = MAXTAG
      Call HgiveN(id,title,nvar,tags,rlows,rhighs)
      If( ivar.le.nvar ) Then
        low = rlows(ivar)
        high = rhighs(ivar)
      End If
C
      Return
      End
C
C
      Subroutine DIS45_tuple_getevt(id,ievent,record,error)
C
      Implicit None 
C input
      Integer  id, Ievent
C output
      Integer  error
      Real  record(*)
C local   
      Integer  Loc, Nvar, I
C begin
      Call HGNPAR(id,'GETEVT')
      Call HGNF(id,ievent,record,error)
      Return
      End
C
C
      Subroutine DIS45_tuple_getvec(id,ivar,first,last,array,error)
C
      Implicit None 
C common
      Include 'pawc.inc'
C input
      Integer  id, ivar, first, last
C output
      Real  array(*)
      Integer  error
C local
      Integer  I, J, Nvar, Nevent, Istart, Iend
      Integer  idbuf, loc
      Character * 80  title
      Character * 8  tags
C function
      Integer  DIS45_malloc
C begin
      Call Hnoent(id,nevent)
      Call DIS45_hinfoN(id,title,Nvar,1,tags)
C
      If( Ivar.lt.1 .or. Ivar.gt.Nvar ) Then
        Write(*,*)
     &    'DIS45_tuple_getvec: Ivar out of range: ', Ivar
        Return
      End If
C
      If( DIS45_malloc(Nvar,idbuf,loc,error).le.0 ) Then
        Write(*,*) 
     &    'DIS45_tuple_getvec: Can''t allocate buufer, size = ', Nvar
        Return
      End If
C
      Istart = first
      Iend = last
      If( Istart.eq.0 ) Then
        Istart = 1
        Iend = nevent
      End If
      Istart = Max(Istart,1)
      Iend = Min(Iend,nevent)
C
      Call HGNPAR(id,'GETVEC')
C
      J = 1
      Do I = Istart, Iend
        Call HGNF(id,I,Rmem(loc),error)
        array(J) = Rmem(loc+Ivar-1)
        J = J + 1
      End Do
C
      Call DIS45_free(idbuf)
      Return              
      End
C
C
      Subroutine DIS45_CopyNT(idfrom,idto,newtitle)
C
      Implicit None
C common
      Include 'tags.inc'
C intput
      Integer  idfrom, idto
      Character * (*)  newtitle
C local
      Character * 80  title
      Real  record(MAXTAG)
      Integer  nvar, nevent, I, error
C begin
      Call DIS45_hinfoN(idfrom,title,nvar,MAXTAG,tags)
      Call HbookN(idto,newtitle,nvar,' ',1000,tags)
      Call Hnoent(idfrom,nevent)
      Do I = 1, nevent
        Call DIS45_tuple_getevt(idfrom,I,record,error)
        Call Hfn(idto,record)
      End Do
      Return
      End
C
C








