C
C File: dis45misc.f
C Descption: Miscellaneous utility routines
C Date: 1-Apr-1994
C Author: A.Shirahashi
C 
C DIS45_sigI, DIS45_sigC, DIS45_sigR, DIS45_sigX, DIS45_sleep
C
C Require CERN Library KERNLIB (SIGNALF,SLEEPF)
C
      Subroutine DIS45_sigI( signum )
C     ... establish signal hander
C input
      Integer signum
C common
      Common /DIS45_sign/ sigsts, sigold
      Logical sigsts
      Integer sigold
C function
      Integer  SignalF
      External DIS45_sigH
C begin
      sigsts = .FALSE.
      sigold = SignalF( signum,DIS45_sigH,-1 )
      Return
      End
C
C
      Logical Function DIS45_sigC( signum )
C     ... check if signal occured
C input
      Integer  signum
C common
      Common /DIS45_sign/ sigsts,sigold
      Logical sigsts
      Integer sigold
C begin
      DIS45_sigC = sigsts
      Return
      End
C
C
      Subroutine DIS45_sigR( signum )
C     ... reset signal flag
C input
      Integer  signum
C common
      Common /DIS45_sign/ sigsts,sigold
      Logical sigsts
      Integer sigold
C begin
      sigsts = .FALSE.
      Return
      End
C
C
      Subroutine DIS45_sigX( signum )
C     ... restore original signal handler
C input
      Integer  signum
C local
      Integer  junk
C function
      Integer  SignalF
C begin
      junk = SignalF( signum, 0, sigold )
      Return
      End
C
C
      Subroutine DIS45_sigH( signum )
C     ... signal handler
      Integer  signum
C common
      Common /DIS45_sign/ sigsts,sigold
      Logical sigsts
      Integer sigold
C begin
      sigsts = .TRUE.
      Return
      End
C
C
      Subroutine DIS45_sleep( minutes )
C input
      Integer  minutes
C begin
      Call SLEEPF( minutes )
      Return
      End
