C 
C File: dis45tool1.f
C Desription: display45_tool.f -> dis45tool1.f, dis45tool2.f
C
C TOOLS for DISPLAY45
C               By T.Takahashi
C
C 23-Mar-1992  A.Shirahashi  add Upcase
C			     HPLOU.INC -> display.inc
C 16-Apr-1992  A.Shirahashi  add DIS45_needhist, DIS45_hinfo1, DIS45_hinfo2
C 20-Apr-1992  A.Shirahashi  add DIS45_{malloc,free,locate}
C                            add DIS45_hrebin2
C                            add DIS45_{getlimits,chan2limits}
C                            add DIS45_makehist
C 21-Apr-1992  A.Shirahashi  add DIS45_hrebin1
C                            add DIS45_{hgetopt,hsetopt}
C                            DIS45_setopt: enrich items
C 23-Apr-1992  A.Shirahashi  add DIS45_delhist
C 24-Apr-1992  A.Shirahashi  move DIS45_getlimits to HLblow.for
C  2-May-1992  A.Shirahashi  move DIS45_{malloc,locate,free,hgetopt,hsetopt}
C                            to DISPLAY45_HUTIL.FOR
C  2-May-1992  A.Shirahashi  add DIS45_{thishist,samehist,hexist,hinfo0}
C  6-May-1992  A.Shirahashi  add DIS45_hdelete
C                            now DIS45_{hinfo[0-2],samehist} checks the
C                            existence of the histogram
C 12-May-1992  A.Shirahashi  fetch DIS45_getlimits from HLblow.for
C 21-May-1992  A.Shirahashi  Add dummy routine DISPLAY45_TOOL for MMS
C 27-May-1992  A.Shirahashi  fix a trivial bug in DIS45_delhist
C  8-Jun-1992  A.Shirahashi  change the rule for boundary bins
C  8-Jun-1992  A.Shirahashi  fix a TRIVIAL bug in DIS45_hrebin1
C  9-Jun-1992  A.Shirahashi  allow #bin for DIS45_getlimits
C                            add DIS45_getchan
C 15-Jun-1992  A.Shirahashi  add DIS45_sethist
C 25-Jun-1992  A.Shirahashi  add HLfnid, DIS45_findid, DIS45_lookup
C 26-Jun-1992  A.Shirahashi  DIS45_numhist now has one argument
C                            DIS45_current_his returns all zero if error
C 21-Jul-1992  A.Shirahashi  DIS45_getchan use FltrdX
C                            add DIS45_HixC, DIS45_HijxyC
C 23-Jul-1992  A.Shirahashi  add DIS45_current, DIS45_set_current
C  3-Aug-1992  A.Shirahashi  'PLAX' option in DIS45_setopt
C                            add DIS45_getopt
C  4-Aug-1992  A.Shirahashi  DIS45_getlimit1, DIS45_chan2limit1
C 18-Aug-1992  A.Shirahashi  DIS45_hinfo0 (N-tuples)
C 19-Aug-1992  A.Shirahashi  DIS45_needhist (dim=3)
C 26-Aug-1992  A.Shirahashi  DIS45_needhist (bug fix)
C  9-Sep-1992  A.Shirahashi  DIS45_hinfo1 (dim = 3)
C 14-Sep-1992  A.Shirahashi  DIS45_setopt/getopt (FIXX)
C 17-Sep-1992                for Iaux in /HvHist/ (display.inc)
C                            DIS45_auxalloc, auxput, auxget
C 18-Sep-1992                display45_tool.f -> dis45tool1.f, dis45tool2.f
C                            DIS45_getopt/setopt have ID argument
C                            remove DIS45_getinfo, DIS45_info
C 22-Sep-1992                DIS45_auxget/put FUNC
C 14-Sep-1992                remove unnecessary init. code in DIS45_insert
C 24-Dec-1992                DIS45_delhist: set Icou=0 when Nh=0
C 16-Feb-1994                DIS45_getinfo, DIS45_putinfo
C  2-Apr-1994                marge HLtahi.f, add DIS45_synchist
C                            add 'SYNC' in DIS45_setopt/getopt
C
C *****
C DIS45_current
C DIS45_set_current
C DIS45_thishist
C DIS45_current_his
C DIS45_info_i
C DIS45_lookup
C DIS45_sethist
C DIS45_setopt
C DIS45_getopt
C DIS45_numhist
C HLfnid = DIS45_findid
C DIS45_delhist
C DIS45_hdelete
C DIS45_makehist
C HLtahi = DIS45_inchist
C DIS45_synchist
C DIS45_needhist
C DIS45_hexist
C DIS45_samehist
C DIS45_auxalloc
C DIS45_aux_getinfo
C DIS45_aux_putinfo
C *****
C                                     
      Subroutine DISPLAY45_TOOL
C     dummy routine just for MMS
      End
C
C
      Integer Function DIS45_current(error)
C ... return current histogram pointer
      Implicit None 
C common
      Include 'display.inc'
C output
      Integer  error
C begin
      If(Nh.le.0) Then
        error = 1 ! you should fetch something
      Else If(Icou.le.0) Then
        error = 2 ! you should move to some id#
      End If
      DIS45_current = Icou
      Return
      End
C
C
      Subroutine DIS45_set_current(i,error)
C ... set current histogram pointer
      Implicit None 
C common
      Include 'display.inc'
C input
      Integer  i
C output  
      Integer  error
C begin
      If(Nh.le.0) Then
        error = 1 ! you should fetch something
      Else If(i.gt.Nh) Then
        error = 3 ! nothing after
      Else If(i.le.0) Then
        error = 4 ! nothing before
      Else If(Icou.le.0) Then
        error = 2 ! you should move to id#
        If(i.ge.1 .and. i.le.Nh) Then
          Icou = i
        End If
      Else
        Icou = i
      End If
      Return
      End
C
C
      Subroutine DIS45_thishist(here, id, dim)
C synonym for DIS45_current_his
      Implicit None
C output
      Integer  here, id, dim
C begin
      Call DIS45_current_his(here, id, dim)
      Return
      End
C
C
      Subroutine DIS45_current_his(here, id, dim)
C ... return current histogram, return all zero in case of error
      Implicit NONE
c
c output:
      Integer here
      Integer id
      Integer dim
c
      Include 'display.inc'
C begin
      If (Icou.gt.0) then
        here = Icou
        id = iv(Icou)
        dim = idim(Icou)
      Else
        here = 0
        id = 0
        dim = 0
      Endif
C
      Return
      End
C
C
      Integer function DIS45_info_i(i)
c return histogram id of the i'th histogram in DISPLAY buffer
      Implicit NONE
c
      Integer i
c
      Include 'display.inc'

      If (nh.gt.0) then
        DIS45_info_i = iv(i)
      else 
        DIS45_info_i = 0
      Endif

      Return
      End
C
C
      Integer Function DIS45_lookup(id)
C ... return histogram pointer which has the specified ID number.
      Implicit None 
C common
      Include 'display.inc'
C input
      Integer  id
C local
      Integer  i
C begin
      Do i = 1, Nh
        If( Iv(i).eq.id ) Then
          DIS45_lookup = i
          Return
        End If
      End Do
      DIS45_lookup = 0
      Return
      End
C
C
      Subroutine DIS45_sethist(id,error)
C ... set current histogram pointer to histogram specified ID number.
      Implicit None 
C common
      Include 'display.inc'
C input
      Integer id
C output
      Integer error
C local
      Integer i
C function
      Integer DIS45_lookup
C begin
      i = DIS45_lookup(id)
C
      If( i.gt.0 ) Then
        Icou = i
      Else
        error = 5 ! this histogram does not exist
      End If
C
      Return
      End
C
C
      Subroutine DIS45_setopt(id,str)
      Implicit NONE
C common
      Include 'display.inc'
c input:
      Integer  id       ! id=0 : apply on the current histogram
      Character*(*) str ! option str
c local:
C     Integer  error, here, id, dim
      Integer  I
c function:
C     Integer  DIS45_needhist
      Integer  DIS45_lookup
c begin
C     If( DIS45_needhist(0,error).le.0 ) Return
C     Call DIS45_current_his(here,id,dim)
      If( id.eq.0 ) Then
        I = Icou
      Else
        I = DIS45_lookup(id)
      End If
      If( I.eq.0 ) Return
c
      If (str.eq.'LOGX') then
        Iopt(I) = Ior(Iopt(I),DIS45_LOGMASK_X)
      else if (str.eq.'LOGY') then
        Iopt(I) = Ior(Iopt(I),DIS45_LOGMASK_Y)
      else if (str.eq.'LINX') then
        Iopt(I) = Iand(Iopt(I),Not(DIS45_LOGMASK_X))
      else if (str.eq.'LINY') then
        Iopt(I) = Iand(Iopt(I),Not(DIS45_LOGMASK_Y))
      Else If (str.eq.'SYNC') Then
        Iopt(I) = Ior(Iopt(I),DIS45_SYNC_MASK)
      else if (str.eq.'PERR'.or.str.eq.'NPER') then
        Call Hidopt(id,str)       
      else if (str.eq.'ERRO'.or.str.eq.'NERR') then
        Call Hidopt(id,str)       
      else if (str.eq.'BARX'.or.str.eq.'NBAX') then
        Call DIS45_hsetopt(id,str) ! undocumented option
      else if (str.eq.'PLAX') then
        Iopt(I) = Ior(Iopt(I),DIS45_PLAX_MASK)
      else
        Write(*,*) 'DIS45_setopt, illegal optstr detected: ', str
      Endif
      Return
      End
C
C
      Subroutine DIS45_getopt(id,str,flag)
      Implicit NONE
C common
      Include 'display.inc'
c input
      Integer  id       ! id=0 : apply on the current histogram
      Character*(*) str ! option str
C output
      Logical  flag
c local
C     Integer  error
      Integer  I
c function
C     Integer  DIS45_needhist
      Integer  DIS45_lookup
c begin
C     If( DIS45_needhist(0,error).le.0 ) Return
      If( id.eq.0 ) Then
        I = Icou
      Else
        I = DIS45_Lookup(id)
      End If
      If( I.eq.0 ) Return
c
      If (str.eq.'LOGX') then
        flag = (Iand(Iopt(I),DIS45_LOGMASK_X).ne.0)
      else if (str.eq.'LOGY') then
        flag = (Iand(Iopt(I),DIS45_LOGMASK_Y).ne.0)
      else if (str.eq.'LINX') then
        flag = (Iand(Iopt(I),DIS45_LOGMASK_X).eq.0)
      else if (str.eq.'LINY') then
        flag = (Iand(Iopt(I),DIS45_LOGMASK_Y).eq.0)
      else if (str.eq.'PLAX') then
        flag = (Iand(Iopt(I),DIS45_PLAX_MASK).ne.0)
      Else If (str.eq.'SYNC') Then
        flag = (Iand(Iopt(I),DIS45_SYNC_MASK).ne.0)
      else
        Write(*,*) 'DIS45_getopt, illegal optstr detected: ', str
      Endif
      Return
      End
C
C
      Integer function DIS45_numhist(error)
C ... return number of histograms
      Implicit NONE
C common
      Include 'display.inc'
C output
      Integer error
C begin
      DIS45_numhist = nh
      If( nh.le.0 ) Then
        error = 1	! you should fetch something
      End If
      Return
      End
C
C
      Subroutine DIS45_findid( idnew, id )
      Entry HLfnid( idnew, id )
C ... find free ID
C input
      Integer  id
C outout
      Integer  idnew
C function
      Logical  Hexist
C begin
      idnew = id
   10 Continue 
      idnew = idnew + 1
      If( Hexist( idnew ) ) Goto 10
      Return
      End
C
C
      Subroutine DIS45_insert(id, dim, error)
C
C insert histogram in display buffer
C
      Implicit NONE
C common
      Include 'display.inc'
C constant
      Integer  NWAUX
      Parameter( NWAUX = 8 )
C input
      Integer id, dim
C output
      Integer error
C local
      Integer ih, idbuf, loc
C funcion
      Integer DIS45_malloc
C begin
C
C     ... remove unnecessary initializtion code in case of Icou = 0
C     If (Icou.Eq.0) Then
C       Nh=0
C       Icou=0
C       Goto 1
C     End If
C
      If (Nh.ge.Nplots) then
        error = 13
        Return
      Endif
      Do Ih = Nh,Icou+1,-1
        Iv(Ih+1) = Iv(Ih)
        Idim(Ih+1) = Idim(Ih)
        Iopt(Ih+1) = Iopt(Ih)
        Iaux(Ih+1) = Iaux(Ih)
      End Do
1     Continue
      Nh = Nh+1
      Iv(Icou+1) = Id
      Idim(Icou+1) = dim
      Iopt(Icou+1) = 0
      Iaux(Icou+1) = 0
C
      If( dim.eq.3 ) Then
        If( DIS45_malloc(NWAUX,idbuf,loc,error) .gt. 0 ) Then
          Iaux(Icou+1) = idbuf
        End If
      End If
      Return
      End
C
C
      Subroutine DIS45_delhist( ic )
C
      Implicit None
C common
      Include 'display.inc'
C input
      Integer  ic
C local
      Integer  i
C begin
      If( ic.eq.0 ) Then
        Nh = 0
        Icou = 0
      Else If( ic.gt.0 .and. ic.le.Nh ) Then
        Do i = ic, Nh - 1
          Iv(i) = Iv(i+1)
          Idim(i) = Idim(i+1)
          Iopt(i) = Iopt(i+1)
          Iaux(i) = Iaux(i+1)
        End Do
        Nh = Nh - 1
        If( Nh.eq.0 ) Then
          Icou = 0
        End If
      Else
        Print *, 'DIS45_delhist: ic = ', ic, ', Nh = ', Nh
      End If
      Return
      End
C
C
      Subroutine DIS45_hdelete( id )
C delete histgram from both display entry and hbook entry
      Implicit None
C common
      Include 'display.inc'
C input
      Integer  id
C local
      Integer  i
C function
      Integer  DIS45_lookup
C begin
      i = DIS45_lookup(id)
C
      If( i.gt.0 ) Then
        Call DIS45_delhist(i)
        Call Hdelet(id)
      Else
        Write(*,*) 'DIS45_hdelete: can''t find histogram id = ',id
      End If
C
      Return
      End
C
C
      Integer Function DIS45_makehist( id,dim,idnew,error )
C
      Implicit None
C input
      Integer id, dim
C output
      Integer idnew, error
C
C begin
      Call DIS45_findid(idnew,id)
      Call DIS45_insert(idnew,dim,error)
      If (error.ne.0) Then
        DIS45_makehist = -1
      Else
        DIS45_makehist = 1
      End If
      Return
      End
C
C
      Subroutine DIS45_inchist( opt )
      Entry HLtahi( opt )
C
C     ... include and register histograms
C      Implicit None
C common
      Include 'display.inc'
C input
      Character * (*)  opt
C local
      Integer  I
      Character * 80  title
C begin
      Call Hidall(Iv,Nh)
C
      Do I = 1, Nh
        Call DIS45_hinfo0(Iv(I),title,Idim(I))
      End Do
C
      If( opt.eq.'M' ) Then
        Do I = 1, Nh
          Call DIS45_setopt(Iv(I),'SYNC')
        End Do
      End If
C
      Return
      End
C
C     
      Subroutine DIS45_synchist(id)
C
      Implicit None
C input
      Integer  id
C local
      Integer  dim
      Character * 80  title
      Logical  status
      Real minval, maxval
C begin
      Call DIS45_hinfo0(id,title,dim)
      Call DIS45_getopt(id,'SYNC',status)
C
      If( status ) Then
        If( dim.eq.1 ) Then
          Call DIS45_hist_minmax(id,minval,maxval)
          Call Hdelet(id)
          Call Hrin(id,9999,0)
          Call Hmaxim(id,maxval)
          Call Hminim(id,minval)
        Else
          Call Hdelet(id)
          Call Hrin(id,9999,0)
        End If        
      End If
C
      Return
      End
C
C
      Integer Function DIS45_needhist(dim,error)
C
C check the validity of current histogram
C
C return value
C   For dim = 1 or 2 or 3
C      -1   NG. Current histogram is 1 dimensional
C      -2   NG. Cureent histogram is 2 dimensional
C      -3   NG. Current histogram is N-tuple
C       0   No histograms exist or selected
C       1   OK. Current histogram is 1 dimensional
C       2   OK. Current histogram is 2 dimensional
C       3   OK. Current histogram is N-tuple
C   For dim = 0
C      -1   No histograms exist or selected   
C       1   Current histogram is 1 dimensional
C       2   Current histogram is 2 dimensional
C
C   dim = 4 : need 1 dim or N-tuple (1+3)
C   dim = 5 : need 2 dim or N-tuple (2+3)
C   dim = 6 : need 1 dim or 2 dim or N-tuple (1+2+3)
C
      Implicit None
C
C input
      Integer dim
C output
      Integer error
C function
      Integer DIS45_numhist
C local
      Integer here, id, idim
C
C begin
      If (DIS45_numhist(error).eq.0) Then
C       error = 1	! you should fetch something
        DIS45_needhist = 0
        Return
      End If
C
      Call DIS45_thishist(here,id,idim)
C
      If (here.eq.0) Then
        error = 2	! you should move to some id
        DIS45_needhist = 0
        Return
      End If
C
      If (dim.eq.1 .or. dim.eq.2) Then
        If (idim.ne.dim) Goto 200
      Else If(dim.eq.3) Then
        If(idim.ne.3) Then
          error = 29 ! command valid only for N-tuple
          DIS45_needhist = -idim
          Return
        End If
      Else If(dim.eq.4) Then
        If(idim.ne.1 .and. idim.ne.3) Goto 200
      Else If(dim.eq.5) Then
        If(idim.ne.2 .and. idim.ne.3) Goto 200
      Else If(dim.eq.6) Then
        If(idim.ne.1 .and. idim.ne.2 .and. idim.ne.3) Goto 200
      Else If(dim.eq.0) Then
        DIS45_needhist = idim
        Return
      End If
C   
      error = 0
      DIS45_needhist = idim
      Return
C
  200 Continue
      If (idim.eq.1) Then
        error = 6 ! command not valid for 1 dim histo 
      Else if(idim.eq.2) Then
        error = 7 ! command not valid for 2 dim histo
      Else if(idim.eq.3) Then
        error = 30 ! command not valid for N-tuples
      End If
      DIS45_needhist = -idim
      Return
      End
C
C
      Integer Function DIS45_hexist(id, error)
C replacement for Hexist
      Implicit None
C input
      Integer  id
C output
      Integer  error
C function
      Logical  Hexist
C begin
      If( Hexist(id) ) Then
	DIS45_hexist = 1
      Else
        error = 5 ! this histogram does not exist
        DIS45_hexist = -1
      End If
      Return
      End
C
C
      Integer Function DIS45_samehist(id1,id2,error)
C check if two hist have same dimension
      Implicit None
C input
      Integer  id1, id2
C output
      Integer  error
C local
      Character * 80  title
      Real  xmin, xmax, ymin, ymax
      Integer  nx1, nx2, ny1, ny2
C begin
      Call DIS45_Hinfo2(id1,title,nx1,xmin,xmax,ny1,ymin,ymax)
      Call Dis45_Hinfo2(id2,title,nx2,xmin,xmax,ny2,ymin,ymax)
C
      If( nx1.eq.0 .or. nx2.eq.0 ) Then
        error = 5 ! histogram does not exist
        DIS45_samehist = -1
      Else If( ny1.eq.0 .and. ny2.gt.0 ) Then
        error = 15 ! dimension mismatch
        DIS45_samehist = -1
      Else If( ny1.gt.0 .and. ny2.eq.0 ) Then
        error = 15 ! dimension mismatch
        DIS45_samehist = -1
      Else If( nx1.ne.nx2 .or. ny1.ne.ny2 ) Then
        error = 33 ! different number of bins
        DIS45_samehist = -1
      Else If( nx1.eq.nx2 .and. ny1.eq.ny2 ) Then
        DIS45_samehist = 1
      Else 
        Print *, 'DIS45_samehist: can''t happen'
        DIS45_samehist = -1
      End If
      Return
      End
C
C
      Subroutine DIS45_auxalloc(id,nwords)
C
C Allocate auxiliary block
C
      Implicit None
C common
      Include 'display.inc'
C input
      Integer  id, nwords
C local
      Integer  idbuf, loc, error, i
C function
      Integer  DIS45_malloc, DIS45_lookup
C begin
      If( DIS45_malloc(nwords,idbuf,loc,error).le.0 ) Return
      i = DIS45_lookup(id)
      If( i.eq.0 ) Return
      Iaux(i) = idbuf
      Return
      End
C
C
      Subroutine DIS45_aux_getinfo(id,opt,val)
C
      Implicit None
C constant
      Integer  K_TYPE, K_FUNC, K_YMIN, K_YMAX
      Parameter( K_TYPE = 0, K_FUNC = 1, K_YMIN = 2, K_YMAX = 3 )
C common
      Include 'pawc.inc'
      Include 'display.inc'
C input
      Integer  id
      Character * (*)  opt
      Real  val
C local
      Integer  I, idaux, loc
C funcion
      Integer  DIS45_lookup
C begin
      If( id.eq.0 ) Then
        I = Icou
      Else
        I = DIS45_lookup(id)
      End If
      If( I.eq.0 ) Return
      idaux = Iaux(I)
      If( idaux.eq.0 ) Return
      Call DIS45_locate( idaux,loc )
      If( loc.le.0 ) Return
C
      If( opt.eq.'FUNC' ) Then
        val = Rmem(loc + K_FUNC)
      Else If( opt.eq.'YMIN' ) Then
        val = Rmem(loc + K_YMIN)
      Else If( opt.eq.'YMAX' ) Then
        val = Rmem(loc + K_YMAX)
      Else
        Print *, 'DIS45_aux_getinfo: no such option: ', opt
      End If
      Return
      End
C
C
      Subroutine DIS45_aux_putinfo(id,opt,val)
C
      Implicit None
C constant
      Integer  K_TYPE, K_FUNC, K_YMIN, K_YMAX
      Parameter( K_TYPE = 0, K_FUNC = 1, K_YMIN = 2, K_YMAX = 3 )
C common
      Include 'pawc.inc'
      Include 'display.inc'
C input
      Integer  id
      Character * (*)  opt
C output
      Real  val
C local
      Integer  I, idaux, loc
C funcion
      Integer  DIS45_lookup
C begin
      If( id.eq.0 ) Then
        I = Icou
      Else
        I = DIS45_lookup(id)
      End If
      If( I.eq.0 ) Return
      idaux = Iaux(I)
      If( idaux.eq.0 ) Return
      Call DIS45_locate( idaux,loc )
      If( loc.le.0 ) Return
C
      If( opt.eq.'FUNC' ) Then
        Rmem(loc + K_FUNC) = val
      Else If( opt.eq.'YMIN' ) Then
        Rmem(loc + K_YMIN) = val
      Else If( opt.eq.'YMAX' ) Then
        Rmem(loc + K_YMAX) = val
      Else
        Print *, 'DIS45_aux_putinfo: no such option: ', opt
      End If
      Return
      End
C
C
      Subroutine DIS45_getinfo(id,opt,val)
C
      Implicit None
C constant
      Integer  K_ZMIN, K_ZMAX
      Parameter( K_ZMIN = 0, K_ZMAX = 1 )
C common
      Include 'display.inc'
C input
      Integer  id
      Character * (*)  opt
      Real  val
C local
      Integer  I
C funcion
      Integer  DIS45_lookup
C begin
      If( id.eq.0 ) Then
        I = Icou
      Else
        I = DIS45_lookup(id)
      End If
C
      If( opt.eq.'ZMIN' ) Then
        val = Smin(I)
      Else If( opt.eq.'ZMAX' ) Then
        val = Smax(I)
      Else
        Print *, 'DIS45_getinfo: no such item: ', opt
      End If
      Return
      End
C
C
      Subroutine DIS45_putinfo(id,opt,val)
C
      Implicit None
C common
      Include 'display.inc'
C input
      Integer  id
      Character * (*)  opt
C output
      Real  val
C local
      Integer  I
C funcion
      Integer  DIS45_lookup
C begin
      If( id.eq.0 ) Then
        I = Icou
      Else
        I = DIS45_lookup(id)
      End If
      If( I.eq.0 ) Return
C
      If( opt.eq.'ZMIN' ) Then
        Smin(I) = val
      Else If( opt.eq.'ZMAX' ) Then
        Smax(I) = val
      Else
        Print *, 'DIS45_putinfo: no such item: ', opt
      End If
      Return
      End
C
C
      



      



