
C File: dis45unix.f
C Descripton: system dependent routines for UNIX
C Date: 22-May-1992
C Author: A.Shirahashi
C
C History: 1-Jun-1992, add DIS45_cwd
C          3-Jun-1992, add DIS45_dynlink
C                      fix wrong call to SYS$SETDDIR
C          5-Jun-1992, filespec translation for DIS45_dynlink
C          8-Jun-1992, upcase from DISPLAY45_TOOL.FOR
C          9-Jun-1992, add DIS45_loadinit1
C         25-Jun-1992, add DIS45_getlun, DIS45_freelun
C
C         25-Jun-1992, UNIX version by Ryosuke Itoh, KEK
C         29-Jun-1992, move command line parsing func. to DIS45_SETUP.f
C         30-Jun-1992, remove STR$TRIM, DIS45_dynlink returns 0
C          6-Jun-1992, DIS45_dynlink returns static addresses
C         13-Jul-1992, DIS45_cwd for UNIX
C         25-Sep-1992, DIS45_loadinit, site init file
C          7-Oct-1992, dis45_loadinit(comand1,comand2)
C
C          6-Nov-1993, DIS45_dynclose
C         18-Nov-1993, DIS45_dynopen
C
C         28-Dec-1993, DIS45_Open_Scratch
C
C         21-Jul-1994, DIS45_getlun (by Ishisaki)
C         30-Sep-1994, DIS45_getlun (LunMax 99 -> 80)
C
C          1-Oct-1994, DIS5_dynopen,dynlink file:entry
C
C
      Subroutine DIS45_output_help(topic)
      Implicit None
C input
      Character * (*)  topic
C local
      Integer  i, length
C function
      Integer  Lenrd
c Main
      Call Fsystem('man dis45')
      Return
      End
C
C
      Subroutine DIS45_cwd(path)
C
      Implicit None
C input
      Character * (*)  path
C local
      Integer  length
c function
      Integer  Lenrd
c Main
      length = Lenrd(path)
      If( length.gt.0 ) Then
         Call Fchdir(path(:length))
      Else
         Call Fgetwd(path)
         length = Lenrd(path)
         Write(*,*) path(:length)
      End If
C
      Return
      End
C
C
      Integer Function DIS45_dynopen( prompt,image )
C
      Implicit None
C inpput
      Character * (*)  prompt
C input/output
      Character * (*)  image
C local
      Logical  status
      Integer  I1, L1, L2, L3
      Character * 80  file
C function
      Integer  Lenrd
      Logical  Xopen
C begin
      Call Txtrd( prompt,image )
C
      L1 = Lenrd(image)
      I1 = Index(image,':')
      file = ' '
      If( I1.eq.0 ) Then
        file(:L1) = image(:L1)
      Else
        file(:I1-1) = image(:I1-1)
      End If
C
      Call DIS45_add_file_ext( file,'.so' )
C
      status =  Xopen( -1,file,'READ','UNFORMATTED','OLD' )
C
      If( status ) Then
        DIS45_dynopen = 1
        Return
      End If
C
      L2 = Lenrd( file )
      If( I1.eq.0 ) Then
        image(:L2) = file(:L2)
        image(L2+1:) = ' '
      Else
        L3 = L2+L1-I1+1
        file(L2+1:L3) = image(I1:L1)
        image(:L3) = file(:L3)
        image(L3+1:) = ' '
      End If
C
      DIS45_dynopen = 0
      Return
      End
C
C
      Subroutine DIS45_add_file_ext( file,ext )
C
      Implicit None
C input
      Character * (*)  ext
C input/output
      Character * (*)  file
C local
      Integer  is, id, Lf, Le
C function
      Integer  Clrchr, Lenrd
C begin
      Lf = Lenrd(file)
      Le = Lenrd(ext)
      is = CLrchr(file,Char(47))
      id = Index(file(is+1:),Char(46))
      If( id.eq.0 .and. Lf+Le.le.Len(file) ) Then
        file(Lf+1:Lf+Le) = ext(:Le)
      End If
C
      Return
      End
C
C
      Integer Function DIS45_dynlink( image, symbol )
C
      Implicit None
C input
      Character * (*)  image, symbol
C local
      Integer  address
      Integer  I1, L1, L2
      Character * 80  file, entry
C function
      Integer  Lenrd
      Integer  Fdynlink
      External  UFUNC, MIN_FUNCT, UWFUNC, USR_FUNCT, BIN_FUNCT
C begin
      L1 = Lenrd(image)
      L2 = Lenrd(symbol)
      file = ' '
      entry = ' '
C
      I1 = Index(image,':')
      If( I1.eq.0 ) Then
        file(:L1) = image(:L1)
        entry(:L2) = symbol(:L2)
      Else
        file(:I1-1) = image(:I1-1)
        entry(:L1-I1) = image(I1+1:L1)
      End If
C
      Call DIS45_add_file_ext( file,'.so' )
      L1 = Lenrd(file)
      L2 = Lenrd(entry)
C
      If( file(:L1).eq.'UFUNC' ) Then
        address = Fdynlink( 'ufunc',entry(:L2) )
      Else If( file(:L1).eq.'UWFUNC' ) Then
        address = Fdynlink( 'uwfunc',entry(:L2) )
      Else
        address = Fdynlink( file(:L1),entry(:L2) )
      End If
C
      If( address.ne.0 ) Then
        DIS45_dynlink = address
        Return
      End If
C
      If( entry(:L2).eq.'UFUNC' ) Then
        Call ExtSub( address,UFUNC )
      Else If( entry(:L2).eq.'MIN_FUNCT' ) Then
        Call ExtSub( address,MIN_FUNCT )
      Else If( entry(:L2).eq.'UWFUNC' ) Then
        Call ExtSub( address,UWFUNC )
      Else If( entry(:L2).eq.'USR_FUNCT' ) Then
        Call ExtSub( address,USR_FUNCT ) 
      Else If( entry(:L2).eq.'BIN_FUNCT' ) Then
        Call ExtSub( address,BIN_FUNCT )
      Else
        Write(*,*) 'DIS45_dynlink: unknown entry: ', entry(:L2)
      End If
C
      DIS45_dynlink = address
      Return
      End
C
C
      Subroutine DIS45_dynclose(address)
C
      Implicit None
C input
      Integer  address
C
C local
      Integer  status
C function
      Integer  Fdynclose
C begin
      If( address.ne.0 ) Then
        status = Fdynclose(address)
      End If
      Return
      End
C
C
      Subroutine DIS45_loadinit(comand1,comand2)
c
      Implicit None
C input
      Character * (*)  comand1, comand2
c local
      Character * 80  initdir, homedir
      Integer  Linit, Lhome, error
      Logical  Lexist
c
c function
      Logical  DIS45_fexist
      Integer * 4  Lkbrd, Lenrd
C begin
C
C ... Get Enviroment Variables
C
      Call Getenv( 'HOME', homedir )
      Lhome = Lkbrd( homedir, 0 )
C
      Call Getenv( 'DISPLAY_INIT', initdir )
      Linit = Lkbrd( initdir,0 )
 
C ... Open Scratch Command File
C
      Call DIS45_Open_Scratch( 1,'display-tmp.rc',error )
C
      Write(1,'(A)') '@%'
C
      Lexist = .FALSE.
C
C ... Check Site Init File
C
      If( Linit .eq. 0 ) Then
        initdir = '/usr/local/lib/display'
        Linit = Lkbrd( initdir,0 )
      End If
      If( DIS45_fexist( initdir(:Linit)//'/display-site.rc' ) ) Then
         Lexist = .TRUE.
         Write(1,'(A)') '@'//initdir(:Linit)//'/display-site.rc'
      End If
C              
C ... Check User Init File
C
      If( DIS45_fexist( homedir(1:Lhome)//'/.dis45rc' ) ) Then
        Lexist = .TRUE.
        Write(1,'(A)') '@'//homedir(:Lhome)//'/.dis45rc'
      End If
C
      Write(1,'(A)') '@#'
C
C ... fetch command / -e command
C
      If( Lenrd(comand1).gt.0 ) Then
        Lexist = .TRUE.
        Write(1,'(A)') comand1
      End If
C
      If( Lenrd(comand2).gt.0 ) Then
        Lexist = .TRUE.
        Write(1,'(A)') comand2
      End If
C
C ... Execute Scratch Command File
C
      If( Lexist ) Then
        Rewind( Unit = 1 )
        Call Lunrd( 1 )
      Else
        Close( Unit = 1 )
      End If
C
      Return
      End
C
C
      Subroutine DIS45_Open_Scratch( lun,file,error )
C input
      Integer  lun
      Character * (*)  file
C output
      Integer  error
C local
      Character * 80  homedir, filenm
      Integer  Lhome Lfile
C function
      Integer  Lkbrd
C begin
      Call Getenv( 'HOME', homedir )
      Lhome = Lkbrd( homedir, 0 )
      filenm = file
      Lfile = Lenrd( filenm )
C
      Open( Unit=lun,File=homedir(:Lhome)//'/'//filenm(:Lfile),
     &      Form='Formatted',Status='UNKNOWN',Err=900 )
      error = 0
      Return

 900  Continue
      error = -1
      Return
      End
C
C
       Logical Function DIS45_fexist( file )
C
      Implicit None 
C input
      Character * (*)  file
C begin
      Inquire ( File=file, Exist=DIS45_fexist )
      Return
      End
C
C
      Subroutine DIS45_getlun( lun )
C
      Implicit None

C output
      Integer  lun
C
C const
      Integer * 4      LunMin, LunMax
      Parameter ( LunMin = 20, LunMax = 80 )
C local
      Integer * 4      Int_Lun / LunMax /
      save             Int_Lun
      Character * (LunMax)   Lun_Table / ' ' /
      save             Lun_Table
C begin
      lun = Int_Lun
      Do while ( Lun_Table(lun:lun) .ne. ' ' )
         lun = lun - 1
         If ( lun .lt. LunMin ) lun = LunMax
         If ( lun .eq. Int_Lun ) then
            Write (*,*) 'DIS45_getlun: Logical Unit Number table FULL'
            Return
         End if
      End do
      Lun_Table(lun:lun) = 'x'
      Int_Lun = lun
      Return
C
      Entry DIS45_freelun( lun )
C
C begin
      If ( (LunMin .ge. lun) .and. (lun .le. LunMax) ) then
         Lun_Table(lun:lun) = ' '
      End if
C
      Return
      End
