C
C File: DISPLAY45_setup.for
C Description: device independent setup routine
C Author: A.Shirhashi
C Date: 29-Jun-1992
C Original: DISPLAY45.FOR
C
C Public: DISPLAY45_setup
C Pricate: DISPLAY45_parsearg
C
C History: 2-Jul-1992, change due to HLFETC.FOR
C          3-Jul-1992, fix a wrong call to HLfetc, HLfetc3
C                      add options '-1' (portable binary)
C                                  '-2' (portable ascii)
C          7-Jul-1992, add option '-v' (version)
C          7-Oct-1992, comand1, comand2, '-e command'
C         16-Oct-1992, CLpath
C         29-May-1993, .hbook
C	  26-Jul-1993, change due to the update of HLHPK (by R.Itoh)
C
      Subroutine DISPLAY45_SETUP
C
      Implicit None       
C local
      Character * 80  comand1, comand2
      Logical  loadinit
C begin
C     ... init for CLI
      Call CLpath( 'DISPLAY_LIB' )
C
C     ... init variables
      comand1 = ' '
      comand2 = ' '
C
C     ... parse command line
      Call DIS45_parsearg(loadinit,comand1,comand2)
C
C     ... load user initialization file if exist.
      If( loadinit ) Then
        Call DIS45_loadinit(comand1,comand2)
      End If
C
      Return
      End
C
C
      Subroutine DIS45_parsearg(loadinit,comand1,comand2)
C
      Implicit None 
C output
      Logical  loadinit
      Character * (*)  comand1, comand2
C local
      Integer  error
      Integer  Nargs, Iarg, Larg
      Integer  Idsh, Ihpk, Ihbk, Isel
      Logical  force1, force2, force3, force4, forceP
      Character * 80  Carg
C function
      Integer  Iargc, Lkbrd
C begin
      loadinit = .TRUE.
      force1 = .FALSE.
      force2 = .FALSE.
      force3 = .FALSE.
      force4 = .FALSE.
      forceP = .FALSE.
C
      Nargs = Iargc()
C
      Iarg = 0
C     Do Iarg = 1, Nargs
 100  Continue
        Iarg = Iarg + 1
        If( Iarg.gt.Nargs ) Goto 200
        Call Getarg( Iarg, Carg )
        If( Carg(1:2).eq.'-1' ) Then
          force1 = .TRUE.
          force4 = .TRUE.
        Else If( Carg(1:2).eq.'-2' ) Then
          force2 = .TRUE.
          force4 = .TRUE.
        Else If( Carg(1:2).eq.'-3' ) Then
          force3 = .TRUE.
        Else If( Carg(1:2).eq.'-4' ) Then
          force4 = .TRUE.
        Else If( Carg(1:2).eq.'-p' .or. Carg(1:2).eq.'-P' ) Then
          forceP = .TRUE.
        Else If( Carg(1:2).eq.'-q' .or. Carg(1:2).eq.'-Q' ) Then
          loadinit = .FALSE.
        Else If( Carg(1:2).eq.'-v' .or. Carg(1:2).eq.'-V' ) Then
          Call DISPLAY45_version
        Else If( Carg(1:2).eq.'-e' .or. Carg(1:2).eq.'-E' ) Then
          Iarg = Iarg + 1
          Call GetArg( Iarg,comand2 )
          Goto 100
        Else If( Carg(1:1).eq.'-' ) Then
          Write(*,*) 'dis45: no such option ', Carg(1:2)
          Call Exit
        Else
          Larg = Lkbrd( Carg, 0 )
          If( force3 .or. force4 .or. forceP ) Then
            Idsh = 0
            Ihbk = 0
            Ihpk = 0
          Else
            Idsh = Index( Carg, '.dsh' ) + Index( Carg, '.DSH' )
            Ihbk = Index( Carg, '.hbk' ) + Index( Carg, '.HBK' )
     &           + Index(Carg, '.hbook') + Index(Carg, '.HBOOK')
            Ihpk = Index( Carg, '.hpk' ) + Index( Carg, '.HPK' )
            If ( Idsh.eq.0 .and. Ihpk.eq.0 .and. Ihbk.eq.0 ) then
              Call Intrd( 
     &             'HBOOK3 (0) or HBOOK4 (1) or HANDYPAK (2)', 
     &             Isel )
              If( Isel .eq. 0 ) Idsh = 1
              If( Isel .eq. 1 ) Ihbk = 1
              If( Isel .eq. 2 ) Ihpk = 1
            End If
          EndIf
          If( force3 .or. Idsh.gt.0 ) Then
C           Call Ugetrd( Carg(:Larg)//' 0', Larg+2 )
C           Call HLfetc3( 0, error )
            comand1 = 'FETC3 '//Carg(:Larg)//' 0'
          Else If( force4 .or. Ihbk.gt.0 ) Then
            Carg(Larg+1:Larg+4) = ' 0 0'
            If( force1 ) Carg(Larg+2:Larg+2) = '1'
            If( force2 ) Carg(Larg+2:Larg+2) = '2'
C           Call Ugetrd( Carg(:Larg+4), Larg+4 )
C           Call HLfetc( 0, error )
            comand1 = 'FETC '//Carg(:Larg+4)
          Else If( forceP .or. Ihpk.gt.0 ) then
C           Call Ugetrd( Carg, Larg )
C           Call HLhpk( 1 )
            comand1 = 'HPKC '//Carg(:Larg)//' 0'
          Else 
            Write(*,*) 'DIS45_parsearg: can''t happen'
          End If
        End If
C     End Do
      Goto 100
 200  Continue
C
      Return
      End
