C
C File: DISPLAY45VMS.FOR
C Descripton: system dependent routines for VAX/VMS
C Date: 22-May-1992
C Author: A.Shirahashi
C
C History: 1-Jun-1992, add DIS45_cwd
C          3-Jun-1992, add DIS45_dynlink
C                      fix wrong call to SYS$SETDDIR
C          5-Jun-1992, filespec translation for DIS45_dynlink
C          8-Jun-1992, upcase from DISPLAY45_TOOL.FOR
C          9-Jun-1992, add DIS45_loadinit
C         25-Jun-1992, add DIS45_getlun, DIS45_freelun
C         29-Jun-1992, ass Iargc, Getarg
C         25-Sep-1992, DIS45_loadinit, site init
C          7-Oct-1992, dis45_loadinit(comand1,comand2)
C          6-Mar-1992, dis45_dynlink '.EXE'
C          8-Nov-1993, dis45_dynclose (dummy)
C         18-Nov-1993, dis45_dynopen
C         28-Dec-1993, DIS45_Open_Scratch
C
      Subroutine DIS45_output_help(topic)
      Implicit None
C constant
      Integer  HLP$M_PROMPT 
      Parameter( HLP$M_PROMPT = 1 )
C input
      Character * (*)  topic
C local
      Integer  status, flags
C function
      Integer  LBR$OUTPUT_HELP, LIB$PUT_OUTPUT, LIB$GET_INPUT
      External  LIB$PUT_OUTPUT, LIB$GET_INPUT
C begin
      flags = HLP$M_PROMPT
C
      status = LBR$OUTPUT_HELP
     &         ( LIB$PUT_OUTPUT,            ! output_routine
     &           80,                        ! output_width
     &           topic,                     ! line_desc
     &           'DISPLAY$HLP:DISPLAY.HLB', ! library_name
     &           flags,                     ! flags
     &           LIB$GET_INPUT              ! input_routine
     &         )     
C
      Return
      End
C
C
      Subroutine DIS45_cwd(path)
C
      Implicit None
C input
      Character * (*)  path
C local
      Integer  length, status, devl
C function
      Integer  SYS$SETDDIR
C begin
      Call STR$TRIM( path,path,length )
      If( length .eq. 0 ) Then
        status = SYS$SETDDIR( 0, length, path )
        Write(6,*)  path(:length)
      Else
        status = SYS$SETDDIR( path(:length),%VAL(0),%VAL(0) )
      End If
C     Print '(1H ,Z8.8)', status
      Return
      End
C
C
      Integer Function DIS45_dynopen( prompt,image )
C
      Implicit None
C inpput
      Character * (*)  prompt
C input/output
      Character * (*)  image
C integer
      Logical status
C function
      Logical Qopen, Xopen
C begin
      Call DIS45_add_file_ext( image,'.exe' )
C
      status =  Qopen( prompt,-1,image,
     &                 'READ','UNFORMATTED','OLD' )
C
      If( status ) Then
        DIS45_dynopen = 1
        Return
      End If
C
      Call DIS45_add_file_ext( image,'.exe' )
C
      status = Xopen(-1,image,'READ','UNFORMATTED','OLD')
C
      If( status ) Then
        DIS45_dynopen = 1
      Else
        DIS45_dynopen = 0
      End If
C
      Return
      End
C
C
      Subroutine DIS45_add_file_ext( file,ext )
C
      Implicit None
C input
      Character * (*)  ext
C input/output
      Character * (*)  file
C local
      Integer  is, id, Lf, Le
C function
      Integer  Clrchr, Lenrd
C begin
      Lf = Lenrd(file)
      Le = Lenrd(ext)
      is = CLrchr(file,']')
      If( is.eq.0 ) Then
        is = CLrchr(file,':')
      End If
      id = Index(file(is+1:),Char(46))
      If( id.eq.0 .and. Lf+Le.le.Len(file) ) Then
        file(Lf+1:Lf+Le) = ext(:Le)
      End If
C
      Return
      End
C
C
      Integer Function DIS45_dynlink( image, symbol )
C
      Implicit None
C input
      Character * (*)  image, symbol
C local
      Integer  status, address, pos, las
      Character * 80  trans
C function
      Integer  Lenrd
      Integer  LIB$FIND_IMAGE_SYMBOL
C begin
      pos = Index(image,']')
      If( pos .eq. 0 ) Then
        pos = Index(image,':')
      End If
C
      las = Index(image(pos+1:),'.')
      If( las.eq.0 ) Then
        las = Lenrd(image)
      Else
        las = las + pos - 1
      End If
C
      status = LIB$FIND_IMAGE_SYMBOL( image(pos+1:las),
     &                                symbol,
     &                                address,
     &                                image(:pos)//'.EXE' )
C
      If( status .and. 1 ) Then
        DIS45_dynlink = address
      Else
        DIS45_dynlink = 0
      End If
C
      Return
      End
C
C
      Subroutine DIS45_dynclose(address)
C
      Implicit None
C input
      Integer  address
C
C local
      Integer  status
C function
      Integer  Fdynclose
C begin
C     If( address.ne.0 ) Then
C       status = Fdynclose(address)
C     End If
      Return
      End
C
C
      Subroutine DIS45_loadinit(comand1,comand2)
C
      Implicit None
C input
      Character * (*)  comand1, comand2
C local
      Integer  error
      Logical  Lexist
C function
      Integer  Lenrd
      Logical  DIS45_fexist
C begin
      Call DIS45_Open_Scratch(1,'DISPLAY-TMP.COM',error)
C
      Write(1,'(A)') '@%'
C
      Lexist = .FALSE.
C      
      If( DIS45_fexist( 'DISPLAY_INIT:DISPLAY-SITE.INI' ) ) Then
        Lexist = .TRUE.      
        Write(1,'(A)') '@DISPLAY_INIT:DISPLAY-SITE.INI' 
      End If
C
      If( DIS45_fexist( 'SYS$LOGIN:DISPLAY.INI' ) ) Then
        Lexist = .TRUE.
        Write(1,'(A)') '@SYS$LOGIN:DISPLAY.INI'
      End If
C
      Write(1,'(A)') '@#'
C
C ... fetch command / -e command
C
      If( Lenrd(comand1).gt.0 ) Then
	Lexist = .TRUE.
        Write(1,'(A)') comand1
      End If
C
      If( Lenrd(comand2).gt.0 ) Then
	Lexist = .TRUE.
        Write(1,'(A)') comand2
      End If
C
C ... Execute Scratch Command File
C
      If( Lexist ) Then
        Rewind( Unit=1 )
        Call Lunrd( 1 )
      Else
        Close( Unit=1 )
      ENd If
C
      Return
      End
C
C
      Subroutine DIS45_Open_Scratch( lun,file,error )
C input
      Integer  lun
      Character * (*)  file
C output
      Integer  error
C begin
      Open( Unit=lun,File='SYS$LOGIN:'//file,
     &      Form='Formatted',Status='SCRATCH',Err=900 )
      error = 0
      Return

 900  Continue
      error = -1
      Return
      End
C
C
      Logical Function DIS45_fexist( file )
C
      Implicit None 
C input
      Character * (*)  file
C begin
      Open( Unit=99,File=file,Readonly,Status='OLD',Err=900 )
      Close( 99 )
      DIS45_fexist = .TRUE.
      Return
C
  900 Continue 
      DIS45_fexist = .FALSE.
      Return
      End
C
C
      Subroutine DIS45_getlun( lun )
C
      Implicit None 
C output
      Integer  lun
C begin
      Call LIB$GET_LUN( lun )
      Return
      End
C
C
      Subroutine DIS45_freelun( lun )
C
      Implicit None 
C output
      Integer  lun
C begin
      Call LIB$FREE_LUN( lun )
      Return
      End
C
C
      Integer Function Iargc()
C
      Implicit None 
C local
      Character * 132  ComLin
      Character *  32  Words(16)
      Integer  Larg, Nargs
C begin
      Call LIB$get_foreign( ComLin, , Larg )
      Call CLword( Comlin(:Larg), ' ', Nargs, Words )
      Iargc = Nargs
      Return
      End
C
C     
      Subroutine Getarg( Iarg, Carg )
C
      Implicit None 
C input
      Integer  Iarg
C output
      Character * (*)  Carg
C local
      Character * 132  ComLin
      Integer  Larg
C begin
      Call LIB$get_foreign( ComLin, , Larg )
      Call CLpart( Comlin(:Larg), Iarg, Carg )
C      
      Return
      End
C
