/*
 file: fdynlink.c
 description:  fortran callable dynamic link support routine for SUN, DG
 author: A.Shirahashi
 date: 9-Jan-1993

 6-Nov-1993: fdynclose
18-Nov-1993: do not add '.so' here
*/

#include <stdio.h>
#include <dlfcn.h>

static void *handle;
static void *address;

void *fdynlink_(path,symbol,lpath,lsymbol)
char *path, *symbol;
int lpath, lsymbol;
{
  char *cpath, *csymbol, *p;

  cpath = (char *)malloc(lpath+4);
  strncpy(cpath,path,lpath);
  *(cpath+lpath) = '\0';

/*** 18-Nov-1993
  if( strcmp(cpath+lpath-3,".so") != 0 ) {
    strcat(cpath,".so");
  }
***/

  csymbol = (char *)malloc(lsymbol+2);
  strncpy(csymbol,symbol,lsymbol);
  *(csymbol+lsymbol) = '\0';

  if( *(csymbol+lsymbol-1) != '_' ) {
    strcat(csymbol,"_");
  }

  for(p=csymbol;*p=tolower(*p);p++) ;

/*
  printf("cpath,csymbol=%s,%s\n",cpath,csymbol);
*/
  
  if( (handle = dlopen(cpath,1)) == NULL ) {
    fprintf(stderr,"fdynlink: can't open %s\n",cpath);
    free(cpath);
    free(csymbol);
    return(0);
  }

  if( (address = dlsym(handle,csymbol)) == NULL ) {
    fprintf(stderr,"fdynlink: can't find %s\n",csymbol);
    free(cpath);
    free(csymbol);
    return(0);
  }

  return( address );
}

int fdynclose_( p )
int *p;
{
  int status;

  if( *p == (int)address ) {
    status = dlclose(handle);
    return(status);
  } else {
    fprintf(stderr,"fdynclose: inconsistent calls between link/close\n");
    return(-1);
  }
}
