/*
 file: fdynlink.c
 description:  fortran callable dynamic link support routine for HP
 author: A.Shirahashi
 date: 9-Jan-1993

 6-Nov-1993: fdynclose
18-Nov-1993: do not add '.so' here
 2-Dec-1994: HP version by R.Itoh, KEK
*/

#include <stdio.h>
#include <dl.h>

static shl_t handle;
static void *address;

void *fdynlink_(path,symbol,lpath,lsymbol)
char *path, *symbol;
int lpath, lsymbol;

{
  char *cpath, *csymbol, *p;
  struct shl_symbol **symbols;
  long adr_store;
  

  cpath = (char *)malloc(lpath+4);
  strncpy(cpath,path,lpath);
  *(cpath+lpath) = '\0';

/*** 18-Nov-1993
  if( strcmp(cpath+lpath-3,".so") != 0 ) {
    strcat(cpath,".so");
  }
***/

  csymbol = (char *)malloc(lsymbol+2);
  strncpy(csymbol,symbol,lsymbol);
  *(csymbol+lsymbol) = '\0';

  if( *(csymbol+lsymbol-1) != '_' ) {
    strcat(csymbol,"_");
  }

  for(p=csymbol;*p=tolower(*p);p++) ;

/*
  printf("cpath,csymbol=%s,%s\n",cpath,csymbol);
*/
  
  if( (handle = shl_load(cpath,BIND_IMMEDIATE,0)) 
             == NULL ) {
    perror ( "shl_load" );
    fprintf(stderr,"fdynlink: can't open %s\n",cpath);
    free(cpath);
    free(csymbol);
    return(0);
  }
/*
  printf ("get symbols.........\n" );
  if ((shl_getsymbols(handle,TYPE_PROCEDURE,IMPORT_SYMBOLS,
		      (char*)malloc(),symbols))
       != 0 ) {
    fprintf (stderr,"fdynlink: error in get symbols.....\n");
  }
  else {
    printf ( "end.......\n" );
    while ( symbols != NULL ) {
      printf ( "symbol = %s\n", (**symbols).name );
      symbols++;
    }
  }
*/
  if( (shl_findsym(&handle,csymbol,TYPE_PROCEDURE,&adr_store)) !=0 ) {
    perror ( "shl_findsym" );
    fprintf(stderr,"fdynlink: can't find %s\n",csymbol);
    free(cpath);
    free(csymbol);
    return(0);
  }
  address = (int *)adr_store;

  return( address );
}

int fdynclose_( p )
int *p;
{
  int status;

  if( *p == (int)address ) {
    status = shl_unload(handle);
    return(status);
  } else {
    fprintf(stderr,"fdynclose: inconsistent calls between link/close\n");
    return(-1);
  }
}


