/*
 file: fdynlink.c
 description:  fortran callable dynamic link support routine for SUN, DG
 author: A.Shirahashi
 date: 9-Jan-1993

 6-Nov-1993: fdynclose
18-Nov-1993: do not add '.so' here
01-Feb-1995: Y.Ishisaki link level 2 -> 8
*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <dlfcn.h>

#define NDYNLINK	8

static int pos = 0;
static void *handle[NDYNLINK];
static int (*address[NDYNLINK])();

static int
call_address0(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf)
void *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9, *pa, *pb, *pc, *pd, *pe, *pf;
{
	return (*address[0])(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf);
}

static int
call_address1(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf)
void *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9, *pa, *pb, *pc, *pd, *pe, *pf;
{
	return (*address[1])(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf);
}

static int
call_address2(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf)
void *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9, *pa, *pb, *pc, *pd, *pe, *pf;
{
	return (*address[2])(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf);
}

static int
call_address3(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf)
void *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9, *pa, *pb, *pc, *pd, *pe, *pf;
{
	return (*address[3])(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf);
}

static int
call_address4(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf)
void *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9, *pa, *pb, *pc, *pd, *pe, *pf;
{
	return (*address[4])(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf);
}

static int
call_address5(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf)
void *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9, *pa, *pb, *pc, *pd, *pe, *pf;
{
	return (*address[5])(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf);
}

static int
call_address6(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf)
void *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9, *pa, *pb, *pc, *pd, *pe, *pf;
{
	return (*address[6])(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf);
}

static int
call_address7(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf)
void *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9, *pa, *pb, *pc, *pd, *pe, *pf;
{
	return (*address[7])(p1,p2,p3,p4,p5,p6,p7,p8,p9,pa,pb,pc,pd,pe,pf);
}

static int (*call_address[NDYNLINK+1])() = {
	call_address0, call_address1, call_address2, call_address3,
	call_address4, call_address5, call_address6, call_address7,
	NULL
};

void *
fdynlink_(path,symbol,lpath,lsymbol)
char *path, *symbol;
int lpath, lsymbol;
{
	char *cpath, *csymbol, *p;
	
	if ( pos == NDYNLINK ) {
		fprintf(stderr,"fdynlink: too many link modules\n");
		return NULL;
	}
	cpath = (char *)malloc(lpath+4);
	strncpy(cpath,path,lpath);
	*(cpath+lpath) = '\0';
	
/*** 18-Nov-1993
	if( strcmp(cpath+lpath-3,".so") != 0 ) {
	  	strcat(cpath,".so");
	}
***/
	
	csymbol = (char *)malloc(lsymbol+2);
	strncpy(csymbol,symbol,lsymbol);
	*(csymbol+lsymbol) = '\0';
	
	if( *(csymbol+lsymbol-1) != '_' ) {
		strcat(csymbol,"_");
	}
	
	for(p=csymbol;*p=tolower(*p);p++) ;
	
/*
	  printf("cpath,csymbol=%s,%s\n",cpath,csymbol);
*/
	
	if( (handle[pos] = dlopen(cpath,1)) == NULL ) {
		fprintf(stderr,"fdynlink: can't open %s\n",cpath);
		free(cpath);
		free(csymbol);
		return(0);
	}
	
	if( (address[pos] = dlsym(handle[pos],csymbol)) == NULL ) {
		fprintf(stderr,"fdynlink: can't find %s\n",csymbol);
		dlclose(handle[pos]);
		free(cpath);
		free(csymbol);
		return(0);
	}
	
	if ( (unsigned long)address[pos] <= 0x7fffffff ) {
		return address[pos++];
	} else {
		return call_address[pos++];
	}
}

int
fdynclose_( p )
int *p;
{
	if ( 0 == pos ||
		( *p != (int)address[pos-1] && *p != (int)call_address[pos-1] ) ) {
		fprintf(stderr,"fdynclose: inconsistent calls between link/close\n");
		return -1;
	}
	pos--;
	return dlclose(handle[pos]);
}
