C
C File: HLarea.FOR
C Description: calculate integrated sum over the area
C Date: 27-Jan-1992
C Author: A.Shirahashi
C
      Subroutine HLarea(error)
C
      Implicit None
C common
      Include 'pawc.inc'
C output
      Integer error
C local
      Integer  here, id, dim
      Integer  idbuf, loc
      Integer  nx, ny, mx, my
      Integer  ixl, iyl, ixh, iyh, i, j, k
      Real  xmin, xmax, ymin, ymax
      Real  sum, all, ratio
      Real  val, err, val_offset, err_offset
      Character * 16   opt
      Character * 80  title
      Logical  Lerr
C function
      Integer  DIS45_needhist, DIS45_malloc, DIS45_hasbar
      Integer  DIS45_getlimit1, DIS45_getlimit2
      Real  Hi, Hij, Hsum
C begin
      If (DIS45_needhist(0,error).le.0) Return
      Call DIS45_thishist(here, id, dim)
C
      If (dim.eq.1) Then 
        Call DIS45_hinfo1(id,title,nx,xmin,xmax)
        Call CLftoa(xmin,opt)
        Call Optrd('from:',opt)
        If( DIS45_getlimit1(id,mx,ixl,ixh,error).le.0 ) Return
        If( opt(1:1).eq.'S' .or. opt(1:1).eq.'A' ) Then
          Lerr = (DIS45_hasbar(id) .ne. 0)
          If( DIS45_malloc(nx*2,idbuf,loc,error).le.0 ) Return
          Call Hunpak(id,Rmem(loc),' ',1)
          Call Hunpke(id,Rmem(loc+nx),' ',1)
          If( opt(1:1).eq.'S' ) Then
            Call Fltrd('new value', val)
            If( Lerr ) Then
              Call Fltrd('new error', err)
            End If
            Do i = ixl, ixh
              Rmem(loc+i-1) = val
              Rmem(loc+nx+i-1) = err
            End Do
          Else If( opt(1:1).eq.'A' ) Then
            Call Fltrd('value offset', val_offset)
            If( Lerr ) Then
              Call Fltrd('error offset', err_offset)
            End If
            Do i = ixl, ixh
              Rmem(loc+i-1) = Rmem(loc+i-1) + val_offset
              Rmem(loc+nx+i-1) = Rmem(loc+nx+i-1) + err_offset
            End Do
          End If
          Call Hpak(id,Rmem(loc))
          If( Lerr ) Then
            Call Hpake(id,Rmem(loc+nx))
          End If
          Call DIS45_free(idbuf)
        Else If( opt(1:1).eq.' ' ) Then
          sum = 0.0
	  Do i = ixl, ixh
            sum = sum + Hi(id,i)
          End Do
          all = Hsum(id)
          If( all.gt.0.0 ) Then
            ratio = sum / all 
          Else
            ratio = 0.0
          End If
          Write(6,100) sum, ratio*100.0
  100     Format(1H ,'integrated counts =', G15.7, '(',F5.1,'%)')
        Else
          error = 23 ! illegal option
        End If
      Else If(dim.eq.2) Then
        Call DIS45_hinfo2(id,title,nx,xmin,xmax,ny,ymin,ymax)
        Call CLftoa(xmin,opt)
        Call Optrd('X from:',opt)
        If( DIS45_getlimit2(id,'X',mx,ixl,ixh,error).le.0 ) Return
        If( DIS45_getlimit2(id,'Y',my,iyl,iyh,error).le.0 ) Return
        If( opt(1:1).eq.'S' .or. opt(1:1).eq.'A' ) Then
          If( DIS45_malloc(nx*ny,idbuf,loc,error).le.0 ) Return
          Call Hunpak(id,Rmem(loc),' ',1)
          If( opt(1:1).eq.'S' ) Then
            Call Fltrd('new value', val)
            Do j = iyl, iyh
              Do i = ixl, ixh
                k = loc + (j-1)*nx + i - 1
                Rmem(k) = val
              End Do
            End Do
          Else If( opt(1:1).eq.'A' ) Then
            Call Fltrd('value offset', val_offset)
            Do j = iyl, iyh
              Do i = ixl, ixh
                k = loc + (j-1)*nx + i - 1
                Rmem(k) = Rmem(k) + val_offset
              End Do
            End Do
          End If
          Call Hpak(id,Rmem(loc))
          If( Lerr ) Then
            Call Hpake(id,Rmem(loc+nx))
          End If
          Call DIS45_free(idbuf)
        Else If( opt(1:1).eq.' ' ) Then
          sum = 0.0
          Do j = iyl, iyh
            Do i = ixl, ixh
              sum = sum + Hij(id,i,j)
            End Do
          End Do
          all = Hsum(id)
          If( all.gt.0.0 ) Then
            ratio = sum / all
          Else
            ratio = 0.0
          End If
          Write(6,200) sum, ratio*100.0
  200     Format(1H ,'integrated counts =', G15.7, '(',F5.1,'%)')
        Else
          error = 23 ! illegal option
        End If
      End If
C
      Return
      End
