C
C File: hlbanx.for
C Description: make band of sliced histogram
C Entry: HLbanx, HLbany
C Author: A.Shirahashi
C History: 12-May-1992, copy from HLprox.for
C           1-Jun-1992, fix bad size of memory allocation
C           5-Jun-1992, try to verify bug reported by T.Tamura, but in vain
C
      Subroutine HLbanx(error)
C
      Implicit None
C common
      Include 'pawc.inc'
C output
      Integer error
C local
      Character * 80  title
      Integer  id, dim, idnew, here
      Integer  idbuf, loc
      Integer  nx, ny
      Integer  mx, ixl, ixh
      Real  xmi, xma, ymi, yma
      Real  xlow, xhigh
C function
      Integer  DIS45_needhist, DIS45_malloc, DIS45_makehist
      Integer  DIS45_getlimit2
C begin
      If (DIS45_needhist(2,error).le.0) Return
      Call DIS45_thishist(here, id, dim)
C
      Call DIS45_hinfo2(id,title,nx,xmi,xma,ny,ymi,yma)
C     Call DIS45_getlimits(nx,xmi,xma,mx,ixl,ixh,xlow,xhigh)
C     Print *, 'xlow,xhigh,ixl,ixh=',xlow,xhigh,ixl,ixh
      If( DIS45_getlimit2(id,'X',mx,ixl,ixh,error).le.0 ) Return
C     Call DIS45_chan2limit2(id,'X',ixl,ixh,xlow,xhigh)
C
      If( DIS45_makehist(id,1,idnew,error).le.0 ) Return
      If( DIS45_malloc(ny,idbuf,loc,error).le.0 ) Return
      Call Hbook1(idnew,'BANX '//title,ny,ymi,yma,0.0)
      Call DIS45_locate(idbuf,loc)
      Call DIS45_hrebin2(id,1,ixl,ixh,ny,1,ny,Hmem(loc),error)
      Call Hpak(idnew,Hmem(loc))
      Call DIS45_free(idbuf)
      Call DIS45_fixentry(idnew)
C	
      Return
      End
C
C
      Subroutine HLbany(error)
C
      Implicit None
C output
      Integer error
C common
      Include 'pawc.inc'
C local
      Character * 80  title
      Integer  id, dim, idnew, here
      Integer  idbuf, loc
      Integer  nx, ny
      Integer  my, iyl, iyh
      Real  xmi, xma, ymi, yma
      Real  ylow, yhigh
C function
      Integer  DIS45_needhist, DIS45_malloc, DIS45_makehist
      Integer  DIS45_getlimit2
C begin
C     require 2 dim histogram
      If (DIS45_needhist(2,error).le.0) Return
      CALL DIS45_thishist(here, id, dim)
C
      Call DIS45_hinfo2(id,title,nx,xmi,xma,ny,ymi,yma)
C     Call DIS45_getlimits(ny,ymi,yma,my,iyl,iyh,ylow,yhigh)
C     Print *, 'ylow,yhigh,iyl,iyh=',ylow,yhigh,iyl,iyh
      If( DIS45_getlimit2(id,'Y',my,iyl,iyh,error).le.0 ) Return
C 
      If (DIS45_makehist(id,1,idnew,error).le.0) Return
      If (DIS45_malloc(nx,idbuf,loc,error).le.0) Return
      Call Hbook1(idnew,'BANY '//title,nx,xmi,xma,0.0)
      Call DIS45_locate(idbuf,loc)
      Call DIS45_hrebin2(id,nx,1,nx,1,iyl,iyh,Hmem(loc),error)
      Call Hpak(idnew,Hmem(loc))
      Call DIS45_free(idbuf)
      Call DIS45_fixentry(idnew)
C	
      Return
      End
