C+
C File : HLbindiff.f
C Description : Calculate bin by bin confidence level
C
C Author : A.Shirahashi, Univ. of Tokyo
C-
C
      Subroutine HLbindiff(error)
C
      Implicit None
C common
      Include 'pawc.inc'
C output
      Integer  error
C local
      Integer  here, id1, id2, idnew, dim
      Integer  nx, idbuf, loc, i
      Real  xmin, xmax, av, sig, nobs, chi2, cnfl
      Character * 80  title
C function
      Integer  DIS45_needhist, DIS45_samehist, DIS45_makehist
      Integer  DIS45_malloc
      Integer  nbad
C begin
      If( DIS45_needhist(1,error).le.0 ) Return
      Call DIS45_thishist(here,id1,dim)
      Call DIS45_hinfo1(id1,title,nx,xmin,xmax)
C  
      Call Intrd('histogram ID', id2)
      If( DIS45_samehist(id1,id2,error).le.0 ) Return
C
      If( DIS45_malloc(nx,idbuf,loc,error).le.0 ) Return
      If( DIS45_makehist(id1,1,idnew,error).le.0 ) Return
C
      Call Hcopy(id1,idnew,'BIND '//title)
      Call Hreset(idnew,' ')
C
      Call Hdiffb(id2,id1,1.0,nx,'NC',nbad,Rmem(loc))
C
      Call Hpak(idnew, Rmem(loc))
      Call DIS45_free(idbuf)
C
      Return
      End
C
