C
C File: HLBLOW.FOR
C Entry: HLblow, DIS45_getlimits
C Date: 16-APR-1992
C History: 20-Apr-1992, almost completely rewritten
C          21-Apr-1992, use DIS45_hrebin1 for 1 dim
C          24-Apr-1992, import DIS45_getlimits from DISPLAY45_TOOL.FOR
C           8-May-1992, fix entry problem
C          12-May-1992, move DIS45_getlimits to DISPLAY45_TOOL.FOR
C           4-Aug-1992, use DIS45_getlimit1, DIS45_chan2limit1
C           1-Sep-1992, support for non equidistant bins
C          18-Sep-1993, support for N-tuples
C          11-Jan-1995, minor bug fix
C Author: A.Shirahashi
C
        Subroutine HLblow(error)
C
        Implicit None
C common
	Include 'pawc.inc'
C output
	Integer error
C local:
      Integer  here, id, dim, idnew
      Integer  idbuf, loc
C     Integer  nx, ny
      Integer  mx, my
      Integer  ixl, iyl, ixh, iyh
C     Real  xmin, xmax, ymin, ymax
      Real  xlow, xhigh, ylow, yhigh
      Character * 80  title
C function
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
      Integer  DIS45_hasbar, DIS45_getlimit1, DIS45_getlimit2
      Integer  DIS45_hgetopt
C begin
C     require 1 dim or 2 dim histogram
      If (DIS45_needhist(0,error).le.0) Return
      Call DIS45_thishist(here, id, dim)
C
      If (dim.eq.1) Then 
        Call DIS45_hinfo0(id,title,dim)
        If( DIS45_getlimit1(id,mx,ixl,ixh,error).le.0 ) Return
        Call DIS45_chan2limit1(id,ixl,ixh,xlow,xhigh)
        If( DIS45_makehist( id,1,idnew,error ).le.0 ) Return
        If( DIS45_malloc( mx*2,idbuf,loc,error ).le.0 ) Return
        If( DIS45_hgetopt(id,'NEQB').eq.0 ) Then
          Call Hbook1( idnew,'BLOW '//title,mx,xlow,xhigh,0.0 )
        Else 
          Call DIS45_getxbins( id,ixl,ixh,Rmem(loc) )
          Call HbookB( idnew,'BLOW '//title,mx,Rmem(loc),0.0 )
        End If 
        Call DIS45_locate( idbuf,loc ) 
        Call DIS45_hrebin1( id,mx,ixl,ixh,Rmem(loc),Rmem(loc+mx),
     &                        error )
        Call Hpak( idnew,Rmem(loc) )
        If( DIS45_hasbar(id).ne.0 ) Then
          Call Hpake( idnew,Rmem(loc+mx) )
        End If          
        Call DIS45_free( idbuf )
	Call DIS45_fixentry(idnew)
      Else If(dim.eq.2) Then
        Call DIS45_hinfo0(id,title,dim)
        If( DIS45_getlimit2(id,'X',mx,ixl,ixh,error).le.0 ) Return
        Call DIS45_chan2limit2(id,'X',ixl,ixh,xlow,xhigh)
        If( DIS45_getlimit2(id,'Y',my,iyl,iyh,error).le.0 ) Return
        Call DIS45_chan2limit2(id,'Y',iyl,iyh,ylow,yhigh)
        If( DIS45_makehist( id,2,idnew,error ).le.0 ) Return
        If( DIS45_malloc( mx*my,idbuf,loc,error ).le.0 ) Return
        Call Hbook2(idnew,'BLOW '//title,mx,xlow,xhigh,
     &                                     my,ylow,yhigh,0.0)    
        Call DIS45_locate( idbuf,loc )
        Call DIS45_hrebin2( id,mx,ixl,ixh,my,iyl,iyh,
     &                        Hmem(loc),error )
        Call Hpak( idnew,Hmem(loc) )
        Call DIS45_free( idbuf )
	Call DIS45_fixentry(idnew)
      Else If(dim.eq.3) Then
        Call HLblowNT( id,error )
      End If
C
      Return
      End
C
C
      Subroutine HLblowNT( id,error )
C 
      Implicit None
C const
      Include 'tags.inc'
C input
      Integer  id
C output
      Integer  error
C local
      Integer  nevent, ievent
      Integer  vidx(MAXTAG), i, nvar
      Real     vmin(MAXTAG), vmax(MAXTAG), record(MAXTAG)
      Logical  select
      Character * 8  var
      Integer  idnew
      Character * 80  title
C function
      Integer  DIS45_makehist
C data
      Integer  nsel
      Save  nsel
      Data nsel / 1 /
C begin
      Call Intrd('# of variables',nsel)
      If( nsel.le.0 ) Return
      If( nsel.gt.MAXTAG ) nsel = MAXTAG
C
      Do i = 1, nsel
        Call HLtuple_asktag(id,'variable',i,var,vidx(i))
        Call DIS45_tuple_minmax(id,vidx(i),vmin(i),vmax(i))
        Call Fltrd('lower limit',vmin(i))
        Call Fltrd('upper limit',vmax(i))
      End Do
C
      If( DIS45_makehist(id,3,idnew,error).le.0 ) Return
C
      Call Hnoent(id,nevent)
      Call DIS45_hinfoN(id,title,nvar,MAXTAG,tags)
      Call HbookN(idnew,'BLOW '//title,nvar,' ',1000,tags)
C
      Do ievent = 1, nevent
        Call DIS45_tuple_getevt(id,ievent,record,error)
        select = .true.
        Do i = 1, nsel
          If( record(vidx(i)).lt.vmin(i) .or.
     &        record(vidx(i)).gt.vmax(i) ) Then
            select = .false.
          End If
        End Do
        If( select ) Then
          Call Hfn(idnew,record)
        End If
      End Do
C
      Return
      End
