C
C File: HLbook.f
C Description: Book New Histogram without contents
C Date: 02-Jan-1993
C Author: T.Takahashi
C
C
      Subroutine HL_book (idnew,error)

      Implicit None
C output:
      Integer idnew
      Integer  error
c local:
      Integer dim_req /1/
c const:

C
      Call INTRD('1. 1dim 2. 2dim ',dim_req)
      If ( (dim_req.ne.1).and.(dim_req.ne.2)) then
         error=10
         Return
      Endif

      If (dim_req.eq.1) then
         Call Hlbook_1dim(idnew, error)
      else if (dim_req.eq.2) then
         Call Hlbook_2dim(idnew, error)
      else
         error=10
         Return
      Endif

      Return
      End

      Subroutine Hlbook_1dim (idnew, error)
      Implicit NONE
c output:
      Integer error
      Integer idnew
C local:
      Integer id /90/ , here, dim, current_id
      Character * 80  title  /'new_histogram'/
      Real  xmin/10.0/, xmax /1000.0/, width /10.0/
      Integer nx /100/
      Real  ratio
      Integer i
      Integer num
      Integer iopt /1/
      Real dx_x /0.1/
      Integer  idbufx, locx

C common
      Include 'pawc.inc'
C function:
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
      Logical Hexist
C begin:

        If( DIS45_needhist(1,error).le.0 ) then
          error=0
        else
          Call DIS45_thishist(here,current_id,dim)
          Call DIS45_hinfo1(current_id,title,nx,xmin,xmax)
          Call DIS45_findid(id,current_id)
        Endif
        id = id+10
        Call Intrd('new histogram ID', id)
        If ( Hexist(id) ) Then
          Call DIS45_findID(idnew,id)
           Write(*,*) 'histogram exist, create new ID',id,'->',idnew
        Else
          idnew = id
        End If
        Call DIS45_insert(idnew,1,error)
        If(error.ne.0 ) Return
        Call TITrd('Title ',title)
        Call INTRD('Number of Bin',nx)
        If (nx.le.0) then
          nx=100
        Endif
      Call FLTRD('X min',xmin)
      Call FLTRD('X max',xmax)
      Call Hbook1(idnew,title,nx,xmin,xmax,0.0)
      Return
      End


      Subroutine Hlbook_2dim (idnew, error)
      Implicit NONE
c output:
      Integer idnew
      Integer error
C local:
      Integer id /90/ , here, dim, current_id
      Character * 80  title  /'new_histogram'/
      Real  xmin/0.0/, xmax /1000.0/, xwidth /10.0/
      Real  ymin/0.0/, ymax /1000.0/, ywidth /10.0/
      Integer nx /100/, ny /100/
      Real  ratio
      Integer i
      Integer num
      Integer iopt /1/
      Real dx_x /0.1/
      Integer  idbufx, locx

C common
      Include 'pawc.inc'
C function:
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
      Logical Hexist
C begin:

        If( DIS45_needhist(2,error).le.0 ) then
          error=0
        else
          Call DIS45_thishist(here,current_id,dim)
          Call DIS45_hinfo2(current_id,title,nx,xmin,xmax,
     &         ny,ymin,ymax)
          Call DIS45_findid(id,current_id)
        Endif
        id = id+10
        Call Intrd('new histogram ID', id)
        If ( Hexist(id) ) Then
          Call DIS45_findID(idnew,id)
           Write(*,*) 'histogram exist, create new ID',id,'->',idnew
        Else
          idnew = id
        End If
        Call DIS45_insert(idnew,2,error)
        If(error.ne.0 ) Return
        Call TITrd('Title ',title)
        Call INTRD('Number of Bin (X)',nx)
        If (nx.le.0) then
          nx=100  

        Endif
        Call FLTRD('X min',xmin)
        Call FLTRD('X max',xmax)
        Call INTRD('Number of Bin (Y)',ny)
        If (nx.le.0) then
          nx=100  

        Endif
        Call FLTRD('Y min',ymin)
        Call FLTRD('Y max',ymax)
        Call Hbook2(idnew,title,nx,xmin,xmax,
     &       ny, ymin, ymax, 0.0)


      Return
      End

