C
C File: HLCHBN.FOR
C Date: 21-Apr-1992
C Author: A.Shirahashi
C
C History: 21-Apr-1992, almost completely rewritten based on HLBLOW.FOR
C          29-Jun-1992, Intrd -> IntrdL
C           8-Dec-1992, call DIS45_fixentry
C          18-Jan-1993, for non-equidistant bins
C           7-Sep-1993, check ERRO instead of PERR
C           9-Oct-1993, check BARX instead of ERRO
C
        Subroutine HLchbn(error)
C
C change bin size
C
        Implicit None
C common:
	Include 'pawc.inc'
C
C output:
	Integer error
C
C function:
        Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
        Integer  DIS45_hgetopt
C
C local:
	Integer  here, id, dim, idnew
	Integer  idbuf, loc
	Integer  nx, ny, mx, my
        Integer  ixl, iyl, ixh, iyh
	Real  xmin, xmax, ymin, ymax
        Real  xlow, xhigh, ylow, yhigh
	Character * 80  title
C
C begin
C       require 1 dim or 2 dim histogram
        If (DIS45_needhist(0,error).le.0) Return
C
	CALL DIS45_thishist(here, id, dim)
C
	If (dim.eq.1) Then 
          Call DIS45_hinfo1(id,title,nx,xmin,xmax)
          Call DIS45_getchbn(nx,xmin,xmax,mx,ixl,ixh,xlow,xhigh)
          If( DIS45_makehist( id,1,idnew,error ).le.0 ) Return
          If( DIS45_malloc( mx*3+1,idbuf,loc,error ).le.0 ) Return
          Call DIS45_HrebinX( id,mx,ixl,ixh,
     &                        Rmem(loc+2*mx),Rmem(loc),Rmem(loc+mx),
     &                        error )
          If( DIS45_hgetopt(id,'NEQB').eq.0 ) Then
            Call Hbook1( idnew,'CHBN '//title,mx,xlow,xhigh,0.0 )
          Else
            Call HbookB( idnew,'CHBN '//title,mx,Rmem(loc+2*mx),0.0 )
          End If
          Call DIS45_locate( idbuf,loc ) ! for safety
          Call Hpak( idnew,Hmem(loc) )
C         error set by ER command DOES propagte
C         error set by RER command does NOT propagte
C         7-Sep-1993, use ERRO flag instead of PERR flag
C         9-Oct-1993, use BARX flag instead of ERRO flag
          If( DIS45_hgetopt(id,'BARX').ne.0 ) Then
            Call Hpake( idnew,Hmem(loc+mx) )
          End If          
          Call DIS45_free( idbuf )
	Else If(dim.eq.2) Then
          Call DIS45_hinfo2(id,title,nx,xmin,xmax,ny,ymin,ymax)
          Call DIS45_getchbn(nx,xmin,xmax,mx,ixl,ixh,xlow,xhigh)
          Call DIS45_getchbn(ny,ymin,ymax,my,iyl,iyh,ylow,yhigh)
          If( DIS45_makehist( id,2,idnew,error ).le.0 ) Return
          If( DIS45_malloc( mx*my,idbuf,loc,error ).le.0 ) Return
          Call Hbook2(idnew,'CHBN '//title,mx,xlow,xhigh,
     &                                     my,ylow,yhigh,0.0)    
          Call DIS45_locate( idbuf,loc ) ! for safety
          Call DIS45_hrebin2( id,mx,ixl,ixh,my,iyl,iyh,
     &                        Hmem(loc),error )
          Call Hpak( idnew,Hmem(loc) )
          Call DIS45_free( idbuf )
	End If
C
	Call DIS45_fixentry( idnew )
	Return
	End
C
C
      Subroutine DIS45_getchbn(nx,xmin,xmax,mx,ilow,ihigh,low,high)
C
      Implicit None
C input
      Integer  nx
      Real  xmin, xmax
C output
      Integer  mx, ilow, ihigh
      Real  low, high
C local
      Integer  fact
C begin
      fact = 1
      ilow = 1
      Call IntrdL('bin size factor',fact,1,nx)
      Call IntrdL('start bin',ilow,1,fact)
      mx = (nx - ilow + 1)/fact
      ihigh = ilow + mx * fact - 1
      Call DIS45_chan2limits(nx,xmin,xmax,ilow,ihigh,low,high)
      Return
      End
