C
C File: HLdist.for
C Description: Make a histogram of distribution for content of each bin
C Date: 28-May-1992
C Author: A.Shirahashi
C
C History: 19-Jan-1995 fix a bug for 2 dim (pointed by Y.Ishisaki)
C
C Public HLdist
C
      Subroutine HLdist( error )
      Implicit None
C common:
      Include 'pawc.inc'
C output:
      Integer  error
C local:
      Character * 80  title  
      Integer  here, dim, id, idnew
      Integer  nx, ny, nbin, i, j
      Real  xmin, xmax, ymin, ymax, zmin, zmax
C function:
      Integer  DIS45_needhist, DIS45_makehist
      Real  Hmin, Hmax, Hi, Hij
C statement function
      Logical  IsInt
      Real  X
      IsInt(X) = (Abs(X).ge.1.0 .and. Abs(X - Real(Nint(X))).lt.0.001)
C begin:
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      If( dim.eq.1 ) Then
        Call DIS45_hinfo1(id,title,nx,xmin,xmax)
      Else If( dim.eq.2 ) Then
        Call DIS45_hinfo2(id,title,nx,xmin,xmax,ny,ymin,ymax)
      Else
        Write(*,*) 'HLdist: unknown hist type: ', dim
        Return
      End If
C
      zmin = Hmin(id)
      zmax = Hmax(id)
      If( IsInt(zmin) .and. IsInt(zmax) .and. IsInt(zmax-zmin) ) Then        
        nbin = Min(Nint(zmax - zmin),100)
      Else
        nbin = 10
      End If
      Call Intrd('number of bins',nbin)
      Call Fltrd('minimum',zmin)
      Call Fltrd('maximum',zmax)
      If( nbin.lt.0 .or. zmax.le.zmin ) Then
        error = 20 ! you have rejected everything
        Return
      End If
C
      If( DIS45_makehist(id,1,idnew,error).le.0 ) Return
      Call Hbook1(idnew,'DIST '//title,nbin,zmin,zmax,0.0)
C
      If( dim.eq.1 ) Then
        Do i = 1, nx
          Call Hf1(idnew,Hi(id,i),1.0)
        End Do
      Else If( dim.eq.2 ) Then
        Do j = 1, ny
          Do i = 1, nx
            Call Hf1(idnew,Hij(id,i,j),1.0)
          End Do
        End Do
      End If
C
      Return
      End
