C
C File: Dofft.for
C Description: FFT for 1 dim histogram 
C Author: N.Yamaoka 
C Date: 1992/5/18
C
C History: 25-Jun-1992, A.Shirahashi, clean up
C
      Subroutine Hldofft(error)
c  NOT support error propagation

      Implicit None
C output:
      Integer error
C common:
      Include 'pawc.inc'
C function:
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
C local:
      Integer  here, id, dim, idnew
      Integer  idbuf, loc
      Integer  nx, mx
      Real  xmin, xmax, xlow, xhigh
      Character * 80  title
      Integer i,ifail
      Real*4 n_ph
C begin
      If (DIS45_needhist(1,error).le.0) Return
      Call DIS45_thishist(here, id, dim)
C
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
      If( DIS45_makehist( id,1,idnew,error ).le.0 ) Return
      mx = nx/2
      xlow = 0.0e0
      xhigh = Real(mx)
      If( DIS45_malloc( nx+mx*2,idbuf,loc,error ).le.0 ) Return
      Call Hbook1( idnew,'FFT '//title,mx,xlow,xhigh,0.0 )
      Call DIS45_locate( idbuf,loc ) ! for safety
      Call Hunpak(id,Rmem(loc),'HIST',1)
      ifail = 0
      Call C06eAe(Rmem(loc),nx,ifail)
      If(ifail.ne.0) Then
        error=26 ! NAG error
      End If
      N_ph = abs(Rmem(loc))
      Do i = 0, mx-1
        Rmem(loc+nx+i) = (Rmem(loc+i)*Rmem(loc+i) +
     &                    Rmem(loc+nx-i)*Rmem(loc+nx-i))*2.0/N_ph
      End Do
      Call Hpak( idnew,Rmem(loc+nx) )
      Call DIS45_free( idbuf )
      Return
      End
