C
c Expand for display45
c       N.Yamaoka 1992/5/19
c NOT support error propagation
c NOT support bin size
C
C History: 21-May-1992, A.Shirahashi, clean up
C          21-May-1992, A.Shirahashi, new version
C
      Subroutine HLexp(error)
C
      Implicit None
C output               
      Integer error
C common
      Include 'pawc.inc'
C local
      Integer  here, id, dim, idnew
      Integer  idbuf, loc
      Integer  nx
      Real  xmin, xmax
      Character * 80  title
      Integer  i
      Real  scale, s
      Real  orig_bin, new_bin
      Real  xlow, xhigh
C function
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
      Real  HLexp_int, Hi
C begin
C     require 1 dim hidtogram
      If (DIS45_needhist(1,error).le.0) Return
      Call DIS45_thishist(here, id, dim)
C
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
C     allocate buffers for hist.(nx) and int. counts(nx+1)
      If( DIS45_malloc( nx*2+1,idbuf,loc,error ).le.0 ) Return
      If( DIS45_makehist( id,1,idnew,error ).le.0 ) Return
      Call Hbook1( idnew,'EXP '//title,nx,xmin,xmax,0.0 )
      Call DIS45_locate( idbuf,loc ) 
C
      s = 0.0
      Do i = 1, nx+1
        Rmem(loc+nx+i-1) = s
        s = s + Hi(id,i)
      End Do
C 
      scale = 1.0
      Call Fltrd('scale factor',scale)
      orig_bin = (xmax-xmin)/Float(nx)
      new_bin = orig_bin / scale
C
      Do i = 1, nx
        xlow = (i - 1) * new_bin
        xhigh = i * new_bin 
        If( xhigh.gt.(xmax-xmin) ) Then
          Rmem(loc+i-1) = 0.0
        Else
          Rmem(loc+i-1) = HLexp_int( nx,orig_bin,Rmem(loc+nx),xhigh )
     &                  - HLexp_int( nx,orig_bin,Rmem(loc+nx),xlow )
        End If
      End Do
C
      Call Hpak( idnew,Rmem(loc) )
      Call DIS45_free( idbuf )
C
      Return
      End
C
C
      Real Function HLexp_int(nx, bin, array, x)
      Implicit None
C input
      Integer  nx
      Real  bin, array(0:nx), x
C local
      Integer ix
      Real  dx1, dx2
C function
      If( x.lt.0.0 ) Then
        HLexp_int = 0.0 
      Else If( x.gt.nx*bin ) Then
        HLexp_int = array(nx)
      Else
        ix = x / bin  
        dx1 = x - ix * bin
        dx2 = bin - dx1
        HLexp_int = ( dx2 * array(ix) + dx1 * array(ix+1) ) / bin
      End If
C
      Return
      End
