C
C File: HLEXTFUN.FOR
C Description: Create a histogram of the extracted fit result
C Date: 10-Dec-1992
C Author: T.Takahashi
C
      Subroutine HLEXTFUN( error )
      Implicit None
C common:
      Include 'pawc.inc'
C output:
      Integer  error
C local:
      Character * 80  title  
      Integer  here, dim, id, idnew
      Integer  nx, i, idbuf, loc
      Real  xmin, xmax
      Integer  nent
C function:
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
      Integer  DIS45_hgetopt
      Real  Hi, Hie, Hif
C begin:
      If( DIS45_needhist(1,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      If( DIS45_hgetopt(id,'PFUN').eq.0 ) Then
        error = 32 ! no associated function
        Return
      End If 
C
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
      If( DIS45_makehist(id,1,idnew,error).le.0 ) Return
      Call Hcopy(id,idnew,'EXTF '//title)
      If( DIS45_malloc(nx*2,idbuf,loc,error).le.0 ) Return
C
      Do i = 1, nx
        Rmem(loc+i-1) = Hif(id,i)
      End Do
C
      Call Hpak( idnew, Rmem(loc) )
      Call DIS45_free(idbuf)
C
      Call Hnoent(id,nent)
      Call DIS45_setentry(idnew,nent)
C
      Call DIS45_hsetopt(idnew,'NPFU')
      Call Hminim(idnew,0.0)
      Call Hmaxim(idnew,0.0)
C
      Return
      End
