C HLfftw   N.Yamaoka
C    control routine for FFT window by Hbook4
C
C History: 6-Jul-1992, Parameter -> Parameter ( )
C                      Character * 5 -> Character * 4
C
      Subroutine HLfftw(error_flag)
c
      Implicit None
C constant
      Integer  Ncomm
      Parameter( Ncomm = 4 )
c output:
      Integer error_flag
c
      Character*4 Comm(Ncomm)
      Data Comm /
     &  'HAMM',                !Hamming window
     &  'HANN',                !Hanning window
     &  'HELP',                !Help menu
     &  'TRI '                 !Triangle window
     &  /
c Local:
      Integer igo
      Character*4 Cmd
      Character*10 Prompt /'?DIS:FFT> '/
c
c Main Body
c
  100 Continue
      Call Keyrd(-1,Prompt,Cmd,Comm,Ncomm,Igo)
      error_flag = 0
      If (Cmd.eq.'HELP') Then
        Call Hlfftw_help(error_flag)
      Else If (Cmd.eq.'HAMM') Then
        Call Hlfftw_body('HAMM',error_flag)
      Else If (Cmd.eq.'HANN') Then
        Call Hlfftw_body('HANN',error_flag)
      Else If (Cmd.eq.'TRI  ') Then
        Call Hlfftw_body('TRI ',error_flag)
      Else
        error_flag=10
      Endif
c
      Return
      End
C----------------------------
C HLfftw_body   N.Yamaoka
C    calc FFT window
C----------------------------
      Subroutine HLFFTW_BODY(Type,error)
      Implicit None
c input :
      Character*4 type
C output:
      Integer error
C common:
      Include 'pawc.inc'
C function:
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
      Integer  DIS45_hgetopt
      Real     Hi,Hie
      Real     func_window
C local:
      Integer  here, id, dim, idnew
      Integer  idbuf, loc
      Integer  nx
      Real  xmin, xmax
      Character * 80  title
      Integer i
C begin
C       require 1 dim hidtogram
      If (DIS45_needhist(1,error).le.0) Return
      Call DIS45_current_his(here, id, dim)
C
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
c for debug
c        write(*,*) 'id=',id,'title=',title,'nx=',nx
      If( DIS45_makehist( id,1,idnew,error ).le.0 ) Return
      If( DIS45_malloc( nx*2,idbuf,loc,error ).le.0 ) Return
      Call Hbook1( idnew,type//title,nx,xmin,xmax,0.0 )
      Call DIS45_locate( idbuf,loc ) ! for safety
      Do i = 0, nx-1
        Rmem(loc+i) = Hi(id,i+1) * func_window(type,nx,i)
        Rmem(loc+nx+i) = Hie(id,i+1) * func_window(type,nx,i)
      End Do
      Call Hpak( idnew,Rmem(loc) )
      If( DIS45_hgetopt(id,'PERR').ne.0 ) Then
        Call Hpake( idnew,Rmem(loc+nx) )
      End If
      Call DIS45_free( idbuf )
  999 Return
      End
c----------------------
c real function func_window
c---------------------------
      Real function func_window(Type,nx,i)
c support only Hamming,Hanning,Triangle window 5/18/1992
      implicit NONE
c input :
      Character*4 type
      Integer nx,i
c local
      Real func_val
      Integer n2,j
      Real rj
c const
      Real PI
      Parameter (PI=3.14151592654e0)
c input i= 0,,,,,,,,,,nx-1 total nx
c local j= -nx/2,,,,,,nx/2 total nx ;j=i-nx/2
      n2=nx/2
      j=i-n2
      rj=real(j)
      If(Type.eq.'HAMM') Then      !Hamming window
        func_val=0.54e0-0.46e0*cos(2.0*real(i)*PI/real(nx))
      Else If(Type.eq.'HANN') Then      !Hanning window
        func_val=0.5e0*(1.0e0-cos(2.0*real(i)*PI/real(nx)))
      Else If(Type.eq.'TRI ') Then      !Triangle window
        func_val = 1.0-abs(rj)/real(n2)
      Endif
      func_window=func_val
      Return
      End
c------------
c hlfftw_help
c-------------
c      just keep only 18-May-1992

      subroutine  Hlfftw_help(error_flag)
c
c input:
      integer error_flag
c
      return
      end
