C-
C-   Purpose and Methods : Utility routines for HLfitXX
C-
C-   Created  at LBL
C
C History: 5-Jun-1992, A.Shirahashi, always superimpse function
C                                    surpress informational message
C
C         13-Jul-1992, A.Shirahashi, add HLfit_chisq
C         25-Jul-1992, A.Shirahashi, HLfit_chisq protect for err = 0
C         22-Jan-1993, 0:Gauss, 1:Fletcher -> 0:chi^2, 1:log(L)
C-
C
      Subroutine Hlfit_option(Ic)
C
      Implicit None
c output:
      Integer Ic
c local
      Character * 1  weight, method
      Save weight, method
      Data weight / '0' /
      Data method / '0' /
C begin
      Call Txtrd(
     &  'weight (0:Stat.(1/dy^2 or 1/N), 1:Equal to 1):',weight)
      Call Strupc(1,weight)
C
      If (weight.eq.'0' .or. weight.eq.'S' .or. weight.eq.'N') Then
        Ic = 2
      Else If (weight.eq.'1' .or. weight.eq.'E') Then
        Ic = 102
      Else
        Write(*,*) 'HLfit_option: no such optuion: ', weight
        Return
      End If
C
      Call Txtrd('algorithm (0:Chi^2, 1:log(L)):',method)
      Call Strupc(1,method)
C
      If (method.eq.'0' .or. method.eq.'C' .or. method.eq.'X') Then
C       Ic = Ic ! do nothing
      Else If(method.eq.'1' .or. method.eq.'L') Then
        Ic = 1000000 + Ic
      Else
        Write(*,*) 'HLfit_option: no such option: ', method
        Return
      End If
C
      Return
      End
C
C
      Subroutine HLfit_chisq(id,ic,chisq)
C
      Implicit None 
C input
      Integer  id, ic
C output
      Real  chisq
C local
      Character * 80  title
      Integer  nx, i
      Real  xmin, xmax
      Double Precision  sum
      Real  err
C function
      Real  Hif, Hi, Hie
C begin
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
      sum = 0.0D0      
      Do i = 1, nx
        If( Mod(ic,1000).gt.100 ) Then
          sum = sum + (Hif(id,i)-Hi(id,i))**2
        Else
          err = Hie(id,i)
          If( err.gt.0.0 ) Then
            sum = sum + (Hif(id,i)-Hi(id,i))**2/err**2
          End If
        End If
      End Do
      chisq = Real(sum)
      Return
      End
C
