C
C File: HLfitex.for
C Description: fits an exponential function to 1 dim histogram
C Author: A.Shirahashi
C Date: 13-Jul-1992
C Original: HLfitga.for
C
C History: 16-Jul-1992, A.Shirahashi, compute chi**2 by myself
C          14-Sep-1992, N-tuples
C           6-Nov-1992, use PROB (CERNLIB) instead of G01BCE (NAG)
C
      Subroutine  HLfitex(error)
C
      Implicit None
C common
      Double Precision  P
      Common /HLfit_Cexpo/ P(2)
C output
      Integer error
C local
      Integer nx
      Real xmin, xmax
      Integer  here, id, dim
      Integer ic
      Real aa, bb, chi2, chisq
      Real sig(2)
      Character*80 title
      Integer length
      Integer  ivx, ivy, ivdy
      Real  ymin, ymax
C     ...for MNstat
C     Real  fmin, fedm, errdef
C     Integer  npari, nparx, istat
      Integer  ndf
      Real  cl
C function
      Integer  DIS45_needhist, Lenrd
      Real  PROB
      External  HLfit_Fexpo
C begin
C     require 1 dim histogram or N-tuples
      If (DIS45_needhist(4,error).le.0) Return
C
      Call DIS45_thishist(here, id, dim)
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
C
      If( nx.le.3 ) Then
        error = 24 ! too small data points
        Return
      EndIf
C
      Call HLfit_option(ic)
C     
      If( dim.eq.1 ) Then
C       ... Hfitga returns chi2 or chi2/ndf ??
        Call Hfitex(id,aa,bb,chi2,ic,sig)
C       ... compute chi**2 by myself
        Call HLfit_chisq(id,ic,chisq)
C       Write(*,*) 'chi2= ',chi2,'  chisq= ',chisq
      Else If( dim.eq.3 ) Then
        Call HLfitNT_askvar(id,ic,ivx,ivy,ivdy)
        Call DIS45_tuple_minmax(id,ivx,xmin,xmax)
        Call DIS45_tuple_minmax(id,ivy,ymin,ymax)
        P(1) = Log10( ymax )
        P(2) = (ymax - ymin) / Exp(1.0) / xmax
        Call HLfitNT(id,ivx,ivy,ivdy,HLfit_Fexpo,2,P,chisq,ic,sig)
        aa = P(1)
        bb = P(2)
      End If
C
      Call DIS45_aux_putinfo(id,'FUNC',2)
C
C     ...check fitting status
C     Call MNstat( fmin,fedm,errdef,npari,nparx,istat )
C     Print *, 'MNstat returns fmin=',fmin,nx-3,fmin/(nx-3)
C
C     ...compute C.L
      ndf = nx - 2
      cl = PROB(chisq,ndf)
C
C print out results
      length = Lenrd(title)
      Write(6,1000) ID,title(1:length)
 1000 Format(5X,I5,1X,A)
C
      Write(6,1010)
 1010 Format(5X,'Exponential Fit: y = exp(AA + BB * x)')
      Write(6,1020) chisq/Real(ndf),cl
 1020 Format(5X,'chi**2/ndf = ',G12.5,'  C.L. = ',F8.5)
      Write(6,1030) aa,sig(1)
 1030 Format(5X,'AA = ',G12.5,' +- ',G12.5)
      Write(6,1040) bb,sig(2)
 1040 Format(5X,'BB = ',G12.5,' +- ',G12.5 )
C
      Return
      END
C
C
      Double Precision Function HLfit_Fexpo( X )
C
C common
      Double Precision  P
      Common /HLfit_Cexpo/ P(2)
C input
      Real  X
C begin
      HLfit_Fexpo = Exp( P(1) + P(2) * X )
      Return
      End

