C
C File: HLfitga.for
C Description: fits a gaussian fit to 1 dim histogram
C Author: T.Takahashi
C Date: 28-Apr-1992
C
C History:  5-Jun-1992, A.Shirahashi, compute C.L., remove lunout
C          16-Jul-1992, A.Shirahashi, compute chi**2 by myself
C          14-Sep-1992, N-tuples
C           6-Nov-1992, use PROB (CERNLIB) instead of G01BCE (NAG)
C
      Subroutine  HLfitga(error)
C
      Implicit None
C common
      Double Precision  P
      Common /HLfit_Cgaus/ P(3)
C output
      Integer error
C local
      Integer nx
      Real xmin, xmax
      Integer  here, id, dim
      Integer IC
      Real c, av, sd, chi2, chisq
      Real sig(3)
      Character*80 title
      Integer length
      Integer  ivx, ivy, ivdy
      Real  ymin, ymax
C     ...for MNstat
C     Real  fmin, fedm, errdef
C     Integer  npari, nparx, istat
      Integer  ndf
      Real  cl
C function
      Integer  DIS45_needhist, Lenrd
      Real  PROB
      External  HLfit_Fgaus
C begin
C     require 1 dim histogram or N-tuples
      If (DIS45_needhist(4,error).le.0) Return
C
      Call DIS45_thishist(here, id, dim)
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
C
      If( nx.le.3 ) Then
        error = 24 ! too small data points
        Return
      EndIf
C                        
      Call HLfit_option(ic)
C     
      If( dim.eq.1 ) Then
C       ... Hfitga returns chi2 or chi2/ndf ??
        Call Hfitga(id,c,av,sd,chi2,ic,sig)
C       ... compute chi**2 by myself
        Call HLfit_chisq(id,ic,chisq)
C       Write(*,*) 'chi2= ',chi2,'  chisq= ',chisq
      Else If( dim.eq.3 ) Then
        Call HLfitNT_askvar(id,ic,ivx,ivy,ivdy)
        Call DIS45_tuple_minmax(id,ivx,xmin,xmax)
        Call DIS45_tuple_minmax(id,ivy,ymin,ymax)
        P(1) = ymax
        P(2) = (xmax+xmin)/2.0
        P(3) = (xmax-xmin)/3.0
        Call HLfitNT(id,ivx,ivy,ivdy,HLfit_Fgaus,3,P,chi2,ic,sig)
        C = P(1)
        AV = P(2)
        SD = P(3)
      End If
C
      Call DIS45_aux_putinfo(id,'FUNC',1)
C
C     ...check fitting status
C     Call MNstat( fmin,fedm,errdef,npari,nparx,istat )
C     Print *, 'MNstat returns fmin=',fmin,nx-3,fmin/(nx-3)
C
C#ifdef NAG
C     ...compute C.L
      ndf = nx - 3
      cl = PROB(chisq,ndf)
C#endif
C
C print out results
      length = Lenrd(title)
      Write(6,1000) ID,title(1:length)
 1000 Format(5X,I5,1X,A)
C
      Write(6,1010)
 1010 Format(5X,'Gaussian Fit: y = C*exp(-((x-AV)/SD)**2/2)')
      Write(6,1020) chisq/Real(ndf),cl
 1020 Format(5X,'chi**2/ndf = ',G12.5,'  C.L. = ',F8.5)
      Write(6,1030) c, sig(1)
 1030 Format(5X,'C  = ',G12.5,' +- ',G12.5 )
      Write(6,1040) av, sig(2)
 1040 Format(5X,'AV = ',G12.5,' +- ',G12.5 )
      Write(6,1050) sd, sig(3)
 1050 Format(5X,'SD = ',G12.5,' +- ',G12.5 )
C
      Return
      END
C
C
      Double Precision Function HLfit_Fgaus( X )
C common
      Double Precision  P
      Common /HLfit_Cgaus/ P(3)
C integer
      Real  X
C begin
      If( P(3).ne.0.0D0 ) Then
        HLfit_Fgaus = P(1) * Exp( - ((X - P(2))/P(3))**2/2.0 )
      Else
        HLfit_Fgaus = 0.0D0
      End If
C
      Return
      End
