C+
C File: HLfitpo.for
C Description: fits to a polinomial function
C Author: T.Takahashi
C Date: 6-JUN-1992 
C
C History: 30-Jun-1992, A.Shirahashi, Intrd -> IntrdL
C          13-Jul-1992, A.Shirahashi, remove 'lunout', add 'C.L.'
C           6-Nov-1992, Use PROB (CERNLIB) instead of G01BCE (NAG)
C-
      Subroutine  HLfitpo(error)
C
      Implicit None
C constant
      Integer MAXPARAM 
      Parameter (MAXPARAM=20)
C common
      Integer  NP
      Double Precision  P
      Common /HLfit_Cpoly/ P(MAXPARAM), NP
C output
      Integer error
C local
      Integer i, nx
      Real xmin, xmax
      Integer  here, id, dim
      Integer ic
      Character*80 title
      Integer  ivx, ivy, ivdy
c fit
      Real  A(MAXPARAM), SIG(MAXPARAM)
C     Integer np
      Integer length
      Real chi2, chisq
C     ...for MNstat
C     Real  fmin, fedm, errdef
C     Integer  npari, nparx, istat
      Integer  ndf
      Real  cl
C function
      Integer  DIS45_needhist, Lenrd
      Real  PROB
      External HLfit_Fpoly
C begin
C     require 1 dim histogram or N-tuples
      If (DIS45_needhist(4,error).le.0) Return
C
      Call DIS45_thishist(here, id, dim)
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
C
      Call HLfit_option(ic)
C     
      Call IntrdL('number of coeff.(order+1)',NP,1,MAXPARAM)
C
      If( nx.le.NP ) Then
        error = 24 ! too small data points
        Return
      EndIf
C
      If( dim.eq.1 ) Then
C       ... Hfitpo returns chi2 or chi2/ndf ??
        Call Hfitpo(id,NP,A,chi2,ic,SIG)
C       ... compute chi**2 by myself
        Call HLfit_chisq(id,ic,chisq)
      Else If( dim.eq.3 ) Then
        Call HLfitNT_askvar(id,ic,ivx,ivy,ivdy)
        Call HLfitNT(id,ivx,ivy,ivdy,HLfit_Fpoly,NP,P,chisq,ic,SIG)
        Do I = 1, NP
          A(I) = Real(P(I))
        End Do
      Else
        Print *, 'Can''t happen in HLfitpo: dim = ', dim
        Return
      End If
C
      Call DIS45_aux_putinfo(id,'FUNC',3)
C
C     Write(*,*) 'chi2= ',chi2,'  chisq= ',chisq
C
C     ...check fitting status
C     Call MNstat( fmin,fedm,errdef,npari,nparx,istat )
C     Print *, 'MNstat returns fmin=',fmin,nx-3,fmin/(nx-3)
C
C     ...compute C.L.
      ndf = nx - NP
      cl = PROB(chisq,ndf)
C
C print out results
      length = Lenrd(title)
      Write(6,1000) ID,title(1:length)
 1000 Format(5X,I5,1X,A)
C
      Write(6,1010) NP-1
 1010 Format(5X,'Polynomial Fit: degree = ',I2)
      Write(6,1020) chisq/Real(ndf), cl
 1020 Format(5X,'chi**2/ndf = ', G12.5, '  C.L. = ',F8.5)
C
      Do i = 1, NP
        Write(6,1030) i-1, A(i), SIG(i)
 1030   Format(5X,'a(',I2,') = ',G12.5,' +- ',G12.5)
      End Do
C
      Return
      END
C
C
      Double Precision Function HLfit_Fpoly( X )
C
C constant
      Integer MAXPARAM 
      Parameter (MAXPARAM=20)
C common
      Integer  NP
      Double Precision  P
      Common /HLfit_Cpoly/ P(MAXPARAM), NP
C input
      Real  X
C local
      Double Precision  sum
C begin
      sum = 0.0D0
      If( X.eq.0.0 ) Then
        sum = P(1)
      Else
        Do I = 1, NP
          sum = sum + P(I) * X ** (I-1)
        End Do
      End If
      HLfit_Fpoly = sum
      Return
      End

