C
C File: HLfitsout.for
C Description: FITSOUT spec|image
C Author: T.Takahashi & H.Kubo
C Date: 26-Dec-1993 
C      
C 27-Dec-1993 K.Matsuzaki .. image
C 10-Jan-1994 H.Kubo ask Detector name
C 18-Jan-1994 H.Kubo detchan
C
      Subroutine HLfitsout(error)
C
      Implicit None 
C output
      Integer error
C local
      Character * 8  ftype
C begin
      Call Txtrd(
     &  '?function (Spectrum FITS,Image FITS)',
     &  ftype)
      Call Strupc(1,ftype)
      If( ftype(1:1).eq.'S' ) Then
        Call HLfitsout_s(error)
      Else If( ftype(1:1).eq.'I' ) Then
c          Write(*,*) 'Not yet implemented'
        Call HLfitsout_i(error)
      Else
        error = 10 ! no such command
      End If
C
      Return
      End
c
c HLFITSOUT_s
c   by T.Takahashi
c      
      Subroutine HLfitsout_s (error)
      Implicit NONE
c
c output:
      Integer error
C function
      Integer  DIS45_needhist
      Real     HI,HIe
      Integer  Lenrd
c     
C local
      Integer  here, id, dim
      Character*80 title
      Integer  nx, ich, length
      Real  xbin, xmin, xmax, x1, y1, dy, xlow, xhigh

      integer status
      Integer lunout
      Integer MAXCL
      Parameter (MAXCL=512)
      character*80 filename, ttype(MAXCL), tform(MAXCL), tunit(MAXCL)
      integer nc, t, i
      Character*80 cline
      Integer iflag /0/
      Character*10 detector/'SIS0'/
      real integ_time /1.0/
      real area_scale /1.0/
      Integer detchans/1024/
c     

C     require 1 dim histogram
      If (DIS45_needhist(1,error).le.0) Return
C
      Call DIS45_thishist(here, id, dim)
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
c

C
      filename = 'display.pha'
      Call TITRD('Output FITS file name', filename)
      length = Lenrd( filename)
      Call unlink(filename(1:length))
      Call DIS45_getlun(lunout)           
      Call ftinit( lunout,filename, 1, status)
      If( status.ne.0 ) Then
        error = 25 ! can't open file for output
        Return
      Endif

      Call TXTRD('Detector name(SIS0,SIS1,GIS2,GIS3)',detector)
      length = Lenrd(detector)
      Call Strupc(length,detector)
      Call FLTRD('Integration Time (s)',integ_time )
      Call FLTRD('Nominal effective area',area_scale)
c
c temporary
      detchans = nx
c     
c (2) Put Primary Header into CHU
c
      Call ftphpr( lunout, .true., 8, 0, 0, 0, 1, 1, status)
c      Write (*,*) status
c (3) 
      Call ftpkys (lunout, 'DATE', '14/11/93', 'FITS file creat',
     &  status)
      Call ftpkys (lunout, 'ORIGIN', 'Display45', 'Display45', status)
      Call ftpdef(lunout, 8, 0, 0, 0, 1, status)

      Call ftcrhd(lunout,status)
      nc=3
      ttype(1) = 'CHANNEL'
      ttype(2) = 'RATE'
      ttype(3) = 'STAT_ERR'
      tform(1) = '1I'
      tform(2) = '1E'
      tform(3) = '1E'
      tunit(1) = 'ch'
      tunit(2) = 'c/s'
      tunit(3) = 'c/s'
      Call ftphbn(lunout,nx,nc,ttype,tform,tunit,'SPECTRUM',0,status)

      Call ftpkys(lunout,'TELESCOP','ASCA','mission/satellite name',
     &  status)
      Call ftpkys(lunout,'INSTRUME',detector,
     &     'instrument/detector name',status)
      Call ftpkye(lunout,'EXPOSURE',integ_time,10,'Exposure Time',
     &  status)
      Call ftpkyl(lunout,'SYS_ERR',0,'no systematic error',status)
      Call ftpkyl(lunout,'GROUPING',0,
     &     'no grouping of the data has been defined',status)
      Call ftpkyl(lunout,'QUALITY',0,
     &  'no data quality information specified',status)
      Call ftpkye(lunout,'AREASCAL',area_scale,10,
     &     'nominal effective area',status)
      Call ftpkye(lunout,'BACKSCAL',1.0,10,
     &     'background scale factor',status)
      Call ftpkye(lunout,'CORRSCAL',0.0,10,
     &     'correlation scale factor',status)
      Call ftpkyj(lunout,'DETCHANS',detchans,
     &     'Total no. detector channels available',status)
      Call ftpkys(lunout,'PHAVERSN','1992a',
     &  'OGIP classificationof FITS format',status)

      Call ftbdef(lunout, nc, tform, 0, nx, status)

 100  Call IntrdX('error (0:No,1:Sqrt,2:Hie)',iflag,cline)
      Call Strupc(1,cline)
      If( cline(1:1).eq.'0' .or. cline(1:1).eq.'N' ) Then
        iflag = 0
      Else If( cline(1:1).eq.'1' .or. cline(1:1).eq.'S' ) Then
        iflag = 1
      Else If( cline(1:1).eq.'2' .or. cline(1:1).eq.'H' ) Then
        iflag = 2
      Else
        Goto 100
      Endif
      
      Do Ich=1,Nx
        Call DIS45_HixC(id,ich,x1)
        Y1= Hi(Id,Ich)
        Call Hix(id,ich,xlow)
        Call Hix(id,ich+1,xhigh)
        If(Iflag.eq.1) Then
          dY = Sqrt(Abs(Y1))
        Elseif(Iflag.eq.2) Then
          dY = Hie(Id,Ich)
        Else
          dy = 0
        End If
        Call ftpcli(lunout, 1, ich, 1, 1, ich,status)         
        Call ftpcle(lunout, 2, ich, 1, 1, Y1/integ_time, status)
        Call ftpcle(lunout, 3, ich, 1, 1, dY/integ_time, status)


      End do
      Call ftclos(lunout,status)
      Return 
      End
c
      Subroutine Hlfitsout_i (error)
      Implicit NONE
c
c output:
      Integer error
C function
      Integer  DIS45_needhist, Lenrd
      Real     HIJ
      Integer  Access
c     
C local
      Integer  here, id, dim
      Character*80 title
      Integer  naxes(2)
      Real  xmin, xmax
      Real  ymin, ymax
      integer status
      Integer lunout
      character*80 filename
      integer ix,iy
c
      Integer length
c     

C     require 1 dim histogram
      If (DIS45_needhist(2,error).le.0) Return
C
      Call DIS45_thishist(here, id, dim)
      Call DIS45_hinfo2(id,title,naxes(1),xmin,xmax,
     &                           naxes(2),ymin,ymax)
c
      filename = 'display.xy'
      Call TITRD('Output FITS file name', filename)
      length = Lenrd( filename)
      Call unlink(filename(1:length))
c
      Call DIS45_getlun(lunout)           
      Call ftinit( lunout,filename, 1, status)
      If( status.ne.0 ) Then
        error = 25 ! can't open file for output
        Return
      Endif
c
c (2) Put Primary Header into CHU
c
      Call ftphpr(lunout, .TRUE., 16, 2, naxes, 0, 1, .FALSE., status )
      Call ftpdef(lunout,         16, 2, naxes, 0, 1,          status )
c (3) 
        
      Do iy=1,naxes(2)
         Do ix=1,naxes(1)
            Call ftppre(lunout,1,(iy-1)*naxes(1)+ix,1,
     &                   HIJ(id,ix,iy), status)
         Enddo
      Enddo
c
      Call ftclos(lunout,status)
c
      Return 
      End


