C
C File: HLfitsp.for
C Description: fit with single polinomial
C Author: T.Takahashi
C Date: 8-Jun-1992
C
C History: 5-Jun-1992  compute C.L. using NAG library
C          15-Jul-1992 fix some bugs
C           6-Nov-1992 use PROB (CERNLIB) instead of G01BCE (NAG)
C
      Subroutine  HLfitsp(error)
C
      Implicit None
c output
      Integer error
C common (for parameter passing)
      Double Precision  P
      Common /HLFITSP_COMP/ P(2)
C local
      Integer  nx
      Real  xmin, xmax
      Integer  here, id, dim
      Integer ic, np
      Real  sigma(2), chi2
      Character * 80  title
      Integer  length
      Real Xval

C     ...for MNstat
C     Real  fmin, fedm, errdef
C     Integer npari, nparx, istat
      Integer  ndf
      Real  cl
C function
      Integer  Lenrd, DIS45_needhist
      Real  PROB
      External  HLfit_spower
C begin
C     require 1 dim histogram
      If (DIS45_needhist(1,error).le.0) Return
C
      Call DIS45_thishist(here, id, dim)
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)

      np = 2
      If( nx.le.np ) Then
        error = 24 ! too small data points
        Return
      End If
C
      Call HLfit_option(ic)
      Call HIX(id,1,xval)
      P(1) = xval
      P(2) = -2.0D0
      Call FDPRD('Init. K',P(1))
      Call FDPRD('Init. Alpha',P(2)) 
C     ...Hfits returns not chi2/ndf but chi2 itself.
      Call Hfits(id,HLfit_spower,np,P,chi2,ic,sigma)
C
C     ...check fitting status
C     Call MNstat( fmin,fedm,errdef,npari,nparx,istat )
C     Print *, 'MNstat returns fmin=',fmin
C#ifdef NAG
C     ... coimpute C.L. using NAG library
      ndf = nx - np
      cl = PROB(chi2,ndf)
C#endif
C
C print out results
      length = Lenrd(title)
      Write(6,1000) ID,title(1:length)
 1000 Format(5X,I5,1X,A)
C
      Write(6,1100) 
 1100 Format(5X,'Single Power Fit: y = K * (x ** Alpha)')
      Write(6,1110) chi2/Real(ndf), cl
 1110 Format(5X,'chi**2/ndf = ', G12.5, '  C.L. = ',F8.5)
C
      Write(6,1120) p(1), sigma(1)
 1120 Format(5X,'K     = ',G12.5,' +- ',G12.5)
      Write(6,1130) p(2), sigma(2)
 1130 Format(5X,'Alpha = ',G12.5,' +- ',G12.5)
C
      Return
      End
C
C
C File: HLFIT_SPOWER.FOR
C Description: Single Power
C Author: T.Takahashi
C Date: 8-Jun-1992
C
      Double Precision Function HLFIT_SPOWER( X )
C 
      Implicit None
C input
      Real  X
C common (for parameter passing)
      Double Precision  P
      Common /HLFITSP_COMP/ P(2)
C begin
      HLFIT_SPOWER = P(1) * X**P(2)
c
      Return
      End
