C
C File: HLinclude.for
C Description: Read ASCII file
C Author: T.Takahashi
C
C History: 25-Jun-1992, A.Shirahashi, clean up
C                                     use malloc in stead of scratch
C                                     use DIS45_getlun in stead of LIB$GETLUN
C                                     use QOPEN
C           1-Jul-1992, A.Shirahashi, INCLUDE file format id title
C          17-Jul-1992, T.Takahashi, x dy y dy
C          23-Jul-1992, A.Shirahashi, ask number of data points
C          30-Jul-1992, A.Shirahashi, use Realloc
C          19-Jul-1992, A.Shirahashi, N-tuples
C          31-Jul-1992, A.Shirahashi, HLinclud{hist,tuple}
C          12-Dec-1992, A.Shirahashi, discard comment
C           5-Feb-1993, <<EOF, program|
C           1-Apr-1992, DIS45_fixentry
C	   26-Aug-1993, TTTp04 Add ERRO option
C          18-Fev-1994, Takahashi, Extend area
C          19-Jan-1995, allow longer filename (pointed by Y.Ishisaki)
C
      Subroutine HLinclude(error)
C
      Implicit None
C output
      Integer error
C local
      Character * 80  title
      Character * 255  infile, direct, eof
      Character * 6   copt
      Integer  id, idnew
      Integer  lun, option, inflag
      Integer  istart, iend, L
C function
      Logical  Qopen, Hexist
      Integer  Lenrd, CLrchr
C data
      Save title, infile, id
      Data title / 'Include Plot' /
      Data infile / 'include.dat' /
      Data option / 1 /
      Data id / 100 /
C begin
      direct = infile
      eof = ' '
      Call Txtrd('input file name',direct)
      L = Lenrd(direct)
      If( direct(1:2).eq.'<<' .and. L.gt.2 ) Then
        inflag = 1
        eof(1:L-2) = direct(3:L)
        Call CLilun(lun)
      Else If( direct(L:L).eq.'|' ) Then
        inflag = 2
        Call DIS45_redirect(direct(:L),lun,error)
        If( error.ne.0 ) Return
      Else
        inflag = 3
        Call Ugetrd(direct,L)
        Call DIS45_getlun(lun)
        If( .not. Qopen('input file name',lun,infile,
     &                           'READ','FORMATTED','OLD') ) Then
          Call DIS45_freelun(lun)
          error = 9 ! can't open file
          Return
        End If
      End If
C
      iend = CLrchr(infile,'.')
      If( iend.eq.0 ) iend = Lenrd(infile)+1
      istart = CLrchr(infile,']') + CLrchr(infile,'/')
      If( iend.gt.istart+1 ) title = infile(istart+1:iend-1)
C        

      Call IntrdX(
     & '1.(x y)2.(x y dy)3.(xmin xmax y)4.(xmin xmax y dy)5.(x dx y dy)'
     & //'N.(tuple)'
     & , option,copt)
C
      Call Strupc(6,copt)
      If( copt.eq.'XY' ) Then
        option = 1
      Else If( copt.eq.'XYDY' ) Then
        option = 2
      Else If( copt.eq.'XXY' ) Then
        option = 3
      Else If( copt.eq.'XXYDY' ) Then
        option = 4
      Else If( copt.eq.'XDXYDY' ) Then
        option = 5
      Else If( copt.eq.'N' ) Then
        option = 6
      Else If( copt(1:1).lt.'1' .or. copt(1:1).gt.'6' ) Then
        error = 23 ! illegal option
        Return
      End If
C
      Call Intrd('new histogram ID', id)
      If ( Hexist(id) ) Then
        Call DIS45_findID(idnew,id)
        Write(*,*) 'histogram exist, create new ID',id,'->',idnew
      Else 

        idnew = id
      End If
C
      If( option.eq.6 ) Then
        Call HLinclude_tuple(lun,eof,idnew,title,error)
      Else
        Call HLinclude_hist(option,lun,eof,idnew,title,error)
      End If
C
      If( inflag.eq.1 ) Then
      Else If( inflag.eq.2 ) Then
        Call DIS45_reclose(lun)
      Else If( inflag.eq.3 ) Then
        Close(lun)
        Call DIS45_freelun(lun)
      End If
C
      id = id + 10
      Return
C
      End
C
C
      Subroutine HLinclude_hist(option,lun,eof,id,title,error)
C
      Implicit None 

C common
      Include 'pawc.inc'
C input
      Integer  option
      Integer  lun, id
      Character * (*)  title, eof
C output
      Integer  error
C local
      Integer  maxdat, num, status
      Integer  idbufx, idbufy, idbufdy, locx, locy, locdy
      Real  upper_edge, xval, dx, xmin, xmax, width
      Character * 255  line
C functiin
      Integer  DIS45_malloc, DIS45_realloc
C begin
      Call Titrd('title:',title)
C
      Call DIS45_insert(id,1,error)
      If( error.ne.0 ) Return
C
      maxdat = 256
      If( DIS45_malloc( maxdat,idbufx,locx,error ).le.0 ) Return
      If( DIS45_malloc( maxdat,idbufy,locy,error ).le.0 ) Return
      If( DIS45_malloc( maxdat,idbufdy,locdy,error ).le.0 ) Return
C
      num = 0
  100 Continue
	Call DIS45_include_one_line(lun,eof,line,status)
	If( status.le.0 ) Goto 200
        If (option.eq.1) Then       ! (x,y)
          Read(line,*,End=200,ERR=200) 

     &      Rmem(locx+num), Rmem(locy+num)
        Else If (option.eq.2) Then
          Read(line,*,End=200,ERR=200)   ! (x,y,dy)
     &      Rmem(locx+num), Rmem(locy+num), Rmem(locdy+num)
        Else If (option.eq.3) Then
          Read(line,*,End=200,ERR=200)   ! (xmin, xmax, y) 

     &      Rmem(locx+num), upper_edge, Rmem(locy+num)
        Else If (option.eq.4) Then
          Read(line,*,End=200,ERR=200)   ! (xmin, xmax, y, dy)
     &      Rmem(locx+num), upper_edge, Rmem(locy+num), Rmem(locdy+num)
        Else If (option.eq.5) Then
          Read(line,*,End=200,ERR=200)   ! (x, dx, y, dy)
     &      xval, dx, Rmem(locy+num), Rmem(locdy+num)
            Rmem(locx+num) = xval - dx
            upper_edge = xval + dx
        End If
        num = num + 1
        If ( num.ge.maxdat ) Then
          maxdat = maxdat + 256
          If( DIS45_realloc( maxdat,idbufx,locx,error ).le.0 ) 

     &      Goto 900
          If( DIS45_realloc( maxdat,idbufy,locy,error ).le.0 )
     &      Goto 900
          If( DIS45_realloc( maxdat,idbufdy,locdy,error ).le.0 ) 

     &      Goto 900
        End If
        Goto 100
  200 Continue
C
      If (num.lt.2) Then
        error = 24 ! too small date point
        Goto 900
      End If
C
      If ( (option.eq.1).or.(option.eq.2) ) Then
        width = Rmem(locx+1) - Rmem(locx)
	Xmin = Rmem(locx) - width/2
	Xmax = Rmem(locx+num-1) + width/2
        Call Hbook1(id,title,num,xmin,xmax,0.0)
        Call Hpak(id,Rmem(locy))
        If (option.eq.2) Then
          Call Hpake(id,Rmem(locdy))
	  Call DIS45_hsetopt(id,'ERRO')
        End If
        Call DIS45_fixentry(id)

      Else If ( (option.eq.3).or.(option.eq.4).or.(option.eq.5) ) Then
        Rmem(locx+num) = upper_edge
        Call Hbookb(id,title,num,Rmem(locx),0.0)
        Call Hpak(id,Rmem(locy))
        If ((option.eq.4).or.(option.eq.5)) Then
          Call Hpake(id,Rmem(locdy))
	  Call DIS45_hsetopt(id,'ERRO')
        End If
        Call DIS45_fixentry(id)
      Else
        Write(*,*) 'HLinclude: no such option: ', option
      End If
C       

  900 Continue
      Call DIS45_free( idbufx )
      Call DIS45_free( idbufy )
      Call DIS45_free( idbufdy )
C
      Return
      End
C
C
      Subroutine HLinclude_tuple(lun,eof,id,title,error)
C
      Implicit None 

C common
      Include 'tags.inc'
C input
      Integer  lun, id
      Character * (*)  title, eof
C output
      Integer  error
C local
      Integer  I, Nvar, Ltag, status
      Character * 20  prompt
      Real  vars(MAXTAG)
      Character * 255  line
C function
      Integer  Lkbrd
C begin
      Call DIS45_insert(id,3,error)
      If( error.ne.0 ) Return
C
      Call IntrdL('number of variables',nvar,1,MAXTAG)
      Do I = 1, nvar
        Write(prompt,'(A,I2)') 'name for variable ',I
        Ltag = Lkbrd(prompt,1)
        Write(tags(I),'(I2)') I
        Ltag = Lkbrd(tags(I),0)
        Call Txtrd(prompt,tags(I))
      End Do
C
      Call Titrd('title',title)
C
      Call Hbookn(id,title,nvar,' ',1000,tags)
C
  100 Continue
      Call DIS45_include_one_line(lun,eof,line,status)
      If( status.le.0 ) Goto 200
      Read(line,*,End=200,Err=200) (vars(I),I=1,nvar)
      Call Hfn(id,vars)
      Goto 100
  200 Continue
      Return
      End
C
C
      Subroutine DIS45_include_one_line(lun,eof,line,status)
C
      Implicit None
C input
      Integer  lun
C output
      Character * (*)  line, eof
      Integer  status
C local
      Integer  I, L
C function
      Integer  Lenrd
C begin
      L = Lenrd(eof)
  100 Continue
      line = ' '
      Read(lun,'(A)',End=900,Err=900) line
      If( L.gt.0 ) Then
        If( eof(1:L).eq.line(1:L) ) Goto 900
      End If
      If( Index('!#*;/',line(1:1)).gt.0 ) Goto 100
      I = 0
  200 Continue
      I = I + 1
      If( I.gt.Len(line) ) Goto 100
      If( line(I:I).eq.' ' ) Goto 200
      If( line(I:I).eq.'(' ) Goto 100
      status = 1
      Return
C
  900 Continue
      status = -1
      Return
      End



