C
C File: HLinteg.for
C Description: Integration over X
C Date: 28-May-1992
C Author: A.Shirahashi
C
C Public HLinteg
C
      Subroutine HLinteg( error )
      Implicit None
C common:
      Include 'pawc.inc'
C output:
      Integer  error
C local:
      Character * 80  title  
      Integer  here, dim, id, idnew
      Integer  nx, i, idbuf, loc
      Real  xmin, xmax, sum
      Integer  nent, region
C function:
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
      Real  Hi
C begin:
      If( DIS45_needhist(1,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      Call IntrdL('region (0:(xmin,x),1:(x,xmax))',region,0,1)
C
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
      If( DIS45_makehist(id,1,idnew,error).le.0 ) Return
      Call Hcopy(id,idnew,'INT '//title)
      If( DIS45_malloc(nx,idbuf,loc,error).le.0 ) Return
C
      sum = 0.0
      If( region.eq.0 ) Then
        Do i = 1, nx
          sum = sum + Hi(id,i)
          Rmem(loc+i-1) = sum
        End Do
      Else If( region.eq.1 ) Then
        Do i = nx, 1, -1
          sum = sum + Hi(id,i)
          Rmem(loc+i-1) = sum
        End Do
      Else
        Write(*,*) 'HLinteg: can''t happen'
      End If      
C
      Call Hpak( idnew, Rmem(loc) )
      Call DIS45_free(idbuf)
C
      Call Hnoent(id,nent)
      Call DIS45_setentry(idnew,nent)
C
      Call DIS45_hsetopt(idnew,'NPFU')
      Call Hminim(idnew,0.0)
      Call Hmaxim(idnew,0.0)
C
      Return
      End
