C
C File: HLjoin.for
C Description: JOIN and PLOT
C Author: A.Shirahashi
C Date: 24-Jun-1992
C
C History: 25-Jun-1992, ask line style, marker size
C          30-Jun-1992, default marker type = 20
C                       fix wrong call to dis45_reset_hplopt
C           6-Jun-1992, call HLaxis_title
C           4-Sep-1992, N-tuples
C          23-Jan-1995, Y.Ishisaki   IGSET('LTYP') -> Hplset('DMOD')
C
C Public: HLjoin, HLmark
C
      Subroutine HLjoin(error)
C
      Implicit None
C output
      Integer  error
C local
      Integer  here, id, dim
      Character * 2  opt
      Integer  level, mode, style
      Real dmod_save
C function
      Integer DIS45_needhist
C data
      Save  level, mode, style
      Data  level / 0 /, mode / 0 /, style / 1 /
C begin      
      If( DIS45_needhist(1,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      Call IntrdL('0:new plot, 1:superimpose ?',mode,0,1)
      If( mode.eq.0 ) Then
        opt(2:2) = ' '
      Else If( mode.eq.1 ) Then
        opt(2:2) = 'S'
      End If
C
      Call IntrdL('0:straight line, 1:smooth curve ?',level,0,1)
      If( level.eq.0 ) Then
        opt(1:1) = 'L'
      Else If( level.eq.1 ) Then
        opt(1:1) = 'C'
      End If
C
      Call Intrd('line style ?',style)
ccc      Call IGSET('LTYP',Float(style))
      Call Hplset('?DMOD', dmod_save)
      Call Hplset('DMOD', Float(style))
C
      If( mode.eq.0 ) Then
        Call DIS45_set_hplopt(id)
      Else
        Call DIS45_set_hplopt_to_compare(id,0)
      End If
C
      Call Hplot(id,opt,' ',0)
      If( mode.eq.0 ) Then
        Call HLaxis_title
      End If
      Call IUWK(0,0)                 ! Update Workstation
C
      If( mode.eq.0 ) Then
        Call DIS45_save_hplopt_to_compare(id)
      End If
      Call DIS45_reset_hplopt(id,0)
      Call Hplset('DMOD', dmod_save)
C
      Return
      End
C
C
      Subroutine HLmark(error)
C
      Implicit None
C output
      Integer  error
C local
      Integer  here, id, dim
      Character * 2  opt
      Integer  marker, mode
      Real  size
C function
      Integer DIS45_needhist
C data
      Save  marker, mode, size
      Data  marker / 20 /, mode / 0 /, size / 1.0 /
C begin      
C     ... need 1 dim (1) or N-tuples (3)
      If( DIS45_needhist(4,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      Call IntrdL('0:new plot, 1:superimpose ?',mode,0,1)
      If( mode.eq.0 ) Then
        opt(2:2) = ' '
      Else If( mode.eq.1 ) Then
        opt(2:2) = 'S'
      End If
C
      Call Intrd('marker type ?',marker)
      Call IGSET('MTYP',Float(marker))
      Call Fltrd('marker size ?',size)
      Call IGSET('MSCF',size)
      opt(1:1) = 'P'
C
      If( mode.eq.0 ) Then
        Call DIS45_set_hplopt(id)
      Else
        Call DIS45_set_hplopt_to_compare(id,0)
      End If
C
      If( dim.eq.1 ) Then
        Call Hplot(id,opt,' ',0)
      Else If( dim.eq.3 ) Then
        Call HLtuple(id,opt(2:2),marker,size,error)
	If( error.ne.0 ) Return
      Else
        Print *, 'HLmark: can''t happen: dim = ', dim
        Return
      End If        
      If( mode.eq.0 ) Then
        Call HLaxis_title
      End If
      Call IUWK(0,0)                 ! Update Workstation
C
      If( mode.eq.0 ) Then
        Call DIS45_save_hplopt_to_compare(id)
      End If
      Call DIS45_reset_hplopt(id,0)
C
      If( mode.eq.1 ) Then
        marker = marker + 1
      End If

C
      Return
      End
