C----------------------------------------------------------------------
C  File: HLlego.for
C  Description: Lego,Surface,Contour Plots
C  Entry: HLlego,HLsurf,HLcntr
C  Created   5-MAR-1992   T.Takahashi
C  History: 27-Apr-1992   hllego.for,hlsurf.for merged into hllego.for 
C           27-Apr-1992   A.Sirahashi, add HLcntr
C           26-Jun-1992   A.Shirahashi, DIS45_numhist
C           30-Jun-1992   Fltrd -> FltrdL
C            6-Aug-1992   Call HLaxis_title
C            2-Apr-1992   CONTOUR n min max
C           16-Jan-1995   Y.Ishiaki, FltrdL -> Fltrd
C----------------------------------------------------------------------
      SUBROUTINE HLLEGO(error)
      IMPLICIT NONE
c output:
      Integer error
c function:
      Integer DIS45_needhist
C local
      Real*4    Theta, Phi
      Integer i
      Integer here, id, dim
C data
      Save  theta, phi
      Data  theta /45.0/, phi /30.0/
C begin
      If( DIS45_needhist(2,error).le.0 ) Return
      Call DIS45_thishist(here, id, dim)
C
ccc      Call FltrdL('theta',Theta,0.0,90.0)
ccc      Call FltrdL('phi',Phi,0.0,90.0)
      Call Fltrd('theta',Theta)
      Call Fltrd('phi',Phi)
      Call Hplego(Id,Theta,Phi)
      Call HLaxis_title
      Call IUWK(0,0)                 ! Update Workstation
  999 RETURN
      END
C
C-
C-   Purpose and Methods : Surface plot 
C-
C-   Created:  24-Apr-1992   A.Shirahashi
C-   Origianl:  HLlego.for
C-
      Subroutine HLsurf(error)
C
      Implicit None
C output
      Integer error
C function
      Integer DIS45_needhist
C local
      Real  theta, phi
      Integer  here, id, dim
C data
      Save  theta, phi
      Data  theta /45.0/, phi /30.0/
C begin
      If (DIS45_needhist(2,error).le.0) Return
      Call DIS45_thishist(here,id,dim)
C
ccc      Call FltrdL('theta',theta,0.0,90.0)
ccc      Call FltrdL('phi',phi,0.0,90.0)
      Call Fltrd('theta',theta)
      Call Fltrd('phi',phi)
C     the 4th argmument is dummy
      Call HPLsur(Id,theta,phi,0)
      Call HLaxis_title
      Call IUWK(0,0)                 ! Update Workstation
      Return
      End
C
C
C-   Purpose and Methods : Contour plot 
C-
C-   Created:  27-Apr-1992   A.Shirahashi
C-   Origianl:  HLsurf
C
      Subroutine HLcntr(error)
C
      Implicit None
C output
      Integer error
C function
      Integer DIS45_needhist
C local
      Integer ncntr
      Integer  here, id, dim
      Real  zmin, zmax, par(4)
C function
      Real  Hmin, Hmax
C data
      Save ncntr
      Data ncntr /10/
C begin
      If (DIS45_needhist(2,error).le.0) Return
      Call DIS45_thishist(here,id,dim)
C
      zmin = Hmin(id)
      zmax = Hmax(id)
C
      Call Intrd('how many contours',ncntr)
      Call Fltrd('z min',zmin)
      Call Fltrd('z max',zmax)
C      Call HPLcon(id,ncntr,1)
      par(1) = Real(ncntr)
      par(2) = 1.0
      par(3) = zmin
      par(4) = zmax
      Call HPLtab(id,4,par,'CONT')
      Call HLaxis_title
      Call IUWK(0,0)                 ! Update Workstation
      Return
      End
