C 
C File: HLmami.for
C Description: set min and max limits
C
C History: 26-Jun-1992, A.Shirahashi, DIS45_numhist
C          17-Sep-1992, N-tuples
C          16-Feb-1994, 2-dim
C
      Subroutine HLmami (error)
      Implicit None
c output:
      Integer error
c
c function
      Integer DIS45_needhist
      Real Hmin, Hmax
c
c local:
      Integer here, id, dim
      Real ymin, ymax
C begin
C     ... need 1D/2D histogram or N-tuples
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      If( dim.eq.1 ) Then
        Ymin = Hmin(id)
        Ymax = Hmax(id)
      Else If( dim.eq.2 ) Then
        Call DIS45_getinfo(id,'ZMIN',Ymin)
        Call DIS45_getinfo(id,'ZMAX',Ymax)
      Else If( dim.eq.3 ) Then
        Call DIS45_aux_getinfo(id,'YMIN',Ymin)
        Call DIS45_aux_getinfo(id,'YMAX',Ymax)
      End If
C
      Call Fltrd('Minimum',Ymin)
      Call Fltrd('Maximum',Ymax)
C
      If( dim.eq.1 ) Then
        Call Hmaxim(id,Ymax)
        Call Hminim(id,Ymin)
      Else If( dim.eq.2 ) Then
        Call DIS45_putinfo(id,'ZMIN',Ymin)
        Call DIS45_putinfo(id,'ZMAX',Ymax)
      Else If( dim.eq.3 ) Then
        Call DIS45_aux_putinfo(id,'YMIN',Ymin)
        Call DIS45_aux_putinfo(id,'YMAX',Ymax)
      End If
C         
      Return
      End
