c
C File: HLmove.for
C Author: for DISPLAY45 by T.Takahashi  mod from PEP4 version
C
C History: 23-Jul-1992, A.Shirahashi, HLnext, HLback
C          24-Mar-1993, dis45_gethid
C
C Public: HLmove, HLnext, HLback
C Private: DIS45_whereami
C
      Subroutine HLmove(error)
      Implicit None
C output
      Integer error
C local
      Integer  here, id, dim
C function
      Integer  DIS45_numhist, DIS45_info_i
C begin
      If(DIS45_numhist(error).le.0) Return
      Call DIS45_thishist(here,id,dim)
C
      If (here.eq.0) Then
        id = DIS45_info_i(1)
      End If
C     Call Intrd('what histogram (id)',id)
      Call DIS45_gethid('what histogram (id or /pat/)',id,error)
      If( error.ne.0 ) Return
      If (id.eq.0) Then
        Call DIS45_set_current(1,error)
        error = 0 ! ignore error
      Else
        Call DIS45_sethist(id,error)
      End If
      If( error.eq.0 ) Then
        Call DIS45_whereami
      End If
      Return
      End
C
C
      Subroutine HLnext(error)
C ... move to next histogram
      Implicit None 
C output
      Integer error
C local
      Integer  i
C function
      Integer  DIS45_numhist, DIS45_current
C begin
      If(DIS45_numhist(error).le.0) Return
      i = DIS45_current(error)
      If(i.eq.0) Then
        Call DIS45_set_current(1,error)
        error = 0 ! ignore error
      Else
        Call DIS45_set_current(i+1,error)
      End If
      If( error.eq.0 ) Then
        Call DIS45_whereami
      End If
      Return
      End
C
C
      Subroutine HLback(error)
C ... move to previious histogram
      Implicit None 
C output
      Integer error
C local
      Integer  n, i
C function
      Integer  DIS45_numhist, DIS45_current
C begin
      n = DIS45_numhist(error)
      If(n.le.0) Return
      i = DIS45_current(error)
      If( i.eq.0 ) Then
        Call DIS45_set_current(n,error)
        error = 0 ! ignore error
      Else
        Call DIS45_set_current(i-1,error)
      End If
      If( error.eq.0 ) Then
        Call DIS45_whereami
      End If
      Return
      End
C
C
      Subroutine DIS45_whereami
C ... show where I am
      Implicit None 
C local
      Integer  here, id, dim, length
      Character * 80  title
C function
      Integer  Lenrd
C begin
      Call DIS45_thishist(here,id,dim)
      Call DIS45_hinfo0(id,title,dim)
      length = Lenrd(title)
      Write(*,1000) id, dim, title(:length)
 1000 Format(1X,I6,I2,2X,A) 
      End
C
C
      Subroutine DIS45_gethid(prompt,id,error)
C
      Implicit None
C input
      Character * (*)  prompt
C output
      Integer  id
      Integer  error
C local
      Integer  first, last, dir
      Character * 1  S
      Character * 80  ans, pat, title
C integer
      Integer  numhist, current, I, La, Le, Lp, dim
C function
      Integer  DIS45_current, DIS45_numhist, DIS45_info_i
      Integer  Lenrd
C save
      Save  pat, Lp
C begin
      Call CLitoa(id,ans)
      Call Titrd(prompt,ans)
      La = Lenrd(ans)
C
      If( ans(1:1).eq.'/' ) Then
        S = '/'
      Else If( ans(1:1).eq.'?' ) Then
        S = '?'
      Else
        Call Ugetrd(ans,La)
        Call Intrd(prompt,id)
        Return
      End If
C
      Le = Index(ans(2:),S)
      If( Le.eq.1 ) Then
C       ... use previous pattern        
      Else If( Le.gt.1 ) Then
        Call Ugetrd(ans(Le+2:),La-Le-1)
        Lp = Le - 1
        pat(:Lp) = ans(2:Le)
      Else
        Lp = La - 1
        pat(:Lp) = ans(2:La)
      End If
C
      numhist = DIS45_numhist(error)
      If( error.ne.0 ) Return
C
      current = DIS45_current(error)
      If( error.ne.0 ) Return
C
      If( S.eq.'/' ) Then
        first = current+1
        last = numhist
        dir = +1
      Else If( S.eq.'?' ) Then
        first = current-1
        last = 1
        dir = -1
      End If
C
      Do I = first, last, dir
        id = DIS45_info_i(I)
        Call DIS45_hinfo0(id,title,dim)
        If( Index(title,pat(:Lp)).gt.0 ) Goto 100
      End Do
C
      id = 0
      error = 5 ! this histogram does not exist
      Return
C
 100  Continue
      Return
      End



