C
C File: hlntplot.f
C Description: generic plot routine for N-tuples
C Author: A.Shirahashi
C Date: 30-Aug-1993
C
C History: 18-Nov-1993 DIS45_dynopen,DIS45_dynclose
C
      Subroutine HLntplot( error )
C
      Implicit None
C const
      Include 'dis45def.inc'
C common
      Include 'pawc.inc'
C output
      Integer  error
C local
      Integer  here, id, dim, address
      Character * 80  title
      Integer  nevent, i, nout
      Integer  idbuf, locx, locy, locdx, locdy, locm, locs, locc
      Real  record(MAXTAG)
      Character * 8  varx, vary
      Logical  flag
      Real  xmin, xmax, ymin, ymax, dx, dy
      Real  x, y, weight, size
      Integer  mark, color, iflag
      Real  mark0, size0, color0
C data
      Integer isel, ivx, ivy
      Save isel, ivx, ivy
      Data isel / 0 /
      Data ivx, ivy / 1, 2 /
      Character * 80  selfun
      Save selfun
      Data selfun / 'ntpsel' /
C function
      Integer  Dis45_needhist, Dis45_malloc
      Integer  Dis45_dynopen, Dis45_dynlink
C begin
      If( DIS45_needhist(3,error).le.0 ) Return
      Call Dis45_thishist(here, id, dim)
      Call Dis45_hinfo0(id,title,dim)
      Call Hnoent(id,nevent)
C
      Call HLtuple_asktag(id,'x variable',ivx,varx,ivx)
      Call Hltuple_asktag(id,'y variable',ivy,vary,ivy)
C
      Call Intrd('selection (0:no selection)',isel)
C
      If( isel.ne.0 ) Then
C
C       Call Txtrd('selection function',selfun)
C
        If( DIS45_dynopen('selection function file',selfun)
     &      .eq.0 ) Then
          error = 9
          Return
        End If
        address = Dis45_dynlink(selfun,'ntpsel')
        If( address .eq. 0 ) Then
          error = 28
          Return
        End If
      End If
C
      Call IGq('MTYPE',mark0)
      Call IGq('MSCF',size0)
      Call IGq('PMCI',color0)
C
      If( DIS45_malloc( nevent*7,idbuf,locx,error ).le.0 ) Return
      locy = locx + nevent
      locdx = locy + nevent
      locdy = locdx + nevent
      locm = locdy + nevent
      locs = locm + nevent
      locc = locs + nevent
C
      flag = .True.
      nout = 0
C
      Do i = 1, nevent
        Call Dis45_tuple_getevt(id,i,record,error)
        x = record(ivx)
        y = record(ivy)
        dx = 0.0
        dy = 0.0
        weight = 1.0
        mark = mark0
        size = size0
        color = color0
        iflag = 1
        If( isel.ne.0 ) Then
          Call Call_NtpSel(%val(address),isel,i,record,ivx,ivy,
     &                     x,y,weight,mark,size,color,iflag)
        End If
        If( weight.gt.0.0 ) Then
          Rmem(locx+nout) = x
          Rmem(locy+nout) = y
          Rmem(locdx+nout) = dx
          Rmem(locdy+nout) = dy
          Hmem(locm+nout) = mark
          Rmem(locs+nout) = size
          Hmem(locc+nout) = color
          nout = nout + 1
          If( flag ) Then
            flag = .False.
            xmin = x
            xmax = x
            ymin = y
            ymax = y
          Else 
            xmin = Min(x,xmin)
            xmax = Max(x,xmax)
            ymin = Min(y,ymin)
            ymax = Max(y,ymax)
          End If
        End If
      End Do
C
      Call HL_draw_frame(title,xmin,xmax,ymin,ymax)
      Call Hplax(varx,vary)
C
      Do i = 0, nout-1
        Call HL_plot_marker(Rmem(locx+i),Rmem(locy+i),
     &                      Hmem(locm+i),Rmem(locs+i),Hmem(locc+i))
      End Do
C
      Call IUWK(0,0) ! update workstatio
C
      Call DIS45_free( idbuf )
C
      Call DIS45_dynclose( address )
C
      Return
      End
C
C
      Subroutine Call_NtpSel(address,isel,irec,record,ivx,ivy,
     &                       x,y,weight,mark,size,color,iflag)
C
C input
      External  address
      Real  record(*)
      Integer  isel, irec
      Integer  ivx, ivy
C output
      Real  x, y, weight
      Integer  mark, color
      Real  size
      Integer iflag
C begin
      Call address(isel,irec,record,idx,idy,x,y,
     &             weight,mark,size,color,iflag)
C
      Return
      End 
C
C
      Subroutine HL_plot_marker(x,y,mark,size,color)
C 
      Implicit None
C input
      Real  x, y
      Integer  mark
      Real  size
      Integer  color
C local
      Real  colors
      Real  dx, dy
      Data dx, dy / 0.0, 0.0 /
C begin
      Call IGq('PMCI',colors)
      Call IGset('PMCI',Real(color))
      Call HPLerr( x,y,dx,dy,1,' ',mark,size*0.2 )
      Call IGset('PMCI',colors)
      Return
      End
