C+
C Description : Apply operation on the histogram
C Author : Ryosuke Itoh, TOPAZ, KEK
C Date : 17 - MAY - 1988
C History: modified for DISPLAY45, 7-May-1992, A.Shirahashi
C          14-Jan-1993, use Hcopy instead of Hbook
C          18-Dec-1994, add 2 dim operation by Y.Ishisaki
C-
C
	Subroutine HLoper(error)
C
	Implicit None
C output
	Integer  error
C local
        Integer  id1, id2, nhist
	Integer  here, id, dim, idnew
        Integer  nx, ny
        Integer  i
	Real  xmin, xmax, ymin, ymax
	Character  title*80
        Character  oper*1 /'+'/
	Real coef1 / 1.0 /, coef2 / 1.0 /
	Save oper, coef1, coef2
C function
	Integer  DIS45_needhist, DIS45_hexist, DIS45_samehist
	Integer  DIS45_makehist
C begin
	If( DIS45_needhist(0,error).le.0 ) Return
	Call DIS45_thishist(here,id,dim)
C
	Call Txtrd('operation',oper)
C
        If( oper.eq.'+' ) Then
          nhist = 2
          Call Intrd('how many histograms',nhist)
          If( nhist.le.0 ) Return
          id1 = id ! this default value is not nice
          Call Intrd('id',id1)
          If( DIS45_hexist(id1,error).le.0 ) Return
          Call DIS45_hinfo0(id1,title,dim)
          If( DIS45_makehist(id,dim,idnew,error).le.0 ) Return
          Call Hcopy(id1,idnew,'OPER '//title)
          id2 = id1 ! this default value is not nice
          Do i = 2, nhist
            Call Intrd('id',id2 )
            If( id2.le.0 ) Return
            If( DIS45_samehist(id1,id2,error).le.0 ) Then
              Call DIS45_hdelete(idnew)
              Return
            End If
            Call Hopera(id2,oper//'E',idnew,idnew,1.0,1.0)
          End Do
        Else If( oper.eq.'-' .or. oper.eq.'*' .or. oper.eq.'/' ) Then
          Call Intrd('histogram 1',id1)
          If( DIS45_hexist(id1,error).le.0 ) Return
	  Call Intrd('histogram 2',id2)
          If( DIS45_hexist(id2,error).le.0 ) Return
	  If( DIS45_samehist(id1,id2,error).le.0 ) Return
	  Call Fltrd('coef 1',coef1)
	  Call Fltrd('coef 2',coef2)
	  Call DIS45_Hinfo0(id1,title,dim)
	  If( DIS45_makehist(id,dim,idnew,error).le.0 ) Return
          Call Hcopy(id1,idnew,'OPER '//title)
          Call Hopera(id1,oper//'E',id2,idnew,coef1,coef2)
        Else
          error = 23 ! illegal option
          oper = '+'
        End If
C
        Return
	End
C
C
        Subroutine HLarith( oper,error )
        Implicit None
C common:
	Include 'pawc.inc'
C input:
	Character * 1  oper
C output:
	Integer  error
C local:
	Character * 80  title  
	Integer  here, dim, id1, id2, idnew
	Integer  n, nx, ny, i, idbuf, loc, loc1, loc2
	Real  xmin, xmax, ymin, ymax
        Integer  ler1, ler2, nent1, nent2, nent
        Real  d, er1, er2
C function:
        Integer  DIS45_needhist, DIS45_hexist, DIS45_samehist
        Integer  DIS45_makehist, DIS45_hasbar, DIS45_malloc
        Real  Hi, Hie
C begin:
C     require 1 dim or 2 dim histogram
        If( DIS45_needhist(0,error).le.0 ) Return
        Call DIS45_thishist(here,id1,dim)
        id2 = id1
        Call Intrd( 'histogram id', id2 )
        If( DIS45_hexist(id2,error).le.0 ) Return
        If( DIS45_samehist(id1,id2,error).le.0 ) Return
	If( 1.eq.dim ) Then
	  Call DIS45_hinfo1(id1,title,n,xmin,xmax)
	Else
	  Call DIS45_hinfo2(id1,title,nx,xmin,xmax,ny,ymin,ymax)
	  n = nx * ny
	End If
C
        If( DIS45_makehist(id1,dim,idnew,error).le.0 ) Return
C       Call Hbook1(idnew, oper//' '//title, nx, xmin, xmax, 0.0)
        Call Hcopy(id1,idnew,oper//' '//title)
        Call Hreset(idnew,' ')
C
        If( DIS45_malloc(2*n,idbuf,loc,error).le.0 ) Return
	loc1 = loc
	loc2 = loc + n
C
	Call Hunpak(id1, Rmem(loc1), 'HIST', 0)
	Call Hunpak(id2, Rmem(loc2), 'HIST', 0)
C
	Call Hnoent(id1,nent1)
	Call Hnoent(id2,nent2)
C
	If ( oper .EQ. '+' ) Then
	  Do i = 0, n-1
            Rmem(loc1+i) = Rmem(loc1+i) + Rmem(loc2+i)
          End Do
        Else If ( oper .EQ. '-' ) Then
	  Do i = 0, n-1
            Rmem(loc1+i) = Rmem(loc1+i) - Rmem(loc2+i)
          End Do
        Else If ( oper .EQ. '*' ) Then
	  Do i = 0, n-1
            Rmem(loc1+i) = Rmem(loc1+i) * Rmem(loc2+i)
          End Do
        Else If ( oper .EQ. '/' ) Then
	  Do i = 0, n-1
            d = Rmem(loc2+i)
            IF( Abs(d).GT.0.0 ) Then
              Rmem(loc1+i) = Rmem(loc1+i) / d
            Else
              Rmem(loc1+i) = 0.0
            End If
          End Do
        End If
        Call DIS45_locate(idbuf,loc1)
        Call Hpak( idnew, Rmem(loc1) )
C
        ler1 = DIS45_hasbar(id1)
        ler2 = DIS45_hasbar(id2)
        If( dim.eq.1 .and. (ler1.ne.0 .or. ler2.ne.0) ) Then
          Do i = 1, n
            If( ler1.ne.0  ) Then
              er1 = Hie(id1,i)
            Else
              er1 = 0.0
            End If
            If( ler2.ne.0 ) Then
              er2 = Hie(id2,i)
            Else
              er2 = 0.0
            End If
            IF ( oper .eq. '+' .or. oper .eq. '-' ) Then
              Rmem(loc+i-1) = Sqrt ( er1**2 + er2**2 )
            Else If ( oper .eq. '*' ) Then
              Rmem(loc+i-1) = Sqrt ( (Hi(id2,i)*er1)**2 +
     #                         (Hi(id1,i)*er2)**2 )
            Else If ( oper .eq. '/' ) Then
              d = Hi(id2,i)
              IF( Abs(d).gt.0.0 ) Then
                Rmem(loc+i-1) = Sqrt ( (er1/d)**2 +
     #                     (Hi(id1,i)*er2/d**2)**2 )
              Else
                Rmem(loc+i-1) = 0.0
              End If
            End If
          End Do
          Call DIS45_locate(idbuf,loc)
          Call Hpake( idnew, Rmem(loc) )
        End If
C
	Call DIS45_free(idbuf)
C
	If( oper.eq.'+' ) Then
	  nent = nent1 + nent2
	Else
          nent = nent1
C	  is this appropriate ?
C         HOPERA sets nent = nent1 + nent2, but it looks strange to me.
	End If
	Call DIS45_setentry(idnew,nent)
C
        Return
        End
