C
C File: HLopt.for 
C Author: T.takahashi                                             
C
C History: 12-May-1992, A.Shirahashi, add "SOFT","HARD"
C           2-Jun-1992, A.Shirahashi, add "DVXR/DVXI/DVYR/DVYI/SHOW"
C          26-Jun-1992, A.Shirahashi, add "PTO/NPTO"
C                                     character*5 -> character*4
C          29-Jun-1992, A.Shirahashi, Parameter()
C           9-Jul-1992, A.Shirahashi, ZFL, TIC
C           7-Sep-1992, A.Shirahashi, LINZ, LOGZ
C          26-Oct-1992, R.Itoh,       FIT, NFIT
C          28-Oct-1992, R.Itoh,       GRID, NGRI
C           4-Jan-1993, A.Shirahashi  DATE, FILE, SQR
C          29-Mar-1994, A.S.          SYNC, ASYN
C          15-Jan-1995, Y.Ishisaki    HTIT, UTIT, ZFL1
C
      Subroutine HLopt (error_flag)
c
      Implicit NONE
c output:
      Integer error_flag
C constant
      Integer  Ncomm
      Parameter (Ncomm = 39)
C local
      Integer igo
      Character*4 Comm(Ncomm)
      Data Comm /
     &  'ASYN',
     &  'BAR ',
     &  'BOX ',
     &  'CHA ',          
     &  'DATE',
     &  'DVXR',
     &  'DVXI',
     &  'DVYR',
     &  'DVYI',
     &  'FILE',                    
     &  'FIT ',
     &  'GRID',
     &  'HARD',     
     &  'LINZ',
     &  'LOGZ',
     &  'SYNC',
     &  'NBAR',
     &  'NBOX',
     &  'NCHA',
     &  'NDAT',
     &  'NFIL',
     &  'NFIT',
     &  'NGRI',
     &  'NPTO',
     &  'NSQR',
     &  'NSTA',
     &  'NTIC',
     &  'NZFL',
     &  'PTO ',
     &  'SOFT',
     &  'SQR ',     
     &  'STAT',
     &  'TIC ',
     &  'ZFL ',
     &  'ZFL1',
     &  'HTIT',
     &  'UTIT',
     &  'SHOW',     
     &  'EXIT'
     &  /
c Local:
      Character*4 Cmd
      Character*10 Prompt /'?DIS:OPT> '/
c
c Main Body
c
100   Continue
      Call Keyrd(-1,Prompt,Cmd,Comm,Ncomm,Igo)
      error_flag = 0
      If (Cmd.eq.'BAR ') then
        Call HPLOPT('BAR ',1)
      else if (Cmd.eq.'BOX ') then
        Call HPLOPT('BOX ',1)
      else if (Cmd.eq.'CHA ') then
        Call HPLOPT('CHA ',1)    
      else if (Cmd.eq.'DATE') then
        Call HPLOPT('DATE',1)
      else if (Cmd.eq.'DVXR') then
        Call HPLOPT('DVXR',1)
      else if (Cmd.eq.'DVXI') then
        Call HPLOPT('DVXI',1)
      else if (Cmd.eq.'DVYR') then
        Call HPLOPT('DVYR',1)
      else if (Cmd.eq.'DVYI') then
        Call HPLOPT('DVYI',1)
      else if (Cmd.eq.'FILE') then
        Call HPLOPT('FILE',1)
      else if (Cmd.eq.'FIT ') then
        Call HPLOPT('FIT ',1)
      else if (Cmd.eq.'GRID') then
        Call HPLOPT('GRID',1)
      else if (Cmd.eq.'HARD') then
        Call HPLOPT('HARD',1)
      else if (Cmd.eq.'LINZ') then
        Call HPLOPT('LINZ',1)
      else if (Cmd.eq.'LOGZ') then
        Call HPLOPT('LOGZ',1)
      else if (Cmd.eq.'NBAR') then
        Call HPLOPT('NBAR',1)
      else if (Cmd.eq.'NBOX') then
        Call HPLOPT('NBOX',1)
      else if (Cmd.eq.'NCHA') then
        Call HPLOPT('NCHA',1)
      else if (Cmd.eq.'NDAT') then
        Call HPLOPT('NDAT',1)
      else if (Cmd.eq.'NFIL') then
        Call HPLOPT('NFIL',1)
      else if (Cmd.eq.'NFIT') then
        Call HPLOPT('NFIT',1)
      else if (Cmd.eq.'NGRI') then
        Call HPLOPT('NGRI',1)
      else if (Cmd.eq.'NPTO') then
        Call HPLOPT('NPTO',1)
      else if (Cmd.eq.'NSQR') then
        Call HPLOPT('NSQR',1)
      else if (Cmd.eq.'NSTA') then
        Call HPLOPT('NSTA',1)
      else if (Cmd.eq.'NTIC') then
        Call HPLOPT('NTIC',1)
      else if (Cmd.eq.'NZFL') then
        Call HPLOPT('NZFL',1)
      else if (Cmd.eq.'PTO ') then
        Call HPLOPT('PTO ',1)
      else if (Cmd.eq.'SOFT') then
        Call HPLOPT('SOFT',1)
      else if (Cmd.eq.'SQR ') then
        Call HPLOPT('SQR ',1)
      else if (Cmd.eq.'STAT') then
        Call HPLOPT('STA ',1)
      else if (Cmd.eq.'TIC ') then
        Call HPLOPT('TIC ',1)
      else if (Cmd.eq.'ZFL ') then
        Call HPLOPT('ZFL ',1)
      else if (Cmd.eq.'ZFL1') then
        Call HPLOPT('ZFL1',1)
      else if (Cmd.eq.'HTIT') Then
        Call HPLOPT('HTIT',1)
      else if (Cmd.eq.'UTIT') Then
        Call HPLOPT('UTIT',1)         
      else if (Cmd.eq.'SHOW') then
        Call HPLOPT('SHOW',1)
      Else If (Cmd.eq.'SYNC') Then
        Call IGset('SYNC',1.0)
      Else If (Cmd.eq.'ASYN') Then
        Call IGset('SYNC',0.0)
      else if (Cmd.eq.'EXIT') then
        Return
      else
        Write(*,*) 'HLopt: no such option: ', Cmd
      Endif
C
      Return
      End
