C
C File: HLpackfun.for
C Description: Pack function values as histogram
C Date: 02-Jan-1993
C Author: T.Takahashi
C
C History:
C 18-Nov-1993 A.Shiahashi DIS45_dynopen, DIS45_dynclose
C
C
      Subroutine HLpackfun( error )

      Implicit NONE
c output
      Integer error
C local
      Integer  itype
      Character * 8  ctype
C data
      Data itype / 1 /
C begin
      Call IntrdX('function (1:usr_funct, 2:min_funct)',itype,ctype)
      Call Strupc(1,ctype)
      If( itype.eq.1 .or. ctype(1:1).eq.'U' ) Then
        Call HLpackfun_usr(error)
      Else If( itype.eq.2 .or. ctype(1:1).eq.'M' ) Then
        Call HLpackfun_minuit(error)
      Else
        error = 10 ! no such command
      End If

      Return
      End
C
C
      Subroutine HLpackfun_usr(error)
      Implicit NONE
C output
      Integer error
C local
      Character*80 exec_name
      Integer  address
      Integer idnew
      Logical init_flag
C function
      Integer  DIS45_dynopen, DIS45_dynlink
C data
      Data exec_name / 'usr_funct' /
C begin
      If( DIS45_dynopen( 'function file',exec_name ).eq.0 ) Then
        error = 9 ! can't open file
        Return
      End If
C
C      Call Txtrd ('exec file for the function ', exec_name)
C      Inquire(file=exec_name(:lenrd(exec_name))//'.exe',
C     &  exist=exist_flag)
C      If (.not.exist_flag) then
C        error = 9
C        Return
C      Endif  
C
      address = DIS45_dynlink(exec_name,'USR_FUNCT')
C
      If( address .eq. 0 ) Then
        error = 28 ! can't load dynamic link module
        Return
      End If

      init_flag = .true.
      Call HLpackfun_exec_usrfunc( init_flag,%val(address),idnew,error)
      init_flag = .false.
      Call HLpackfun_create_hist (idnew,error)
      If (error.ne.0) Return
      Call HLpackfun_exec_usrfunc(init_flag,%val(address),idnew,error)
C
      Call DIS45_dynclose(address)
      Return
      End


      Subroutine HLpackfun_minuit( error )

      Implicit None
C output:
      Integer  error
c const:
      Integer MAXPARAM
      Parameter (MAXPARAM=50)
C local:
      Integer numparam
      Double Precision param(MAXPARAM)
      Character * 10 chnam(MAXPARAM)
      Character * 120  minfile
      Character * 80  title 
      Character * 80 exec_name 
      Integer idnew
      Integer  address
C function
      Integer DIS45_dynopen, DIS45_dynlink
C data
      Data exec_name / 'min_funct' /
      Data minfile   / 'dis45_fcn.min' /
      Data title     / 'function' /
C begin:
      If( DIS45_dynopen( 'function file',exec_name ).eq.0 ) Then
        error = 9 ! can't open file
        Return
      ENd If
C
C      Call Txtrd ('exec file for the function ', exec_name)
C
      address = DIS45_dynlink(exec_name,'MIN_FUNCT')
      If( address .eq. 0 ) Then
        error = 28 ! can't load dynamic link module
        Return
      End If
C
c ask param.
      Call HLPACKFUN_param_minuit(idnew,MAXPARAM,minfile,
     &   numparam, param,chnam,error)
      If (error.ne.0) Return
c
c create hist
      Call HLpackfun_create_hist (idnew,error)
      If (error.ne.0) Return
c
c plot func
      Call HLPACKFUN_exec_minuit(%val(address),idnew,numparam,param,
     &  error)
c
c punch out new parameters if needed
      Call HLPACKFUN_punch(minfile,title,numparam,param,chnam,error)
C
C unlink dynamic load module
      Call DIS45_dynclose(address)
C
      Return
      End


      Subroutine HLPACKFUN_param_minuit(id,MAXPARAM, minfile,
     &  number_of_parameters,
     &  param, chnam,error)
      Implicit NONE
c input
      Integer id
      Integer MAXPARAM
c output
      Character*(*)  minfile
      Integer number_of_parameters
      Real*8 param(*)
      Character*10 chnam(*)
      Integer error
c local:
      Character*120 title
      Integer num
c
      Logical exist_flag
c
c
c COM dialogue
      Integer MAXPARAM_LOCAL
      Parameter(MAXPARAM_LOCAL=50)
      Character*32 help (MAXPARAM_LOCAL)

      error = 0
      Call Txtrd('Parameter file name',minfile)
C
      Inquire(file=minfile,exist=exist_flag)
      If (.not.exist_flag) then
        error = 9
        Return
      Endif  
      Call OPNRD(minfile)

      Call Titrd('?title',title)
      Call Hreset(id,title)
      WRITE (*,*) 'Enter Parameter',
     &  ' Number, Name, Value, Error, Lower and Upper Limits'

      number_of_parameters = 0

      DO While (.true.)
        If (number_of_parameters.gt.MAXPARAM) then
          error=35
          Return
        Endif
        CALL LINRD(1,0)
        CALL INTRD('?Param',num)
        CALL TXTRD('?Name ',chnam(number_of_parameters+1))
        CALL FDPRD('?Value',param(number_of_parameters+1))
        If (num.eq.0) Goto 1
        number_of_parameters = number_of_parameters + 1
      End do
    1 Continue
c
c confirmation
c
      Call Init_Com_talk('FCN')  
      Call MODVAL('Param. Value',number_of_parameters,chnam,help,
     &  'D',param)
      Return
      End

      Subroutine HLPACKFUN_exec_usrfunc(init_flag,funct, idnew, error)
      Implicit NONE
c input:
      External funct
      Logical init_flag
      Integer idnew

c output:
      Integer error
c local:
c
      Character*120  minfile
      Character*120 title
      Integer idim
      Real Xmin, Xmax, Ymin, Ymax
      Integer Nbinx, Nbiny
      Integer * 4      Nwt, Iloc
      Integer integ_flag /1/, i

      Real*8 xbin
      Real*8 xval
      Real*4 low, high
      Real*8 theory
      Real*8 step
      Integer numstep /10/
c
      Integer ibin,num,ichoice
c
      If (init_flag) then
          Call funct( init_flag, Xval,theory)
          Return
      Endif

      Call Hgive(idnew, title, Nbinx, Xmin, Xmax, Nbiny, Ymin, Ymax,
     #           Nwt,Iloc)

      Call INTrd('1.Val at Xcent, 2.Integ. over bin/Norm. by width',
     &  integ_flag)
      If (integ_flag.eq.2) then
        Call INTrd('Num of steps for Integ per bin',numstep)
        If (numstep.le.0) numstep = 1
      else
        numstep=1
      Endif
c
c parameter initialization

      Do Ibin=1,nbinx

        Call HIX(Idnew,Ibin, low)
        Call HIX(Idnew,Ibin+1,high)

        Xbin = high-low
        Xval = low + Xbin/2.0D0
        
        step=Xbin/Dble(numstep)
        Do i=1,numstep
          Xval = Dble(low) + step/2.0D0 + step*Dble(i-1)
          Call funct( init_flag, Xval,theory)
          Call Hf1(idnew, Real(Xval), Real(theory/Dble(numstep)))
        End do
      End do
      Return
      End

      Subroutine HLPACKFUN_exec_minuit(funct, idnew, 
     &    numparam, param,  error)
      Implicit NONE
c input:
      External funct
      Integer idnew
      Integer numparam
      Double Precision param(numparam)

c output:
      Integer error
c local:
c
      Character*120  minfile
      Character*120 title
      Integer idim
      Real Xmin, Xmax, Ymin, Ymax
      Integer Nbinx, Nbiny
      Integer * 4      Nwt, Iloc
      Integer integ_flag /1/, i

      Real*8 xbin
      Real*8 xval, yval, yerr 
      Real*4 low, high
      Real*8 theory, back, sig, step
      Integer numstep /10/
c
      Integer ibin,num,ichoice
c
      Call Hgive(idnew, title, Nbinx, Xmin, Xmax, Nbiny, Ymin, Ymax,
     #           Nwt,Iloc)

      Call INTrd('1.Val at Xcent, 2.Integ. over bin/Norm. by width',
     &  integ_flag)
      If (integ_flag.eq.2) then
        Call INTrd('Num of steps for Integ per bin',numstep)
        If (numstep.le.0) numstep = 1
      else
        numstep=1
      Endif

      Do Ibin=1,nbinx
        Call HIX(Idnew,Ibin, low)
        Call HIX(Idnew,Ibin+1,high)

        Xbin = high-low
        Xval = low + Xbin/2.0D0
        
        step=Xbin/Dble(numstep)
        Do i=1,numstep
          Xval = Dble(low) + step/2.0D0 + step*Dble(i-1)
          Call funct( Xval,Xbin,param,ichoice,theory,back,sig)
          Call Hf1(idnew, Real(Xval), Real(theory/Dble(numstep)))
        End do
      End do
      Return
      End

      Subroutine HLPACKFUN_punch(minfile,title,numparam, param, chname,
     &  error)
      Implicit NONE
c input:
      Character*(*) minfile
      Character*(*) title
      Integer numparam
      Real*8 param(*)
      Character*(*) chname(*)
c output:
      Integer error
c local:
      Logical out_flag
      Integer lunout,i
c
      Call Logrd('Punch out Parameters',out_flag)
      If (.not.out_flag) then
        Return
      Endif

      Call Txtrd('Output file name',minfile)
      Call DIS45_GETLUN (lunout)
#ifndef linux
      Open (Unit=lunout,name=minfile,type='NEW',
     &     CarriageControl='LIST',Err=998)
#else
      Open (Unit=lunout,name=minfile,type='NEW',
     &     Err=998)
#endif
c
      Write(lunout,'(A)') title
      DO i=1,numparam
        Write (lunout,1001) I,Chname(i),param(i)
 1001   Format (1X,I5,1X,A10,1X,G13.5)
      End do
      Write(lunout,*)
      Close(Unit=lunout)
      Call DIS45_freelun (lunout)
      Return
  998 Continue
      error=25
      Return
      End

      Subroutine HLpackfun_create_hist( idnew, error )

      Implicit None
C output:
      Integer idnew
      Integer  error
c const:
C local:
      Integer id /100/
      Character * 80  title  /'function'/
      Real  xmin/10.0/, xmax /1000.0/, width /10.0/
      Real  ratio
      Integer i
      Integer num
      Integer iopt /1/
      Real dx_x /0.1/
      Integer  idbufx, locx

C common
      Include 'pawc.inc'
C function:
      Logical Hexist
      Integer DIS45_malloc
C begin:
C

      Call Intrd('new histogram ID', id)
      If ( Hexist(id) ) Then
        Call DIS45_findID(idnew,id)
        Write(*,*) 'histogram exist, create new ID',id,'->',idnew
      Else 
        idnew = id
      End If

c
c create histogram
      Call FLTRD('X min',xmin)
      xmax = max(xmin*1.1,1.0)
      Call FLTRD('X max',xmax)
      Call INTRD('1.fix width, 2.dx/x=const 3. User',iopt)
      If ((iopt.lt.1).or.(iopt.gt.3)) then
        error=23 ! illegal option
        Return
      Endif


      Call DIS45_insert(idnew,1,error)

      If( error.ne.0 ) Return
      If (iopt.eq.1) then
        Call  FLTRD('Bin width',width)
        If (width.eq.0) then
          width = 1.0
        Endif
        num = (xmax-xmin)/width
        Call Hbook1(idnew,title,num,xmin,xmax,0.0)
      else if (iopt.eq.2) then
        Call FLTRD('Bandwidth (dx/x)',dx_x)
        ratio =(2+dx_x)/(2-dx_x)
        num = (log(xmax)-log(xmin))/log(ratio)
        If( DIS45_malloc( num,idbufx,locx,error ).le.0 ) Return
        Rmem(locx)=xmin
        Do i=1,num
          Rmem(locx+i)=Rmem(locx+i-1)*ratio
        End do
        Call Hbookb(idnew,title,num,Rmem(locx),0.0)
        Call DIS45_free( idbufx )
      else if (iopt.eq.3) then
      Endif

      id = id+10
      Return
      End

