C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Print definition of histogram
C-
C-   Created  14-FEB-1991   T.Takahashi
C-
C-   History: 24-Jun-1992, A.Shirahashi, recovered from HLPDEF.LIS
C-            25-Jun-1992, A.Shirahashi, change arg format, bug fix
C-            19-Aug-1992, A.Shirahahsi, N-tuples
C-             1-Aug-1992, A.Shirahashi, Non equidistant bin
C-
C----------------------------------------------------------------------
      Subroutine HLpdef(error)
C
      Implicit None 
C common
      Include 'tags.inc'
C output:
      Integer error
C local:
      Integer  here, id, dim
      Character*80 title
      Integer  nx, ny
      Real     xmin, xmax, ymin, ymax
      Integer  noent
      Real  vs, bsz_x, bsz_y
      Integer  nvar, I, Ltit
C function
      Integer  DIS45_needhist, DIS45_hgetopt, Lenrd
      Real  Hsum
C begin
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim) 
C
      Call Hnoent(id, noent)
C
      If (dim.eq.1) Then
        Call DIS45_hinfo1(id,title,nx,xmin,xmax)
        bsz_x = (xmax-xmin)/Real(nx)
        vs = Hsum(id)
        Ltit = Lenrd(title)
        Write(6,1000) id, dim, title(:Ltit)
        If( DIS45_hgetopt(id,'NEQB').eq.0 ) Then
          Write(6,1001) nx, xmin, xmax, bsz_x
        Else
          Write(6,1005) nx, xmin, xmax
        End If
        Write(6,1002) noent, vs
      Else If(dim.eq.2) Then
        Call DIS45_hinfo2(id,title,nx,xmin,xmax,ny,ymin,ymax)
        bsz_x = (xmax-xmin)/Real(nx)
        bsz_y = (ymax-ymin)/Real(ny)
        vs = Hsum(id)
        Ltit = Lenrd(title)
        Write(6,1000) id,dim,title(:Ltit)
        Write(6,1001) nx,xmin,xmax,bsz_x,ny,ymin,ymax,bsz_y
        Write(6,1002) noent,vs
      Else If(dim.eq.3) Then
        Call DIS45_hinfon(id,title,nvar,MAXTAG,tags)
        Ltit = Lenrd(title)
        Write(6,1000) id,dim,title(:Ltit)
        Write(6,1003) nvar, noent
        Write(6,1004) (I,tags(I),I=1,Min(nvar,MAXTAG))
      Else
        Write(*,*) 'HLpdef: unknown dim = ', dim
      End If
C
 1000 Format(5x,i5,i2,1x,a)
 1001 Format(5x,'chan:',i4,'  beg:',g13.5,'  End:',g13.5,
     .                     '  bin size:',g13.5)
 1002 Format(5x,'entries:',i9,'  integrated content:',g13.5)
 1003 Format(5X,'number of variables = ',I3, '  number of events = ',I9)
 1004 Format(5X,6(I2,':',A8,2X),/)
 1005 Format(5X,'chan:',I4,'  beg:',G13.5,'  end:',G13.5)
C      
      Return
      End
