C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Plot Histogram
C-
C-
C-   Created   5-MAR-1992   T.Takahashi
C-
C-   History  11-May-1992   A.Shirahashi, add HLts, HLtc
C-                                        add DIS45_set_hplopt
C-                                            DIS45_reset_hplopt
C-                                            DIS45_save_hplopt_to_compare
C-                                            DIS45_set_hplot_to_compare
C-            12-May-1992  A.Shirahashi, remove dirty tricks in HLtc
C-            23-Jun-1992  A.Shirahashi, HPLOT(id,' ',' ',0) in stead of
C-                                       HPLOT(id,'H',' ',0)
C-            26-Jun-1992  A.Shirahashi, add HLgpl, HLtsc
C-            29-Jun-1992  A.Shirahashi, fix a bug in rest_hplopt
C-             6-Jul-1992, A.Shirahashi, remove the declaration for entry.
C-             3-Aug-1992, A.Shirahashi, Call HLaxis_title
C-             6-Aug-1992, A.S, HLgpl: remove PTO option
C-            18-Sep-1992,               DIS45_info -> DIS45_getopt
C-             5-Mar-1993,               add HLplotP
C-            10-Feb-1994,               add HLnt, HLbt
C-             2-Apr-1994, A.S. Call DIS45_synchist in DIS45_set_hplopt
C-             5-Apr-1994, A.S. Call ... in DIS45_set_hplopt_to_compare
C-
C----------------------------------------------------------------------
C
      Subroutine HLplot(error)
C plot histogram
      Implicit None
C output
      Integer error
C local
      Integer  here, id, dim
C function
      Integer  DIS45_needhist
C
C begin
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_thishist(here, id, dim)
      Call DIS45_set_hplopt(id)
      Call Hplot(id,' ',' ',0)
      Call HLaxis_title
      Call IUWK(0,0)                 ! Update Workstation
      Call DIS45_save_hplopt_to_compare(id)
      Call DIS45_reset_hplopt(id,0)
      Return
      End
C
C
      Subroutine HLplotP(error)
C plot histogram with option
      Implicit None
C output
      Integer error
C local
      Integer  here, id, dim
      Character * 4  copt
C function
      Integer  DIS45_needhist
C
C begin
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_thishist(here, id, dim)
C
      Call Txtrd('?option',copt)
C
      Call DIS45_set_hplopt(id)
      Call Hplot(id,copt,' ',0)
      Call HLaxis_title
      Call IUWK(0,0)                 ! Update Workstation
      Call DIS45_save_hplopt_to_compare(id)
      Call DIS45_reset_hplopt(id,0)
      Return
      End
C
C
      Subroutine HLts(error)
C plot superimposed histogram
      Implicit None
C output
      Integer  error
C local
      Integer  here, id, dim
C function
      Integer  DIS45_needhist
C begin
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_thishist(here, id, dim)
      Call DIS45_set_hplopt(id)
      Call Hplot(id,'S',' ',0)
      Call IUWK(0,0)                 ! Update Workstation
      Call DIS45_reset_hplopt(id,0)
      Return
      End
C
C
      Subroutine HLtc(error)
C plot superimposed histogram for comparison
      Implicit None
C output
      Integer  error
C begin
C local
      Integer  here, id, dim
C function
      Integer  DIS45_needhist
C begin
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_thishist(here, id, dim)
      Call DIS45_set_hplopt_to_compare(id,0)
      Call Hplot(id,'S',' ',0)
      Call IUWK(0,0)                 ! Update Workstation
      Call DIS45_reset_hplopt(id,0)
      Return
      End
C
C
      Subroutine HLtsc(error)
C plot superimposed histogram for comparison with scaling
      Implicit None
C output
      Integer  error
C begin
C local
      Integer  here, id, dim
C function
      Integer  DIS45_needhist
C begin
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_thishist(here, id, dim)
      Call DIS45_set_hplopt_to_compare(id,1)
      Call Hplot(id,'S',' ',0)
      Call IUWK(0,0)                 ! Update Workstation
      Call DIS45_reset_hplopt(id,1)
      Return
      End
C
C      
      Subroutine DIS45_set_hplopt(id)
C set options before plot
      Implicit None
C input
      Integer  id
C local
      Character * 80 title
      Integer  dim
      Logical  logx, logy
C begin
      Call DIS45_hinfo0(id,title,dim)
C
      If (dim.eq.1) Then
        Call DIS45_getopt(id,'LOGX',logx)
        Call DIS45_getopt(id,'LOGY',logy)
        If (logx) then
          Call HPLopt('LOGX',1)
        Endif
        If (logy) then
          Call HPLopt('LOGY',1)
        Endif
      Else If (dim.eq.2) Then
C       do nothing for 2 dim
      Endif 
C
C     ... sync in case of memory operation
      Call DIS45_synchist(id)
      Return
      End
C
C
      Subroutine DIS45_reset_hplopt(id,scale)
C reset option after plot
      Implicit None
C input
      Integer id, scale
C local
      Real  sum
C function
      Real  Hsum
C begin
      Call HPLopt('LINX',1)
      Call HPLopt('LINY',1)
      If( scale.ne.0 ) Then
        sum = Hsum(id)
        Call Hnorma(id,sum)
      End If
      Return
      End
C
C
      Subroutine DIS45_save_hplopt_to_compare(id)
C get/set hplot parameters for comparison
C     ... I cannot use 'Implicit None' due to the subtle difference
C         between VAX fortran and SUN fortran.
C     Implicit None
C input
      Integer  id
C (DIS45_set_hplopt_to_compare)
      Integer  scale
C static data
      Integer  tcid
      Logical  tclogx, tclogy
      Real  tcymin, tcymax, tcfact
      Save  tcid, tclogx, tclogy, tcymin, tcymax, tcfact
C local
      Character * 80  title
      Integer  dim  
      Real ymin, ymax
C (DIS45_set_hplopt_to_compare)
      Integer  entref, entcmp
      Real  factor
C entry
C     ... this declaration is necessary for VAX Fortran, but illegal
C         for SUN fortran
C     Integer  DIS45_set_hplopt_to_compare ! just for Implicit None
C function
      Real  Hsum
C begin                                  
      tcid = id               
      Call DIS45_hinfo0(tcid,title,dim)
      If( dim.eq.1 ) Then
        Call DIS45_getopt(tcid,'LOGX',tclogx)
        Call DIS45_getopt(tcid,'LOGY',tclogy)
      Else If( dim.eq.2 ) Then
        tclogx = .FALSE.
        tclogy = .FALSE.
      EndIf
C
C     We no longer need the following dirty code
C     because 'HPLOT(,'S',,)' takes care of the min/max limits.
C
C     Call DIS45_hplinfo('YMINI',tcymin)
C     Call DIS45_hplinfo('YMAXI',tcymax)
C     If( tclogy ) Then
C       tcymin = 10.0 ** tcymin
C       tcymax = 10.0 ** tcymax
C     End If
C     Call DIS45_hplinfo('FACTOR',tcfact)
C
C     Print *, 'YMINI=',tcymin
C     Print *, 'YMAXI=',tcymax
C     Print *, 'FACTOR=',tcfact
C
      Return
C
      Entry DIS45_set_hplopt_to_compare(id,scale)
C
      If( tclogx ) Then
        Call HPLopt('LOGX',1)
      Else
        Call HPLopt('LINX',1)
      EndIf
C
      If( tclogy ) Then
        Call HPLopt('LOGY',1)
      Else
        Call HPLopt('LINY',1)
      EndIf
C
C     ... sync in case of memory operation
      Call DIS45_synchist(id)
C
C     ... ajust scale for comparison
      If( scale.ne.0 ) Then
        Call Hnoent( tcid,entref )
        Call Hnoent( id,entcmp )
        factor = Float(entref) / Float(entcmp)
        Call Hnorma( id,factor*Hsum(id) )
      End If
C
C     We no longer need the following dirty code
C     because 'HPLOT(,'S',,)' takes care of the min/max limits.
C
C     ymin = tcymin/tcfact
C     ymax = tcymax/tcfact
C     Call Hminim(id, ymin)
C     Call Hmaxim(id, ymax)
C
      Return
      End
C
C
      Subroutine HLgpl(error)
C ... plot all histograms
      Implicit None 
C output
      Integer error
C function
      Integer DIS45_numhist
C begin
      If( DIS45_numhist(error).le.0 ) Return
C
C*    Call Hplopt('PTO ',1)
      Call Hplot(0,' ',' ',0)      
C*    Call Hplopt('NPTO',1)
      Return
      End
C
C
      Subroutine HLnt(error)
C
      Implicit None
C output
      Integer error
C begin
      Call HLnext(error)
      If(error.eq.0) Call HLplot(error)
      Return
      End
C
C
      Subroutine HLbt(error)
C
      Implicit None
C output
      Integer error
C begin
      Call HLback(error)
      If(error.eq.0) Call HLplot(error)
      Return
      End
C
