C
C File: hlprox.for
C Description: Projection onto X/Y axes
C Entry: HLprox, HLproy
C Author: T.Takahashi
C 24-Apr-1992  use DIS45_{malloc,hrebin2} by A.Shirahashi
C 27-Apr-1992  merge hlprox.for,hlproy.for into hlprox.for
C 12-May-1992  fix wrong argument pass to mekehist in HLproy
C              fix entry problem
C
        Subroutine HLprox(error)
C
	Implicit None
C common
        Include 'pawc.inc'
C output
	Integer error
C local
	Character * 80  title
	Integer  id, dim, idnew, here
        Integer  idbuf, loc
	Integer  nx, ny
	Real  xmi, xma, ymi, yma
C function
        Integer  DIS45_needhist, DIS45_malloc, DIS45_makehist
C begin
      If (DIS45_needhist(2,error).le.0) Return
      Call DIS45_thishist(here, id, dim)
C
      Call DIS45_hinfo2(id,title,nx,xmi,xma,ny,ymi,yma)
C
      If( DIS45_makehist(id,1,idnew,error).le.0 ) Return
      If( DIS45_malloc(nx,idbuf,loc,error).le.0 ) Return
      Call Hbook1(idnew,'PROX '//title,nx,xmi,xma,0.0)
      Call DIS45_locate(idbuf,loc)
      Call DIS45_hrebin2(id,nx,1,nx,1,1,ny,Hmem(loc),error)
      Call Hpak(idnew,Hmem(loc))
      Call DIS45_free(idbuf)
      Call DIS45_fixentry(idnew)
C	
      Return
      End
C
C
C File: hlproy.for
C Author: A.Shirahashi
C
C 16-apr-1992, A.Shirahashi, Use DIS45_needhist, DIS45_hinfo2
C 23-Apr-1992, A.Shirahashi, Use DIS45_{malloc,hrebin2}
C
        Subroutine HLproy(error)
C
	Implicit None
C output
	Integer error
C common
	INCLUDE 'pawc.inc'
C local
	Character * 80  title
	Integer  id, dim, idnew, here
        Integer  idbuf, loc
	Integer  nx, ny
	Real  xmi, xma, ymi, yma
C function
        Integer  DIS45_needhist, DIS45_malloc, DIS45_makehist
C begin
C     require 2 dim histogram
      If (DIS45_needhist(2,error).le.0) Return
      Call DIS45_thishist(here, id, dim)
C
      Call DIS45_hinfo2(id,title,nx,xmi,xma,ny,ymi,yma)
 
      If (DIS45_makehist(id,1,idnew,error).le.0) Return
      If (DIS45_malloc(ny,idbuf,loc,error).le.0) Return
      Call Hbook1(idnew,'PROY '//title,ny,ymi,yma,0.0)
      Call DIS45_locate(idbuf,loc)
      Call DIS45_hrebin2(id,1,1,nx,ny,1,ny,Hmem(loc),error)
      Call Hpak(idnew,Hmem(loc))
      Call DIS45_free(idbuf)
      Call DIS45_fixentry(idnew)
C	
      Return
      End
