c+
c File : HLrepeat.f
c Description : Repeat given command line until CTRL-C is pressed
c
c Author : Ryosuke Itoh, Physics Division, KEK
c Date : 31 - Mar - 1994
C
C History: 31-Mar-94 - 1-Apr-1994, A.Shirahashi
c-
c
      Subroutine HLrepeat ( Error )
c
      Implicit      NONE
c
c Arg
c
      Integer * 4      Error
c
c Var
      Integer * 4  times, interval, Lcom, Lbuf, I
      Character * 256  command, buffer
c Func
      Integer * 4  Lenrd
      Logical  DIS45_sigC
C Main
      Call CLIopt('AT',0)
      Call Intrd( 'How many times (0:infinite)', times )
      Call Intrd( 'Interval(sec) ', Interval )
      Call Titrd( 'command(s)', command )
      Call CLIopt('AT',1)
      Lcom = Lenrd(command)
      If( Lcom.le.0 ) Return
C
      If( command(1:1).eq.'@' ) Then
        Call CLopen( command(2:Lcom),1,'R',error,'.com')
        If( error.ne.0 ) Then
          error = 0
          Return
        End If
        Call DIS45_Open_Scratch( 2,'display45-repeat-tmp.rc',error )
 100    Continue
          Read(1,'(A)',End=200) buffer
          Lbuf = Lenrd(buffer)
          Write(2,'(A)') buffer(:Lbuf)
        Goto 100
 200    Continue
        Close(1)
        Write(2,'(A)') 'EXIT'
      Else
        Call DIS45_Open_Scratch( 2,'display45-repeat-tmp.rc',error )
        Write(2,'(A)') command(:Lcom)
        Write(2,'(A)') 'EXIT'
      End If
C
      Call Lunrd(2)
C
C     ... setup Ctrl-C handler
      Call DIS45_sigI( 2 )
C
      If( times.eq.0 ) Then
 300    Continue
          Rewind(2)
          Call HLrepeat_execute(error)
          If( error.ne.0 ) Goto 500
          If( DIS45_sigC(2) ) Goto 400
          Call DIS45_Sleep( interval )
        Goto 300
      Else
        Do I = 1, times
          Rewind(2)
          Call HLrepeat_execute(error)
          If( error.ne.0 ) Goto 500
          If( DIS45_sigC(2) ) Goto 400
          Call DIS45_Sleep( interval )
        End Do
        Goto 500
      End If
C
 400  Continue
      Write(*,'(1X,A)') '%DIS-I, Interrupted by Ctrl-C'
C     ... finish command file
      Call CLIeof
C     ... restore original signal handler
      Call DIS45_sigX(2)
      Return
C
 500  Continue
C     ... clean up temporary file
      Close(2)
C     ... restore original signal handler
      Call DIS45_sigX( 2 )
      Return
      End
C
C
      Subroutine HLrepeat_execute(error)
C
      Implicit None
C output
      Integer error
C local
      Character * 6  cmd
      Integer  length, igo
C function
      Integer  Lenrd
C begin
C
 100  Continue
      Call Display45_GetComand(-3,'?DIS>',cmd,igo)
C
      length = Lenrd(cmd)
      If( cmd(:length).eq.'EXIT' ) Then
        Return
      End If
C
      Call Display45_DoComand(cmd,error)
      If( error.ne.0 ) Then
        Call CLerok()
        Call CLstop()
        Return
      End If
      Goto 100
C
      End


