C
C File: HLset.for 
C Description: set HPLOT various parameters
C Author: T.takahashi
C
C History: 15-Jun-1992, A.Shirahashi, add "SHOW"
C          19-Jun-1992, A.Shirahashi, add "BARO","BARW"
C           6-Jul-1992, Parameter -> Parameter ( )
C           3-Aug-1992, A.Shirahashi, add "*SIZ", "*FON"
C          19-Aug-1992, A.Shirahashi, add "MTYP", "MSCF"
C          26-Aug-1992, R.Itoh,       add "VFON", "VSIZ", "CSIZ", "KSIZ"
C          28-Aug-1992, R.Itoh,       add "STAT", "FIT "
C           4-Jan-1992, A.Shirahashi, add DATE,FILE,GRID,XCOL,YCOL,NCOL
C                                         HCOL,BCOL,PCOL,FCOL
C          20-Jan-1992, add CHHE,TANG,TXAL,TXFP
C          21-Jan-1992, add CFON,PASS,CSHI
C          12-Feb-1993, HLasksetP, add XSIZ, YSIZ
C           3-Jun-1993, add XMGL,XMGR,YMGL,YMGR,XLAB,YLAB,XVAL,YVAL (Itoh)
C           4-Jun-1993, Use HLasksetP for Itoh's modification
C          31-Aug-1993, add PLCI,PMCI,FACI,TXCI
C          29-Dec-1993, RGB, HLS
C          12-Mar-1994, SMGR,SMGU,YGTI,HWID,BWID,PWID,FWID,XWID,YWID
C                       by Ishisaki (phys.s.u-tokyo.ac.jp)
C          23-Jan-1995, Y.Ishisaki rewrite HLset() to use table
C
      Subroutine HLset (error)
c
      Implicit NONE
c constant
      Integer  Ncomm
      Parameter( NCOMM = 103 )
      Character * 10  Prompt
      Parameter( Prompt = '?DIS:SET> ' )
c output
      Integer error
c local
      Integer ikey
      Real rval(2)
      Integer val_txfp, val_txal
      Character * 4 keytbl(NCOMM)
c data
      Character * 4 key /' '/
      Save key
      Character * 64  Comm(NCOMM) /
c HPLSET
     &  'XSIZ R length of X axis',
     &  'YSIZ R length of Y axis',
     &  'XMGL R X MarGin Left',
     &  'XMGR R X MarGin Right',
     &  'XLAB R distance y axis to LABel',
     &  'XVAL R distance y axis to axis VALues',
     &  'XTIC R X axis TICk marks length',
     &  'YMGL R Y MarGin Low',
     &  'YMGU R Y MarGin Up',
     &  'YLAB R distance x axis to LABel',
     &  'YVAL R distance x axis to axis VALues',
     &  'YTIC R Y axis TICk marks length',
     &  'YNPG R Y position for Number of PaGe',
     &  'YGTI R Y position of Global TItle',
     &  'YHTI R Y position of Histogram TItle',
     &  'SMGR R Stat MarGin Right (%)',
     &  'SMGU R Stat MarGin Up (%)',
     &  'KSIZ R Hershey charact. (HPLKEY) SIZe',
     &  'GSIZ R Global title SIZe',
     &  'TSIZ R histogram Title SIZe',
     &  'ASIZ R Axis label SIZe',
     &  'CSIZ R Comment and stat SIZe',
     &  'PSIZ R Page number SIZe',
     &  'VSIZ R axis Values SIZe',
     &  'SSIZ R aSterisk SIZe (for functions)',
     &  '2SIZ R scatter-plot & tablechar. SIZe',
     &  'XWIN R X space between WINdows',
     &  'YWIN R Y space between WINdows',
     &  'HMAX R Histogram MAXimum for scale',
     &  'PASS R number of PASS for characters',
     &  'CSHI R Character SHIft between 2 pass',
     &  'BARO R BAR histogram Offset (%)',
     &  'BARW R BARhistogram Width (%)',
     &  'DASH R length of basic DASHed segment',
     &  'DMOD I Dash MODe (or type) for lines',
     &  'GRID I GRID line type',
     &  'DATE I DATE position',
     &  'FILE I FILE name position',
     &  'STAT I STAT values to be plotted',
     &  'FIT  I FIT values to be plotted',
     &  'HTYP I Histogram  fill area TYPe',
     &  'BTYP I Box fill area TYPe',
     &  'PTYP I Picture fill area TYPe',
     &  'FTYP I Function fill area TYPe',
     &  'HCOL I Histogram fill area COLor',
     &  'BCOL I Box fill area and shading COLor',
     &  'PCOL I Picture fill area COLor',
     &  'FCOL I Function fill area COLor',
     &  'XCOL I X axis COLor',
     &  'YCOL I Y axis COLor',
     &  'HWID I Histogram line WIDth',
     &  'BWID I Box line WIDth',
     &  'PWID I Picture line WIDth',
     &  'FWID I Function line WIDth',
     &  'XWID I X ticks WIDth',
     &  'YWID I Y ticks WIDth',
     &  'TFON I Text (and Title) FONT and PREC',
     &  'GFON I Global title FONT and PREC',
     &  'VFON I axis Values FONT and PREC',
     &  'LFON I axis Labels FONT and PREC',
     &  'CFON I Comment FONT and PREC',
     &  'NDVX I Number of DIVisions for X axis',
     &  'NDVY I Number of DIVisions for Y axis',
     &  'NDVZ I Number of DIVisions for Z axis',
     &  'FPGN I First PaGe Number',
     &  'ERRX R ERRor on X (% of bin width)',
     &  '1DEF I 1D Plot Option',
     &  '2DEF I 2D Plot Option',
c IGSET
     &  'FAIS I Fill area interior style',
     &  'FASI I Fill area style index',
     &  'LTYP I Line type',
     &  'BASL R Basic segment length (NDC)',
     &  'LWID R Line width',
     &  'MTYP I Marker type',
     &  'MSCF R Marker scale factor',
     &  'PLCI I Polyline color index',
     &  'PMCI I Polymarker color index',
     &  'FACI I Fill area color index',
     &  'TXCI I Text color index',
     &  'TXAL I Text alignment',
     &  'CHHE R Character height',
     &  'TANG R Text angle',
     &  'TXFP I Text font and precision',
     &  'PICT I Current automatic number',
     &  'BORD I Border flag',
     &  'PASS I Number of pass in IGTEXT',
     &  'CSHI R IGTEXT shift',
     &  'LASI R Label axis size',
     &  'LAOF R Label axis offset',
     &  'TMSI R Tick marks size',
     &  'AWLN R Axis wire lenght',
     &  'BARO R Offset of IGHIST (IGRAPH) bars',
     &  'BARW R Width of IGHIST (IGRAPH) bars',
     &  'NCOL I Number of COLors',
     &  'CLIP I Clipping mode',
     &  'NLIN I Number of line for 3D shapes',
     &  'AURZ I Automatic saving flag',
     &  'DIME I Dimension used (2D or 3D)',
c others
     &  'RGB ',
     &  'HLS ',
     &  '*   ',
     &  'SHOW',
     &  'EXIT'
     & /
c
c Main Body
c
      Do ikey = 1, NCOMM
         keytbl(ikey) = Comm(ikey)(:4)
      End do
      Call Keyrd(-1, Prompt, key, keytbl, NCOMM, ikey)
      error = 0
c
      If ( 'EXIT'.eq.key ) then
         Continue
      Else if ( 'SHOW'.eq.key ) then
         Call HPLset('SHOW',0.0)
      Else if ( '*   '.eq.key ) then
         Call HPLset('*',0.0)
      Else if ( 'RGB '.eq.key ) then
         Call HLsetRGB
      Else if ( 'HLS '.eq.key ) then  
         Call HLsetHLS
      Else if ( 'TXFP'.eq.key ) then
         Call IGq('TXFP',rval)
         val_txfp = Int(rval(1))*10 + Int(rval(2))
         Call Intrd('10*font+precision',val_txfp)
         Call IGset('TXFP',Real(val_txfp))
      Else if ( 'TXAL'.eq.key ) then
         Call IGq('TXAL',rval)
         val_txal = Int(rval(1))*10 + Int(rval(2))
         Call Intrd(
     &        '10*hori+vert' //
     &        ' (0:left/bottom, 2:center/top, 3:right/center)',
     &        val_txal)
         Call IGset('TXAL',Real(val_txal))
      Else
         Call HLasksetP(Comm(ikey)(8:), key, Comm(ikey)(6:6))
      End if
      Return
c
      End
C
C
      Subroutine HLasksetP(prompt,option,type)
C
      Implicit None
C input
      Character * (*)  prompt, option
      Character * 1  type
C local
      Real  value
      Integer  ivalue, length, Lenrd
      Character * 80 string
C begin
      string = '?'
      length = Lenrd(option)
      string = string(:1)//option(:length)
      Call HPLset(string,value)
      If( type.eq.'I' ) Then
        ivalue = value
        Call Intrd(prompt,ivalue)
        value = ivalue
      Else
        Call Fltrd(prompt,value)
      End If
      Call HPLset(option,value)
C
      Return
      End
C
C
      Subroutine HLasksetG(prompt,option,type)
C
      Implicit None
C input
      Character * (*)  prompt, option
      Character * 1  type
C local
      Real  value
      Integer  ivalue
C begin
      Call IGq(option,value)
      If( type.eq.'I' ) Then
        ivalue = value
        Call Intrd(prompt,ivalue)
        value = ivalue
      Else
        Call Fltrd(prompt,value)
      End If
      Call IGset(option,value)
C
      Return
      End
C
C
      Subroutine HLsetRGB
C
      Implicit None
C const
      Integer  WKID
      Parameter( WKID = 1 )
C local
      Integer  ci
      Real  r, g, b
      Real  rval(4)
C begin
      Call Intrd('color index',ci)
      rval(1) = Real(ci)
      Call IGQ('RGB ',rval)
      r = rval(2)
      g = rval(3)
      b = rval(4)
      Call Fltrd('red (0-1)',r)     
      Call FLtrd('green (0-1)',g)
      Call Fltrd('blue (0-1)',b)
      Call ISCR(WKID,ci,r,g,b)
      Return
      End
C
C
      Subroutine HLsetHLS
C
      Implicit None
C const
      Integer  WKID
      Parameter( WKID = 1 )
C local
      Integer  ci
      Real  h, l, s
      Real  r, g, b
      Real  rval(4)
C begin
      Call Intrd('color index',ci)
      rval(1) = Real(ci)
      Call IGQ('RGB ',rval)
      r = rval(2)
      g = rval(3)
      b = rval(4)
      Call IGRTOH(r,g,b,h,l,s)
      Call Fltrd('hue (0-360)',h)     
      Call FLtrd('light (0-1)',l)
      Call Fltrd('saturation (0-1)',s)
      Call IGHTOR(h,l,s,r,g,b)
      Call ISCR(WKID,ci,r,g,b)
      Return
      End
