C
C File: HLslix.for
C Description: Slice in X/Y direction
C Author: A.Shirahashi
C Date: 24-Apr-1992
C History: 27-Apr-1992 merge hlslix.for,hlsliy.for into hlslix.for
C           8-May-1992 fix entry problem, apply HCOMPA after slice
C          22-Jun-1992 Intrd -> IntrdL
C
        Subroutine HLslix(error)
C
	Implicit None
C common
        Include 'pawc.inc'
C output
	Integer error
C local
	Character  title*80, slinum*2
	Integer  id, dim, idnew, here
        Integer  idbuf, loc
	Integer  nx, ny, nsli, nsx
	Real  xmi, xma, ymi, yma
        Integer  ilow, ihigh, is
        Real  xlow, xhigh
C function
        Integer  DIS45_needhist, DIS45_malloc, DIS45_makehist
C begin
        If (DIS45_needhist(2,error).le.0) Return
	Call DIS45_thishist(here, id, dim)
C
        Call DIS45_hinfo2(id,title,nx,xmi,xma,ny,ymi,yma)
        Call IntrdL('how many slices',nsli,1,nx)
        nsx = nx/nsli
C       allocate buffers for data and id vectors
        If( DIS45_malloc(ny+nsli,idbuf,loc,error).le.0 ) Return
C
        Do is = 0, nsli-1
          If( DIS45_makehist(id,1,idnew,error).le.0 ) Goto 100
          Write(slinum,'(I2.2)') is+1
	  Call Hbook1(idnew,'SLIX '//slinum//' '//title,
     &                      ny,ymi,yma,0.0 )
          ilow = is * nsx + 1
          ihigh = ilow + nsx - 1
          Call DIS45_locate(idbuf,loc)
          Hmem(loc+ny+is) = idnew
          Call DIS45_hrebin2(id,1,ilow,ihigh,ny,1,ny,Hmem(loc),error)
	  Call Hpak(idnew,Hmem(loc))
	  Call DIS45_fixentry(idnew)
        End Do
C
        Call DIS45_locate(idbuf,loc)
        Call Hcompa(Hmem(loc+ny),nsli)
C
 100    Continue
        Call DIS45_free(idbuf)
C	
        Return
        End
C
C
C File: HLsliy.for
C Description: Slice in Y direction
C Author: A.Shirahashi
C Date: 24-Apr-1992
C
        Subroutine HLsliy(error)
C
	Implicit None
C common
        Include 'pawc.inc'
C output
	Integer error
C local
	Character  title*80, slinum*2
	Integer  id, dim, idnew, here
        Integer  idbuf, loc
	Integer  nx, ny, nsli, nsy
	Real  xmi, xma, ymi, yma
        Integer  ilow, ihigh, is
        Real  ylow, yhigh
C function
        Integer  DIS45_needhist, DIS45_malloc, DIS45_makehist
C begin
        If (DIS45_needhist(2,error).le.0) Return
	Call DIS45_thishist(here, id, dim)
C
        Call DIS45_hinfo2(id,title,nx,xmi,xma,ny,ymi,yma)
        Call IntrdL('how many slices',nsli,1,ny)
        nsy = ny/nsli
C       allocate buffers for data and id vectors
        If( DIS45_malloc(nx+nsli,idbuf,loc,error).le.0 ) Return
C
        Do is = 0, nsli-1
          If( DIS45_makehist(id,1,idnew,error).le.0 ) Goto 100
          Write(slinum,'(I2.2)') is+1
	  Call Hbook1(idnew,'SLIY '//slinum//' '//title,
     &                      nx,xmi,xma,0.0 )
          ilow = is * nsy + 1
          ihigh = ilow + nsy - 1
          Call DIS45_locate(idbuf,loc)          
          Hmem(loc+nx+is) = idnew
          Call DIS45_hrebin2(id,nx,1,nx,1,ilow,ihigh,Hmem(loc),error)
	  Call Hpak(idnew,Hmem(loc))
	  Call DIS45_fixentry(idnew)
        End Do
C
        Call DIS45_locate(idbuf,loc)
        Call Hcompa(Hmem(loc+nx),nsli)
C
 100    Continue
        Call DIS45_free(idbuf)
C	
        Return
        End
C
