C
C File: HLsmooth.for
C Description: Smooth histogram
C Author: A.Shirahashi
C Date: 4-Jun-1992
C
C Public HLsmooth, HLspline
C
C History: 26-Jun-1992, A.Shirahashi, modify options
C          29-Jun-1992, fix several bugs, Intrd -> IntrdL
C           1-Jun-1992, A.Shirahashi, spline knots-x degree-x knots-y degree-y
C
      Subroutine HLsmooth(error)
C 
      Implicit None 
C output
      Integer error
C local
      Integer  here, id, dim
      Real chi2
      Integer case
      Save case
      Data case / 0 /
C function
      Integer DIS45_needhist
C begin
      If( DIS45_needhist(1,error).le.0 ) Return
      Call DIS45_thishist(here, id, dim)
C
      Call IntrdL(
     &  '0:replace original histogram, 1:superimpose as a function',
     &  case,0,1 )
C
      Call Hsmoof(id,case+1,chi2)
      Return
      End
C
C
      Subroutine HLspline(error)
C 
      Implicit None 
C output
      Integer error
C local
      Integer  here, id, dim
      Real chi2
      Integer case, nk, ds, nkx, nky, dsx, dsy
      Save case, nk, ds, nkx, nky, dsx, dsy
      Data case / 0 /
      Data nk, nkx, nky / 13,13,13 /
      Data ds, dsx, dsy / 3,3,3 /
C function
      Integer DIS45_needhist
C begin
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_thishist(here, id, dim)
C
      If( dim.eq.1 ) Then
        Call IntrdL(
     &    '0:replace original histogram, 1:superimpose as a function',
     &    case,0,1 )
        Call Intrd('number of knots',nk)
        Call Intrd('degree of spline',ds)
        Call Hspli1(id,case+1,nk,ds,chi2)
      Else If( dim.eq.2 ) Then
        Call Intrd('number of knots (x)',nkx)
        Call Intrd('degree of spline (x)',dsx)
        Call Intrd('number of knots (y)',nky)
        Call Intrd('degree of spline (y)',dsy)
        Call Hspli2(id,nkx,nky,dsx,dsy)
      Else
        Print *, 'can''t happen in HLspline'
        Return        
      End If
C
      Return
      End
