C
C File: HLsort.for
C Description: Sort histograms by id, title,...
C Author: A.Shirahashi
C Date: 12-Jun-1992
C
C History: 15-Jun-1992, sort by title
C          26-Jun-1992, DIS45_numhist
C          30-Jun-1992, Intrd -> IntrdL
C          17-Sep-1992, for Iaux in /HvHist/ (display.inc)
C                                  
      Subroutine HLsort(error)
C 
      Implicit None 
C output
      Integer  error
C local
      Integer  here, id, dim, n
      Integer sortby / 1 /
      Save sortby
C function
      Integer  DIS45_numhist
      External  HLsort_id, HLsort_title, HLsort_exchange
C begin
      n = DIS45_numhist(error)
      If( n.le.0 ) Return
      Call DIS45_thishist(here, id, dim)
C
      Call IntrdL( '1:by id, 2:by title:',sortby,0,2 )
C
      If( sortby.eq.0 .or. sortby.eq.1 ) Then
        Call HLsort_shell( n,HLsort_id,HLsort_exchange )
      Else If( sortby.eq.2 ) Then
        Call HLsort_shell( n,HLsort_title,HLsort_exchange )
      Else
        Write(*,*) 'Can''t happen in HLsort.'
      End If
C
      Call DIS45_sethist(id,error)
      If( id.eq.0 ) error = 0
      Return
      End
C
C
      Integer Function  HLsort_id(i,j)
C
      Implicit None 
C common
      Include 'display.inc'
C input
      Integer  i, j
C begin
      If( i.lt.1 .or. i.gt.Nh ) Then
        Write(*,*) 'Can''t happen in HLsort_id, i = ', i
      End If
      If( j.lt.1 .or. j.gt.Nh ) Then
        Write(*,*) 'Can''t happen in HLsort_id, j = ', j
      End If
      HLsort_id = Iv(i) - Iv(j)
      Return
      End
C
C
      Integer Function  HLsort_title(i,j)
C
      Implicit None 
C common
      Include 'display.inc'
C input
      Integer  i, j
C local
      Integer  dimi, dimj, leni, lenj, length
      Character * 80  titlei, titlej
C function
      Integer  Lenrd
C begin
      If( i.lt.1 .or. i.gt.Nh ) Then
        Write(*,*) 'Can''t happen in HLsort_title, i = ', i
      End If
      If( j.lt.1 .or. j.gt.Nh ) Then
        Write(*,*) 'Can''t happen in HLsort_title, j = ', j
      End If
C
      Call DIS45_hinfo0( Iv(i),titlei,dimi )
      Call DIS45_hinfo0( Iv(j),titlej,dimj )
      If( dimi.eq.0 .or. dimj.eq.0 ) Then
        Write(*,*) 'Can''t happen in HLsort_title'
      End If
C
      leni = Lenrd(titlei)
      lenj = Lenrd(titlej)
      length = Min( leni,lenj )
C
      If( titlei(:length).lt.titlej(:length) ) Then
        HLsort_title = -1
      Else If( titlei(:length).gt.titlej(:length) ) Then
        HLsort_title = +1
      Else If( leni.ne.lenj ) Then
        HLsort_title = leni - lenj
      Else
        HLsort_title = Iv(i) - Iv(j)
      End If
C
      Return
      End
C
C
      Subroutine  HLsort_exchange(i,j)
C
      Implicit None 
C common
      Include 'display.inc'
C input
      Integer  i, j
C local
      Integer  t
C begin
      t = Iv(i)
      Iv(i) = Iv(j)
      Iv(j) = t
      t = Idim(i)
      Idim(i) = Idim(j)
      Idim(j) = t
      t = Iopt(i)
      Iopt(i) = Iopt(j)
      Iopt(j) = t
      t = Iaux(i)
      Iaux(i) = Iaux(j)
      Iaux(j) = t
C
      Return
      End
C
C
      Subroutine HLsort_shell( n,compare,exchange )
C
C input
      Integer * 4  n
      Integer  Compare
      External  Compare, Exchange
C local
      Integer * 4  I, J, GAP
C begin
      GAP = N / 2
10    Continue
        If( GAP .le. 0 ) Goto 110
        I = GAP
20      Continue
          If( I .ge. N ) Goto 120
          J = I - GAP
30        Continue
            If( J .lt. 0 ) Goto 130
C           ... compare
            If( Compare(j+1,j+gap+1).le.0 ) Goto 130
C           ... exchange
            Call Exchange(j+1,j+gap+1)
            J = J - GAP
          Goto 30
130       Continue
          I = I + 1
        Goto 20
120     Continue
        GAP = GAP / 2
      Goto 10
110   Continue
C
      Return
      End
