C
C File: HLsplot.for
C Description: N-tuples operations
C Author: A.Shirahashi
C Date: 19-Aug-1992
C
C History: 20-Aug-1992, HLtuple -> HLsplot
C          24-Dec-1992, move HLsplot2 into hlsplot2.f
C           7-Sep-1993, HL_draw_frame: CALL HBINSZ('NO  ')
C
C           6-Nov-1993, Call DIS45_dynclose
C
C Public: HLsplot, HLproj1, HLproj2
C
      Subroutine HLsplot(error)
C
      Implicit None 
C output
      Integer  error
C local
      Character * 8  varx, vary
      Integer  ivarx, ivary
      Integer  ifirst, ilast, isel
      Integer  here, id, dim
      Character * 80  title
      Real  xmin, xmax, ymin, ymax
      Integer  link
C function
      Integer  DIS45_needhist
      External Dy_uwfunc
C begin
C     ... need N-tuple or 2-dim
      If( DIS45_needhist(5,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      If( dim.eq.2 ) Then
         Call HLsplot2(id,error)
         Return
      End If
C
      Call DIS45_hinfo0(id,title,dim)
C
      Call HLtuple_asktag(id,'x variable',1,varx,ivarx)
      Call HLtuple_asktag(id,'y variable',2,vary,ivary)
C
      Call HLtuple_askevt(id,ifirst,ilast,error)
      If( error.ne.0 ) Return
C
      Call HLtuple_asksel(isel,link,error)
      If( error.ne.0 ) Return
C
      Call DIS45_tuple_minmax(id,ivarx,xmin,xmax)
      Call DIS45_tuple_minmax(id,ivary,ymin,ymax)
      Call HL_draw_frame(title,xmin,xmax,ymin,ymax)
      Call Hplax(varx,vary)
C
      Call Hplnt(id,isel,Dy_uwfunc,ifirst,ilast,ivarx,ivary)
      Call IUWK(0,0) ! update workstation
C
      Call DIS45_dynclose(link)
C
      Return
      End
C
C
      Subroutine HL_draw_frame(title,xmin,xmax,ymin,ymax)
C
      Implicit None
C input
      Character * (*)  title
      Real  xmin, xmax, ymin, ymax
C local
      Integer  here, id, dim, idnew, error
      Real  dx, dy
C function
      Integer  Dis45_makehist
C begin
      Call Dis45_thishist(here, id, dim)
      If( DIS45_makehist(id,2,idnew,error).le.0 ) Return
      dx = (xmax-xmin)*0.05
      xmin = xmin - dx
      xmax = xmax + dx
      dy = (ymax-ymin)*0.05
      ymin = ymin - dy
      ymax = ymax + dy
      Call Hbinsz('YES ')
      Call Hbook2(idnew,title,10,xmin,xmax,10,ymin,ymax,0.0)
      Call Hbinsz('NO  ')
C
      Call Hplot(idnew,' ',' ',1)
      Call DIS45_hdelete(idnew)
C
      Return
      End
C
C
      Subroutine HLproj1(error)
C
      Implicit None 
C output
      Integer  error
C local
      Character * 8  varx
      Integer  ivarx
      Integer  ifirst, ilast, isel
      Integer  here, id, dim, idnew
      Integer  nx, Ltit, Lvar
      Character * 80  title
      Real  xmin, xmax
      Integer  link
C function
      Integer  DIS45_needhist, DIS45_makehist, Lenrd
      External Dy_uwfunc
C data
      Data  nx /100/
C begin
      If( DIS45_needhist(3,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      Call DIS45_hinfo0(id,title,dim)
C
      Call HLtuple_asktag(id,'x variable',1,varx,ivarx)
C
      Call HLtuple_askevt(id,ifirst,ilast,error)
      If( error.ne.0 ) Return
C
      Call HLtuple_asksel(isel,link,error)
      If( error.ne.0 ) Return
C
      Call Intrd('number of x bin',nx)
      If( nx.le.0 ) Return
C
      Call DIS45_tuple_minmax(id,ivarx,xmin,xmax)
      Call Fltrd('x minumum',xmin)
      Call Fltrd('x maximum',xmax)
      If( xmin.ge.xmax ) Return
C
      If( DIS45_makehist(id,1,idnew,error).le.0 ) Return
C
      Ltit = Lenrd(title)
      Lvar = Lenrd(varx)
      title(Ltit+2:) = '('//varx(:Lvar)//')'
      Write(*,*) 'HLproj1: xmin,xmax=',xmin,xmax
      Call Hbook1(idnew,title,nx,xmin,xmax,0.0)
C
      Call Hproj1(idnew,id,isel,Dy_uwfunc,ifirst,ilast,ivarx)
C
      Call DIS45_dynclose(link)
C
      Return
      End
C
C
      Subroutine HLproj2(error)
C
      Implicit None 
C output
      Integer  error
C local
      Character * 8  varx, vary
      Integer  ivarx, ivary
      Integer  ifirst, ilast, isel
      Integer  here, id, dim, idnew
      Integer  nx, ny, Ltit, Lvarx, Lvary
      Character * 80  title
      Real  xmin, xmax, ymin, ymax
      Integer  link
C function
      Integer  DIS45_needhist, DIS45_makehist, Lenrd
      External Dy_uwfunc
C data
      Data  nx, ny /100,100/
C begin
      If( DIS45_needhist(3,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      Call DIS45_hinfo0(id,title,dim)
C
      Call HLtuple_asktag(id,'x variable',1,varx,ivarx)
      Call HLtuple_asktag(id,'y variable',2,vary,ivary)
C
      Call HLtuple_askevt(id,ifirst,ilast,error)
      If( error.ne.0 ) Return
C
      Call HLtuple_asksel(isel,link,error)
      If( error.ne.0 ) Return
C
      Call Intrd('number of x bin',nx)
      If( nx.le.0 ) Return
      Call Intrd('number of y bin',ny)
      If( ny.le.0 ) Return
C
      Call DIS45_tuple_minmax(id,ivarx,xmin,xmax)
      Call Fltrd('x minumum',xmin)
      Call Fltrd('x maximum',xmax)
      If( xmin.ge.xmax ) Return
C
      Call DIS45_tuple_minmax(id,ivary,ymin,ymax)
      Call Fltrd('y minumum',ymin)
      Call Fltrd('y maximum',ymax)
      If( ymin.ge.ymax ) Return
C
      If( DIS45_makehist(id,2,idnew,error).le.0 ) Return
C
      Ltit = Lenrd(title)
      Lvarx = Lenrd(varx)
      Lvary = Lenrd(vary)
      title(Ltit+2:) = '('//varx(:Lvarx)//' vs '//vary(:Lvary)//')'
      Call Hbook2(idnew,title,nx,xmin,xmax,ny,ymin,ymax,0.0)
C
      Call Hproj2(idnew,id,isel,Dy_uwfunc,ifirst,ilast,ivarx,ivary)
C
      Call DIS45_dynclose(link)
C
      Return
      End


