C
C File: HLsplot2.for
C Description: splot command for 2D histogram
C Author: A.Shirahashi
C Date: 24-Dec-1992
C
C History:  5-Jan-1992, call hpltab
C          16-Feb-1994, zmin, zmax
C
C Public: HLsplot2
C
      Subroutine HLsplot2(id,error)
C
      Implicit None
C common
      Include 'pawc.inc'
C input
      Integer  id
C output
      Integer  error
C local
      Character * 8  opt
      Character * 80  title
      Integer  dim
C begin
      Call DIS45_hinfo0(id,title,dim)
      If( dim.eq.1 ) Then
        error = 6  ! command not valid for 1-dim
      Else If( dim.eq.3 ) Then
        error = 30 ! command not valud for N-tuple
      End If
C
      Call Txtrd(
     &  '?option (P,B,R,C,T,K,COL,L,L1,L2,S,S1,S2,S3,S4)',
     &  opt)
      Call Strupc(8,opt)
      If( Index('PBRCTKLS',opt(1:1)).eq.0 ) Then
        error = 23 ! illegal option
        Return
      End If
C
      If( opt(1:1).eq.'L' .or. opt(1:1).eq.'S' ) Then
        Call DIS45_IGtabl3(id,opt,error)
      Else
        Call DIS45_IGtabl2(id,opt,error)
      End If
C
      Return
      End
C
C
      Subroutine DIS45_IGtabl2(id,opt,error)
C
      Implicit None
C common
      Include 'pawc.inc'
C input
      Integer  id
      Character * (*)  opt
C output
      Integer  error
C local
      Character * 80  title
      Character * 5  tabopt
      Integer  npar, nx, ny
      Real  xmin, xmax, ymin, ymax, zmin, zmax
      Real  par(32)
C begin
      Call DIS45_hinfo2(id,title,nx,xmin,xmax,ny,ymin,ymax)
      If( ny.eq.0 ) Return
C
      If( opt(1:1).eq.'P' .or. opt(1:4).eq.'SCAT' ) Then
        tabopt = 'SCAT'
        par(1) = 1.0
        par(2) = 50.0
      Else If( opt(1:1).eq.'B' .or. opt(1:3).eq.'BOX' ) Then
        tabopt = 'BOX'
      Else If( opt(1:1).eq.'R' .or. opt(1:3).eq.'ARR' ) Then
        tabopt = 'ARR'
      Else If( opt(1:3).eq.'COL' ) Then
        tabopt = 'COL'
        par(1) = 0.0
      Else If( opt(1:1).eq.'C' .or. opt(1:4).eq.'CONT' ) Then
        tabopt = 'CONT'
        par(1) = 20.0
        par(2) = 0.0
        If( opt(5:5).eq.'1' ) par(2) = 1.0
        If( opt(5:5).eq.'2' ) par(2) = 2.0
        If( opt(5:5).eq.'3' ) par(2) = 3.0
      Else If( opt(1:1).eq.'T' .or. opt(1:4).eq.'TEXT' ) Then
        tabopt = 'TEXT'
        par(1) = 1.0
        par(2) = 0.0
      Else If( opt(1:1).eq.'K' .or. opt(1:4).eq.'CHAR' ) Then
        tabopt = 'CHAR'
        par(1) = 1.0
        par(2) = 0.0
      Else
        Print *, 'DIS45_IGtabl2: no such option: ', opt
        Return
      End If
C
      npar = 2
C
      Call DIS45_getinfo(id,'ZMIN',zmin)
      Call DIS45_getinfo(id,'ZMAX',zmax)
C
      If( zmin.lt.zmax ) Then
        par(3) = zmin
        par(4) = zmax
        npar = 4
      End If

      Call HPLtab(id,npar,par,tabopt)
C
      Call IUWK(0,0) ! update workstation
C
      Return
      End
C
C
      Subroutine DIS45_IGtabl3(id,opt,error)
C
      Implicit None
C common
      Include 'pawc.inc'
C input
      Integer  id
      Character * (*)  opt
C output
      Integer  error
C local
      Character * 80  title
      Character * 5  tabopt
      Integer  npar, nx, ny
      Real  xmin, xmax, ymin, ymax, zmin, zmax
      Real  par(32)
C begin
      Call DIS45_hinfo2(id,title,nx,xmin,xmax,ny,ymin,ymax)
      If( ny.eq.0 ) Return
C
      If( opt(1:2).eq.'L1' .or. opt(1:5).eq.'LEGO1' ) Then
        tabopt = 'LEGO1'
      Else If( opt(1:2).eq.'L2' .or. opt(1:5).eq.'LEGO2' ) Then
        tabopt = 'LEGO2'
      Else If( opt(1:1).eq.'L' .or. opt(1:4).eq.'LEGO' ) Then
        tabopt = 'LEGO'
      Else If( opt(1:2).eq.'S1' .or. opt(1:5).eq.'SURF1' ) Then
        tabopt = 'SURF1'
      Else If( opt(1:2).eq.'S2' .or. opt(1:5).eq.'SURF2' ) Then
        tabopt = 'SURF2'
      Else If( opt(1:2).eq.'S3' .or. opt(1:5).eq.'SURF3' ) Then
        tabopt = 'SURF3'
      Else If( opt(1:2).eq.'S4' .or. opt(1:5).eq.'SURF4' ) Then
        tabopt = 'SURF4'
      Else If( opt(1:1).eq.'S' .or. opt(1:4).eq.'SURF' ) Then
        tabopt = 'SURF'
      Else  
        Print *, 'DIS45_IGtabl3: no such option: ', opt
        Return
      End If
C
      par(1) = 30.0
      par(2) = 30.0
      npar = 2
C
      Call DIS45_getinfo(id,'ZMIN',zmin)
      Call DIS45_getinfo(id,'ZMAX',zmax)
C
      If( zmin.lt.zmax ) Then
        par(3) = zmin
        par(4) = zmax
        npar = 4
      End If
C
      Call HPLtab(id,npar,par,tabopt)
C
      Call IUWK(0,0) ! update workstation
C
      Return
      End


