C
C File: HLstat.for
C Deascription: Compute some statistics values for 1 dim histogram
C Author: A.Shirahashi
C Date: 27-May-1992
C Origianl FACOM version
C
C History: 29-Jul-92, HLstat1, HLstat2
C
C Public: HLstat
C Private: HLstat1, HLstat2, HLstat_cal1, HLstat_cal2
C          HLstat3, HLstat_eval
C
      Subroutine HLstat( error )
C
      Implicit None
C output
      Integer  error
C local
      Integer  here, id, dim
C function
      Integer  DIS45_needhist
C begin
      If( DIS45_needhist( 0,error ).le.0 ) Return
      Call DIS45_thishist( here, id, dim )
C
      If( dim.eq.1 ) Then
        Call HLstat1( id )
      Else If( dim.eq.2 ) Then
        Call HLstat2( id )
      Else
        Write(*,*) 'HLstat: don''t know dim = ', dim
      End If
C
      Return
      End
C
C
      Subroutine HLstat1( id )
C
      Implicit None 
C input
      Integer  id
C local
      Real  sum, vm, sig, erm, ers, res, err
      Integer  dim, noent, length
      Character * 80  title
C function
      Real  Hsum
      Integer  Lenrd
C begin      
C     ... unfortunately, Hstati does not return correct values
C         for non-equivalent width bins
C     vm = Hstati(id,1,'HIST',1)
C     sig = Hstati(id,2,'HIST',1)
C
C     If( an.gt.0.0 ) Then
C       rp = Sqrt(sum)
C       erm = sig/rp
C       ers = erm/Sqrt(2.0)
C     Else
C       erm = 0.0
C       ers = 0.0
C     End If
C
      Call DIS45_hinfo0( id,title,dim )
C
      sum = Hsum( id )
      Call Hnoent( id,noent )
      Call HLstat_cal1( id,vm,sig )
C
      If( sum.gt.0.0 ) Then
        erm = sig/Sqrt(sum)
        ers = erm/Sqrt(2.0)
      Else
        erm = 0.0
        ers = 0.0
      End If
C
      length = Lenrd(title)
      Write(6,1000) id, title(:length)
 1000 Format( 5X,I5,1X,A )
      Write(6,1010) noent, sum
 1010 Format( 5X,'entries = ', I8, '     sum = ', G12.5 )
      Write(6,1020) vm, erm
 1020 Format( 5X,'mean       = ',G12.5, ' +- ', G12.5 )
      Write(6,1030) sig, ers
 1030 Format( 5X,'sigma      = ',G12.5, ' +- ', G12.5 )
C
      If( vm.gt.0.0 ) Then
        res = sig/vm
        err = ers/vm
        Write(6,1040) res, err
 1040   Format( 5X,'resolution = ',G12.5, ' +- ', G12.5 )
      End If
C
      Return
      End
C
C
      Subroutine HLstat2( id )
C
      Implicit None 
C input
      Integer  id
C local
      Real  sum, xm, xs, ym, ys
      Real  exm, exs, eym, eys
      Integer  dim, noent, length
      Character * 80  title
C function
      Real  Hsum
      Integer  Lenrd            
C begin
      Call DIS45_hinfo0( id,title,dim )
C
      sum = Hsum( id )
      Call Hnoent( id,noent )
C
      Call HLstat_cal2( id, xm, xs, ym, ys )
C
      If( sum.gt.0.0 ) Then
        exm = xs/Sqrt(sum)
        exs = exm/Sqrt(2.0)
        eym = ys/Sqrt(sum)
        eys = eym/Sqrt(2.0)
      Else
        exm = 0.0
        exs = 0.0
        eym = 0.0
        eys = 0.0
      End If
C
      length = Lenrd(title)
      Write(6,1000) id, title(:length)
 1000 Format( 5X,I5,1X,A )
      Write(6,1010) noent, sum
 1010 Format( 5X,'entries = ', I8, '     sum = ', G12.5 )
      Write(6,1020) xm, exm
 1020 Format( 5X,'X mean     = ',G12.5, ' +- ', G12.5 )
      Write(6,1030) xs, exs
 1030 Format( 5X,'X sigma    = ',G12.5, ' +- ', G12.5 )
      Write(6,1040) ym, eym
 1040 Format( 5X,'Y mean     = ',G12.5, ' +- ', G12.5 )
      Write(6,1050) ys, eys
 1050 Format( 5X,'Y sigma    = ',G12.5, ' +- ', G12.5 )
      Return
      End
C
C
      Subroutine HLstat_cal1( id,ev,es )
C
      Implicit None
C input
      Integer  id
C output
      Real  ev, es
C local
      Integer  i
      Real*8  sw, swx, swxx
      Real  x, y
      Character * 80  title
      Integer  nx
      Real  xmin, xmax
C function
      Real  Hi
C     Real  Hstati, Hsum
C begin
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
C
      sw = 0.0
      swx = 0.0
      swxx = 0.0
C
      Do i = 1, nx
        Call DIS45_hixC( id,i,x )
        y = Hi(id,i)
        sw = sw + y
        swx = swx + y * x
        swxx = swxx + y * x * x
      End Do
C
      If( sw.gt.0.0 ) Then 
        ev = swx / sw
        es = Sqrt( Max( swxx/sw - ev**2, 0.0d0 ) )      
      Else     
        ev = 0.0
        es = 0.0
      End If
C
      Return
      End
C
C
      Subroutine HLstat_cal2( id,xm,xs,ym,ys )
C
      Implicit None 
C input
      Integer  id
C output
      Real  xm, xs, ym, ys
C local
      Integer  i, j
      Real*8  sw, swx, swxx, swy, swyy
      Real  x, y, z
      Character * 80  title
      Integer  nx, ny
      Real  xmin, xmax, ymin, ymax
C function
      Real  Hij
C begin
      Call DIS45_hinfo2(id,title,nx,xmin,xmax,ny,ymin,ymax)
C
      sw = 0.0
      swx = 0.0
      swxx = 0.0
      swy = 0.0
      swyy = 0.0
C
      Do i = 1, nx
        Do j = 1, ny
          Call DIS45_hijxyC( id,i,j,x,y )
          z = Hij(id,i,j)
          sw = sw + z
          swx = swx + z * x
          swxx = swxx + z * x * x
          swy = swy + z * y
          swyy = swyy + z * y * y
        End Do
      End Do
C
      If( sw.gt.0.0 ) Then 
        xm = swx / sw
        xs = Sqrt( Max( swxx/sw - xm**2, 0.0d0 ) )      
        ym = swy / sw
        ys = Sqrt( Max( swyy/sw - ym**2, 0.0d0 ) )      
      Else     
        xm = 0.0
        xs = 0.0
        ym = 0.0
        ys = 0.0
      End If
C
      Return
      End
C
C
      Subroutine HLstat3( error )
C
      Implicit None
C output
      Integer  error
C local
      Integer  here, id, dim
      Real  val(3), def(3), sum
      Real  rp, med, sig, erm, res, ers, err, sig1, sig2
C function
      Integer  DIS45_needhist
C data
      Data def / 0.5,0.16,0.84 /
C begin
      If( DIS45_needhist( 1,error ).le.0 ) Return
      Call DIS45_thishist( here, id, dim )
C
      Call HLstat_eval( id,3,def,val,sum )
C
      rp = Sqrt(sum)
C
      sig = (val(3) - val(2))*.5
      sig1 = val(3) - val(1)
      sig2 = val(1) - val(2)
C
      med = val(1)
      erm = sig / rp
C
      ers = erm / Sqrt(2.0)
C
      If( med.gt.0.0 ) Then
        res = sig / med
        err = res / (Sqrt(2.0)*rp)
        Write(6,100) med,erm,sig1,sig2,sig,ers,res,err
      Else
        Write(6,200) med,erm,sig1,sig2,sig,ers
      End If
C
  100 Format(1X,' med',F8.3,' +-',F6.3,' sig',3F8.3,' +-',F6.3,
     &       ' res ',F6.3,' +-',F6.3)
  200 Format(1X,' med',F8.3,' +-',F6.3,' sig',3F8.3,' +-',F6.3)
C
      Return
      End
C
C
      Subroutine HLstat_eval( id,nval,def,val,sum )
C
C ID is the histogram ident
C This program reads an hbook histogram and finds the points where
C DEF(I) of the entries are at the left.
C DEF (I) are the fractions of the entries to be left at the left
C for example .5 to calculate the mediane,.16 and.84 to calculate
C 2*SIGMA.
C The number of values to calculate is nval,the result in val
C
C input
      Integer nval
      Real def(nval), sum
C output
      Real val(nval)
C local
      Integer  nx, i, j
      Real  xmin, xmax
      Real  s1, s2, x1, x2, y
      Character * 80 title
C function
      Real  Hsum, Hi
C begin
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
C
      sum = Hsum(id)
C
      Do i = 1, nval
        val(i) = sum * def(i)
      End Do
C
      s1 = 0.0
      Do i = 1, nx
        y = Hi(id,i)
        s2 = s1 + y
        If(y.gt.0.0) Then
          Do j = 1, nval
            If(s1.le.val(j) .and. val(j).lt.s2) Then
              Call Hix( id,i,x1 )
              Call Hix( id,i+1,x2 )
              val(j) = x1 + ((val(j)-s1)/y) * (x2 - x1)
            End If
          End Do
        End If
        s1 = s2
      End Do
C
      Return
      End
C
C
