C
C File: HLstdiff.for
C Description: compute statistical difference between two histograms
C Date: 4-Aug-1992
C Author: A.Shirahashi
C
C Public: HLstdiff
C
      Subroutine HLstdiff(error)
C
      Implicit None
C output
      Integer  error
C local
      Integer  id1, id2
      Integer  here,id, dim
      Character * 80  title1, title2 
      Logical  nflag, fflag
      Real  prob
      Integer  iopt, len1, len2
      Character * 5  opt
C function
      Integer  DIS45_numhist, DIS45_samehist, Lenrd
C data
      Data  nflag /.True./, fflag /.False./
C begin
      If( DIS45_numhist(error).le.0 ) Return
      Call DIS45_thishist(here, id, dim)
C
      id1 = id
      Call Intrd('id 1',id1)
      id2 = id
      Call Intrd('id 2',id2)
      If( DIS45_samehist(id1,id2,error).le.0 ) Return
      Call DIS45_hinfo0(id1,title1,dim)
      Call DIS45_hinfo0(id2,title2,dim)
C
      iopt = 0
      opt = ' '
      Call Logrd('normalization',nflag)
      If( .not. nflag ) Then
        iopt = iopt + 1
        opt(iopt:iopt) = 'N'
      End If
      Call Logrd('take account of under/overflow',fflag)
      If( fflag ) Then
        If( dim.eq.1 ) Then
          opt(iopt+1:iopt+2) = 'OU'
        Else If( dim.eq.2 ) Then
          opt(iopt+1:iopt+4) = 'LRBT'
        End If
      End If
C
      Call Hdiff(id1,id2,prob,opt)  
C
      len1 = Lenrd(title1)
      Write(6,1000) id1, title1(:len1)
 1000 Format(5X,I5,1X,A)
      len2 = Lenrd(title2)
      Write(6,1010) id2, title2(:len2)
 1010 Format(5X,I5,1X,A)
      Write(6,1020) prob
 1020 Format(5X,'probability of compatibility = ',F8.5 )
      Return
      End
