C
C File: HLtable.for
C Description: Print out contents of histogram
C Created: 4/28/1992 
C $Revision: 1.6 $
C Last Modified: $Date: 1993/02/24 06:26:01 $ by $Author: sirahasi $
C
C Author: T.Takahashi
C
C History: 30-Jun-1992, A.Shirahashi, Intrd -> IntrdL, STR$TRIM -> Lenrd
C          20-Jul-1992, remove 'lunout'
C           4-Aug-1992, A.Shirahashi, Non equidistant bins
C           7-Jan-1993, A.S, ipoint = 1, format 5
C           2-Feb-1993, >file, >>file
C          24-Feb-1993, N-tuple
C
      Subroutine HLtable(error)
C
      Implicit None
C common
      Include 'pawc.inc'
C output
      Integer error
C local
      Integer  here, id, dim
      Character * 80 title, cline
      Character  tags*8, tagp*16
      Integer  iflag, ipoint, len, Lout
      Integer  nx, ich, length
      Real  xbin, xmin, xmax, x1, y1, dy, xlow, xhigh
      Integer  nall, nvar, nevent, i, j
      Integer  idbuf, loc
C function
      Integer  DIS45_needhist, DIS45_malloc, Lenrd
      Real  Hi, Hie
C data
      Data iflag / 0 /
      Data ipoint / 1 /
C begin
C     require 1 dim or N-tuple histogram
      If (DIS45_needhist(4,error).le.0) Return
      Call DIS45_thishist(here, id, dim)
C
      Lout = 6
C
      If (dim.eq.1) Then 
 100    Call IntrdX('error (0:No,1:Sqrt,2:Hie)',iflag,cline)
        length = Lenrd(cline)
        Call Strupc(1,cline)
        If( cline(1:1).eq.'0' .or. cline(1:1).eq.'N' ) Then
          iflag = 0
        Else If( cline(1:1).eq.'1' .or. cline(1:1).eq.'S' ) Then
          iflag = 1
        Else If( cline(1:1).eq.'2' .or. cline.eq.'H' ) Then
          iflag = 2
        Else If( cline(1:1).eq.'>' .or. cline(1:1).eq.'|' ) Then
          Call DIS45_redirect(cline,Lout,error)
          If( error.ne.0 ) Return
          Goto 100
        Else
          error = 23 ! illeagal option
          Return
        End If
        Call DIS45_hinfo1(id,title,nx,xmin,xmax)
        Call Intrd(
     &    'format: 1.(x y)2.(x y dy)3.(xmin xmax y)'//
     &    '4.(xmin xmax y dy)5.(x dx y dy)',
     &    ipoint)
        If( ipoint.lt.1 .or. ipoint.gt.5 ) Then
          error = 23 ! illegal option
	  Return
        End If
        Xbin = (xmax-xmin)/Float(Nx)
        len = Lenrd(title)
        Write (Lout,*) '(', id,':'//title(1:len)//')'
        Write (Lout,*) ' '
        Do Ich=1,Nx
          Call DIS45_HixC(id,ich,x1)
          Y1= Hi(Id,Ich)
          Call Hix(id,ich,xlow)
          Call Hix(id,ich+1,xhigh)
          If(Iflag.eq.1) Then
            dY = Sqrt(Abs(Y1))
          Elseif(Iflag.eq.2) Then
            dY = Hie(Id,Ich)
          Else
            dy = 0
          End If
          If(ipoint.eq.1) Then
            Write(Lout,*) X1,Y1
          elseif(ipoint.eq.2) Then
            Write(Lout,*) x1,Y1,Dy
          Else If (ipoint.eq.3) Then
            Write(Lout,*) xlow,xhigh,y1
          Else If (ipoint.eq.4) Then
            Write(Lout,*) xlow,xhigh,y1,dy
          Else If (ipoint.eq.5) Then
            Write(Lout,*) x1,(xhigh-xlow)/2.0,y1,dy
          End If
        End Do
      Else If( dim.eq.3 ) Then
        Call DIS45_hinfoN(id,title,nall,1,tags)
        If( DIS45_malloc(nall*2,idbuf,loc,error).le.0 ) Return
        nvar = 0
 200    Call IntrdX('number of variables (0:all)',nvar,cline)
        If( cline(1:1).eq.'>' .or. cline(1:1).eq.'|' ) Then
          Call DIS45_redirect(cline,Lout,error)
          If( error.ne.0 ) Return
          Goto 200
        End If
        nvar = Min(nvar,nall)
        If( nvar.le.0 ) Then
          nvar = nall
          Do i = 1, nvar
            Hmem(loc+nall+i-1) = i
          End Do
        Else
          Do i = 1, nvar
            Call CLitoa(i,tagp)
            Call HLtuple_asktag(id,'variable '//tagp,i,tags,
     &                          Hmem(loc+nall+i-1))
          End Do
        End If
        Call Hnoent(id,nevent)
        len = Lenrd(title)
        Write (Lout,*) '(', id,':'//title(1:len)//')'
        Write (Lout,*) ' '
        Do i = 1, nevent
          Call DIS45_tuple_getevt(id,i,Rmem(loc),error)
          Write(Lout,*) (Rmem(loc+Hmem(loc+nall+j-1)-1),j=1,nvar)
        End Do
        Call DIS45_free(idbuf)
      End If
C
      If( Lout.ne.6 ) Then
        Call DIS45_reclose( Lout )
      End If
C
      Return
      End
