C
C File: HLtitle.for
C Description: write a title on a picture
C Author: A.Shirahashi
C Date: 20-Jan-93
C       31-Mar-93, DATA, TOP, BOTTOM, LEFT, RIGHT
C
      Subroutine HLtitle(error)
C
      Implicit None
C input
      Integer  error
C local
      Real  x, y
      Character * 80  title
      Character * 8  opt
      Integer  length
      Real  xl, xm, xh, yl, ym, yh
      Real  chhe, tang, txal, txfp
      Real  hori, vert, font, prec
      Real  csiz, cfon, angle
      Real  xlab, xval, ylab, yhti
      Real  rval(4)
      Integer  ival
      Integer  ntold
C function
      Integer Lenrd
C begin
C     ... save current NT
      Call IGQWK(1,'NTNB',rval)
      ntold = Int(rval(1))
C     ... select NT=1
      Call Iselnt(1)
C     ... save current parameters
      Call IGQ('CHHE',chhe)
      Call IGQ('TANG',tang)
      Call IGQ('TXAL',rval)
      hori = rval(1)
      vert = rval(2)
      txal = 10.0 * hori + vert
      Call IGQ('TXFP',rval)
      font = rval(1)
      prec = rval(2)
      txfp = 10.0 * font + prec
C
C     ... get defaults font size and font type
      Call HPLset('?CSIZ',csiz)
      Call HPLset('?CFON',cfon)
C     
C     ... get position (x,y)
      Call FltrdX('x',x,opt)
      Call Strupc(8,opt)
      If( opt.eq.'TOP'.or.opt.eq.'BOTTOM'.or.
     &    opt.eq.'LEFT'.or.opt.eq.'RIGHT' ) Then
        Call HPLgiv( xl,yl,xh,yh )
        xm = (xl + xh)/2.0
        ym = (yl + yh)/2.0
        Call HPLset('?XLAB',xlab)
        Call HPLset('?XVAL',xval)
        Call HPLset('?YLAB',ylab)
        Call HPLset('?YHTI',yhti)
        Call HPLset('?TSIZ',csiz)
        If( opt.eq.'TOP' ) Then
          x = xm
          y = yh + ylab
          hori = 2.0
        Else If( opt.eq.'BOTTOM' ) Then
          x = xm
          y = yl - yhti - csiz
          hori = 2.0
        Else If( opt.eq.'LEFT' ) Then
          x = xl - xlab
          y = ym
          Call IGset('TANG',90.0)
          font = -1.0
          prec = 1.0
          cfon = Abs(font) * 10.0 + Abs(prec)
          If( font.lt.0.0 ) cfon = - cfon
          hori = 2.0
        Else If( opt.eq.'RIGHT' ) Then
          x = xh + xval + csiz
          y = ym
          Call IGset('TANG',90.0)
          font = -1.0
          prec = 1.0
          cfon = Abs(font) * 10.0 + Abs(prec)
          If( font.lt.0.0 ) cfon = - cfon
          hori = 2.0
        End If
      Else
        Call Fltrd('y',y)
      End If
C
 100  Continue
      Call Txtrd('?title',title)
      length = Lenrd(title)
      opt = title(:8)
      Call Strupc(8,opt)
C
      If( opt.eq.'DATA' .or. opt.eq.'-D' ) Then
        Call DIS45_conv_d2t( ntold, x, y, x, y )
        Goto 100
      Else If( opt.eq.'SIZE' .or. opt.eq.'-S' ) Then
        Call Fltrd('size',csiz)
        Goto 100
      Else If( opt.eq.'ANGLE' .or. opt.eq.'-A' ) Then
        Call Fltrd('angle',angle)
        Call IGset('TANG',angle)
        Goto 100
      Else If( opt.eq.'FONT' .or. opt.eq.'-F' ) Then
        Call Intrd('font',ival)
        font = Real(ival)
        cfon = Abs(font) * 10.0 + Abs(prec)
        If( font.lt.0.0 ) cfon = - cfon
        Goto 100
      Else If( opt.eq.'PREC' .or. opt.eq.'-P' ) Then
        Call Intrd('precision',ival)
        prec = Real(ival)
        cfon = Abs(font) * 10.0 + Abs(prec)
        If( font.lt.0.0 ) cfon = - cfon
        Goto 100
      Else If( opt.eq.'LEFT' .or. opt.eq.'-L' ) Then
        hori = 1.0
        Goto 100
      Else If( opt.eq.'CENTER' .or. opt.eq.'-C' ) Then
        hori = 2.0
        Goto 100
      Else If( opt.eq.'RIGHT' .or. opt.eq.'-R' ) Then
        hori = 3.0
        Goto 100
      Else If( opt.eq.'TOP' .or. opt.eq.'-T' ) Then
        vert = 1.0
        Goto 100
      Else If( opt.eq.'MIDDLE' .or. opt.eq.'-M' ) Then
        vert = 3.0
        Goto 100
      Else If( opt.eq.'RIGHT' .or. opt.eq.'-R' ) Then
        vert = 2.0
        Goto 100
      End If
C
C     ... set parameters
      Call IGset('CHHE',csiz)
      Call IGset('TXFP',cfon)
      Call IGset('TXAL',hori*10.0+vert)
C
C     ... get title text
      Call Ugetrd(title(:length),length)
      Call Titrd('title',title)
      length = Lenrd(title)
C
      Call ITX(x,y,title(:length))
      Call IUWK(0,0)
C
C     ... restore parameters
      Call IGset('CHHE',chhe)
      Call IGset('TANG',tang)
      Call IGset('TXAL',txal)
      Call IGset('TXFP',txfp)
C     ... restore NT
      Call Iselnt(ntold)
C
      Return
      End
C
C
      Subroutine DIS45_conv_d2t( nt, xi, yi, xo, yo )
C
      Implicit None
C input
      Integer  nt
      Real  xi, yi
C output
      Real  xo, yo
C local
      Real  x, y
      Real  xl, yl, xh, yh, x1, y1, x2, y2
      Real  rval(4)
      Integer  ntold
C begin
      Call IGqwk( 1,'NTNB',rval )
      ntold = Int(rval(1))
      Call Iselnt( nt )
C
      x = xi
      y = yi
C
      Call HPLgiv( xl,yl,xh,yh )
      Call IGqwk( 1, 'NTWN', rval )
C
      x1 = rval(1)
      x2 = rval(2)
      y1 = rval(3)
      y2 = rval(4)
C
      xo = (x-x1)*(xh-xl)/(x2-x1) + xl
      yo = (y-y1)*(yh-yl)/(y2-y1) + yl
C
      Call Iselnt( ntold )
      Return
      End
