C
C File: HLtuple.for
C Description: N-tuple routines
C Author: A.Shirahashi
C Date: 7-Sep-1992
C
C History: 18-Sep-1992, DIS45_get/setopt(id,...)
C          30-Aug-1993, HLframeNT: plot  a title
C           7-Sep-1993, HLframeNT: HBINSZ('NO  ')
C
C           9-Nov-1993, asksel returns address
C
C Public: HLtuple, HLplotNT, HLframeNT, HLfitNT
C         HLtuple_asktag, HLtuple_askevt, HLtuple_asksel
C
      Subroutine HLtuple(id,opt,mtype,msize,error)
C
      Implicit None
C input
      Integer  id, mtype
      Real  msize
      Character * 1  opt
C output
      Integer  error
C local
      Integer  ifmt, flag
      Character * 8  varx, vary, vardx, vardy
      Integer  ivx, ivy, ivdx, ivdy
C function
      External  HLfit_Fgaus, HLfit_Fexpo, HLfit_Fpoly, DyFunc
C begin
      Call IntrdL('format (0:xy, 1:xydy, 2:xydxdy)',ifmt,0,2)
C      
      Call HLtuple_asktag(id,'x variable',1,varx,ivx)
      Call Hltuple_asktag(id,'y variable',2,vary,ivy)
C
      ivdx = 0
      ivdy = 0
C
      If( ifmt.eq.1 ) Then
        Call HLtuple_asktag(id,'dy variable',3,vardy,ivdy)
      Else If( ifmt.eq.2 ) Then
        Call HLtuple_asktag(id,'dx variable',3,vardx,ivdx)
        Call HLtuple_asktag(id,'dy variable',4,vardy,ivdy)
      End If
C
      Call HLplotNT(id,opt,ivx,ivy,ivdx,ivdy,mtype,msize,error)
C
      Call DIS45_aux_getinfo(id,'FUNC',flag)
      If( flag.eq.1 ) Then
        Call HLplotFX(HLfit_Fgaus,error)
      Else If( flag.eq.2 ) Then
        Call HLplotFX(HLfit_Fexpo,error)
      Else If( flag.eq.3 ) Then
        Call HLplotFX(HLfit_Fpoly,error)
      Else If( flag.eq.4 ) Then
        Call HLplotFX(DyFunc,error)
      End If
C
      Return
      End
C
C
      Subroutine HLplotNT(id,opt,ivx,ivy,ivdx,ivdy,mtype,msize,error)
C
      Implicit None
C common
      Include 'pawc.inc'
C input
      Integer  id, ivx, ivy, ivdx, ivdy, mtype
      Real  msize
      Character * 1  opt
C output
      Integer  error
C local
      Integer  idbuf, nevent, locx, locy, locdx, locdy
C function
      Integer  DIS45_malloc
C begin
      Call Hnoent(id,nevent)
C
      If( DIS45_malloc( nevent*4,idbuf,locx,error ).le.0 ) Return
      locy = locx + nevent
      locdx = locy + nevent
      locdy = locdx + nevent
C
      Call DIS45_tuple_getvec(id,ivx,1,nevent,Rmem(locx),error)
      Call DIS45_tuple_getvec(id,ivy,1,nevent,Rmem(locy),error)
      If( ivdx.ne.0 ) Then
        Call DIS45_tuple_getvec(id,ivdx,1,nevent,Rmem(locdx),error)
      End If
      If( ivdy.ne.0 ) Then
        Call DIS45_tuple_getvec(id,ivdy,1,nevent,Rmem(locdy),error)
      End If
C
      If( Index(opt,'S').eq.0 ) Then
        Call HLframeNT(id,ivx,ivy,ivdx,ivdy,locx,locy,locdx,locdy)
      End If
C
      Call HPLerr(Rmem(locx),Rmem(locy),Rmem(locdx),Rmem(locdy),
     &            nevent,' ',mtype,msize*0.2)
C
      Call DIS45_free( idbuf )
      Return
      End
C
C
      Subroutine HLframeNT(id,ivx,ivy,ivdx,ivdy,
     &                        locx,locy,locdx,locdy)
C
      Implicit None
C common
      Include 'pawc.inc'
C input
      Integer  id
      Integer  ivx, ivy, ivdx, ivdy
      Integer  locx, locy, locdx, locdy
C local
      Integer  I, nevent, dim
      Real  xmin, xmax, ymin, ymax
      Real  x, y, dx, dy
      Integer  idnew, error
      Character * 80  title
      Logical  logx, logy
C function
      Integer  DIS45_makehist
C begin
      Call DIS45_hinfo0(id,title,dim)
      Call Hnoent(id,nevent)
C
      Call DIS45_tuple_minmax(id,ivx,xmin,xmax)
C
      If( ivdx.ne.0 ) Then
        Do I = 1, nevent
	  x = Rmem(locx+I-1)
	  dx = Rmem(locdx+I-1)
	  xmin = Min(xmin,x-dx)
	  xmax = Max(xmax,x+dx)
        End Do
      End If
C
      dx = (xmax-xmin)*0.05
      xmin = xmin - dx
      xmax = xmax + dx
C
      Call DIS45_aux_getinfo(id,'YMIN',ymin)
      Call DIS45_aux_getinfo(id,'YMAX',ymax)
C
      If( ymin.ge.ymax ) Then
C
        Call DIS45_tuple_minmax(id,ivy,ymin,ymax)
C
        If( ivdy.ne.0 ) Then
         Do I = 1, nevent
	    y = Rmem(locy+I-1)
	    dy = Rmem(locdy+I-1)
	    ymin = Min(ymin,y-dy)
	    ymax = Max(ymax,y+dy)
          End Do
        End If
C
        dy = (ymax-ymin)*0.05
        ymin = ymin - dy
        ymax = ymax + dy
C
      End If
C
      If( DIS45_makehist(id,2,idnew,error).le.0 ) Return
      Call Hbinsz('YES ')
      Call Hbook1(idnew,title,20,xmin,xmax,0.0)
      Call Hminim(idnew,ymin)
      Call Hmaxim(idnew,ymax)
      Call Hbinsz('NO  ')
C
      Call DIS45_getopt(id,'LOGX',logx)
      If( logx ) Call HPLopt('LOGX',1)
      Call DIS45_getopt(id,'LOGY',logy)
      If( logy ) Call HPLopt('LOGY',1)
      Call Hplot(idnew,' ',' ',1)
      Call HPLopt('LINX',1)
      Call HPLopt('LINY',1)
C
      Call DIS45_hdelete(idnew)
      Return
      End
C
C
      Subroutine HLplotFX(Func,error)
C
      Implicit None
C common
      Include 'pawc.inc'
C input
      Double Precision  Func
      External Func
C output
      Integer  error
C constant
      Integer  WKID, NXDIV
      Parameter( WKID = 1, NXDIV = 100 )
C local
      Real  wval(4), xbin
      Integer  idbuf, locx, locy, I
C function
      Integer  DIS45_malloc
C begin
      Call IGQWK(WKID,'NTWN',wval)
C
      xbin = (wval(2)-wval(1))/Real(NXDIV)
C
      If( DIS45_malloc((NXDIV+1)*2,idbuf,locx,error).le.0 ) Return
      locy = locx + NXDIV + 1
C
      Do I = 0, NXDIV
        Rmem(locx+I) = wval(1) + Real(I) * xbin
        Rmem(locy+I) = Func(Rmem(locx+I))
      End Do
C
      Call HPLfun(Rmem(locx),Rmem(locy),NXDIV+1,' ')
C
      Call DIS45_free(idbuf)
      Return
      End
C
C
      Subroutine HLfitNT_askvar(id,ic,ivx,ivy,ivdy)
C
      Implicit None
C input
      Integer  id, ic
C output
      Integer  ivx, ivy, ivdy
C local
      Character * 8  varx, vary, vardy
C begin
      Call HLtuple_asktag(id,'x variable',1,varx,ivx)
      Call Hltuple_asktag(id,'y variable',2,vary,ivy)
C
      If( Mod(ic,1000).gt.100 ) Then
        ivdy = 0
      Else
        Call HLtuple_asktag(id,'dy variable',3,vardy,ivdy)
      End If
C
      Return
      End
C
C
      Subroutine HLfitNT(id,ivx,ivy,ivdy,func,np,p,chi2,ic,sigma)
C
      Implicit None
C common
      Include 'pawc.inc'
C input
      Integer  ivx, ivy, ivdy
      Integer  id,  np, ic
C input/output
      Double Precision  p(*)
C output
      Real  chi2, sigma(*)
C local
      Integer  nevent
      Integer  idbuf, locx, locy, locdy, error
C function
      External  func
      Integer  DIS45_malloc
C begin
      Call Hnoent(id,nevent)
      If( DIS45_malloc( nevent*3,idbuf,locx,error ).le.0 ) Return
      locy = locx + nevent
      locdy = locy + nevent
C
      Call DIS45_tuple_getvec(id,ivx,1,nevent,Rmem(locx),error)
      Call DIS45_tuple_getvec(id,ivy,1,nevent,Rmem(locy),error)
      If( ivdy.gt.0 ) Then
        Call DIS45_tuple_getvec(id,ivdy,1,nevent,Rmem(locdy),error)
      End If
C
      Call Hfit1(Rmem(locx),Rmem(locy),Rmem(locdy),nevent,
     &           func,np,p,chi2,ic,sigma)
C
      Call DIS45_free( idbuf )
      Return
      End
C
C
      Subroutine HLtuple_asktag(id,prompt,inivar,var,ivar)
C
      Implicit None 
C common
      Include 'tags.inc'
C input
      Integer  id, inivar
      Character * (*)  prompt
C output
      Character * (*)  var
      Integer  ivar
C local
      Character * 80  title
      Integer  nvar
C begin
      Call DIS45_hinfon(id,title,nvar,MAXTAG,tags)
      nvar = Min(nvar,MAXTAG)
      var = tags(inivar)
      Call Keyrd(-1,prompt,var,tags,nvar,ivar)
      Return
      End
C
C
      Subroutine HLtuple_asksel(isel,link,error)
C 
      Implicit None 
C output
      Integer  isel
      Integer  error
      Integer  link
C common (for dynamic linking)
      Integer  address
      Common /HLtuple_link/ address
C function
      Integer  DIS45_dynlink
C begin
      isel = 0      
      Call Intrd('selection (0:no selection)',isel)
      If( isel.ne.0 ) Then
        address = DIS45_dynlink('UWFUNC','UWFUNC')
        link = address
        If( address .eq. 0 ) Then
          error = 28 ! can't load DYNLINK module
          Return
        End If
      End If
C
      Return
      End
C
C
      Subroutine HLtuple_askevt(id,ifirst,ilast,error)
C
      Implicit None 
C input
      Integer  id
C output
      Integer  ifirst, ilast, error
C local
      Integer  nevent
C begin
      Call Hnoent(id,nevent)
      ifirst = 1
      Call Intrd('first event (0:all)',ifirst)
      If( ifirst.eq.0 ) Then
        ifirst = 1
        ilast = nevent
      Else
        ilast = nevent
        Call Intrd('last event',ilast)
      End If
      If( ifirst.gt.ilast ) Then
        error = 20 ! you have rejected everything
        Return
      End If
C
      Return
      End
C
C
      Real Function Dy_uwfunc(X,ISEL)
C
      Implicit None 
C input
      Real  X(*)
      Integer  ISEL
C common (for dynamic linking)
      Integer  address
      Common /HLtuple_link/ address
C function
      Real  Call_uwfunc
C local
      Dy_uwfunc = Call_uwfunc( X,ISEL,%VAL(address) )
      Return
      End
C
C
      Real Function Call_uwfunc( X,ISEL,FUNC )
C
      Implicit None 
C input
      Real  X(*)
      Integer  ISEL
      Real  FUNC
      External FUNC
C begin
      Call_uwfunc = FUNC( X,ISEL )
      Return
      End
