C
C File: HLVAL.FOR
C
C History: 21-May-1992, A.Shirahahsi, use HXI in stead of HXE
C          16-Jul-1992, A.Shirahashi, remove an argument 'lunout'
C                                     allows #channel in add. to coord.
C          21-Jul-1992, A.Shirahashi, use DIS45_getchan
C          21-Jan-1993, T.Takahashi   support ADD SUB ...
C          26-Jan-1993, A.S, clean up, add '#'
C                                    
      Subroutine HLvals(error)
C
      Implicit None 
C output
      Integer error
C local
      Real  x
      Character * 16  opt
      Integer  Lopt
C funcion
      Integer  Lenrd, DIS45_needhist
C data
      Data x /1.0/
C begin
      If( DIS45_needhist(0,error).le.0 ) Return
C
      Call FltrdX( 
     &  'value or (SET, ADD)',
     &  x,opt )
      Lopt = Lenrd(opt)
      Call Strupc(Lopt,opt)
      If( opt(1:1).eq.'S' ) Then
        Call HLval('S',error)
      Else If( opt(1:1).eq.'A' ) Then
        Call HLval('A',error)
      Else If( Index('0123456789+-.#',opt(1:1)).gt.0 ) Then
        Call Ugetrd(opt,Lopt)
        Call HLval('V',error)
      Else
        error = 23 ! illegal option
      End If
C
      Return
      End
C
C
      Subroutine HLval(opt,error)
C
      Implicit None
C incput
      Character  opt
C output:
      Integer error
C common
      Include 'pawc.inc'
C local
      Integer here, id, dim, i, j, pos
      Real val, x, y, err, val_offset, err_offset
      Integer  nx, ny
      Real  xmin, xmax, ymin, ymax
      Character * 80  title
      Integer  size, idbuf, loc
      Logical  Lerr
C function
      Real Hi, Hie, Hij
      Integer  DIS45_needhist, DIS45_hasbar
      Integer  DIS45_malloc
C begin
C     require 1 dim or 2 dim histogram
      If (DIS45_needhist(0,error).le.0) Return
      CALL DIS45_thishist(here, id, dim)
C
      If (dim.eq.1) Then 
C
        Call DIS45_hinfo1(id,title,nx,xmin,xmax)
        size = nx * 2
        If( DIS45_malloc(size,idbuf,loc,error).le.0 ) Return
        Call DIS45_locate(idbuf,loc)
        Call DIS45_getchan('x (or #channel)',nx,xmin,xmax,x,x,pos)
        If( pos.eq.0 ) Then
          Call Hxi(id,x,pos)
        Else
          Call DIS45_HixC(id,pos,x)
        End If
C
        val = Hi(id,pos)
        err = Hie(id,pos)
C
        Lerr = (DIS45_hasbar(id) .ne. 0)
C
        If ((opt.eq.' ').or.(opt.eq.'V')) then
          Write(6,1000) val, err, x
 1000     Format(5X,'value: ',G12.5,'  error: ',G12.5
     &          ,'  at  x = ',G12.5)
        else if(opt.eq.'S' .or. opt.eq.'A') then
          Call Hunpak(id,Rmem(loc),' ',1)
          Call Hunpke(id,Rmem(loc+nx),' ',1)
          If( opt.eq.'S' ) Then
            Call Fltrd('new value', val)
            If( Lerr ) Then
              Call Fltrd('new error', err)
            End If
          Else If( opt.eq.'A' ) Then
            Call Fltrd('value offset', val_offset)
            val = val + val_offset
            If( Lerr ) Then
              Call Fltrd('error offset', err_offset)
              err = err + err_offset
            End If
          End If
          Rmem(loc+pos-1) = val
          Call Hpak(id,Rmem(loc))
          If( Lerr ) Then
            Rmem(loc+nx+pos-1) = err
            Call Hpake(id,Rmem(loc+nx))
          End If
        End If
        Call DIS45_free (idbuf)
C
      Else If(dim.eq.2) Then
C
        Call DIS45_hinfo2(id,title,nx,xmin,xmax,ny,ymin,ymax)
        Call DIS45_getchan('x (or #channel)',nx,xmin,xmax,x,x,i)
        If( i.eq.0 ) Then
          Call Hxyij(id,x,y,i,j)
        Else
C         Call Hijxy(id,i,j,x,y)
          Call DIS45_HijxyC(id,i,j,x,y)
        End If
        Call DIS45_getchan('y (or #channel)',ny,ymin,ymax,y,y,j)
        If( j.eq.0 ) Then
          Call Hxyij(id,x,y,i,j)
        Else
C         Call Hijxy(id,i,j,x,y)
          Call DIS45_HijxyC(id,i,j,x,y)
        End If
        val = Hij(id,i,j)
        Write(6,1100) val, x, y
 1100   Format(5X,'value: ',G12.5,'  at (x,y) = ',G12.5,',',G12.5)
      End If
C
      Return
      End
C
