c+
c File : hlhpkvms.for
c Description : read HPK file
c
c Author : Ryosuke Itoh, TOPAZ, KEK
c Date : 26 - OCT- 1991
c Modified : 13 - Jan - 1993, R.Itoh, VMS version
C Modified : 26 - JUL - 1993, R.Itoh, selective read of hist file
C             2 - APR - 1993, HLtahi -> DIS45_inchist
c-
c
      Subroutine HLHPK ( IOD )
c
      Implicit         NONE
c
c Arg
c
      Integer * 4      IOD
c
c IOD = 0 -> FETC ( add mode )
c IOD = 1 -> FETC ( replace mode )
c     = 2 -> FETX
c
c Cons
c
      Integer * 4      INUNIT
      Parameter        ( INUNIT = 26 )
c
      Integer * 4      BUFSIZE
      Parameter        ( BUFSIZE = 50000 )
c
c Var
c
      Character * 80   Infile
      Integer * 4      Istat
      Integer * 4      Nw, I
      Integer * 4      Header ( 10 )
      Integer * 4      Buffer ( BUFSIZE )
      Integer * 4      Nhist, Nid, Hist_List(100), ID
c
c Func
c
c      Integer * 4      IOPEN
      Logical * 4      QOPEN
      Logical * 4      hpk_search
c
c Main
c
C      Call TXTRD ( 'Input HPK File : ', Infile )
C      Istat = IOPEN ( INUNIT, Infile, '.hpk', 'RU' )
C      If ( Istat .NE. 0 ) then
      If ( .not. QOPEN ( 'Input HPK file : ', INUNIT, Infile, 
     #                   'READ', 'UNFORMATTED', 'OLD' ) )then
        Print *, '%HLHPK-F, Error in opening input file'
        Return
      End If
      Call INTRD ( 'How many histograms (0 for all) ', Nhist )
      If ( Nhist .GT. 0 ) then
        Do Nid = 1, Nhist
          Call INTRD ( '?Histogram ID # ', Hist_List(Nid) )
        End Do
      End if
c
c... Loop over histogram nodes
c
 10   Continue
CUNIX    Call hpk_read ( INUNIT, Nw, Header )
CUNIX    If ( Nw .EQ. 0 ) Goto 20   ! End Of File
	Read ( Unit=INUNIT, End=20 ) (Header(I),I=1,6)
	Nw = Header ( 3 )
CUNIX    Call hpk_read ( INUNIT, Nw, Buffer )
CC	Print *, 'NW = ', Nw
	Read ( Unit=INUNIT, End=20 ) (Buffer(I),I=1,Nw)
        ID = Buffer ( 4 )
        If ( Nhist .LE. 0 .OR. 
     #       hpk_search ( ID, Nhist, Hist_List ) ) then
          Call hpk_to_hbk ( Nw, Buffer, Buffer, IOD )
        End If
      Goto 10
 20   Continue
      Close ( Unit=INUNIT )
      Call DIS45_inchist( ' ' )
      Return
      End
c
c----------
c hpk_to_hbk
c----------
c
      Subroutine hpk_to_hbk ( Nw, Buffer, Rbuf, Iod )
c
      Implicit        NONE
c
c Arg
c
      Integer * 4      Nw
      Integer * 4      Buffer ( * )
      Real * 4         Rbuf ( * )
      Integer * 4      Iod
c
c Var
c
      Integer * 4      ID, Class, Size
      Integer * 4      A4ID
      Integer * 4      Pntr_H, Pntr_T, Pntr_P
      Integer * 4      Ms
      Character * 80   Hbk_title
      Integer * 4      Ltit
      Integer * 4      Nx, Ny
      Real * 4         Xmin, Xmax, Ymin, Ymax
      Integer * 4      Idnew
      Integer * 4      I, J, Ip
      Real * 4         Total
      Integer * 4      Noent
c
c Function
c
      Integer * 4      Hpk_Id_to_Hbk
      Real * 4         HSUM
c
c Work Buffer
c
      Common /Scratch/ Hbk_Data ( 25000 ), Hbk_Error ( 25000 ),
     #                 Scr_Data ( 25000 )
      Real * 4         Hbk_Data, Hbk_Error, Scr_Data
c
c Main
c
c 0. Get Node Info.
c
      ID = Buffer ( 4 )
      Class = Buffer (  5 )
      A4ID = Buffer ( 6 )
      Size = Buffer ( 7 )
      Pntr_P = Buffer ( 10 )
      Pntr_H = Buffer ( 12 )
      Pntr_T = Buffer ( 13 )
      If ( A4ID .EQ. 'TYPE' .OR. A4ID .EQ. 'URHD' ) then
        Return    ! Skip FULL Info histograms.
      End If
c
c 1. Get Node Params.
c
      Ms = Buffer ( Pntr_P+1 )
      Nx = Buffer ( Pntr_P+5 )
      Xmin = Rbuf ( Pntr_P+6 )
      Xmax = Rbuf ( Pntr_P+8 )
      Ny = Buffer ( Pntr_P+9 )
      Ymin = Rbuf ( Pntr_P+10 )
      Ymax = Rbuf ( Pntr_P+12 )
CC      Print *, 'Converting : ID=', ID, ' Ms = ', Ms
CC      Print *, 'Nx = ', Nx, ' Xmin = ', Xmin, ' Xmax = ', Xmax
c
c 2. Convert Node Contents
c
      Call Hpk_title_to_Hbk ( %REF(Buffer(Pntr_T)), Hbk_Title, Ltit )
      If ( Class .EQ. 1 ) then
        Call Hpk_data_to_Hbk_1 ( Ms, Nx,
     #       Buffer(Pntr_H+1), Buffer(Pntr_H+1), Buffer(Pntr_H+1),
     #       Buffer(Pntr_H+1),
     #       Hbk_Data, Hbk_Error )
        IDnew = Hpk_ID_to_Hbk ( ID, Iod )
C        Print *, 'ID, Iod, Idnew = ', ID, Iod, Idnew
        If ( IDnew .EQ. 0 ) then
          IDnew = ID
          If ( Ms .GE. 5 .AND. Ms .LE. 14 ) then
            Print *, 'HLHPK-F, Add mode is not available for ID:',IDnew
            Print *, '         hist will be replaced'
          Else
            Call HUNPAK ( IDnew, Scr_Data, 'HIST', 0 )
            Do I = 1, Nx
              Hbk_Data ( I ) = Hbk_Data ( I ) + Scr_Data ( I )
            End Do
          End If
        Else
          Call HBOOK1 ( IDnew, Hbk_title(1:Ltit), Nx, Xmin, Xmax, 0.0 )
        End If
        Call HPAK ( IDnew, Hbk_data )
        If ( Ms .GE. 5 .AND. Ms .LE. 14 ) then
          Call HPAKE ( IDnew, Hbk_Error )
        End If
        Total = MIN ( HSUM ( IDnew ), 1.0E30 )
        Noent = INT ( Total )
        Call HLENT ( IDnew, Noent )
      Else If ( Class .EQ. 2 ) then
        Call Hpk_data_to_Hbk_2 ( Ms, Nx, Ny,
     #   Buffer(Pntr_H+1), Buffer(Pntr_H+1), Buffer(Pntr_H+1),
     #   BUffer(Pntr_H+1),
     #   Hbk_Data, Hbk_Error )
        IDnew = Hpk_ID_to_Hbk ( ID, Iod )
        If ( IDnew .EQ. 0 ) then
          IDnew = ID
          If ( Ms .GE. 5 .AND. Ms .LE. 14 ) then
            Print *, 'HLHPK-F, Add mode is not available for ID:',IDnew
            Print *, '         hist will be replaced'
          Else
            Call HUNPAK ( IDnew, Scr_Data, 'HIST', 0 )
            Do I = 1, Nx
              Do J = 1, Ny
                Ip = Nx*(I-1) + J
                Hbk_Data ( Ip ) = Hbk_Data ( Ip ) + Scr_Data ( Ip )
              End Do
            End Do
          End If
        Else
          Call HBOOK2 ( IDnew, Hbk_title(1:Ltit), Nx, Xmin, Xmax,
     #                  Ny, Ymin, Ymax, 0.0 )
        End If
C        Call HLINSR ( IDnew, 2 )
        Call HPAK ( IDnew, Hbk_data )
        If ( Ms .GE. 5 .AND .Ms. LE. 14 ) then
          Call HPAKE ( IDnew, Hbk_Error )
        End If
        Total = MIN ( HSUM ( IDnew ), 1.0E30 )
        Noent = INT ( Total )
        Call HLENT ( IDnew, Noent )
      Else
        Print *, '%HLHPK-F, Illegal Class, ID=', ID, ' Class=', Class
      End If
      Return
      End
c
c----------
c Hpk_title_to_hbk
c----------
c
      Subroutine Hpk_title_to_hbk ( Hpkbuf, Hbk_title, Ltit )
c
      Implicit         NONE
c
c Arg
c
      Logical * 1      Hpkbuf (*)
      Character * (*)  Hbk_title
      Integer * 4      Ltit
c
c Var
c
      Integer * 4      Pntr
      Character * 80   Hpk_title
      Integer * 4      I
c
c Main
c
      Do I = 1, 80
	Hpk_title(I:I) = ' '
      End Do	
      Do I = 1, 80
	If ( Char(Hpkbuf(I)) .EQ. '@' ) Goto 10
	Hpk_title(I:I) = Char(Hpkbuf(I))
      End Do
10    Continue
C      Pntr = INDEX ( Hpk_title, '@' )
      Pntr = I
      If ( Pntr .LT. 9 ) then
        Pntr = 9
      End If
      Hbk_title(1:Pntr-5) = HPK_title(5:Pntr-1)
C      Hbk_title(Pntr:Pntr) = '$'
      Ltit = Pntr - 5
      Return
      End
c
c----------
c Hpk_data_to_Hbk_1
c----------
c
      Subroutine Hpk_data_to_Hbk_1 ( Ms, Nbin,
     #                        Lmemor, I2memr, Hmemor,
     #                        Rmemor, Hbk_Data, Hbk_Error )
c
      Implicit         NONE
c
c Arg
c
      Integer * 4      Ms
      Integer * 4      Nbin
      Logical * 1      Lmemor ( * )
      Integer * 2      I2memr ( * )
      Integer * 4      Hmemor ( * )
      Real * 4         Rmemor ( * )
      Real * 4         Hbk_Data ( * ), Hbk_Error ( * )
      Real * 4         B2, B3
c
c Var
c
      Integer * 4      I
c
c Main
c
      If ( Ms.EQ.1 ) then
        Do 10 I = 1, Nbin
          Hbk_Data ( I ) = Lmemor( I )
 10     Continue
      Else If ( Ms.Eq.2 ) Then
        Do 20 I = 1, Nbin
          Hbk_Data ( I ) = I2memr( I )
 20     Continue
      Else If ( Ms.Eq.3 ) Then
        Do 30 I = 1, Nbin
          Hbk_Data ( I ) = Hmemor( I )
 30     Continue
      Else If ( Ms.Eq.4 ) Then
        Do 40 I = 1, Nbin
          Hbk_Data ( I ) = Rmemor( I )
 40     Continue
      Else If ( Ms.Eq.5 .Or. Ms.Eq.6 .Or. Ms.Eq.7 ) Then
        Do 50 I = 1, Nbin
          Hbk_Data ( I ) = Rmemor( (I-1) * 2 + 1 )
          Hbk_Error( I ) = Sqrt( Rmemor ( (I-1) * 2 + 2 ) )
 50     Continue
      Else If ( Ms.Eq.8 ) Then
        Do 60 I = 1, Nbin
          Hbk_Data ( I ) = Rmemor( (I-1) * 3 + 1 )
          B2 = Rmemor( (I-1) * 3 + 2 )
          B3 = Rmemor( (I-1) * 3 + 3 )
          If( B3 .Gt. 0.0 ) Then
            Hbk_Error( I ) = Sqrt( B2 / B3 )
          Else
            Hbk_Error( I ) = 0.0
          End If
 60     Continue
      Else If ( Ms.Eq.9 ) Then
        Do 70 I = 1, Nbin
          Hbk_Data ( I ) = Rmemor( (I-1)*2 + 1 )
          Hbk_Error( I ) = Rmemor( (I-1)*2 + 2 )
 70     Continue
      Else If ( Ms.Eq.10 ) Then
        Do 80 I = 1, Nbin
          Hbk_Data ( I ) = I2memr( (I-1)*2 + 1 )
          Hbk_Error( I ) = I2memr( (I-1)*2 + 2 )
 80     Continue
      Else If ( Ms.Eq.11 ) Then
        Do 90 I = 1, Nbin
          Hbk_Data ( I ) = Lmemor( (I-1)*2 + 1 )
          Hbk_Error( I ) = Lmemor( (I-1)*2 + 2 )
 90     Continue
      Else
	Print *, '%HLHPK-F, Conversion Error!!!!!'
      End If
      Return
      End
c
c----------
c Hpk_data_to_Hbk_2
c----------
c
      Subroutine Hpk_data_to_Hbk_2 ( Ms, Nx, Ny,
     #                        Lmemor, I2memr, Hmemor,
     #                        Rmemor, Hbk_Data, Hbk_Error )
c
      Implicit         NONE
c
c Arg
c
      Integer * 4      Ms
      Integer * 4      Nx, Ny
      Logical * 1      Lmemor ( * )
      Integer * 2      I2memr ( * )
      Integer * 4      Hmemor ( * )
      Real * 4         Rmemor ( * )
      Real * 4         Hbk_Data(Nx,Ny), Hbk_Error (Nx,Ny)
c
c Var
c
      Integer * 4      I, J
      Integer * 4      Offset
      Real * 4         B2, B3
c
c Main
c
      If ( Ms.EQ.1 ) then
        Do I = 1, Ny
          Do J = 1, Nx
            Hbk_Data ( J, I ) = Lmemor( Nx*(I-1)+J )
          End Do
        End Do
      Else If ( Ms.Eq.2 ) Then
        Do I = 1, Ny
          Do J = 1, Nx
            Hbk_Data ( J, I ) = I2memr( Nx*(I-1)+J )
          End Do
        End Do
      Else If ( Ms.Eq.3 ) Then
        Do I = 1, Ny
          Do J = 1, Nx
            Hbk_Data ( J, I ) = Hmemor( Nx*(I-1)+J )
          End Do
        End Do
      Else If ( Ms.Eq.4 ) Then
        Do I = 1, Ny
          Do J = 1, Nx
            Hbk_Data ( J, I ) = Rmemor( Nx*(I-1)+J )
          End Do
        End Do
      Else If ( Ms.Eq.5 ) Then
        Do I = 1, Ny
          Do J = 1, Nx
            Offset = Nx*(I-1)*2 + (J-1)*2
            Hbk_Data ( J, I ) = Rmemor(Offset+1)
            Hbk_Error ( J, I ) = Sqrt( Rmemor(Offset+2) )
          End Do
        End Do
      Else If ( Ms.Eq.8 ) Then
        Do I = 1, Ny
          Do J = 1, Nx
            Offset = Nx*(I-1)*3 + (J-1)*3
            Hbk_Data ( J, I ) = Rmemor(Offset+1)
            B2 = Rmemor(Offset+2)
            B3 = Rmemor(Offset+3)
            If ( B3 .Gt. 0.0 ) then
              Hbk_Error(J,I) = Sqrt ( B2 / B3 )
            Else
              Hbk_Error(J,I) = 0.0
            End If
          End Do
        End Do
      Else
	Print *, '%HLHPK-F, Conversion Error!!!!!'
      End If
      Return
      End
c
c----------
c Hpk_ID_to_Hbk
c----------
c
      Integer * 4 Function Hpk_ID_to_Hbk ( ID, Iod )
c
      Implicit         NONE
c
c Arg
c
      Integer * 4      ID, Iod
c
c Var
c
      Integer * 4      NewID
      Integer * 4      Istat, Iret, Ierr
c
c Functions
c
      Integer * 4      DIS45_hexist
c
c Main
c
      NewID = ID
COLD      Call HLEXST ( NewId, Istat )
      Istat = DIS45_hexist ( NewID, Ierr )
      If ( Istat .EQ. 1 ) then
        If ( Iod .EQ. 0 ) then
          NewID = 0
        Else If ( Iod .EQ. 1 ) then
COLD          Call HLSETH ( NewID, Iret )
          Ierr = 0
          Call DIS45_sethist ( NewID, Ierr )
          If ( Ierr .NE. 5 ) CALL HLDEL
        Else If ( Iod .EQ. 2 ) then
          Istat = 1
          Do while ( Istat .EQ. 1 )
            NewID = NewID + 1000
COLD            Call HLEXST ( NewID, Istat )
            Istat = DIS45_hexist ( NewID, Ierr )
          End Do
        End If
      End If
      Hpk_ID_to_Hbk = NewID
      Return
      End
c
c----------
c hpk_search
c----------
c
      Logical * 4 Function hpk_search ( ID, Nhist, Hist_List )
c
      Implicit         NONE
c
c Arg
c
      Integer * 4      ID, Nhist, Hist_List(*)
c
c Var
c
      Integer * 4      I
c
c Main
c
      Do I = 1, Nhist
        If ( ID .EQ. Hist_List(I) ) then
          hpk_search = .TRUE.
          Return
        End If
      End Do
      hpk_search = .FALSE.
      Return
      End
